(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxpkg#main
    (lambda _args2530_
      (letrec* ((_install-cmd2532_
                 (std/getopt#command__%
                  '#f
                  '"install one or more packages"
                  'install
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to install"
                   absent-value
                   'pkg)))
                (_uninstall-cmd2533_
                 (std/getopt#command__%
                  '#f
                  '"uninstall one or more packages"
                  'uninstall
                  (std/getopt#flag__%__0
                   '#f
                   '"force uninstall even if there are orphaned dependencies"
                   'force
                   '"-f")
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to uninstall"
                   absent-value
                   'pkg)))
                (_update-cmd2534_
                 (std/getopt#command__%
                  '#f
                  '"update one or more packages"
                  'update
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to update; all for all packages"
                   absent-value
                   'pkg)))
                (_link-cmd2535_
                 (std/getopt#command__%
                  '#f
                  '"link a local development package"
                  'link
                  (std/getopt#argument__%
                   '#f
                   '"package to link"
                   absent-value
                   'pkg)
                  (std/getopt#argument__%
                   '#f
                   '"path to package source directory"
                   absent-value
                   'src)))
                (_unlink-cmd2536_
                 (std/getopt#command__%
                  '#f
                  '"unlink one or more local development packages"
                  'unlink
                  (std/getopt#flag__%__0
                   '#f
                   '"force unlink even if there are orphaned dependencies"
                   'force
                   '"-f")
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to unlink"
                   absent-value
                   'pkg)))
                (_build-cmd2537_
                 (std/getopt#command__%
                  '#f
                  '"rebuild one or more packages and their dependents"
                  'build
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to build; all for all packages"
                   absent-value
                   'pkg)))
                (_clean-cmd2538_
                 (std/getopt#command__%
                  '#f
                  '"clean compilation artefacts from one or more packages"
                  'clean
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to clean"
                   absent-value
                   'pkg)))
                (_list-cmd2539_
                 (std/getopt#command__% '#f '"list installed packages" 'list))
                (_retag-cmd2540_
                 (std/getopt#command__%
                  '#f
                  '"retag installed packages"
                  'retag))
                (_search-cmd2541_
                 (std/getopt#command__%
                  '#f
                  '"search the package directory"
                  'search
                  (std/getopt#rest-arguments__%
                   '#f
                   '"keywords to search for"
                   absent-value
                   'keywords)))
                (_help-cmd2542_
                 (std/getopt#command__%
                  '#f
                  '"display help; help <command> for command help"
                  'help
                  (std/getopt#optional-argument__%
                   '#f
                   absent-value
                   string->symbol
                   absent-value
                   'command)))
                (_gopt2543_
                 (std/getopt#getopt
                  _install-cmd2532_
                  _uninstall-cmd2533_
                  _update-cmd2534_
                  _link-cmd2535_
                  _unlink-cmd2536_
                  _build-cmd2537_
                  _clean-cmd2538_
                  _list-cmd2539_
                  _retag-cmd2540_
                  _search-cmd2541_
                  _help-cmd2542_)))
        (with-exception-catcher
         (lambda (_g25442546_)
           (if ((lambda (_$obj2549_)
                  (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _$obj2549_
                     'std/getopt#getopt-error::t)))
                _g25442546_)
               (let ((_exn2552_ _g25442546_))
                 (std/getopt#getopt-display-help__%
                  _exn2552_
                  '"gxpkg"
                  (current-error-port))
                 (exit '1))
               (if '#t
                   (let ((_e2554_ _g25442546_))
                     (display-exception _e2554_ (current-error-port))
                     (exit '2))
                   (raise _g25442546_))))
         (lambda ()
           (let ((_g7436_ (std/getopt#getopt-parse _gopt2543_ _args2530_)))
             (begin
               (let ((_g7437_ (let ()
                                (declare (not safe))
                                (if (##values? _g7436_)
                                    (##vector-length _g7436_)
                                    1))))
                 (if (not (let () (declare (not safe)) (##fx= _g7437_ 2)))
                     (error "Context expects 2 values" _g7437_)))
               (let ((_cmd2557_
                      (let () (declare (not safe)) (##vector-ref _g7436_ 0)))
                     (_opt2558_
                      (let () (declare (not safe)) (##vector-ref _g7436_ 1))))
                 (let* ((_ht2560_ _opt2558_) (_$e2813_ _cmd2557_))
                   (if (eq? 'install _$e2813_)
                       (gerbil/tools/gxpkg#install-pkgs
                        (table-ref _ht2560_ 'pkg))
                       (if (eq? 'uninstall _$e2813_)
                           (gerbil/tools/gxpkg#uninstall-pkgs
                            (table-ref _ht2560_ 'pkg)
                            (table-ref _ht2560_ 'force '#f))
                           (if (eq? 'update _$e2813_)
                               (gerbil/tools/gxpkg#update-pkgs
                                (table-ref _ht2560_ 'pkg))
                               (if (eq? 'link _$e2813_)
                                   (gerbil/tools/gxpkg#pkg-link
                                    (table-ref _ht2560_ 'pkg)
                                    (table-ref _ht2560_ 'src))
                                   (if (eq? 'unlink _$e2813_)
                                       (gerbil/tools/gxpkg#unlink-pkgs
                                        (table-ref _ht2560_ 'pkg)
                                        (table-ref _ht2560_ 'force '#f))
                                       (if (eq? 'build _$e2813_)
                                           (gerbil/tools/gxpkg#build-pkgs
                                            (table-ref _ht2560_ 'pkg))
                                           (if (eq? 'clean _$e2813_)
                                               (gerbil/tools/gxpkg#clean-pkgs
                                                (table-ref _ht2560_ 'pkg))
                                               (if (eq? 'list _$e2813_)
                                                   (gerbil/tools/gxpkg#list-pkgs)
                                                   (if (eq? 'retag _$e2813_)
                                                       (gerbil/tools/gxpkg#pkg-retag)
                                                       (if (eq? 'search
                                                                _$e2813_)
                                                           (gerbil/tools/gxpkg#pkg-search
                                                            (table-ref
                                                             _ht2560_
                                                             'keywords))
                                                           (if (eq? 'help
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _$e2813_)
                       (std/getopt#getopt-display-help-topic__0
                        _gopt2543_
                        (table-ref _ht2560_ 'command '#f)
                        '"gxkpg")
                       '#!void))))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  (define gerbil/tools/gxpkg#install-pkgs
    (lambda (_pkgs2486_)
      (if (let _lp2488_ ((_rest2491_ _pkgs2486_) (_result2493_ '#f))
            (let* ((_rest24952503_ _rest2491_)
                   (_else24972511_ (lambda () _result2493_))
                   (_K24992518_
                    (lambda (_rest2514_ _pkg2515_)
                      (if (gerbil/tools/gxpkg#pkg-install _pkg2515_)
                          (_lp2488_ _rest2514_ '#t)
                          (_lp2488_ _rest2514_ _result2493_)))))
              (if (let () (declare (not safe)) (##pair? _rest24952503_))
                  (let ((_hd25002521_
                         (let () (declare (not safe)) (##car _rest24952503_)))
                        (_tl25012523_
                         (let () (declare (not safe)) (##cdr _rest24952503_))))
                    (let* ((_pkg2526_ _hd25002521_) (_rest2528_ _tl25012523_))
                      (_K24992518_ _rest2528_ _pkg2526_)))
                  (_else24972511_))))
          (gerbil/tools/gxpkg#pkg-retag)
          '#!void)))
  (define gerbil/tools/gxpkg#uninstall-pkgs
    (lambda (_pkgs2441_ _force?2442_)
      (if (let _lp2444_ ((_rest2447_ _pkgs2441_) (_result2449_ '#f))
            (let* ((_rest24512459_ _rest2447_)
                   (_else24532467_ (lambda () _result2449_))
                   (_K24552474_
                    (lambda (_rest2470_ _pkg2471_)
                      (if (gerbil/tools/gxpkg#pkg-uninstall__%
                           _pkg2471_
                           _force?2442_)
                          (_lp2444_ _rest2470_ '#t)
                          (_lp2444_ _rest2470_ _result2449_)))))
              (if (let () (declare (not safe)) (##pair? _rest24512459_))
                  (let ((_hd24562477_
                         (let () (declare (not safe)) (##car _rest24512459_)))
                        (_tl24572479_
                         (let () (declare (not safe)) (##cdr _rest24512459_))))
                    (let* ((_pkg2482_ _hd24562477_) (_rest2484_ _tl24572479_))
                      (_K24552474_ _rest2484_ _pkg2482_)))
                  (_else24532467_))))
          (gerbil/tools/gxpkg#pkg-retag)
          '#!void)))
  (define gerbil/tools/gxpkg#update-pkgs
    (lambda (_pkgs2395_)
      (if (let _lp2397_ ((_rest2400_ _pkgs2395_) (_result2402_ '#f))
            (let* ((_rest24042412_ _rest2400_)
                   (_else24062420_ (lambda () _result2402_))
                   (_K24082427_
                    (lambda (_rest2423_ _pkg2424_)
                      (if (gerbil/tools/gxpkg#pkg-update _pkg2424_)
                          (_lp2397_ _rest2423_ '#t)
                          (_lp2397_ _rest2423_ _result2402_)))))
              (if (let () (declare (not safe)) (##pair? _rest24042412_))
                  (let ((_hd24092430_
                         (let () (declare (not safe)) (##car _rest24042412_)))
                        (_tl24102432_
                         (let () (declare (not safe)) (##cdr _rest24042412_))))
                    (let* ((_pkg2435_ _hd24092430_) (_rest2437_ _tl24102432_))
                      (_K24082427_ _rest2437_ _pkg2435_)))
                  (_else24062420_))))
          (begin
            (for-each
             (lambda (_pkg2439_)
               (if (equal? _pkg2439_ '"all")
                   (for-each
                    gerbil/tools/gxpkg#pkg-install-deps
                    (gerbil/tools/gxpkg#pkg-list))
                   (gerbil/tools/gxpkg#pkg-install-deps _pkg2439_)))
             _pkgs2395_)
            (for-each gerbil/tools/gxpkg#pkg-build _pkgs2395_)
            (gerbil/tools/gxpkg#pkg-retag))
          '#!void)))
  (define gerbil/tools/gxpkg#link-pkg
    (lambda (_pkg2392_ _src2393_)
      (gerbil/tools/gxpkg#pkg-link _pkg2392_ _src2393_)))
  (define gerbil/tools/gxpkg#unlink-pkgs
    (lambda (_pkgs2385_ _force?2386_)
      (for-each
       (lambda (_g23872389_)
         (gerbil/tools/gxpkg#pkg-unlink__% _g23872389_ _force?2386_))
       _pkgs2385_)))
  (define gerbil/tools/gxpkg#build-pkgs
    (lambda (_pkgs2383_) (for-each gerbil/tools/gxpkg#pkg-build _pkgs2383_)))
  (define gerbil/tools/gxpkg#clean-pkgs
    (lambda (_pkgs2381_) (for-each gerbil/tools/gxpkg#pkg-clean _pkgs2381_)))
  (define gerbil/tools/gxpkg#list-pkgs
    (lambda () (for-each displayln (gerbil/tools/gxpkg#pkg-list))))
  (define gerbil/tools/gxpkg#retag-pkgs
    (lambda () (gerbil/tools/gxpkg#pkg-retag)))
  (define gerbil/tools/gxpkg#search-pkgs
    (lambda (_keywords2377_) (gerbil/tools/gxpkg#pkg-search _keywords2377_)))
  (define gerbil/tools/gxpkg#+root-dir+ (getenv '"GERBIL_PATH" '"~/.gerbil"))
  (define gerbil/tools/gxpkg#+pkg-root-dir+
    (path-expand '"pkg" gerbil/tools/gxpkg#+root-dir+))
  (define gerbil/tools/gxpkg#+pkg-lib-dir+
    (path-expand '"lib" gerbil/tools/gxpkg#+root-dir+))
  (define gerbil/tools/gxpkg#+pkg-lib-static-dir+
    (path-expand '"static" gerbil/tools/gxpkg#+pkg-lib-dir+))
  (define gerbil/tools/gxpkg#+pkg-bin-dir+
    (path-expand '"bin" gerbil/tools/gxpkg#+root-dir+))
  (define gerbil/tools/gxpkg#pkg-root-dir
    (let ((_once2374_
           (make-promise
            (lambda ()
              (create-directory* gerbil/tools/gxpkg#+root-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-root-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-lib-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-lib-static-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-bin-dir+)))))
      (lambda () (force _once2374_) gerbil/tools/gxpkg#+pkg-root-dir+)))
  (define gerbil/tools/gxpkg#pkg-install
    (lambda (_pkg2361_)
      (letrec ((_git-clone-url2363_
                (lambda (_pkg2371_)
                  (string-append '"https://" _pkg2371_ '".git"))))
        (if (or (string-prefix? '"github.com/" _pkg2361_)
                (string-prefix? '"gitlab.com/" _pkg2361_)
                (string-prefix? '"bitbucket.org/" _pkg2361_))
            (gerbil/tools/gxpkg#pkg-install-git
             _pkg2361_
             (_git-clone-url2363_ _pkg2361_))
            (error '"Unknown package provider" _pkg2361_)))))
  (define gerbil/tools/gxpkg#pkg-install-git
    (lambda (_pkg2351_ _clone-url2352_)
      (let* ((_root2354_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2356_ (path-expand _pkg2351_ _root2354_)))
        (if (file-exists? _dest2356_)
            '#f
            (let ((_path2359_ (path-directory _dest2356_)))
              (displayln '"... install " _pkg2351_)
              (create-directory* _path2359_)
              (std/misc/process#run-process__%
               '#f
               void
               absent-value
               absent-value
               _path2359_
               absent-value
               '#f
               absent-value
               absent-value
               absent-value
               (cons '"git"
                     (cons '"clone" (cons '"-q" (cons _clone-url2352_ '())))))
              (gerbil/tools/gxpkg#pkg-install-deps _pkg2351_)
              (gerbil/tools/gxpkg#pkg-build__0 _pkg2351_)
              '#t)))))
  (define gerbil/tools/gxpkg#pkg-install-deps
    (lambda (_pkg2344_)
      (let* ((_plist2346_ (gerbil/tools/gxpkg#pkg-plist _pkg2344_))
             (_deps2348_ (pgetq 'depend: _plist2346_ '())))
        (for-each gerbil/tools/gxpkg#pkg-install _deps2348_))))
  (define gerbil/tools/gxpkg#pkg-uninstall__%
    (lambda (_pkg2324_ _force?2325_)
      (let* ((_root2327_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2329_ (path-expand _pkg2324_ _root2327_)))
        (if (file-exists? _dest2329_)
            (if (not (gerbil/tools/gxpkg#file-symbolic-link? _dest2329_))
                (begin
                  (if _force?2325_
                      '#!void
                      (let ((_deps2332_
                             (gerbil/tools/gxpkg#pkg-dependents__0 _pkg2324_)))
                        (if (null? _deps2332_)
                            '#!void
                            (error '"Refuse to uninstall package; orphaned dependencies"
                                   _deps2332_))))
                  (gerbil/tools/gxpkg#pkg-clean _pkg2324_)
                  (displayln '"... uninstall " _pkg2324_)
                  (std/misc/process#run-process__%
                   '#f
                   void
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   (cons '"rm"
                         (cons '"-rf" (cons (path-normalize _dest2329_) '()))))
                  '#t)
                '#f)
            '#f))))
  (define gerbil/tools/gxpkg#pkg-uninstall__0
    (lambda (_pkg2337_)
      (let ((_force?2339_ '#f))
        (gerbil/tools/gxpkg#pkg-uninstall__% _pkg2337_ _force?2339_))))
  (define gerbil/tools/gxpkg#pkg-uninstall
    (lambda _g7439_
      (let ((_g7438_ (let () (declare (not safe)) (##length _g7439_))))
        (cond ((let () (declare (not safe)) (##fx= _g7438_ 1))
               (apply gerbil/tools/gxpkg#pkg-uninstall__0 _g7439_))
              ((let () (declare (not safe)) (##fx= _g7438_ 2))
               (apply gerbil/tools/gxpkg#pkg-uninstall__% _g7439_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-uninstall
                _g7439_))))))
  (define gerbil/tools/gxpkg#pkg-update
    (lambda (_pkg2273_)
      (if (equal? _pkg2273_ '"all")
          (let _lp2275_ ((_rest2278_ (gerbil/tools/gxpkg#pkg-list))
                         (_result2280_ '#f))
            (let* ((_rest22822290_ _rest2278_)
                   (_else22842298_ (lambda () _result2280_))
                   (_K22862305_
                    (lambda (_rest2301_ _pkg2302_)
                      (if (gerbil/tools/gxpkg#pkg-update _pkg2302_)
                          (_lp2275_ _rest2301_ '#t)
                          (_lp2275_ _rest2301_ _result2280_)))))
              (if (let () (declare (not safe)) (##pair? _rest22822290_))
                  (let ((_hd22872308_
                         (let () (declare (not safe)) (##car _rest22822290_)))
                        (_tl22882310_
                         (let () (declare (not safe)) (##cdr _rest22822290_))))
                    (let* ((_pkg2313_ _hd22872308_) (_rest2315_ _tl22882310_))
                      (_K22862305_ _rest2315_ _pkg2313_)))
                  (_else22842298_))))
          (if (or (string-prefix? '"github.com/" _pkg2273_)
                  (string-prefix? '"gitlab.com/" _pkg2273_)
                  (string-prefix? '"bitbucket.org/" _pkg2273_))
              (gerbil/tools/gxpkg#pkg-update-git _pkg2273_)
              (error '"Unknown package provider" _pkg2273_)))))
  (define gerbil/tools/gxpkg#pkg-update-git
    (lambda (_pkg2261_)
      (let* ((_root2263_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2265_ (path-expand _pkg2261_ _root2263_)))
        (if (file-exists? _dest2265_)
            '#!void
            (error '"Cannot update uknown package" _pkg2261_))
        (if (not (gerbil/tools/gxpkg#file-symbolic-link? _dest2265_))
            (begin
              (displayln '"... update " _pkg2261_)
              (let* ((_result2268_
                      (std/misc/process#run-process__%
                       '#f
                       absent-value
                       absent-value
                       absent-value
                       _dest2265_
                       absent-value
                       absent-value
                       absent-value
                       absent-value
                       absent-value
                       (cons '"git" (cons '"pull" '()))))
                     (_update?2270_
                      (not (equal? _result2268_ '"Already up-to-date.\n"))))
                _update?2270_))
            '#f))))
  (define gerbil/tools/gxpkg#pkg-link
    (lambda (_pkg2253_ _src2254_)
      (let* ((_root2256_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2258_ (path-expand _pkg2253_ _root2256_)))
        (if (file-exists? _dest2258_)
            (error '"Cannot link package; destination already exists"
                   _pkg2253_
                   _dest2258_)
            '#!void)
        (create-directory* (path-directory _dest2258_))
        (create-symbolic-link _src2254_ _dest2258_))))
  (define gerbil/tools/gxpkg#pkg-unlink__%
    (lambda (_pkg2233_ _force?2234_)
      (let* ((_root2236_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2238_ (path-expand _pkg2233_ _root2236_)))
        (if (file-exists? _dest2238_)
            (begin
              (if (gerbil/tools/gxpkg#file-symbolic-link? _dest2238_)
                  '#!void
                  (error '"Cannot unlink package; not a symbolic link"
                         _dest2238_))
              (if _force?2234_
                  '#!void
                  (let ((_deps2241_
                         (gerbil/tools/gxpkg#pkg-dependents__0 _pkg2233_)))
                    (if (null? _deps2241_)
                        '#!void
                        (error '"Refuse to unlink package; orphaned dependencies"
                               _deps2241_))))
              (gerbil/tools/gxpkg#pkg-clean _pkg2233_)
              (delete-file _dest2238_))
            '#!void))))
  (define gerbil/tools/gxpkg#pkg-unlink__0
    (lambda (_pkg2246_)
      (let ((_force?2248_ '#f))
        (gerbil/tools/gxpkg#pkg-unlink__% _pkg2246_ _force?2248_))))
  (define gerbil/tools/gxpkg#pkg-unlink
    (lambda _g7441_
      (let ((_g7440_ (let () (declare (not safe)) (##length _g7441_))))
        (cond ((let () (declare (not safe)) (##fx= _g7440_ 1))
               (apply gerbil/tools/gxpkg#pkg-unlink__0 _g7441_))
              ((let () (declare (not safe)) (##fx= _g7440_ 2))
               (apply gerbil/tools/gxpkg#pkg-unlink__% _g7441_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-unlink
                _g7441_))))))
  (define gerbil/tools/gxpkg#pkg-build__%
    (lambda (_pkg2191_ _dependents?2192_)
      (if (equal? _pkg2191_ '"all")
          (let* ((_pkgs2194_ (gerbil/tools/gxpkg#pkg-list))
                 (_deps2200_
                  (map (lambda (_g21952197_)
                         (gerbil/tools/gxpkg#pkg-dependents*__%
                          _g21952197_
                          _pkgs2194_))
                       _pkgs2194_))
                 (_pkgs+deps2202_ (map cons _pkgs2194_ _deps2200_))
                 (_sorted2207_
                  (std/sort#sort
                   _pkgs+deps2202_
                   (lambda (_pa2204_ _pb2205_)
                     (member (car _pb2205_) (cdr _pa2204_))))))
            (for-each
             (lambda (_g22092211_)
               (gerbil/tools/gxpkg#pkg-build__% _g22092211_ '#f))
             (map car _sorted2207_)))
          (let* ((_root2214_ (gerbil/tools/gxpkg#pkg-root-dir))
                 (_path2216_ (path-expand _pkg2191_ _root2214_))
                 (_g7442_ (if (file-exists? _path2216_)
                              '#!void
                              (error '"Cannot build unknown package"
                                     _pkg2191_)))
                 (_build.ss2219_
                  (gerbil/tools/gxpkg#pkg-build-script _pkg2191_)))
            (displayln '"... build " _pkg2191_)
            (std/misc/process#run-process__%
             '#f
             void
             absent-value
             absent-value
             _path2216_
             absent-value
             '#f
             absent-value
             absent-value
             absent-value
             (cons _build.ss2219_ (cons '"compile" '())))
            (if _dependents?2192_
                (for-each
                 gerbil/tools/gxpkg#pkg-build
                 (gerbil/tools/gxpkg#pkg-dependents__0 _pkg2191_))
                '#!void)))))
  (define gerbil/tools/gxpkg#pkg-build__0
    (lambda (_pkg2225_)
      (let ((_dependents?2227_ '#t))
        (gerbil/tools/gxpkg#pkg-build__% _pkg2225_ _dependents?2227_))))
  (define gerbil/tools/gxpkg#pkg-build
    (lambda _g7444_
      (let ((_g7443_ (let () (declare (not safe)) (##length _g7444_))))
        (cond ((let () (declare (not safe)) (##fx= _g7443_ 1))
               (apply gerbil/tools/gxpkg#pkg-build__0 _g7444_))
              ((let () (declare (not safe)) (##fx= _g7443_ 2))
               (apply gerbil/tools/gxpkg#pkg-build__% _g7444_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-build
                _g7444_))))))
  (define gerbil/tools/gxpkg#pkg-clean
    (lambda (_pkg1912_)
      (letrec* ((_gpath1914_ (getenv '"GERBIL_PATH" '"~/.gerbil"))
                (_libdir1915_ (path-expand '"lib" _gpath1914_))
                (_bindir1916_ (path-expand '"bin" _gpath1914_))
                (_clean-lib1917_
                 (lambda (_mod2149_)
                   (let* ((_modpath2151_ (path-expand _mod2149_ _libdir1915_))
                          (_moddir2153_ (path-directory _modpath2151_))
                          (_modname2155_ (path-strip-directory _modpath2151_))
                          (_mod-dot2157_ (string-append _modname2155_ '"."))
                          (_mod-us2159_ (string-append _modname2155_ '"__"))
                          (_mod-nested2161_
                           (string-append _modname2155_ '"$")))
                     (if (file-exists? _moddir2153_)
                         (for-each
                          (lambda (_file2164_)
                            (if (or (string-prefix? _mod-dot2157_ _file2164_)
                                    (string-prefix? _mod-us2159_ _file2164_)
                                    (string-prefix?
                                     _mod-nested2161_
                                     _file2164_))
                                (let ((_path2172_
                                       (path-expand _file2164_ _moddir2153_)))
                                  (delete-file _path2172_))
                                '#!void))
                          (directory-files _moddir2153_))
                         '#!void))
                   (let* ((_static-libdir2174_
                           (path-expand '"static" _libdir1915_))
                          (_static-modname2176_
                           (string-join (string-split _mod2149_ '#\/) '"__"))
                          (_mod-self2178_
                           (string-append _static-modname2176_ '".scm"))
                          (_mod-nested2180_
                           (string-append _static-modname2176_ '"$")))
                     (if (file-exists? _static-libdir2174_)
                         (for-each
                          (lambda (_file2183_)
                            (if (or (equal? _file2183_ _mod-self2178_)
                                    (string-prefix?
                                     _mod-nested2180_
                                     _file2183_))
                                (let ((_path2188_
                                       (path-expand
                                        _file2183_
                                        _static-libdir2174_)))
                                  (delete-file _path2188_))
                                '#!void))
                          (directory-files _static-libdir2174_))
                         '#!void))))
                (_clean-bin1918_
                 (lambda (_exe2145_)
                   (let ((_bin2147_ (path-expand _exe2145_ _bindir1916_)))
                     (if (file-exists? _bin2147_)
                         (delete-file _bin2147_)
                         '#!void))))
                (_clean-static-include1919_
                 (lambda (_file2138_)
                   (let* ((_filename2140_ (path-strip-directory _file2138_))
                          (_static-path2142_
                           (path-expand
                            _filename2140_
                            (path-expand '"static" _libdir1915_))))
                     (if (file-exists? _static-path2142_)
                         (delete-file _static-path2142_)
                         '#!void)))))
        (let* ((_root1921_ (gerbil/tools/gxpkg#pkg-root-dir))
               (_path1923_ (path-expand _pkg1912_ _root1921_))
               (_g7445_ (if (file-exists? _path1923_)
                            '#!void
                            (error '"Cannot clean unknown package" _pkg1912_)))
               (_build.ss1926_ (gerbil/tools/gxpkg#pkg-build-script _pkg1912_))
               (_build-spec1928_
                (std/misc/process#run-process__%
                 '#f
                 read
                 absent-value
                 absent-value
                 _path1923_
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 (cons _build.ss1926_ (cons '"spec" '()))))
               (_plist1930_ (gerbil/tools/gxpkg#pkg-plist _pkg1912_))
               (_prefix1932_ (pgetq 'package: _plist1930_))
               (_prefix1934_
                (if _prefix1932_ (symbol->string _prefix1932_) '#f))
               (_with-prefix1938_
                (if _prefix1934_
                    (lambda (_mod1936_)
                      (string-append _prefix1934_ '"/" _mod1936_))
                    values)))
          (for-each
           (lambda (_e19401942_)
             (let* ((_g19441987_ _e19401942_)
                    (_E19531991_
                     (lambda () (error '"No clause matching" _g19441987_))))
               (let ((_K19852133_
                      (lambda (_modf2131_)
                        (_clean-lib1917_ (_with-prefix1938_ _modf2131_))))
                     (_K19802115_
                      (lambda (_modf2113_)
                        (_clean-lib1917_ (_with-prefix1938_ _modf2113_))))
                     (_K19752096_
                      (lambda (_modf2094_)
                        (_clean-lib1917_ (_with-prefix1938_ _modf2094_))))
                     (_K19702077_
                      (lambda (_modf2075_)
                        (_clean-lib1917_ (_with-prefix1938_ _modf2075_))))
                     (_K19652054_
                      (lambda (_opts2051_ _modf2052_)
                        (_clean-lib1917_ (_with-prefix1938_ _modf2052_))
                        (_clean-bin1918_ (pgetq 'bin: _opts2051_ _modf2052_))))
                     (_K19602030_
                      (lambda (_opts2027_ _modf2028_)
                        (_clean-lib1917_ (_with-prefix1938_ _modf2028_))
                        (_clean-bin1918_ (pgetq 'bin: _opts2027_ _modf2028_))))
                     (_K19552008_
                      (lambda (_file2006_)
                        (_clean-static-include1919_ _file2006_)))
                     (_K19541997_
                      (lambda (_unexpected1995_)
                        (displayln
                         '"Ignoring unexpected build artifact "
                         _unexpected1995_))))
                 (let ((_try-match19462128_
                        (lambda ()
                          (if (let ()
                                (declare (not safe))
                                (##pair? _g19441987_))
                              (let ((_tl19822120_
                                     (let ()
                                       (declare (not safe))
                                       (##cdr _g19441987_)))
                                    (_hd19812118_
                                     (let ()
                                       (declare (not safe))
                                       (##car _g19441987_))))
                                (if (let ()
                                      (declare (not safe))
                                      (##eq? _hd19812118_ 'gxc:))
                                    (if (let ()
                                          (declare (not safe))
                                          (##pair? _tl19822120_))
                                        (let* ((_hd19832123_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl19822120_)))
                                               (_modf2126_ _hd19832123_))
                                          (_K19802115_ _modf2126_))
                                        (let ((_unexpected2000_ _g19441987_))
                                          (_K19541997_ _unexpected2000_)))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _hd19812118_ 'gsc:))
                                        (if (let ()
                                              (declare (not safe))
                                              (##pair? _tl19822120_))
                                            (let* ((_hd19782104_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl19822120_)))
                                                   (_modf2107_ _hd19782104_))
                                              (_K19752096_ _modf2107_))
                                            (let ((_unexpected2000_
                                                   _g19441987_))
                                              (_K19541997_ _unexpected2000_)))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _hd19812118_ 'ssi:))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl19822120_))
                                                (let* ((_hd19732085_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl19822120_)))
                                                       (_modf2088_
                                                        _hd19732085_))
                                                  (_K19702077_ _modf2088_))
                                                (let ((_unexpected2000_
                                                       _g19441987_))
                                                  (_K19541997_
                                                   _unexpected2000_)))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##eq? _hd19812118_ 'exe:))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##pair? _tl19822120_))
                                                    (let ((_tl19692064_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##cdr _tl19822120_)))
                                                          (_hd19682062_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##car _tl19822120_))))
                                                      (let ((_modf2067_
                                                             _hd19682062_)
                                                            (_opts2069_
                                                             _tl19692064_))
                                                        (_K19652054_
                                                         _opts2069_
                                                         _modf2067_)))
                                                    (let ((_unexpected2000_
                                                           _g19441987_))
                                                      (_K19541997_
                                                       _unexpected2000_)))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _hd19812118_
                                                             'static-exe:))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##pair? _tl19822120_))
                                                        (let ((_tl19642040_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##cdr _tl19822120_)))
                      (_hd19632038_
                       (let () (declare (not safe)) (##car _tl19822120_))))
                  (let ((_modf2043_ _hd19632038_) (_opts2045_ _tl19642040_))
                    (_K19602030_ _opts2045_ _modf2043_)))
                (let ((_unexpected2000_ _g19441987_))
                  (_K19541997_ _unexpected2000_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##eq? _hd19812118_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         'static-include:))
                (if (let () (declare (not safe)) (##pair? _tl19822120_))
                    (let ((_tl19592018_
                           (let () (declare (not safe)) (##cdr _tl19822120_)))
                          (_hd19582016_
                           (let () (declare (not safe)) (##car _tl19822120_))))
                      (if (let () (declare (not safe)) (##null? _tl19592018_))
                          (let ((_file2021_ _hd19582016_))
                            (_clean-static-include1919_ _file2021_))
                          (let ((_unexpected2000_ _g19441987_))
                            (_K19541997_ _unexpected2000_))))
                    (let ((_unexpected2000_ _g19441987_))
                      (_K19541997_ _unexpected2000_)))
                (let ((_unexpected2000_ _g19441987_))
                  (_K19541997_ _unexpected2000_)))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                              (let ((_unexpected2000_ _g19441987_))
                                (_K19541997_ _unexpected2000_))))))
                   (if (string? _g19441987_)
                       (let ((_modf2136_ _g19441987_))
                         (_K19852133_ _modf2136_))
                       (_try-match19462128_))))))
           _build-spec1928_)))))
  (define gerbil/tools/gxpkg#pkg-list
    (lambda ()
      (letrec* ((_root1837_ (gerbil/tools/gxpkg#pkg-root-dir))
                (_walk1838_
                 (lambda (_dir1900_ _pkgpath1901_)
                   (for-each
                    (lambda (_file1903_)
                      (let* ((_path1905_ (path-expand _file1903_ _dir1900_))
                             (_gerbil.pkg1907_
                              (path-expand '"gerbil.pkg" _path1905_))
                             (_pkgpath1909_
                              (if (string-empty? _pkgpath1901_)
                                  _file1903_
                                  (string-append
                                   _pkgpath1901_
                                   '"/"
                                   _file1903_))))
                        (if (file-exists? _gerbil.pkg1907_)
                            (std/coroutine#yield _pkgpath1909_)
                            (if (gerbil/tools/gxpkg#file-directory? _path1905_)
                                (_walk1838_ _path1905_ _pkgpath1909_)
                                '#!void))))
                    (directory-files _dir1900_)))))
        (let ((_iterable1862_ (lambda () (_walk1838_ _root1837_ '"")))
              (_iter-do1864_
               (lambda (_val1841_)
                 (let* ((_val18431848_ _val1841_)
                        (_E18451852_
                         (lambda ()
                           (error '"No clause matching" _val18431848_)))
                        (_K18461857_ (lambda (_pkg1855_) _pkg1855_))
                        (_pkg1860_ _val18431848_))
                   (_K18461857_ _pkg1860_)))))
          (if (pair? _iterable1862_)
              (map _iter-do1864_ _iterable1862_)
              (if (null? _iterable1862_)
                  '()
                  (let* ((_it1867_ (std/iter#iter _iterable1862_))
                         (_next!1870_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _it1867_
                             '2
                             std/iter#iterator::t
                             '#f))))
                    (declare (not safe))
                    (let ((_root1875_ (cons '#f '())))
                      (let _lp1878_ ((_tl1881_ _root1875_))
                        (let ((_val1884_ (_next!1870_ _it1867_)))
                          (if (eq? std/iter#iter-end _val1884_)
                              (begin
                                (let ((_$e1886_
                                       (##unchecked-structure-ref
                                        _it1867_
                                        '3
                                        std/iter#iterator::t
                                        '#f)))
                                  (if _$e1886_
                                      ((lambda (_g18881890_)
                                         (_g18881890_ _it1867_))
                                       _$e1886_)
                                      '#!void))
                                (cdr _root1875_))
                              (let* ((_xval1893_ (_iter-do1864_ _val1884_))
                                     (_tl*1896_ (cons _xval1893_ '())))
                                (set-cdr! _tl1881_ _tl*1896_)
                                (_lp1878_ _tl*1896_)))))))))))))
  (define gerbil/tools/gxpkg#pkg-retag
    (lambda ()
      (let* ((_root1829_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dirs1833_
              (filter (lambda (_file1831_)
                        (gerbil/tools/gxpkg#file-directory?
                         (path-expand _file1831_ _root1829_)))
                      (directory-files _root1829_))))
        (displayln '"... tagging packages")
        (std/misc/process#run-process__%
         '#f
         absent-value
         absent-value
         absent-value
         _root1829_
         absent-value
         absent-value
         absent-value
         absent-value
         absent-value
         (cons '"gxtags" _dirs1833_)))))
  (define gerbil/tools/gxpkg#pkg-search
    (lambda (_keywords1700_)
      (letrec ((_search1702_
                (lambda (_alst1768_)
                  (let _lp1770_ ((_rest1772_ _alst1768_) (_r1773_ '()))
                    (let* ((_rest17741784_ _rest1772_)
                           (_else17761792_ (lambda () (reverse _r1773_)))
                           (_K17781807_
                            (lambda (_rest1795_ _desc1796_ _pkg1797_ _hd1798_)
                              (if (andmap1 (lambda (_kw1800_)
                                             (let ((_rx1802_
                                                    (std/pregexp#pregexp
                                                     (string-append
                                                      '"(?i:"
                                                      _kw1800_
                                                      '")"))))
                                               (or (std/pregexp#pregexp-match
                                                    _rx1802_
                                                    _pkg1797_)
                                                   (std/pregexp#pregexp-match
                                                    _rx1802_
                                                    _desc1796_))))
                                           _keywords1700_)
                                  (_lp1770_ _rest1795_ (cons _hd1798_ _r1773_))
                                  (_lp1770_ _rest1795_ _r1773_)))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _rest17741784_))
                          (let ((_hd17791810_
                                 (let ()
                                   (declare (not safe))
                                   (##car _rest17741784_)))
                                (_tl17801812_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _rest17741784_))))
                            (let ((_hd1815_ _hd17791810_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _hd17791810_))
                                  (let ((_hd17811817_
                                         (let ()
                                           (declare (not safe))
                                           (##car _hd17791810_)))
                                        (_tl17821819_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _hd17791810_))))
                                    (let* ((_pkg1822_ _hd17811817_)
                                           (_desc1824_ _tl17821819_)
                                           (_rest1826_ _tl17801812_))
                                      (_K17781807_
                                       _rest1826_
                                       _desc1824_
                                       _pkg1822_
                                       _hd1815_)))
                                  (_else17761792_))))
                          (_else17761792_))))))
               (_display-pkgs1703_
                (lambda (_alst1709_)
                  (let ((_iterable1742_ _alst1709_)
                        (_iter-do1744_
                         (lambda (_val1711_)
                           (let* ((_val17131720_ _val1711_)
                                  (_E17151724_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _val17131720_)))
                                  (_K17161730_
                                   (lambda (_desc1727_ _pkg1728_)
                                     (displayln _pkg1728_ '": " _desc1727_))))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _val17131720_))
                                 (let ((_hd17171733_
                                        (let ()
                                          (declare (not safe))
                                          (##car _val17131720_)))
                                       (_tl17181735_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _val17131720_))))
                                   (let* ((_pkg1738_ _hd17171733_)
                                          (_desc1740_ _tl17181735_))
                                     (_K17161730_ _desc1740_ _pkg1738_)))
                                 (_E17151724_))))))
                    (if (pair? _iterable1742_)
                        (for-each _iter-do1744_ _iterable1742_)
                        (if (null? _iterable1742_)
                            '#!void
                            (let* ((_it1747_ (std/iter#iter _iterable1742_))
                                   (_next!1750_
                                    (let ()
                                      (declare (not safe))
                                      (##unchecked-structure-ref
                                       _it1747_
                                       '2
                                       std/iter#iterator::t
                                       '#f))))
                              (declare (not safe))
                              (begin
                                (let _lp1755_ ()
                                  (let ((_val1759_ (_next!1750_ _it1747_)))
                                    (if (eq? std/iter#iter-end _val1759_)
                                        '#!void
                                        (begin
                                          (_iter-do1744_ _val1759_)
                                          (_lp1755_)))))
                                (let ((_$e1761_
                                       (##unchecked-structure-ref
                                        _it1747_
                                        '3
                                        std/iter#iterator::t
                                        '#f)))
                                  (if _$e1761_
                                      ((lambda (_g17631765_)
                                         (_g17631765_ _it1747_))
                                       _$e1761_)
                                      '#!void))
                                '#!void))))))))
        (let ((_alst1705_ (gerbil/tools/gxpkg#pkg-directory-list)))
          (if (null? _keywords1700_)
              (_display-pkgs1703_ _alst1705_)
              (let ((_matches1707_ (_search1702_ _alst1705_)))
                (_display-pkgs1703_ _matches1707_)))))))
  (define gerbil/tools/gxpkg#+pkg-directory+
    '"https://raw.githubusercontent.com/vyzo/gerbil-directory/master/README.md")
  (define gerbil/tools/gxpkg#pkg-directory-list
    (lambda ()
      (let* ((_txt1562_
              (std/net/request#request-text
               (std/net/request#http-get__%
                '#f
                absent-value
                absent-value
                absent-value
                absent-value
                absent-value
                absent-value
                gerbil/tools/gxpkg#+pkg-directory+)))
             (_lines1564_ (string-split _txt1562_ '#\newline)))
        (let _lp1567_ ((_rest1569_ _lines1564_))
          (let* ((_rest15701577_ _rest1569_)
                 (_E15721581_
                  (lambda () (error '"No clause matching" _rest15701577_)))
                 (_K15731688_
                  (lambda (_rest1584_ _hd1585_)
                    (if (equal? _hd1585_ '"<!-- begin-pkg -->")
                        (let _lp21587_ ((_rest1589_ (cddr _rest1584_))
                                        (_pkgs1590_ '()))
                          (let* ((_rest15911598_ _rest1589_)
                                 (_E15931602_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _rest15911598_)))
                                 (_K15941676_
                                  (lambda (_rest1605_ _hd1606_)
                                    (if (equal? _hd1606_ '"<!-- end-pkg -->")
                                        (reverse _pkgs1590_)
                                        (let* ((_g16071618_
                                                (string-split _hd1606_ '#\|))
                                               (_E16091622_
                                                (lambda ()
                                                  (error '"No clause matching"
                                                         _g16071618_)))
                                               (_K16101658_
                                                (lambda (_pkg-desc1625_
                                                         _pkg-link1626_)
                                                  (let* ((_g16271636_
                                                          (std/pregexp#pregexp-match
                                                           '"\\[([^]]+)\\]"
                                                           _pkg-link1626_))
                                                         (_E16291640_
                                                          (lambda ()
                                                            (error '"No clause matching"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _g16271636_)))
                 (_K16301645_
                  (lambda (_pkg1643_)
                    (_lp21587_
                     _rest1605_
                     (cons (cons _pkg1643_
                                 (std/srfi/13#string-trim__0 _pkg-desc1625_))
                           _pkgs1590_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##pair? _g16271636_))
                                                        (let ((_tl16321648_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##cdr _g16271636_))))
                  (if (let () (declare (not safe)) (##pair? _tl16321648_))
                      (let ((_hd16331651_
                             (let ()
                               (declare (not safe))
                               (##car _tl16321648_)))
                            (_tl16341653_
                             (let ()
                               (declare (not safe))
                               (##cdr _tl16321648_))))
                        (let ((_pkg1656_ _hd16331651_))
                          (if (let ()
                                (declare (not safe))
                                (##null? _tl16341653_))
                              (_K16301645_ _pkg1656_)
                              (_E16291640_))))
                      (_E16291640_)))
                (_E16291640_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                          (if (let ()
                                                (declare (not safe))
                                                (##pair? _g16071618_))
                                              (let ((_tl16121661_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##cdr _g16071618_))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##pair? _tl16121661_))
                                                    (let ((_hd16131664_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##car _tl16121661_)))
                                                          (_tl16141666_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##cdr _tl16121661_))))
                                                      (let ((_pkg-link1669_
                                                             _hd16131664_))
                                                        (if (let ()
                                                              (declare
                                                                (not safe))
                                                              (##pair? _tl16141666_))
                                                            (let* ((_hd16151671_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (let () (declare (not safe)) (##car _tl16141666_)))
                           (_pkg-desc1674_ _hd16151671_))
                      (_K16101658_ _pkg-desc1674_ _pkg-link1669_))
                    (_E16091622_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_E16091622_)))
                                              (_E16091622_)))))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _rest15911598_))
                                (let ((_hd15951679_
                                       (let ()
                                         (declare (not safe))
                                         (##car _rest15911598_)))
                                      (_tl15961681_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _rest15911598_))))
                                  (let* ((_hd1684_ _hd15951679_)
                                         (_rest1686_ _tl15961681_))
                                    (_K15941676_ _rest1686_ _hd1684_)))
                                (_E15931602_))))
                        (_lp1567_ _rest1584_)))))
            (if (let () (declare (not safe)) (##pair? _rest15701577_))
                (let ((_hd15741691_
                       (let () (declare (not safe)) (##car _rest15701577_)))
                      (_tl15751693_
                       (let () (declare (not safe)) (##cdr _rest15701577_))))
                  (let* ((_hd1696_ _hd15741691_) (_rest1698_ _tl15751693_))
                    (_K15731688_ _rest1698_ _hd1696_)))
                (_E15721581_)))))))
  (define gerbil/tools/gxpkg#+pkg-plist+ (make-table))
  (define gerbil/tools/gxpkg#pkg-plist
    (lambda (_pkg1544_)
      (let ((_$e1546_
             (table-ref gerbil/tools/gxpkg#+pkg-plist+ _pkg1544_ '#f)))
        (if _$e1546_
            (values _$e1546_)
            (let* ((_root1549_ (gerbil/tools/gxpkg#pkg-root-dir))
                   (_path1551_ (path-expand _pkg1544_ _root1549_))
                   (_gerbil.pkg1553_ (path-expand '"gerbil.pkg" _path1551_))
                   (_g7446_ (if (file-exists? _gerbil.pkg1553_)
                                '#!void
                                (error '"Bad package; missing gerbil.pkg"
                                       _pkg1544_)))
                   (_plist1556_ (call-with-input-file _gerbil.pkg1553_ read))
                   (_plist1558_
                    (if (eof-object? _plist1556_) '() _plist1556_)))
              (table-set! gerbil/tools/gxpkg#+pkg-plist+ _pkg1544_ _plist1558_)
              _plist1558_)))))
  (define gerbil/tools/gxpkg#pkg-build-script
    (lambda (_pkg1528_)
      (let* ((_root1530_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_path1532_ (path-expand _pkg1528_ _root1530_))
             (_plist1534_ (gerbil/tools/gxpkg#pkg-plist _pkg1528_))
             (_build1536_ (pgetq 'build: _plist1534_))
             (_build.ss1541_
              (path-expand
               (let ((_$e1538_ _build1536_))
                 (if _$e1538_ _$e1538_ '"build.ss"))
               _path1532_)))
        (if (file-exists? _build.ss1541_)
            '#!void
            (error '"Bad package; missing build script"
                   _pkg1528_
                   _build.ss1541_))
        (path-normalize _build.ss1541_))))
  (define gerbil/tools/gxpkg#pkg-dependents__%
    (lambda (_pkg1506_ _pkgs1507_)
      (letrec ((_dependent1509_
                (lambda (_xpkg1511_)
                  (let* ((_plist1513_
                          (gerbil/tools/gxpkg#pkg-plist _xpkg1511_))
                         (_deps1515_ (pgetq 'depend: _plist1513_ '())))
                    (if (member _pkg1506_ _deps1515_) _xpkg1511_ '#f)))))
        (filter-map1 _dependent1509_ _pkgs1507_))))
  (define gerbil/tools/gxpkg#pkg-dependents__0
    (lambda (_pkg1521_)
      (let ((_pkgs1523_ (gerbil/tools/gxpkg#pkg-list)))
        (gerbil/tools/gxpkg#pkg-dependents__% _pkg1521_ _pkgs1523_))))
  (define gerbil/tools/gxpkg#pkg-dependents
    (lambda _g7448_
      (let ((_g7447_ (let () (declare (not safe)) (##length _g7448_))))
        (cond ((let () (declare (not safe)) (##fx= _g7447_ 1))
               (apply gerbil/tools/gxpkg#pkg-dependents__0 _g7448_))
              ((let () (declare (not safe)) (##fx= _g7447_ 2))
               (apply gerbil/tools/gxpkg#pkg-dependents__% _g7448_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-dependents
                _g7448_))))))
  (define gerbil/tools/gxpkg#pkg-dependents*__%
    (lambda (_pkg1450_ _pkgs1451_)
      (let ((_deps1453_
             (gerbil/tools/gxpkg#pkg-dependents__% _pkg1450_ _pkgs1451_)))
        (let _lp1455_ ((_rest1457_ _deps1453_) (_r1458_ '()))
          (let* ((_rest14591467_ _rest1457_)
                 (_else14611475_ (lambda () _r1458_))
                 (_K14631483_
                  (lambda (_rest1478_ _pkg1479_)
                    (if (member _pkg1479_ _r1458_)
                        (_lp1455_ _rest1478_ _r1458_)
                        (let ((_deps1481_
                               (gerbil/tools/gxpkg#pkg-dependents__%
                                _pkg1479_
                                _pkgs1451_)))
                          (_lp1455_
                           (foldl1 cons _rest1478_ _deps1481_)
                           (cons _pkg1479_ _r1458_)))))))
            (if (let () (declare (not safe)) (##pair? _rest14591467_))
                (let ((_hd14641486_
                       (let () (declare (not safe)) (##car _rest14591467_)))
                      (_tl14651488_
                       (let () (declare (not safe)) (##cdr _rest14591467_))))
                  (let* ((_pkg1491_ _hd14641486_) (_rest1493_ _tl14651488_))
                    (_K14631483_ _rest1493_ _pkg1491_)))
                (_else14611475_)))))))
  (define gerbil/tools/gxpkg#pkg-dependents*__0
    (lambda (_pkg1498_)
      (let ((_pkgs1500_ (gerbil/tools/gxpkg#pkg-list)))
        (gerbil/tools/gxpkg#pkg-dependents*__% _pkg1498_ _pkgs1500_))))
  (define gerbil/tools/gxpkg#pkg-dependents*
    (lambda _g7450_
      (let ((_g7449_ (let () (declare (not safe)) (##length _g7450_))))
        (cond ((let () (declare (not safe)) (##fx= _g7449_ 1))
               (apply gerbil/tools/gxpkg#pkg-dependents*__0 _g7450_))
              ((let () (declare (not safe)) (##fx= _g7449_ 2))
               (apply gerbil/tools/gxpkg#pkg-dependents*__% _g7450_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-dependents*
                _g7450_))))))
  (define gerbil/tools/gxpkg#file-directory?
    (lambda (_path1447_) (eq? (file-type _path1447_) 'directory)))
  (define gerbil/tools/gxpkg#file-symbolic-link?
    (lambda (_path1445_)
      (eq? (file-info-type (file-info _path1445_ '#f)) 'symbolic-link))))
