(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/cipher#::digest-type
    std/crypto/digest#digest::sha256)
  (define std/actor/rpc/proto/cipher#::digest-size
    (std/crypto/digest#digest-size std/actor/rpc/proto/cipher#::digest-type))
  (define std/actor/rpc/proto/cipher#::cipher-type
    std/crypto/cipher#cipher::aes-128-cbc)
  (define std/actor/rpc/proto/cipher#::cipher-key-length
    (std/crypto/cipher#cipher-key-length
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::cipher-iv-length
    (std/crypto/cipher#cipher-iv-length
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::cipher-block-size
    (std/crypto/cipher#cipher-block-size
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::DH::new std/crypto/dh#DH-get-1024-160)
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
    (lambda (_ibuf254643_ _obuf254644_)
      (let* ((_dh254646_ (std/actor/rpc/proto/cipher#::DH::new))
             (_g310709_ (std/crypto/dh#DH-generate-key _dh254646_))
             (_pubk254649_ (std/crypto/libcrypto#DH_pub_key _dh254646_))
             (_bytes254651_ (std/crypto/bn#BN->bytes _pubk254649_)))
        (std/net/bio/output#bio-write-u8
         std/actor/rpc/proto/message#rpc-proto-key-exchange
         _obuf254644_)
        (std/net/bio/output#bio-write-u32
         (u8vector-length _bytes254651_)
         _obuf254644_)
        (std/net/bio/output#bio-write-bytes _bytes254651_ _obuf254644_)
        (std/net/bio/output#bio-force-output _obuf254644_)
        (let ((_e254654_ (std/net/bio/input#bio-read-u8 _ibuf254643_)))
          (if (eq? _e254654_
                   std/actor/rpc/proto/message#rpc-proto-key-exchange)
              (let* ((_sz254656_ (std/net/bio/input#bio-read-u32 _ibuf254643_))
                     (_g310710_
                      (if (fx> _sz254656_ '1024)
                          (std/actor/proto#raise-rpc-io-error
                           'rpc-proto-key-exchange
                           '"inordinately sized key"
                           _sz254656_)
                          '#!void))
                     (_bytes254659_ (make-u8vector _sz254656_))
                     (_g310711_
                      (std/net/bio/input#bio-read-bytes
                       _bytes254659_
                       _ibuf254643_))
                     (_peerk254662_
                      (std/crypto/bn#bytes->BN__0 _bytes254659_)))
                (std/crypto/dh#DH-compute-key _dh254646_ _peerk254662_))
              (if (eof-object? _e254654_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-key-exchange
                   '"connection closed")
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-key-exchange
                   '"key exchange error"
                   _e254654_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
    (lambda (_secret254629_)
      (let ((_key254631_
             (subu8vector
              _secret254629_
              '0
              std/actor/rpc/proto/cipher#::cipher-key-length))
            (_hmac254632_
             (make-u8vector std/actor/rpc/proto/cipher#::digest-size))
            (_iv254633_
             (make-u8vector std/actor/rpc/proto/cipher#::cipher-iv-length))
            (_ctext254634_ (box (make-u8vector '4096))))
        (lambda (_g254635254638_ _g254636254640_)
          (std/actor/rpc/proto/cipher#rpc-cipher-proto-read
           _g254635254638_
           _g254636254640_
           _secret254629_
           _key254631_
           _hmac254632_
           _iv254633_
           _ctext254634_)))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-read
    (lambda (_ibuf254590_
             _bytes254591_
             _secret254592_
             _key254593_
             _hmac254594_
             _iv254595_
             _ctext254596_)
      (let ((_e254598_ (std/net/bio/input#bio-read-u8 _ibuf254590_)))
        (if (eq? _e254598_ std/actor/rpc/proto/message#rpc-proto-message)
            (let* ((_digest254600_
                    (let ((__obj310703
                           (make-object std/crypto/digest#digest::t '2)))
                      (std/crypto/digest#digest:::init!
                       __obj310703
                       std/actor/rpc/proto/cipher#::digest-type)
                      __obj310703))
                   (_cipher254602_
                    (let ((__obj310704
                           (make-object std/crypto/cipher#cipher::t '2)))
                      (std/crypto/cipher#cipher:::init!
                       __obj310704
                       std/actor/rpc/proto/cipher#::cipher-type)
                      __obj310704))
                   (_g310712_
                    (std/net/bio/input#bio-read-bytes
                     _hmac254594_
                     _ibuf254590_))
                   (_g310713_
                    (std/net/bio/input#bio-read-bytes _iv254595_ _ibuf254590_))
                   (_size254606_ (std/net/bio/input#bio-read-u32 _ibuf254590_))
                   (_g310714_
                    (if (fx<= _size254606_
                              std/actor/rpc/proto/message#rpc-proto-message-max-length)
                        '#!void
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"message too large"
                         _size254606_)))
                   (_ctext254613_
                    (let ((_buf254609_ (unbox _ctext254596_)))
                      (if (fx< (u8vector-length _buf254609_) _size254606_)
                          (let ((_buf254611_ (make-u8vector _size254606_)))
                            (set-box! _ctext254596_ _buf254611_)
                            _buf254611_)
                          _buf254609_)))
                   (_rd254615_
                    (std/net/bio/input#bio-read-subu8vector-unbuffered
                     _ctext254613_
                     '0
                     _size254606_
                     _ibuf254590_))
                   (_g310715_
                    (if (fx< _rd254615_ _size254606_)
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"incomplete message"
                         _rd254615_
                         _size254606_)
                        '#!void))
                   (_g310716_
                    (std/crypto/digest#digest-update!__0
                     _digest254600_
                     _secret254592_))
                   (_g310717_
                    (std/crypto/digest#digest-update!__0
                     _digest254600_
                     _iv254595_))
                   (_g310718_
                    (std/crypto/digest#digest-update!__%
                     _digest254600_
                     _ctext254613_
                     '0
                     _size254606_))
                   (_hmac*254621_
                    (std/crypto/digest#digest-final!__0 _digest254600_))
                   (_g310719_
                    (if (equal? _hmac254594_ _hmac*254621_)
                        '#!void
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"HMAC failure")))
                   (_bytes254624_
                    (if (fx< (u8vector-length _bytes254591_) _size254606_)
                        (make-u8vector _size254606_)
                        _bytes254591_))
                   (_len254626_
                    (std/crypto/cipher#decrypt-u8vector!
                     _cipher254602_
                     _key254593_
                     _iv254595_
                     _ctext254613_
                     '0
                     _size254606_
                     _bytes254624_)))
              (values _bytes254624_ _len254626_))
            (if (eq? _e254598_
                     std/actor/rpc/proto/message#rpc-proto-keep-alive)
                '#!void
                (if (eof-object? _e254598_)
                    _e254598_
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-read
                     '"bad message"
                     _e254598_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
    (lambda (_secret254577_)
      (let ((_key254579_
             (subu8vector
              _secret254577_
              '0
              std/actor/rpc/proto/cipher#::cipher-key-length))
            (_iv254580_
             (make-u8vector std/actor/rpc/proto/cipher#::cipher-iv-length))
            (_ctext254581_ (box (make-u8vector '4096))))
        (lambda (_g254582254585_ _g254583254587_)
          (std/actor/rpc/proto/cipher#rpc-cipher-proto-write
           _g254582254585_
           _g254583254587_
           _secret254577_
           _key254579_
           _iv254580_
           _ctext254581_)))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-write
    (lambda (_obuf254512_
             _obj254513_
             _secret254514_
             _key254515_
             _iv254516_
             _ctext254517_)
      (if (eq? _obj254513_ '#!void)
          (begin
            (std/net/bio/output#bio-write-u8
             std/actor/rpc/proto/message#rpc-proto-keep-alive
             _obuf254512_)
            (std/net/bio/output#bio-force-output _obuf254512_))
          (if (u8vector? _obj254513_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-message
                 _obuf254512_)
                (let* ((_digest254519_
                        (let ((__obj310705
                               (make-object std/crypto/digest#digest::t '2)))
                          (std/crypto/digest#digest:::init!
                           __obj310705
                           std/actor/rpc/proto/cipher#::digest-type)
                          __obj310705))
                       (_cipher254521_
                        (let ((__obj310706
                               (make-object std/crypto/cipher#cipher::t '2)))
                          (std/crypto/cipher#cipher:::init!
                           __obj310706
                           std/actor/rpc/proto/cipher#::cipher-type)
                          __obj310706))
                       (_g310720_ (std/crypto/etc#random-bytes!__0 _iv254516_))
                       (_plen254524_ (u8vector-length _obj254513_))
                       (_maxlen254526_
                        (fx+ _plen254524_
                             std/actor/rpc/proto/cipher#::cipher-block-size))
                       (_ctext254532_
                        (let ((_buf254528_ (unbox _ctext254517_)))
                          (if (fx< (u8vector-length _buf254528_)
                                   _maxlen254526_)
                              (let ((_buf254530_
                                     (make-u8vector _maxlen254526_)))
                                (set-box! _ctext254517_ _buf254530_)
                                _buf254530_)
                              _buf254528_)))
                       (_clen254534_
                        (std/crypto/cipher#encrypt-u8vector!
                         _cipher254521_
                         _key254515_
                         _iv254516_
                         _obj254513_
                         '0
                         _plen254524_
                         _ctext254532_))
                       (_g310721_
                        (std/crypto/digest#digest-update!__0
                         _digest254519_
                         _secret254514_))
                       (_g310722_
                        (std/crypto/digest#digest-update!__0
                         _digest254519_
                         _iv254516_))
                       (_g310723_
                        (std/crypto/digest#digest-update!__%
                         _digest254519_
                         _ctext254532_
                         '0
                         _clen254534_))
                       (_hmac254539_
                        (std/crypto/digest#digest-final!__0 _digest254519_)))
                  (std/net/bio/output#bio-write-bytes
                   _hmac254539_
                   _obuf254512_)
                  (std/net/bio/output#bio-write-bytes _iv254516_ _obuf254512_)
                  (std/net/bio/output#bio-write-u32 _clen254534_ _obuf254512_)
                  (std/net/bio/output#bio-write-subu8vector
                   _ctext254532_
                   '0
                   _clen254534_
                   _obuf254512_)
                  (std/net/bio/output#bio-force-output _obuf254512_)))
              (if (##structure-instance-of?
                   _obj254513_
                   'std/net/bio/buffer#chunked-output-buffer::t)
                  (begin
                    (std/net/bio/output#bio-write-u8
                     std/actor/rpc/proto/message#rpc-proto-message
                     _obuf254512_)
                    (let* ((_digest254542_
                            (let ((__obj310707
                                   (make-object
                                    std/crypto/digest#digest::t
                                    '2)))
                              (std/crypto/digest#digest:::init!
                               __obj310707
                               std/actor/rpc/proto/cipher#::digest-type)
                              __obj310707))
                           (_cipher254544_
                            (let ((__obj310708
                                   (make-object
                                    std/crypto/cipher#cipher::t
                                    '2)))
                              (std/crypto/cipher#cipher:::init!
                               __obj310708
                               std/actor/rpc/proto/cipher#::cipher-type)
                              __obj310708))
                           (_g310724_
                            (std/crypto/etc#random-bytes!__0 _iv254516_))
                           (_plen254547_
                            (std/net/bio/buffer#chunked-output-length
                             _obj254513_))
                           (_chunks254549_
                            (std/net/bio/buffer#chunked-output-chunks
                             _obj254513_))
                           (_maxlen254551_
                            (fx+ _plen254547_
                                 std/actor/rpc/proto/cipher#::cipher-block-size))
                           (_ctext254557_
                            (let ((_buf254553_ (unbox _ctext254517_)))
                              (if (fx< (u8vector-length _buf254553_)
                                       _maxlen254551_)
                                  (let ((_buf254555_
                                         (make-u8vector _maxlen254551_)))
                                    (set-box! _ctext254517_ _buf254555_)
                                    _buf254555_)
                                  _buf254553_)))
                           (_g310725_
                            (std/crypto/cipher#encrypt-init!
                             _cipher254544_
                             _key254515_
                             _iv254516_))
                           (_clen254565_
                            (foldl1 (lambda (_chunk254560_ _r254561_)
                                      (let ((_count254563_
                                             (std/crypto/cipher#encrypt-update!
                                              _cipher254544_
                                              _ctext254557_
                                              _r254561_
                                              _chunk254560_
                                              '0
                                              (u8vector-length
                                               _chunk254560_))))
                                        (fx+ _r254561_ _count254563_)))
                                    '0
                                    _chunks254549_))
                           (_flen254567_
                            (std/crypto/cipher#encrypt-final!__%
                             _cipher254544_
                             _ctext254557_
                             _clen254565_))
                           (_clen254569_ (fx+ _clen254565_ _flen254567_))
                           (_g310726_
                            (std/crypto/digest#digest-update!__0
                             _digest254542_
                             _secret254514_))
                           (_g310727_
                            (std/crypto/digest#digest-update!__0
                             _digest254542_
                             _iv254516_))
                           (_g310728_
                            (std/crypto/digest#digest-update!__%
                             _digest254542_
                             _ctext254557_
                             '0
                             _clen254569_))
                           (_hmac254574_
                            (std/crypto/digest#digest-final!__0
                             _digest254542_)))
                      (std/net/bio/output#bio-write-bytes
                       _hmac254574_
                       _obuf254512_)
                      (std/net/bio/output#bio-write-bytes
                       _iv254516_
                       _obuf254512_)
                      (std/net/bio/output#bio-write-u32
                       _clen254569_
                       _obuf254512_)
                      (std/net/bio/output#bio-write-subu8vector
                       _ctext254557_
                       '0
                       _clen254569_
                       _obuf254512_)
                      (std/net/bio/output#bio-force-output _obuf254512_)))
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-write
                   '"unexpected object"
                   _obj254513_))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-accept
    (lambda (_ibuf254504_ _obuf254505_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254504_
       _obuf254505_
       std/actor/rpc/proto/message#rpc-proto-cipher
       (lambda (_ibuf254507_ _obuf254508_)
         (let ((_secret254510_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf254507_
                 _obuf254508_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret254510_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret254510_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-connect
    (lambda (_ibuf254496_ _obuf254497_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254496_
       _obuf254497_
       std/actor/rpc/proto/message#rpc-proto-cipher
       (lambda (_ibuf254499_ _obuf254500_)
         (let ((_secret254502_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf254499_
                 _obuf254500_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret254502_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret254502_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-accept
    (lambda (_ibuf254487_ _obuf254488_ _cookie254489_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254487_
       _obuf254488_
       std/actor/rpc/proto/message#rpc-proto-cookie-cipher
       (lambda (_ibuf254491_ _obuf254492_)
         (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
          _ibuf254491_
          _obuf254492_
          _cookie254489_)
         (let ((_secret254494_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf254491_
                 _obuf254492_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret254494_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret254494_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-connect
    (lambda (_ibuf254476_ _obuf254477_ _cookie254478_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254476_
       _obuf254477_
       std/actor/rpc/proto/message#rpc-proto-cookie-cipher
       (lambda (_ibuf254480_ _obuf254481_)
         (let ((_e254483_ (std/net/bio/input#bio-read-u8 _ibuf254480_)))
           (if (eq? _e254483_ std/actor/rpc/proto/message#rpc-proto-challenge)
               (begin
                 (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
                  _ibuf254480_
                  _obuf254481_
                  _cookie254478_)
                 (let ((_secret254485_
                        (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                         _ibuf254480_
                         _obuf254481_)))
                   (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                            _secret254485_)
                           (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                            _secret254485_))))
               (if (eof-object? _e254483_)
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"connect closed")
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"bad hello"
                    _e254483_))))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto
    (lambda ()
      (##structure
       std/actor/rpc/base#!rpc-protocol::t
       std/actor/rpc/proto/cipher#rpc-cipher-proto-accept
       std/actor/rpc/proto/cipher#rpc-cipher-proto-connect)))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
    (lambda (_cookie-file254449_)
      (let ((_cookie254451_ (call-with-input-file _cookie-file254449_ read)))
        (if (u8vector? _cookie254451_)
            (##structure
             std/actor/rpc/base#!rpc-protocol::t
             (lambda (_g254452254455_ _g254453254457_)
               (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-connect
                _g254452254455_
                _g254453254457_
                _cookie254451_))
             (lambda (_g254459254462_ _g254460254464_)
               (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-accept
                _g254459254462_
                _g254460254464_
                _cookie254451_)))
            (error '"Invalid cookie; expected u8vector"
                   _cookie-file254449_
                   _cookie254451_)))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__0
    (lambda ()
      (let ((_cookie-file254471_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
         _cookie-file254471_))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto
    (lambda _g310730_
      (let ((_g310729_ (##length _g310730_)))
        (cond ((##fx= _g310729_ 0)
               (apply std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__0
                      _g310730_))
              ((##fx= _g310729_ 1)
               (apply std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
                      _g310730_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto
                _g310730_)))))))
