(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/cipher#cipher::t
    (make-struct-type
     'std/crypto#cipher::t
     '#f
     '2
     'cipher
     '()
     ':init!
     '(type ctx)))
  (define std/crypto/cipher#cipher?
    (make-struct-predicate std/crypto/cipher#cipher::t))
  (define std/crypto/cipher#make-cipher
    (lambda _$args209659_
      (apply make-struct-instance std/crypto/cipher#cipher::t _$args209659_)))
  (define std/crypto/cipher#cipher-type
    (make-struct-field-accessor std/crypto/cipher#cipher::t '0))
  (define std/crypto/cipher#cipher-ctx
    (make-struct-field-accessor std/crypto/cipher#cipher::t '1))
  (define std/crypto/cipher#cipher-type-set!
    (make-struct-field-mutator std/crypto/cipher#cipher::t '0))
  (define std/crypto/cipher#cipher-ctx-set!
    (make-struct-field-mutator std/crypto/cipher#cipher::t '1))
  (define std/crypto/cipher#cipher:::init!
    (lambda (_self209654_ _type209655_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _type209655_)
          '#!void
          (error '"Invalid cipher" _type209655_))
      (let ((_ctx209657_ (std/crypto/libcrypto#EVP_CIPHER_CTX_create)))
        (if _ctx209657_ '#!void (error '"Failed to allocate cipher context"))
        (if (let ((__tmp301599
                   (let ()
                     (declare (not safe))
                     (##vector-length _self209654_))))
              (declare (not safe))
              (##fx< '2 __tmp301599))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self209654_ '1 _type209655_))
              (let ()
                (declare (not safe))
                (##vector-set! _self209654_ '2 _ctx209657_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self209654_)))))
  (bind-method!
   std/crypto/cipher#cipher::t
   ':init!
   std/crypto/cipher#cipher:::init!
   '#f)
  (define std/crypto/cipher#cipher-name
    (lambda (_cipher209530_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209530_)
          (std/crypto/libcrypto#EVP_CIPHER_name _cipher209530_)
          (std/crypto/libcrypto#EVP_CIPHER_name
           (##structure-ref
            _cipher209530_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-block-size
    (lambda (_cipher209528_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209528_)
          (std/crypto/libcrypto#EVP_CIPHER_block_size _cipher209528_)
          (std/crypto/libcrypto#EVP_CIPHER_block_size
           (##structure-ref
            _cipher209528_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-key-length
    (lambda (_cipher209526_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209526_)
          (std/crypto/libcrypto#EVP_CIPHER_key_length _cipher209526_)
          (std/crypto/libcrypto#EVP_CIPHER_key_length
           (##structure-ref
            _cipher209526_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-iv-length
    (lambda (_cipher209524_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209524_)
          (std/crypto/libcrypto#EVP_CIPHER_iv_length _cipher209524_)
          (std/crypto/libcrypto#EVP_CIPHER_iv_length
           (##structure-ref
            _cipher209524_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-copy
    (lambda (_cipher209514_)
      (let* ((_ctx209516_ (std/crypto/cipher#cipher-context _cipher209514_))
             (_copy209518_
              (let ((__obj301554 (make-object std/crypto/cipher#cipher::t '2)))
                (std/crypto/cipher#cipher:::init!
                 __obj301554
                 (##structure-ref
                  _cipher209514_
                  '1
                  std/crypto/cipher#cipher::t
                  '#f))
                __obj301554)))
        (let ((_res209521_
               (std/crypto/libcrypto#EVP_CIPHER_CTX_copy
                (##structure-ref
                 _copy209518_
                 '2
                 std/crypto/cipher#cipher::t
                 '#f)
                _ctx209516_)))
          (if (let () (declare (not safe)) (##fxzero? _res209521_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _copy209518_)))
  (define std/crypto/cipher#cipher-context
    (lambda (_cipher209509_)
      (let ((_$e209511_
             (##structure-ref
              _cipher209509_
              '2
              std/crypto/cipher#cipher::t
              '#f)))
        (if _$e209511_
            _$e209511_
            (error '"Cipher has been finalized" _cipher209509_)))))
  (define std/crypto/cipher#cipher-check-key+iv-length
    (lambda (_cipher209505_ _key209506_ _iv209507_)
      (if (= (std/crypto/cipher#cipher-key-length
              (##structure-ref
               _cipher209505_
               '1
               std/crypto/cipher#cipher::t
               '#f))
             (u8vector-length _key209506_))
          '#!void
          (error '"Bad cipher key; key length mismatch"))
      (if (= (std/crypto/cipher#cipher-iv-length
              (##structure-ref
               _cipher209505_
               '1
               std/crypto/cipher#cipher::t
               '#f))
             (u8vector-length _iv209507_))
          '#!void
          (error '"Bad cipher iv; iv length mismatch"))))
  (define std/crypto/cipher#cipher-init!
    (lambda (_cipher209497_ _key209498_ _iv209499_ _EVP-init209500_)
      (std/crypto/cipher#cipher-check-key+iv-length
       _cipher209497_
       _key209498_
       _iv209499_)
      (let ((_res209502_
             (_EVP-init209500_
              (std/crypto/cipher#cipher-context _cipher209497_)
              (##structure-ref
               _cipher209497_
               '1
               std/crypto/cipher#cipher::t
               '#f)
              _key209498_
              _iv209499_)))
        (if (let () (declare (not safe)) (##fxzero? _res209502_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/cipher#cipher-update!
    (lambda (_ctx209487_
             _out209488_
             _out-start209489_
             _in209490_
             _start209491_
             _end209492_
             _EVP-update209493_)
      (let ((_r209495_
             (_EVP-update209493_
              _ctx209487_
              _out209488_
              _out-start209489_
              _in209490_
              _start209491_
              _end209492_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r209495_)))
            _r209495_
            (std/crypto/etc#raise-libcrypto-error _ctx209487_)))))
  (define std/crypto/cipher#cipher-final!
    (lambda (_ctx209480_ _out209481_ _out-start209482_ _EVP-final209483_)
      (let ((_r209485_
             (_EVP-final209483_ _ctx209480_ _out209481_ _out-start209482_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r209485_)))
            _r209485_
            (std/crypto/etc#raise-libcrypto-error _ctx209480_)))))
  (define std/crypto/cipher#encrypt-init!
    (lambda (_cipher209476_ _key209477_ _iv209478_)
      (std/crypto/cipher#cipher-init!
       _cipher209476_
       _key209477_
       _iv209478_
       std/crypto/libcrypto#EVP_EncryptInit)))
  (define std/crypto/cipher#encrypt-update!
    (lambda (_cipher209469_
             _out209470_
             _out-start209471_
             _in209472_
             _start209473_
             _end209474_)
      (std/crypto/cipher#cipher-update!
       (std/crypto/cipher#cipher-context _cipher209469_)
       _out209470_
       _out-start209471_
       _in209472_
       _start209473_
       _end209474_
       std/crypto/libcrypto#EVP_EncryptUpdate)))
  (define std/crypto/cipher#encrypt-final!__%
    (lambda (_cipher209451_ _out209452_ _out-start209453_)
      (let ((_olen209455_
             (std/crypto/cipher#cipher-final!
              (std/crypto/cipher#cipher-context _cipher209451_)
              _out209452_
              _out-start209453_
              std/crypto/libcrypto#EVP_EncryptFinal)))
        (##structure-set!
         _cipher209451_
         '#f
         '2
         std/crypto/cipher#cipher::t
         '#f)
        _olen209455_)))
  (define std/crypto/cipher#encrypt-final!__0
    (lambda (_cipher209460_ _out209461_)
      (let ((_out-start209463_ '0))
        (std/crypto/cipher#encrypt-final!__%
         _cipher209460_
         _out209461_
         _out-start209463_))))
  (define std/crypto/cipher#encrypt-final!
    (lambda _g301601_
      (let ((_g301600_ (let () (declare (not safe)) (##length _g301601_))))
        (cond ((let () (declare (not safe)) (##fx= _g301600_ 2))
               (apply std/crypto/cipher#encrypt-final!__0 _g301601_))
              ((let () (declare (not safe)) (##fx= _g301600_ 3))
               (apply std/crypto/cipher#encrypt-final!__% _g301601_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#encrypt-final!
                _g301601_))))))
  (define std/crypto/cipher#decrypt-init!
    (lambda (_cipher209446_ _key209447_ _iv209448_)
      (std/crypto/cipher#cipher-init!
       _cipher209446_
       _key209447_
       _iv209448_
       std/crypto/libcrypto#EVP_DecryptInit)))
  (define std/crypto/cipher#decrypt-update!
    (lambda (_cipher209439_
             _out209440_
             _out-start209441_
             _in209442_
             _start209443_
             _end209444_)
      (std/crypto/cipher#cipher-update!
       (std/crypto/cipher#cipher-context _cipher209439_)
       _out209440_
       _out-start209441_
       _in209442_
       _start209443_
       _end209444_
       std/crypto/libcrypto#EVP_DecryptUpdate)))
  (define std/crypto/cipher#decrypt-final!__%
    (lambda (_cipher209421_ _out209422_ _out-start209423_)
      (let ((_olen209425_
             (std/crypto/cipher#cipher-final!
              (std/crypto/cipher#cipher-context _cipher209421_)
              _out209422_
              _out-start209423_
              std/crypto/libcrypto#EVP_DecryptFinal)))
        (##structure-set!
         _cipher209421_
         '#f
         '2
         std/crypto/cipher#cipher::t
         '#f)
        _olen209425_)))
  (define std/crypto/cipher#decrypt-final!__0
    (lambda (_cipher209430_ _out209431_)
      (let ((_out-start209433_ '0))
        (std/crypto/cipher#decrypt-final!__%
         _cipher209430_
         _out209431_
         _out-start209433_))))
  (define std/crypto/cipher#decrypt-final!
    (lambda _g301603_
      (let ((_g301602_ (let () (declare (not safe)) (##length _g301603_))))
        (cond ((let () (declare (not safe)) (##fx= _g301602_ 2))
               (apply std/crypto/cipher#decrypt-final!__0 _g301603_))
              ((let () (declare (not safe)) (##fx= _g301602_ 3))
               (apply std/crypto/cipher#decrypt-final!__% _g301603_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#decrypt-final!
                _g301603_))))))
  (define std/crypto/cipher#encrypt
    (lambda (_cipher209415_ _key209416_ _iv209417_ _in209418_)
      (if (string? _in209418_)
          (std/crypto/cipher#encrypt-u8vector__0
           _cipher209415_
           _key209416_
           _iv209417_
           (std/text/utf8#string->utf8__0 _in209418_))
          (if (u8vector? _in209418_)
              (std/crypto/cipher#encrypt-u8vector__0
               _cipher209415_
               _key209416_
               _iv209417_
               _in209418_)
              (if (input-port? _in209418_)
                  (std/crypto/cipher#encrypt-port
                   _cipher209415_
                   _key209416_
                   _iv209417_
                   _in209418_)
                  (error '"Bad input source" _in209418_))))))
  (define std/crypto/cipher#encrypt-u8vector__%
    (lambda (_cipher209361_
             _key209362_
             _iv209363_
             _in209364_
             _start209365_
             _end209366_)
      (let* ((_len209368_
              (let () (declare (not safe)) (##fx- _end209366_ _start209365_)))
             (_buflen209371_
              (let ((__tmp301604
                     (let ((__tmp301605
                            (std/crypto/cipher#cipher-block-size
                             _cipher209361_)))
                       (declare (not safe))
                       (##fx* '2 __tmp301605))))
                (declare (not safe))
                (##fx+ _len209368_ __tmp301604)))
             (_buf209374_ (make-u8vector _buflen209371_)))
        (std/crypto/cipher#encrypt-init! _cipher209361_ _key209362_ _iv209363_)
        (let* ((_ulen209378_
                (std/crypto/cipher#encrypt-update!
                 _cipher209361_
                 _buf209374_
                 '0
                 _in209364_
                 _start209365_
                 _end209366_))
               (_flen209381_
                (std/crypto/cipher#encrypt-final!__%
                 _cipher209361_
                 _buf209374_
                 _ulen209378_))
               (_olen209384_
                (let ()
                  (declare (not safe))
                  (##fx+ _ulen209378_ _flen209381_))))
          (if (let () (declare (not safe)) (##fx< _olen209384_ _buflen209371_))
              (u8vector-shrink! _buf209374_ _olen209384_)
              '#!void)
          _buf209374_))))
  (define std/crypto/cipher#encrypt-u8vector__0
    (lambda (_cipher209391_ _key209392_ _iv209393_ _in209394_)
      (let* ((_start209396_ '0) (_end209398_ (u8vector-length _in209394_)))
        (std/crypto/cipher#encrypt-u8vector__%
         _cipher209391_
         _key209392_
         _iv209393_
         _in209394_
         _start209396_
         _end209398_))))
  (define std/crypto/cipher#encrypt-u8vector__1
    (lambda (_cipher209400_ _key209401_ _iv209402_ _in209403_ _start209404_)
      (let ((_end209406_ (u8vector-length _in209403_)))
        (std/crypto/cipher#encrypt-u8vector__%
         _cipher209400_
         _key209401_
         _iv209402_
         _in209403_
         _start209404_
         _end209406_))))
  (define std/crypto/cipher#encrypt-u8vector
    (lambda _g301607_
      (let ((_g301606_ (let () (declare (not safe)) (##length _g301607_))))
        (cond ((let () (declare (not safe)) (##fx= _g301606_ 4))
               (apply std/crypto/cipher#encrypt-u8vector__0 _g301607_))
              ((let () (declare (not safe)) (##fx= _g301606_ 5))
               (apply std/crypto/cipher#encrypt-u8vector__1 _g301607_))
              ((let () (declare (not safe)) (##fx= _g301606_ 6))
               (apply std/crypto/cipher#encrypt-u8vector__% _g301607_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#encrypt-u8vector
                _g301607_))))))
  (define std/crypto/cipher#encrypt-u8vector!
    (lambda (_cipher209345_
             _key209346_
             _iv209347_
             _bytes209348_
             _start209349_
             _end209350_
             _buf209351_)
      (std/crypto/cipher#encrypt-init! _cipher209345_ _key209346_ _iv209347_)
      (let* ((_ulen209353_
              (std/crypto/cipher#encrypt-update!
               _cipher209345_
               _buf209351_
               '0
               _bytes209348_
               _start209349_
               _end209350_))
             (_flen209355_
              (std/crypto/cipher#encrypt-final!__%
               _cipher209345_
               _buf209351_
               _ulen209353_))
             (_olen209357_
              (let () (declare (not safe)) (##fx+ _ulen209353_ _flen209355_))))
        _olen209357_)))
  (define std/crypto/cipher#encrypt-port
    (lambda (_cipher209309_ _key209310_ _iv209311_ _inp209312_)
      (let* ((_bufsz209314_ '1024)
             (_buf209317_
              (make-u8vector
               (let ((__tmp301608
                      (std/crypto/cipher#cipher-block-size _cipher209309_)))
                 (declare (not safe))
                 (##fx+ _bufsz209314_ __tmp301608))))
             (_outp209320_ (open-output-u8vector)))
        (letrec ((_grow-buffer-if-needed209324_
                  (lambda (_ilen209339_)
                    (let ((_max-olen209342_
                           (let ((__tmp301609
                                  (std/crypto/cipher#cipher-block-size
                                   _cipher209309_)))
                             (declare (not safe))
                             (##fx+ _ilen209339_ __tmp301609))))
                      (if (let ((__tmp301610 (u8vector-length _buf209317_)))
                            (declare (not safe))
                            (##fx> _max-olen209342_ __tmp301610))
                          (set! _buf209317_ (make-u8vector _max-olen209342_))
                          '#!void)))))
          (std/crypto/cipher#encrypt-init!
           _cipher209309_
           _key209310_
           _iv209311_)
          (std/crypto/etc#call-with-binary-input
           (lambda (_bytes209327_ _start209329_ _end209331_)
             (_grow-buffer-if-needed209324_ (- _end209331_ _start209329_))
             (let ((_olen209334_
                    (std/crypto/cipher#encrypt-update!
                     _cipher209309_
                     _buf209317_
                     '0
                     _bytes209327_
                     _start209329_
                     _end209331_)))
               (write-subu8vector _buf209317_ '0 _olen209334_ _outp209320_)))
           _inp209312_)
          (let ((_olen209337_
                 (std/crypto/cipher#encrypt-final!__0
                  _cipher209309_
                  _buf209317_)))
            (write-subu8vector _buf209317_ '0 _olen209337_ _outp209320_)
            (get-output-u8vector _outp209320_))))))
  (define std/crypto/cipher#decrypt
    (lambda (_cipher209304_ _key209305_ _iv209306_ _in209307_)
      (if (u8vector? _in209307_)
          (std/crypto/cipher#decrypt-u8vector__0
           _cipher209304_
           _key209305_
           _iv209306_
           _in209307_)
          (if (input-port? _in209307_)
              (std/crypto/cipher#decrypt-port
               _cipher209304_
               _key209305_
               _iv209306_
               _in209307_)
              (error '"Bad input source" _in209307_)))))
  (define std/crypto/cipher#decrypt-u8vector__%
    (lambda (_cipher209250_
             _key209251_
             _iv209252_
             _in209253_
             _start209254_
             _end209255_)
      (let* ((_len209257_
              (let () (declare (not safe)) (##fx- _end209255_ _start209254_)))
             (_buflen209260_
              (let ((__tmp301611
                     (let ((__tmp301612
                            (std/crypto/cipher#cipher-block-size
                             _cipher209250_)))
                       (declare (not safe))
                       (##fx* '2 __tmp301612))))
                (declare (not safe))
                (##fx+ _len209257_ __tmp301611)))
             (_buf209263_ (make-u8vector _buflen209260_)))
        (std/crypto/cipher#decrypt-init! _cipher209250_ _key209251_ _iv209252_)
        (let* ((_ulen209267_
                (std/crypto/cipher#decrypt-update!
                 _cipher209250_
                 _buf209263_
                 '0
                 _in209253_
                 _start209254_
                 _end209255_))
               (_flen209270_
                (std/crypto/cipher#decrypt-final!__%
                 _cipher209250_
                 _buf209263_
                 _ulen209267_))
               (_olen209273_
                (let ()
                  (declare (not safe))
                  (##fx+ _ulen209267_ _flen209270_))))
          (if (let () (declare (not safe)) (##fx< _olen209273_ _buflen209260_))
              (u8vector-shrink! _buf209263_ _olen209273_)
              '#!void)
          _buf209263_))))
  (define std/crypto/cipher#decrypt-u8vector__0
    (lambda (_cipher209280_ _key209281_ _iv209282_ _in209283_)
      (let* ((_start209285_ '0) (_end209287_ (u8vector-length _in209283_)))
        (std/crypto/cipher#decrypt-u8vector__%
         _cipher209280_
         _key209281_
         _iv209282_
         _in209283_
         _start209285_
         _end209287_))))
  (define std/crypto/cipher#decrypt-u8vector__1
    (lambda (_cipher209289_ _key209290_ _iv209291_ _in209292_ _start209293_)
      (let ((_end209295_ (u8vector-length _in209292_)))
        (std/crypto/cipher#decrypt-u8vector__%
         _cipher209289_
         _key209290_
         _iv209291_
         _in209292_
         _start209293_
         _end209295_))))
  (define std/crypto/cipher#decrypt-u8vector
    (lambda _g301614_
      (let ((_g301613_ (let () (declare (not safe)) (##length _g301614_))))
        (cond ((let () (declare (not safe)) (##fx= _g301613_ 4))
               (apply std/crypto/cipher#decrypt-u8vector__0 _g301614_))
              ((let () (declare (not safe)) (##fx= _g301613_ 5))
               (apply std/crypto/cipher#decrypt-u8vector__1 _g301614_))
              ((let () (declare (not safe)) (##fx= _g301613_ 6))
               (apply std/crypto/cipher#decrypt-u8vector__% _g301614_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#decrypt-u8vector
                _g301614_))))))
  (define std/crypto/cipher#decrypt-u8vector!
    (lambda (_cipher209234_
             _key209235_
             _iv209236_
             _bytes209237_
             _start209238_
             _end209239_
             _buf209240_)
      (std/crypto/cipher#decrypt-init! _cipher209234_ _key209235_ _iv209236_)
      (let* ((_ulen209242_
              (std/crypto/cipher#decrypt-update!
               _cipher209234_
               _buf209240_
               '0
               _bytes209237_
               _start209238_
               _end209239_))
             (_flen209244_
              (std/crypto/cipher#decrypt-final!__%
               _cipher209234_
               _buf209240_
               _ulen209242_))
             (_olen209246_
              (let () (declare (not safe)) (##fx+ _ulen209242_ _flen209244_))))
        _olen209246_)))
  (define std/crypto/cipher#decrypt-port
    (lambda (_cipher209198_ _key209199_ _iv209200_ _inp209201_)
      (let* ((_bufsz209203_ '1024)
             (_buf209206_
              (make-u8vector
               (let ((__tmp301615
                      (std/crypto/cipher#cipher-block-size _cipher209198_)))
                 (declare (not safe))
                 (##fx+ _bufsz209203_ __tmp301615))))
             (_outp209209_ (open-output-u8vector)))
        (letrec ((_grow-buffer-if-needed209213_
                  (lambda (_ilen209228_)
                    (let ((_max-olen209231_
                           (let ((__tmp301616
                                  (std/crypto/cipher#cipher-block-size
                                   _cipher209198_)))
                             (declare (not safe))
                             (##fx+ _ilen209228_ __tmp301616))))
                      (if (let ((__tmp301617 (u8vector-length _buf209206_)))
                            (declare (not safe))
                            (##fx> _max-olen209231_ __tmp301617))
                          (set! _buf209206_ (make-u8vector _max-olen209231_))
                          '#!void)))))
          (std/crypto/cipher#decrypt-init!
           _cipher209198_
           _key209199_
           _iv209200_)
          (std/crypto/etc#call-with-binary-input
           (lambda (_bytes209216_ _start209218_ _end209220_)
             (_grow-buffer-if-needed209213_ (- _end209220_ _start209218_))
             (let ((_olen209223_
                    (std/crypto/cipher#decrypt-update!
                     _cipher209198_
                     _buf209206_
                     '0
                     _bytes209216_
                     _start209218_
                     _end209220_)))
               (write-subu8vector _buf209206_ '0 _olen209223_ _outp209209_)))
           _inp209201_)
          (let ((_olen209226_
                 (std/crypto/cipher#decrypt-final!__0
                  _cipher209198_
                  _buf209206_)))
            (write-subu8vector _buf209206_ '0 _olen209226_ _outp209209_)
            (get-output-u8vector _outp209209_))))))
  (define std/crypto/cipher#cipher::aes-128-ecb
    (std/crypto/libcrypto#EVP_aes_128_ecb))
  (define std/crypto/cipher#make-aes-128-ecb-cipher
    (lambda ()
      (let ((__obj301555 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301555
         std/crypto/cipher#cipher::aes-128-ecb)
        __obj301555)))
  (define std/crypto/cipher#aes-128-ecb-cipher?
    (lambda (_obj209195_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209195_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209195_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-cbc
    (std/crypto/libcrypto#EVP_aes_128_cbc))
  (define std/crypto/cipher#make-aes-128-cbc-cipher
    (lambda ()
      (let ((__obj301556 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301556
         std/crypto/cipher#cipher::aes-128-cbc)
        __obj301556)))
  (define std/crypto/cipher#aes-128-cbc-cipher?
    (lambda (_obj209192_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209192_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209192_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-cfb
    (std/crypto/libcrypto#EVP_aes_128_cfb))
  (define std/crypto/cipher#make-aes-128-cfb-cipher
    (lambda ()
      (let ((__obj301557 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301557
         std/crypto/cipher#cipher::aes-128-cfb)
        __obj301557)))
  (define std/crypto/cipher#aes-128-cfb-cipher?
    (lambda (_obj209189_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209189_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209189_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ofb
    (std/crypto/libcrypto#EVP_aes_128_ofb))
  (define std/crypto/cipher#make-aes-128-ofb-cipher
    (lambda ()
      (let ((__obj301558 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301558
         std/crypto/cipher#cipher::aes-128-ofb)
        __obj301558)))
  (define std/crypto/cipher#aes-128-ofb-cipher?
    (lambda (_obj209186_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209186_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209186_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ctr
    (std/crypto/libcrypto#EVP_aes_128_ctr))
  (define std/crypto/cipher#make-aes-128-ctr-cipher
    (lambda ()
      (let ((__obj301559 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301559
         std/crypto/cipher#cipher::aes-128-ctr)
        __obj301559)))
  (define std/crypto/cipher#aes-128-ctr-cipher?
    (lambda (_obj209183_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209183_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209183_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ccm
    (std/crypto/libcrypto#EVP_aes_128_ccm))
  (define std/crypto/cipher#make-aes-128-ccm-cipher
    (lambda ()
      (let ((__obj301560 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301560
         std/crypto/cipher#cipher::aes-128-ccm)
        __obj301560)))
  (define std/crypto/cipher#aes-128-ccm-cipher?
    (lambda (_obj209180_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209180_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209180_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-gcm
    (std/crypto/libcrypto#EVP_aes_128_gcm))
  (define std/crypto/cipher#make-aes-128-gcm-cipher
    (lambda ()
      (let ((__obj301561 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301561
         std/crypto/cipher#cipher::aes-128-gcm)
        __obj301561)))
  (define std/crypto/cipher#aes-128-gcm-cipher?
    (lambda (_obj209177_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209177_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209177_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-xts
    (std/crypto/libcrypto#EVP_aes_128_xts))
  (define std/crypto/cipher#make-aes-128-xts-cipher
    (lambda ()
      (let ((__obj301562 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301562
         std/crypto/cipher#cipher::aes-128-xts)
        __obj301562)))
  (define std/crypto/cipher#aes-128-xts-cipher?
    (lambda (_obj209173_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209173_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209173_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-xts))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ecb
    (std/crypto/libcrypto#EVP_aes_192_ecb))
  (define std/crypto/cipher#make-aes-192-ecb-cipher
    (lambda ()
      (let ((__obj301563 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301563
         std/crypto/cipher#cipher::aes-192-ecb)
        __obj301563)))
  (define std/crypto/cipher#aes-192-ecb-cipher?
    (lambda (_obj209170_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209170_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209170_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-cbc
    (std/crypto/libcrypto#EVP_aes_192_cbc))
  (define std/crypto/cipher#make-aes-192-cbc-cipher
    (lambda ()
      (let ((__obj301564 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301564
         std/crypto/cipher#cipher::aes-192-cbc)
        __obj301564)))
  (define std/crypto/cipher#aes-192-cbc-cipher?
    (lambda (_obj209167_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209167_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209167_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-cfb
    (std/crypto/libcrypto#EVP_aes_192_cfb))
  (define std/crypto/cipher#make-aes-192-cfb-cipher
    (lambda ()
      (let ((__obj301565 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301565
         std/crypto/cipher#cipher::aes-192-cfb)
        __obj301565)))
  (define std/crypto/cipher#aes-192-cfb-cipher?
    (lambda (_obj209164_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209164_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209164_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ofb
    (std/crypto/libcrypto#EVP_aes_192_ofb))
  (define std/crypto/cipher#make-aes-192-ofb-cipher
    (lambda ()
      (let ((__obj301566 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301566
         std/crypto/cipher#cipher::aes-192-ofb)
        __obj301566)))
  (define std/crypto/cipher#aes-192-ofb-cipher?
    (lambda (_obj209161_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209161_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209161_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ctr
    (std/crypto/libcrypto#EVP_aes_192_ctr))
  (define std/crypto/cipher#make-aes-192-ctr-cipher
    (lambda ()
      (let ((__obj301567 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301567
         std/crypto/cipher#cipher::aes-192-ctr)
        __obj301567)))
  (define std/crypto/cipher#aes-192-ctr-cipher?
    (lambda (_obj209158_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209158_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209158_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ccm
    (std/crypto/libcrypto#EVP_aes_192_ccm))
  (define std/crypto/cipher#make-aes-192-ccm-cipher
    (lambda ()
      (let ((__obj301568 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301568
         std/crypto/cipher#cipher::aes-192-ccm)
        __obj301568)))
  (define std/crypto/cipher#aes-192-ccm-cipher?
    (lambda (_obj209155_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209155_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209155_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-gcm
    (std/crypto/libcrypto#EVP_aes_192_gcm))
  (define std/crypto/cipher#make-aes-192-gcm-cipher
    (lambda ()
      (let ((__obj301569 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301569
         std/crypto/cipher#cipher::aes-192-gcm)
        __obj301569)))
  (define std/crypto/cipher#aes-192-gcm-cipher?
    (lambda (_obj209151_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209151_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209151_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ecb
    (std/crypto/libcrypto#EVP_aes_256_ecb))
  (define std/crypto/cipher#make-aes-256-ecb-cipher
    (lambda ()
      (let ((__obj301570 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301570
         std/crypto/cipher#cipher::aes-256-ecb)
        __obj301570)))
  (define std/crypto/cipher#aes-256-ecb-cipher?
    (lambda (_obj209148_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209148_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209148_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-cbc
    (std/crypto/libcrypto#EVP_aes_256_cbc))
  (define std/crypto/cipher#make-aes-256-cbc-cipher
    (lambda ()
      (let ((__obj301571 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301571
         std/crypto/cipher#cipher::aes-256-cbc)
        __obj301571)))
  (define std/crypto/cipher#aes-256-cbc-cipher?
    (lambda (_obj209145_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209145_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209145_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-cfb
    (std/crypto/libcrypto#EVP_aes_256_cfb))
  (define std/crypto/cipher#make-aes-256-cfb-cipher
    (lambda ()
      (let ((__obj301572 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301572
         std/crypto/cipher#cipher::aes-256-cfb)
        __obj301572)))
  (define std/crypto/cipher#aes-256-cfb-cipher?
    (lambda (_obj209142_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209142_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209142_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ofb
    (std/crypto/libcrypto#EVP_aes_256_ofb))
  (define std/crypto/cipher#make-aes-256-ofb-cipher
    (lambda ()
      (let ((__obj301573 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301573
         std/crypto/cipher#cipher::aes-256-ofb)
        __obj301573)))
  (define std/crypto/cipher#aes-256-ofb-cipher?
    (lambda (_obj209139_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209139_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209139_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ctr
    (std/crypto/libcrypto#EVP_aes_256_ctr))
  (define std/crypto/cipher#make-aes-256-ctr-cipher
    (lambda ()
      (let ((__obj301574 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301574
         std/crypto/cipher#cipher::aes-256-ctr)
        __obj301574)))
  (define std/crypto/cipher#aes-256-ctr-cipher?
    (lambda (_obj209136_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209136_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209136_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ccm
    (std/crypto/libcrypto#EVP_aes_256_ccm))
  (define std/crypto/cipher#make-aes-256-ccm-cipher
    (lambda ()
      (let ((__obj301575 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301575
         std/crypto/cipher#cipher::aes-256-ccm)
        __obj301575)))
  (define std/crypto/cipher#aes-256-ccm-cipher?
    (lambda (_obj209133_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209133_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209133_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-gcm
    (std/crypto/libcrypto#EVP_aes_256_gcm))
  (define std/crypto/cipher#make-aes-256-gcm-cipher
    (lambda ()
      (let ((__obj301576 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301576
         std/crypto/cipher#cipher::aes-256-gcm)
        __obj301576)))
  (define std/crypto/cipher#aes-256-gcm-cipher?
    (lambda (_obj209130_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209130_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209130_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-xts
    (std/crypto/libcrypto#EVP_aes_256_xts))
  (define std/crypto/cipher#make-aes-256-xts-cipher
    (lambda ()
      (let ((__obj301577 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301577
         std/crypto/cipher#cipher::aes-256-xts)
        __obj301577)))
  (define std/crypto/cipher#aes-256-xts-cipher?
    (lambda (_obj209126_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209126_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209126_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-xts))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-ecb
    (std/crypto/libcrypto#EVP_camellia_128_ecb))
  (define std/crypto/cipher#make-camellia-128-ecb-cipher
    (lambda ()
      (let ((__obj301578 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301578
         std/crypto/cipher#cipher::camellia-128-ecb)
        __obj301578)))
  (define std/crypto/cipher#camellia-128-ecb-cipher?
    (lambda (_obj209123_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209123_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209123_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-cbc
    (std/crypto/libcrypto#EVP_camellia_128_cbc))
  (define std/crypto/cipher#make-camellia-128-cbc-cipher
    (lambda ()
      (let ((__obj301579 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301579
         std/crypto/cipher#cipher::camellia-128-cbc)
        __obj301579)))
  (define std/crypto/cipher#camellia-128-cbc-cipher?
    (lambda (_obj209120_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209120_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209120_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-cfb
    (std/crypto/libcrypto#EVP_camellia_128_cfb))
  (define std/crypto/cipher#make-camellia-128-cfb-cipher
    (lambda ()
      (let ((__obj301580 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301580
         std/crypto/cipher#cipher::camellia-128-cfb)
        __obj301580)))
  (define std/crypto/cipher#camellia-128-cfb-cipher?
    (lambda (_obj209117_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209117_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209117_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-ofb
    (std/crypto/libcrypto#EVP_camellia_128_ofb))
  (define std/crypto/cipher#make-camellia-128-ofb-cipher
    (lambda ()
      (let ((__obj301581 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301581
         std/crypto/cipher#cipher::camellia-128-ofb)
        __obj301581)))
  (define std/crypto/cipher#camellia-128-ofb-cipher?
    (lambda (_obj209113_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209113_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209113_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-ecb
    (std/crypto/libcrypto#EVP_camellia_192_ecb))
  (define std/crypto/cipher#make-camellia-192-ecb-cipher
    (lambda ()
      (let ((__obj301582 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301582
         std/crypto/cipher#cipher::camellia-192-ecb)
        __obj301582)))
  (define std/crypto/cipher#camellia-192-ecb-cipher?
    (lambda (_obj209110_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209110_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209110_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-cbc
    (std/crypto/libcrypto#EVP_camellia_192_cbc))
  (define std/crypto/cipher#make-camellia-192-cbc-cipher
    (lambda ()
      (let ((__obj301583 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301583
         std/crypto/cipher#cipher::camellia-192-cbc)
        __obj301583)))
  (define std/crypto/cipher#camellia-192-cbc-cipher?
    (lambda (_obj209107_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209107_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209107_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-cfb
    (std/crypto/libcrypto#EVP_camellia_192_cfb))
  (define std/crypto/cipher#make-camellia-192-cfb-cipher
    (lambda ()
      (let ((__obj301584 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301584
         std/crypto/cipher#cipher::camellia-192-cfb)
        __obj301584)))
  (define std/crypto/cipher#camellia-192-cfb-cipher?
    (lambda (_obj209104_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209104_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209104_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-ofb
    (std/crypto/libcrypto#EVP_camellia_192_ofb))
  (define std/crypto/cipher#make-camellia-192-ofb-cipher
    (lambda ()
      (let ((__obj301585 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301585
         std/crypto/cipher#cipher::camellia-192-ofb)
        __obj301585)))
  (define std/crypto/cipher#camellia-192-ofb-cipher?
    (lambda (_obj209100_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209100_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209100_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-ecb
    (std/crypto/libcrypto#EVP_camellia_256_ecb))
  (define std/crypto/cipher#make-camellia-256-ecb-cipher
    (lambda ()
      (let ((__obj301586 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301586
         std/crypto/cipher#cipher::camellia-256-ecb)
        __obj301586)))
  (define std/crypto/cipher#camellia-256-ecb-cipher?
    (lambda (_obj209097_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209097_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209097_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-cbc
    (std/crypto/libcrypto#EVP_camellia_256_cbc))
  (define std/crypto/cipher#make-camellia-256-cbc-cipher
    (lambda ()
      (let ((__obj301587 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301587
         std/crypto/cipher#cipher::camellia-256-cbc)
        __obj301587)))
  (define std/crypto/cipher#camellia-256-cbc-cipher?
    (lambda (_obj209094_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209094_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209094_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-cfb
    (std/crypto/libcrypto#EVP_camellia_256_cfb))
  (define std/crypto/cipher#make-camellia-256-cfb-cipher
    (lambda ()
      (let ((__obj301588 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301588
         std/crypto/cipher#cipher::camellia-256-cfb)
        __obj301588)))
  (define std/crypto/cipher#camellia-256-cfb-cipher?
    (lambda (_obj209091_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209091_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209091_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-ofb
    (std/crypto/libcrypto#EVP_camellia_256_ofb))
  (define std/crypto/cipher#make-camellia-256-ofb-cipher
    (lambda ()
      (let ((__obj301589 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301589
         std/crypto/cipher#cipher::camellia-256-ofb)
        __obj301589)))
  (define std/crypto/cipher#camellia-256-ofb-cipher?
    (lambda (_obj209087_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209087_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209087_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-ecb
    (std/crypto/libcrypto#EVP_cast5_ecb))
  (define std/crypto/cipher#make-cast5-ecb-cipher
    (lambda ()
      (let ((__obj301590 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301590
         std/crypto/cipher#cipher::cast5-ecb)
        __obj301590)))
  (define std/crypto/cipher#cast5-ecb-cipher?
    (lambda (_obj209084_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209084_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209084_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-cbc
    (std/crypto/libcrypto#EVP_cast5_cbc))
  (define std/crypto/cipher#make-cast5-cbc-cipher
    (lambda ()
      (let ((__obj301591 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301591
         std/crypto/cipher#cipher::cast5-cbc)
        __obj301591)))
  (define std/crypto/cipher#cast5-cbc-cipher?
    (lambda (_obj209081_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209081_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209081_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-cfb
    (std/crypto/libcrypto#EVP_cast5_cfb))
  (define std/crypto/cipher#make-cast5-cfb-cipher
    (lambda ()
      (let ((__obj301592 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301592
         std/crypto/cipher#cipher::cast5-cfb)
        __obj301592)))
  (define std/crypto/cipher#cast5-cfb-cipher?
    (lambda (_obj209078_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209078_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209078_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-ofb
    (std/crypto/libcrypto#EVP_cast5_ofb))
  (define std/crypto/cipher#make-cast5-ofb-cipher
    (lambda ()
      (let ((__obj301593 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301593
         std/crypto/cipher#cipher::cast5-ofb)
        __obj301593)))
  (define std/crypto/cipher#cast5-ofb-cipher?
    (lambda (_obj209074_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209074_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209074_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-ecb (std/crypto/libcrypto#EVP_bf_ecb))
  (define std/crypto/cipher#make-bf-ecb-cipher
    (lambda ()
      (let ((__obj301594 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301594
         std/crypto/cipher#cipher::bf-ecb)
        __obj301594)))
  (define std/crypto/cipher#bf-ecb-cipher?
    (lambda (_obj209071_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209071_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209071_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-cbc (std/crypto/libcrypto#EVP_bf_cbc))
  (define std/crypto/cipher#make-bf-cbc-cipher
    (lambda ()
      (let ((__obj301595 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301595
         std/crypto/cipher#cipher::bf-cbc)
        __obj301595)))
  (define std/crypto/cipher#bf-cbc-cipher?
    (lambda (_obj209068_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209068_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209068_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::bf-cfb (std/crypto/libcrypto#EVP_bf_cfb))
  (define std/crypto/cipher#make-bf-cfb-cipher
    (lambda ()
      (let ((__obj301596 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301596
         std/crypto/cipher#cipher::bf-cfb)
        __obj301596)))
  (define std/crypto/cipher#bf-cfb-cipher?
    (lambda (_obj209065_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209065_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209065_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-ofb (std/crypto/libcrypto#EVP_bf_ofb))
  (define std/crypto/cipher#make-bf-ofb-cipher
    (lambda ()
      (let ((__obj301597 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301597
         std/crypto/cipher#cipher::bf-ofb)
        __obj301597)))
  (define std/crypto/cipher#bf-ofb-cipher?
    (lambda (_obj209061_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209061_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209061_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::rc4 (std/crypto/libcrypto#EVP_rc4))
  (define std/crypto/cipher#make-rc4-cipher
    (lambda ()
      (let ((__obj301598 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301598
         std/crypto/cipher#cipher::rc4)
        __obj301598)))
  (define std/crypto/cipher#rc4-cipher?
    (lambda (_obj209057_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209057_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209057_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::rc4))
          '#f))))
