(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/dh#with-null-check
    (lambda (_makef210166_)
      (let ((_$e210168_ (_makef210166_)))
        (if _$e210168_
            _$e210168_
            (error '"error allocating key; NULL POINTER")))))
  (define std/crypto/dh#DH-get-1024-160
    (lambda ()
      (std/crypto/dh#with-null-check std/crypto/libcrypto#DH_get_1024_160)))
  (define std/crypto/dh#DH-get-2048-224
    (lambda ()
      (std/crypto/dh#with-null-check std/crypto/libcrypto#DH_get_2048_224)))
  (define std/crypto/dh#DH-get-2048-256
    (lambda ()
      (std/crypto/dh#with-null-check std/crypto/libcrypto#DH_get_2048_256)))
  (define std/crypto/dh#DH-generate-key
    (lambda (_dh210158_)
      (let ((_res210160_ (std/crypto/libcrypto#DH_generate_key _dh210158_)))
        (if (let () (declare (not safe)) (##fxzero? _res210160_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/dh#DH-compute-key
    (lambda (_dh210148_ _bn210149_)
      (let* ((_len210151_ (std/crypto/libcrypto#DH_size _dh210148_))
             (_secret210153_ (make-u8vector _len210151_))
             (_count210155_
              (std/crypto/libcrypto#DH_compute_key
               _secret210153_
               _bn210149_
               _dh210148_)))
        (if (let () (declare (not safe)) (##fx< _count210155_ _len210151_))
            (u8vector-shrink! _secret210153_ _count210155_)
            '#!void)
        _secret210153_))))
