(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/digest#digest::t
    (make-struct-type
     'std/crypto#digest::t
     '#f
     '2
     'digest
     '()
     ':init!
     '(type ctx)))
  (define std/crypto/digest#digest?
    (make-struct-predicate std/crypto/digest#digest::t))
  (define std/crypto/digest#make-digest
    (lambda _$args174544_
      (apply make-struct-instance std/crypto/digest#digest::t _$args174544_)))
  (define std/crypto/digest#digest-type
    (make-struct-field-accessor std/crypto/digest#digest::t '0))
  (define std/crypto/digest#digest-ctx
    (make-struct-field-accessor std/crypto/digest#digest::t '1))
  (define std/crypto/digest#digest-type-set!
    (make-struct-field-mutator std/crypto/digest#digest::t '0))
  (define std/crypto/digest#digest-ctx-set!
    (make-struct-field-mutator std/crypto/digest#digest::t '1))
  (define std/crypto/digest#digest:::init!
    (lambda (_self174536_ _type174537_)
      (if (std/crypto/libcrypto#EVP_MD? _type174537_)
          '#!void
          (error '"Invalid digest type" _type174537_))
      (let ((_ctx174539_ (std/crypto/libcrypto#EVP_MD_CTX_create)))
        (if _ctx174539_ '#!void (error '"Failed to allocate digest context"))
        (let ((_res174541_
               (std/crypto/libcrypto#EVP_DigestInit _ctx174539_ _type174537_)))
          (if (let () (declare (not safe)) (##fxzero? _res174541_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        (if (let ((__tmp301454
                   (let ()
                     (declare (not safe))
                     (##vector-length _self174536_))))
              (declare (not safe))
              (##fx< '2 __tmp301454))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self174536_ '1 _type174537_))
              (let ()
                (declare (not safe))
                (##vector-set! _self174536_ '2 _ctx174539_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self174536_)))))
  (bind-method!
   std/crypto/digest#digest::t
   ':init!
   std/crypto/digest#digest:::init!
   '#f)
  (define std/crypto/digest#digest-size
    (lambda (_digest174412_)
      (if (std/crypto/libcrypto#EVP_MD? _digest174412_)
          (std/crypto/libcrypto#EVP_MD_size _digest174412_)
          (std/crypto/libcrypto#EVP_MD_size
           (##structure-ref
            _digest174412_
            '1
            std/crypto/digest#digest::t
            '#f)))))
  (define std/crypto/digest#digest-name
    (lambda (_digest174410_)
      (if (std/crypto/libcrypto#EVP_MD? _digest174410_)
          (std/crypto/libcrypto#EVP_MD_name _digest174410_)
          (std/crypto/libcrypto#EVP_MD_name
           (##structure-ref
            _digest174410_
            '1
            std/crypto/digest#digest::t
            '#f)))))
  (define std/crypto/digest#digest-copy
    (lambda (_digest174400_)
      (let* ((_ctx174402_ (std/crypto/digest#digest-context _digest174400_))
             (_copy174404_
              (let ((__obj301436 (make-object std/crypto/digest#digest::t '2)))
                (std/crypto/digest#digest:::init!
                 __obj301436
                 (##structure-ref
                  _digest174400_
                  '1
                  std/crypto/digest#digest::t
                  '#f))
                __obj301436)))
        (let ((_res174407_
               (std/crypto/libcrypto#EVP_MD_CTX_copy
                (##structure-ref
                 _copy174404_
                 '2
                 std/crypto/digest#digest::t
                 '#f)
                _ctx174402_)))
          (if (let () (declare (not safe)) (##fxzero? _res174407_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _copy174404_)))
  (define std/crypto/digest#digest-context
    (lambda (_digest174395_)
      (let ((_$e174397_
             (##structure-ref
              _digest174395_
              '2
              std/crypto/digest#digest::t
              '#f)))
        (if _$e174397_
            _$e174397_
            (error '"Digest has been finalized" _digest174395_)))))
  (define std/crypto/digest#digest-update!__%
    (lambda (_digest174355_ _bytes174356_ _start174357_ _end174358_)
      (let* ((_start174363_
              (let ((_$e174360_ _start174357_)) (if _$e174360_ _$e174360_ '0)))
             (_end174368_
              (let ((_$e174365_ _end174358_))
                (if _$e174365_ _$e174365_ (u8vector-length _bytes174356_)))))
        (let ((_res174371_
               (std/crypto/libcrypto#EVP_DigestUpdate
                (std/crypto/digest#digest-context _digest174355_)
                _bytes174356_
                _start174363_
                _end174368_)))
          (if (let () (declare (not safe)) (##fxzero? _res174371_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void)))))
  (define std/crypto/digest#digest-update!__0
    (lambda (_digest174377_ _bytes174378_)
      (let* ((_start174380_ '#f) (_end174382_ '#f))
        (std/crypto/digest#digest-update!__%
         _digest174377_
         _bytes174378_
         _start174380_
         _end174382_))))
  (define std/crypto/digest#digest-update!__1
    (lambda (_digest174384_ _bytes174385_ _start174386_)
      (let ((_end174388_ '#f))
        (std/crypto/digest#digest-update!__%
         _digest174384_
         _bytes174385_
         _start174386_
         _end174388_))))
  (define std/crypto/digest#digest-update!
    (lambda _g301456_
      (let ((_g301455_ (let () (declare (not safe)) (##length _g301456_))))
        (cond ((let () (declare (not safe)) (##fx= _g301455_ 2))
               (apply std/crypto/digest#digest-update!__0 _g301456_))
              ((let () (declare (not safe)) (##fx= _g301455_ 3))
               (apply std/crypto/digest#digest-update!__1 _g301456_))
              ((let () (declare (not safe)) (##fx= _g301455_ 4))
               (apply std/crypto/digest#digest-update!__% _g301456_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/digest#digest-update!
                _g301456_))))))
  (define std/crypto/digest#digest-update*
    (lambda (_digest174343_ _in174344_ . _args174345_)
      (apply std/crypto/etc#call-with-binary-input
             (lambda (_bytes174347_ _start174348_ _end174349_)
               (let ((_res174351_
                      (std/crypto/libcrypto#EVP_DigestUpdate
                       (std/crypto/digest#digest-context _digest174343_)
                       _bytes174347_
                       _start174348_
                       _end174349_)))
                 (if (let () (declare (not safe)) (##fxzero? _res174351_))
                     (apply std/crypto/etc#raise-libcrypto-error '())
                     '#!void)))
             _in174344_
             _args174345_)))
  (define std/crypto/digest#digest-final!__%
    (lambda (_digest174317_ _bytes174318_)
      (let* ((_ctx174320_ (std/crypto/digest#digest-context _digest174317_))
             (_size174322_ (std/crypto/libcrypto#EVP_MD_CTX_size _ctx174320_))
             (_bytes174327_
              (let ((_$e174324_ _bytes174318_))
                (if _$e174324_ _$e174324_ (make-u8vector _size174322_)))))
        (let ((_res174330_
               (std/crypto/libcrypto#EVP_DigestFinal
                _ctx174320_
                _bytes174327_)))
          (if (let () (declare (not safe)) (##fxzero? _res174330_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        (##structure-set!
         _digest174317_
         '#f
         '2
         std/crypto/digest#digest::t
         '#f)
        _bytes174327_)))
  (define std/crypto/digest#digest-final!__0
    (lambda (_digest174336_)
      (let ((_bytes174338_ '#f))
        (std/crypto/digest#digest-final!__% _digest174336_ _bytes174338_))))
  (define std/crypto/digest#digest-final!
    (lambda _g301458_
      (let ((_g301457_ (let () (declare (not safe)) (##length _g301458_))))
        (cond ((let () (declare (not safe)) (##fx= _g301457_ 1))
               (apply std/crypto/digest#digest-final!__0 _g301458_))
              ((let () (declare (not safe)) (##fx= _g301457_ 2))
               (apply std/crypto/digest#digest-final!__% _g301458_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/digest#digest-final!
                _g301458_))))))
  (define std/crypto/digest#digest::md5 (std/crypto/libcrypto#EVP_md5))
  (define std/crypto/digest#make-md5-digest
    (if std/crypto/digest#digest::md5
        (lambda ()
          (let ((__obj301437 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301437
             std/crypto/digest#digest::md5)
            __obj301437))
        '#f))
  (define std/crypto/digest#md5-digest?
    (if std/crypto/digest#digest::md5
        (lambda (_obj174312_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174312_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174312_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::md5))
              '#f))
        '#f))
  (define std/crypto/digest#md5
    (if std/crypto/digest#digest::md5
        (lambda _args174306_
          (let ((_digest174309_ (std/crypto/digest#make-md5-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174309_
                   _args174306_)
            (std/crypto/digest#digest-final!__0 _digest174309_)))
        '#f))
  (define std/crypto/digest#digest::sha1 (std/crypto/libcrypto#EVP_sha1))
  (define std/crypto/digest#make-sha1-digest
    (if std/crypto/digest#digest::sha1
        (lambda ()
          (let ((__obj301438 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301438
             std/crypto/digest#digest::sha1)
            __obj301438))
        '#f))
  (define std/crypto/digest#sha1-digest?
    (if std/crypto/digest#digest::sha1
        (lambda (_obj174302_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174302_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174302_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha1))
              '#f))
        '#f))
  (define std/crypto/digest#sha1
    (if std/crypto/digest#digest::sha1
        (lambda _args174296_
          (let ((_digest174299_ (std/crypto/digest#make-sha1-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174299_
                   _args174296_)
            (std/crypto/digest#digest-final!__0 _digest174299_)))
        '#f))
  (define std/crypto/digest#digest::sha224 (std/crypto/libcrypto#EVP_sha224))
  (define std/crypto/digest#make-sha224-digest
    (if std/crypto/digest#digest::sha224
        (lambda ()
          (let ((__obj301439 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301439
             std/crypto/digest#digest::sha224)
            __obj301439))
        '#f))
  (define std/crypto/digest#sha224-digest?
    (if std/crypto/digest#digest::sha224
        (lambda (_obj174292_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174292_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174292_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha224))
              '#f))
        '#f))
  (define std/crypto/digest#sha224
    (if std/crypto/digest#digest::sha224
        (lambda _args174286_
          (let ((_digest174289_ (std/crypto/digest#make-sha224-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174289_
                   _args174286_)
            (std/crypto/digest#digest-final!__0 _digest174289_)))
        '#f))
  (define std/crypto/digest#digest::sha256 (std/crypto/libcrypto#EVP_sha256))
  (define std/crypto/digest#make-sha256-digest
    (if std/crypto/digest#digest::sha256
        (lambda ()
          (let ((__obj301440 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301440
             std/crypto/digest#digest::sha256)
            __obj301440))
        '#f))
  (define std/crypto/digest#sha256-digest?
    (if std/crypto/digest#digest::sha256
        (lambda (_obj174282_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174282_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174282_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha256))
              '#f))
        '#f))
  (define std/crypto/digest#sha256
    (if std/crypto/digest#digest::sha256
        (lambda _args174276_
          (let ((_digest174279_ (std/crypto/digest#make-sha256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174279_
                   _args174276_)
            (std/crypto/digest#digest-final!__0 _digest174279_)))
        '#f))
  (define std/crypto/digest#digest::sha384 (std/crypto/libcrypto#EVP_sha384))
  (define std/crypto/digest#make-sha384-digest
    (if std/crypto/digest#digest::sha384
        (lambda ()
          (let ((__obj301441 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301441
             std/crypto/digest#digest::sha384)
            __obj301441))
        '#f))
  (define std/crypto/digest#sha384-digest?
    (if std/crypto/digest#digest::sha384
        (lambda (_obj174272_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174272_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174272_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha384))
              '#f))
        '#f))
  (define std/crypto/digest#sha384
    (if std/crypto/digest#digest::sha384
        (lambda _args174266_
          (let ((_digest174269_ (std/crypto/digest#make-sha384-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174269_
                   _args174266_)
            (std/crypto/digest#digest-final!__0 _digest174269_)))
        '#f))
  (define std/crypto/digest#digest::sha512 (std/crypto/libcrypto#EVP_sha512))
  (define std/crypto/digest#make-sha512-digest
    (if std/crypto/digest#digest::sha512
        (lambda ()
          (let ((__obj301442 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301442
             std/crypto/digest#digest::sha512)
            __obj301442))
        '#f))
  (define std/crypto/digest#sha512-digest?
    (if std/crypto/digest#digest::sha512
        (lambda (_obj174262_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174262_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174262_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha512))
              '#f))
        '#f))
  (define std/crypto/digest#sha512
    (if std/crypto/digest#digest::sha512
        (lambda _args174256_
          (let ((_digest174259_ (std/crypto/digest#make-sha512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174259_
                   _args174256_)
            (std/crypto/digest#digest-final!__0 _digest174259_)))
        '#f))
  (define std/crypto/digest#digest::ripemd160
    (std/crypto/libcrypto#EVP_ripemd160))
  (define std/crypto/digest#make-ripemd160-digest
    (if std/crypto/digest#digest::ripemd160
        (lambda ()
          (let ((__obj301443 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301443
             std/crypto/digest#digest::ripemd160)
            __obj301443))
        '#f))
  (define std/crypto/digest#ripemd160-digest?
    (if std/crypto/digest#digest::ripemd160
        (lambda (_obj174252_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174252_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174252_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::ripemd160))
              '#f))
        '#f))
  (define std/crypto/digest#ripemd160
    (if std/crypto/digest#digest::ripemd160
        (lambda _args174246_
          (let ((_digest174249_ (std/crypto/digest#make-ripemd160-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174249_
                   _args174246_)
            (std/crypto/digest#digest-final!__0 _digest174249_)))
        '#f))
  (define std/crypto/digest#digest::whirlpool
    (std/crypto/libcrypto#EVP_whirlpool))
  (define std/crypto/digest#make-whirlpool-digest
    (if std/crypto/digest#digest::whirlpool
        (lambda ()
          (let ((__obj301444 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301444
             std/crypto/digest#digest::whirlpool)
            __obj301444))
        '#f))
  (define std/crypto/digest#whirlpool-digest?
    (if std/crypto/digest#digest::whirlpool
        (lambda (_obj174242_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174242_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174242_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::whirlpool))
              '#f))
        '#f))
  (define std/crypto/digest#whirlpool
    (if std/crypto/digest#digest::whirlpool
        (lambda _args174236_
          (let ((_digest174239_ (std/crypto/digest#make-whirlpool-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174239_
                   _args174236_)
            (std/crypto/digest#digest-final!__0 _digest174239_)))
        '#f))
  (define std/crypto/digest#digest::blake2s256
    (std/crypto/libcrypto#EVP_blake2s256))
  (define std/crypto/digest#make-blake2s256-digest
    (if std/crypto/digest#digest::blake2s256
        (lambda ()
          (let ((__obj301445 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301445
             std/crypto/digest#digest::blake2s256)
            __obj301445))
        '#f))
  (define std/crypto/digest#blake2s256-digest?
    (if std/crypto/digest#digest::blake2s256
        (lambda (_obj174232_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174232_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174232_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::blake2s256))
              '#f))
        '#f))
  (define std/crypto/digest#blake2s256
    (if std/crypto/digest#digest::blake2s256
        (lambda _args174226_
          (let ((_digest174229_ (std/crypto/digest#make-blake2s256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174229_
                   _args174226_)
            (std/crypto/digest#digest-final!__0 _digest174229_)))
        '#f))
  (define std/crypto/digest#digest::blake2b512
    (std/crypto/libcrypto#EVP_blake2b512))
  (define std/crypto/digest#make-blake2b512-digest
    (if std/crypto/digest#digest::blake2b512
        (lambda ()
          (let ((__obj301446 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301446
             std/crypto/digest#digest::blake2b512)
            __obj301446))
        '#f))
  (define std/crypto/digest#blake2b512-digest?
    (if std/crypto/digest#digest::blake2b512
        (lambda (_obj174222_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174222_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174222_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::blake2b512))
              '#f))
        '#f))
  (define std/crypto/digest#blake2b512
    (if std/crypto/digest#digest::blake2b512
        (lambda _args174216_
          (let ((_digest174219_ (std/crypto/digest#make-blake2b512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174219_
                   _args174216_)
            (std/crypto/digest#digest-final!__0 _digest174219_)))
        '#f))
  (define std/crypto/digest#digest::sha3_224
    (std/crypto/libcrypto#EVP_sha3_224))
  (define std/crypto/digest#make-sha3_224-digest
    (if std/crypto/digest#digest::sha3_224
        (lambda ()
          (let ((__obj301447 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301447
             std/crypto/digest#digest::sha3_224)
            __obj301447))
        '#f))
  (define std/crypto/digest#sha3_224-digest?
    (if std/crypto/digest#digest::sha3_224
        (lambda (_obj174212_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174212_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174212_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_224))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_224
    (if std/crypto/digest#digest::sha3_224
        (lambda _args174206_
          (let ((_digest174209_ (std/crypto/digest#make-sha3_224-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174209_
                   _args174206_)
            (std/crypto/digest#digest-final!__0 _digest174209_)))
        '#f))
  (define std/crypto/digest#digest::sha3_256
    (std/crypto/libcrypto#EVP_sha3_256))
  (define std/crypto/digest#make-sha3_256-digest
    (if std/crypto/digest#digest::sha3_256
        (lambda ()
          (let ((__obj301448 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301448
             std/crypto/digest#digest::sha3_256)
            __obj301448))
        '#f))
  (define std/crypto/digest#sha3_256-digest?
    (if std/crypto/digest#digest::sha3_256
        (lambda (_obj174202_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174202_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174202_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_256))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_256
    (if std/crypto/digest#digest::sha3_256
        (lambda _args174196_
          (let ((_digest174199_ (std/crypto/digest#make-sha3_256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174199_
                   _args174196_)
            (std/crypto/digest#digest-final!__0 _digest174199_)))
        '#f))
  (define std/crypto/digest#digest::sha3_384
    (std/crypto/libcrypto#EVP_sha3_384))
  (define std/crypto/digest#make-sha3_384-digest
    (if std/crypto/digest#digest::sha3_384
        (lambda ()
          (let ((__obj301449 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301449
             std/crypto/digest#digest::sha3_384)
            __obj301449))
        '#f))
  (define std/crypto/digest#sha3_384-digest?
    (if std/crypto/digest#digest::sha3_384
        (lambda (_obj174192_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174192_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174192_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_384))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_384
    (if std/crypto/digest#digest::sha3_384
        (lambda _args174186_
          (let ((_digest174189_ (std/crypto/digest#make-sha3_384-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174189_
                   _args174186_)
            (std/crypto/digest#digest-final!__0 _digest174189_)))
        '#f))
  (define std/crypto/digest#digest::sha3_512
    (std/crypto/libcrypto#EVP_sha3_512))
  (define std/crypto/digest#make-sha3_512-digest
    (if std/crypto/digest#digest::sha3_512
        (lambda ()
          (let ((__obj301450 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301450
             std/crypto/digest#digest::sha3_512)
            __obj301450))
        '#f))
  (define std/crypto/digest#sha3_512-digest?
    (if std/crypto/digest#digest::sha3_512
        (lambda (_obj174182_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174182_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174182_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_512))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_512
    (if std/crypto/digest#digest::sha3_512
        (lambda _args174176_
          (let ((_digest174179_ (std/crypto/digest#make-sha3_512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174179_
                   _args174176_)
            (std/crypto/digest#digest-final!__0 _digest174179_)))
        '#f))
  (define std/crypto/digest#digest::shake128
    (std/crypto/libcrypto#EVP_shake128))
  (define std/crypto/digest#make-shake128-digest
    (if std/crypto/digest#digest::shake128
        (lambda ()
          (let ((__obj301451 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301451
             std/crypto/digest#digest::shake128)
            __obj301451))
        '#f))
  (define std/crypto/digest#shake128-digest?
    (if std/crypto/digest#digest::shake128
        (lambda (_obj174172_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174172_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174172_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::shake128))
              '#f))
        '#f))
  (define std/crypto/digest#shake128
    (if std/crypto/digest#digest::shake128
        (lambda _args174166_
          (let ((_digest174169_ (std/crypto/digest#make-shake128-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174169_
                   _args174166_)
            (std/crypto/digest#digest-final!__0 _digest174169_)))
        '#f))
  (define std/crypto/digest#digest::shake256
    (std/crypto/libcrypto#EVP_shake256))
  (define std/crypto/digest#make-shake256-digest
    (if std/crypto/digest#digest::shake256
        (lambda ()
          (let ((__obj301452 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301452
             std/crypto/digest#digest::shake256)
            __obj301452))
        '#f))
  (define std/crypto/digest#shake256-digest?
    (if std/crypto/digest#digest::shake256
        (lambda (_obj174162_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174162_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174162_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::shake256))
              '#f))
        '#f))
  (define std/crypto/digest#shake256
    (if std/crypto/digest#digest::shake256
        (lambda _args174156_
          (let ((_digest174159_ (std/crypto/digest#make-shake256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174159_
                   _args174156_)
            (std/crypto/digest#digest-final!__0 _digest174159_)))
        '#f))
  (define std/crypto/digest#digest::keccak256
    (std/crypto/libcrypto#EVP_keccak256))
  (define std/crypto/digest#make-keccak256-digest
    (if std/crypto/digest#digest::keccak256
        (lambda ()
          (let ((__obj301453 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301453
             std/crypto/digest#digest::keccak256)
            __obj301453))
        '#f))
  (define std/crypto/digest#keccak256-digest?
    (if std/crypto/digest#digest::keccak256
        (lambda (_obj174152_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174152_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174152_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::keccak256))
              '#f))
        '#f))
  (define std/crypto/digest#keccak256
    (if std/crypto/digest#digest::keccak256
        (lambda _args174146_
          (let ((_digest174149_ (std/crypto/digest#make-keccak256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174149_
                   _args174146_)
            (std/crypto/digest#digest-final!__0 _digest174149_)))
        '#f)))
