(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/hmac#hmac::t
    (make-struct-type 'std/crypto#hmac::t '#f '2 'hmac '() ':init! '(md ctx)))
  (define std/crypto/hmac#hmac?
    (make-struct-predicate std/crypto/hmac#hmac::t))
  (define std/crypto/hmac#make-hmac
    (lambda _$args210145_
      (apply make-struct-instance std/crypto/hmac#hmac::t _$args210145_)))
  (define std/crypto/hmac#hmac-md
    (make-struct-field-accessor std/crypto/hmac#hmac::t '0))
  (define std/crypto/hmac#hmac-ctx
    (make-struct-field-accessor std/crypto/hmac#hmac::t '1))
  (define std/crypto/hmac#hmac-md-set!
    (make-struct-field-mutator std/crypto/hmac#hmac::t '0))
  (define std/crypto/hmac#hmac-ctx-set!
    (make-struct-field-mutator std/crypto/hmac#hmac::t '1))
  (define std/crypto/hmac#hmac:::init!
    (lambda (_self210140_ _md210141_)
      (if (std/crypto/libcrypto#EVP_MD? _md210141_)
          '#!void
          (error '"Invalid digest type" _md210141_))
      (let ((_ctx210143_ (std/crypto/libcrypto#HMAC_CTX_create)))
        (if _ctx210143_ '#!void (error '"Failed to allocate hmac context"))
        (if (let ((__tmp301629
                   (let ()
                     (declare (not safe))
                     (##vector-length _self210140_))))
              (declare (not safe))
              (##fx< '2 __tmp301629))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self210140_ '1 _md210141_))
              (let ()
                (declare (not safe))
                (##vector-set! _self210140_ '2 _ctx210143_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self210140_)))))
  (bind-method!
   std/crypto/hmac#hmac::t
   ':init!
   std/crypto/hmac#hmac:::init!
   '#f)
  (define std/crypto/hmac#hmac-init!
    (lambda (_hmac210012_ _key210013_)
      (let ((_res210015_
             (std/crypto/libcrypto#HMAC_Init
              (##structure-ref _hmac210012_ '2 std/crypto/hmac#hmac::t '#f)
              _key210013_
              (##structure-ref _hmac210012_ '1 std/crypto/hmac#hmac::t '#f))))
        (if (let () (declare (not safe)) (##fxzero? _res210015_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/hmac#hmac-update!__%
    (lambda (_hmac209972_ _bytes209973_ _start209974_ _end209975_)
      (let* ((_start209980_
              (let ((_$e209977_ _start209974_)) (if _$e209977_ _$e209977_ '0)))
             (_end209985_
              (let ((_$e209982_ _end209975_))
                (if _$e209982_ _$e209982_ (u8vector-length _bytes209973_)))))
        (let ((_res209988_
               (std/crypto/libcrypto#HMAC_Update
                (##structure-ref _hmac209972_ '2 std/crypto/hmac#hmac::t '#f)
                _bytes209973_
                _start209980_
                _end209985_)))
          (if (let () (declare (not safe)) (##fxzero? _res209988_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void)))))
  (define std/crypto/hmac#hmac-update!__0
    (lambda (_hmac209994_ _bytes209995_)
      (let* ((_start209997_ '#f) (_end209999_ '#f))
        (std/crypto/hmac#hmac-update!__%
         _hmac209994_
         _bytes209995_
         _start209997_
         _end209999_))))
  (define std/crypto/hmac#hmac-update!__1
    (lambda (_hmac210001_ _bytes210002_ _start210003_)
      (let ((_end210005_ '#f))
        (std/crypto/hmac#hmac-update!__%
         _hmac210001_
         _bytes210002_
         _start210003_
         _end210005_))))
  (define std/crypto/hmac#hmac-update!
    (lambda _g301631_
      (let ((_g301630_ (let () (declare (not safe)) (##length _g301631_))))
        (cond ((let () (declare (not safe)) (##fx= _g301630_ 2))
               (apply std/crypto/hmac#hmac-update!__0 _g301631_))
              ((let () (declare (not safe)) (##fx= _g301630_ 3))
               (apply std/crypto/hmac#hmac-update!__1 _g301631_))
              ((let () (declare (not safe)) (##fx= _g301630_ 4))
               (apply std/crypto/hmac#hmac-update!__% _g301631_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-update!
                _g301631_))))))
  (define std/crypto/hmac#hmac-final!__%
    (lambda (_hmac209947_ _bytes209948_)
      (let* ((_size209950_
              (std/crypto/libcrypto#EVP_MD_size
               (##structure-ref _hmac209947_ '1 std/crypto/hmac#hmac::t '#f)))
             (_bytes209955_
              (let ((_$e209952_ _bytes209948_))
                (if _$e209952_ _$e209952_ (make-u8vector _size209950_)))))
        (let ((_res209958_
               (std/crypto/libcrypto#HMAC_Final
                (##structure-ref _hmac209947_ '2 std/crypto/hmac#hmac::t '#f)
                _bytes209955_)))
          (if (let () (declare (not safe)) (##fxzero? _res209958_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _bytes209955_)))
  (define std/crypto/hmac#hmac-final!__0
    (lambda (_hmac209964_)
      (let ((_bytes209966_ '#f))
        (std/crypto/hmac#hmac-final!__% _hmac209964_ _bytes209966_))))
  (define std/crypto/hmac#hmac-final!
    (lambda _g301633_
      (let ((_g301632_ (let () (declare (not safe)) (##length _g301633_))))
        (cond ((let () (declare (not safe)) (##fx= _g301632_ 1))
               (apply std/crypto/hmac#hmac-final!__0 _g301633_))
              ((let () (declare (not safe)) (##fx= _g301632_ 2))
               (apply std/crypto/hmac#hmac-final!__% _g301633_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-final!
                _g301633_))))))
  (define std/crypto/hmac#hmac-digest__%
    (lambda (_md209901_ _key209902_ _bytes209903_ _start209904_ _end209905_)
      (if (std/crypto/libcrypto#EVP_MD? _md209901_)
          '#!void
          (error '"Bad digest type" _md209901_))
      (let* ((_start209910_
              (let ((_$e209907_ _start209904_)) (if _$e209907_ _$e209907_ '0)))
             (_end209915_
              (let ((_$e209912_ _end209905_))
                (if _$e209912_ _$e209912_ (u8vector-length _bytes209903_))))
             (_size209917_ (std/crypto/libcrypto#EVP_MD_size _md209901_))
             (_digest209919_ (make-u8vector _size209917_)))
        (std/crypto/libcrypto#HMAC
         _md209901_
         _key209902_
         _bytes209903_
         _start209910_
         _end209915_
         _digest209919_)
        _digest209919_)))
  (define std/crypto/hmac#hmac-digest__0
    (lambda (_md209925_ _key209926_ _bytes209927_)
      (let* ((_start209929_ '#f) (_end209931_ '#f))
        (std/crypto/hmac#hmac-digest__%
         _md209925_
         _key209926_
         _bytes209927_
         _start209929_
         _end209931_))))
  (define std/crypto/hmac#hmac-digest__1
    (lambda (_md209933_ _key209934_ _bytes209935_ _start209936_)
      (let ((_end209938_ '#f))
        (std/crypto/hmac#hmac-digest__%
         _md209933_
         _key209934_
         _bytes209935_
         _start209936_
         _end209938_))))
  (define std/crypto/hmac#hmac-digest
    (lambda _g301635_
      (let ((_g301634_ (let () (declare (not safe)) (##length _g301635_))))
        (cond ((let () (declare (not safe)) (##fx= _g301634_ 3))
               (apply std/crypto/hmac#hmac-digest__0 _g301635_))
              ((let () (declare (not safe)) (##fx= _g301634_ 4))
               (apply std/crypto/hmac#hmac-digest__1 _g301635_))
              ((let () (declare (not safe)) (##fx= _g301634_ 5))
               (apply std/crypto/hmac#hmac-digest__% _g301635_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-digest
                _g301635_))))))
  (define std/crypto/hmac#hmac-md5__%
    (lambda (_key209870_ _bytes209872_ _start209874_ _end209876_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::md5
       _key209870_
       _bytes209872_
       _start209874_
       _end209876_)))
  (define std/crypto/hmac#hmac-md5__0
    (lambda (_key209882_ _bytes209883_)
      (let* ((_start209885_ '#f) (_end209887_ '#f))
        (std/crypto/hmac#hmac-md5__%
         _key209882_
         _bytes209883_
         _start209885_
         _end209887_))))
  (define std/crypto/hmac#hmac-md5__1
    (lambda (_key209889_ _bytes209890_ _start209891_)
      (let ((_end209893_ '#f))
        (std/crypto/hmac#hmac-md5__%
         _key209889_
         _bytes209890_
         _start209891_
         _end209893_))))
  (define std/crypto/hmac#hmac-md5
    (lambda _g301637_
      (let ((_g301636_ (let () (declare (not safe)) (##length _g301637_))))
        (cond ((let () (declare (not safe)) (##fx= _g301636_ 2))
               (apply std/crypto/hmac#hmac-md5__0 _g301637_))
              ((let () (declare (not safe)) (##fx= _g301636_ 3))
               (apply std/crypto/hmac#hmac-md5__1 _g301637_))
              ((let () (declare (not safe)) (##fx= _g301636_ 4))
               (apply std/crypto/hmac#hmac-md5__% _g301637_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-md5
                _g301637_))))))
  (define std/crypto/hmac#hmac-sha1__%
    (lambda (_key209839_ _bytes209841_ _start209843_ _end209845_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha1
       _key209839_
       _bytes209841_
       _start209843_
       _end209845_)))
  (define std/crypto/hmac#hmac-sha1__0
    (lambda (_key209851_ _bytes209852_)
      (let* ((_start209854_ '#f) (_end209856_ '#f))
        (std/crypto/hmac#hmac-sha1__%
         _key209851_
         _bytes209852_
         _start209854_
         _end209856_))))
  (define std/crypto/hmac#hmac-sha1__1
    (lambda (_key209858_ _bytes209859_ _start209860_)
      (let ((_end209862_ '#f))
        (std/crypto/hmac#hmac-sha1__%
         _key209858_
         _bytes209859_
         _start209860_
         _end209862_))))
  (define std/crypto/hmac#hmac-sha1
    (lambda _g301639_
      (let ((_g301638_ (let () (declare (not safe)) (##length _g301639_))))
        (cond ((let () (declare (not safe)) (##fx= _g301638_ 2))
               (apply std/crypto/hmac#hmac-sha1__0 _g301639_))
              ((let () (declare (not safe)) (##fx= _g301638_ 3))
               (apply std/crypto/hmac#hmac-sha1__1 _g301639_))
              ((let () (declare (not safe)) (##fx= _g301638_ 4))
               (apply std/crypto/hmac#hmac-sha1__% _g301639_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha1
                _g301639_))))))
  (define std/crypto/hmac#hmac-sha256__%
    (lambda (_key209808_ _bytes209810_ _start209812_ _end209814_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha256
       _key209808_
       _bytes209810_
       _start209812_
       _end209814_)))
  (define std/crypto/hmac#hmac-sha256__0
    (lambda (_key209820_ _bytes209821_)
      (let* ((_start209823_ '#f) (_end209825_ '#f))
        (std/crypto/hmac#hmac-sha256__%
         _key209820_
         _bytes209821_
         _start209823_
         _end209825_))))
  (define std/crypto/hmac#hmac-sha256__1
    (lambda (_key209827_ _bytes209828_ _start209829_)
      (let ((_end209831_ '#f))
        (std/crypto/hmac#hmac-sha256__%
         _key209827_
         _bytes209828_
         _start209829_
         _end209831_))))
  (define std/crypto/hmac#hmac-sha256
    (lambda _g301641_
      (let ((_g301640_ (let () (declare (not safe)) (##length _g301641_))))
        (cond ((let () (declare (not safe)) (##fx= _g301640_ 2))
               (apply std/crypto/hmac#hmac-sha256__0 _g301641_))
              ((let () (declare (not safe)) (##fx= _g301640_ 3))
               (apply std/crypto/hmac#hmac-sha256__1 _g301641_))
              ((let () (declare (not safe)) (##fx= _g301640_ 4))
               (apply std/crypto/hmac#hmac-sha256__% _g301641_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha256
                _g301641_))))))
  (define std/crypto/hmac#hmac-sha384__%
    (lambda (_key209777_ _bytes209779_ _start209781_ _end209783_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha384
       _key209777_
       _bytes209779_
       _start209781_
       _end209783_)))
  (define std/crypto/hmac#hmac-sha384__0
    (lambda (_key209789_ _bytes209790_)
      (let* ((_start209792_ '#f) (_end209794_ '#f))
        (std/crypto/hmac#hmac-sha384__%
         _key209789_
         _bytes209790_
         _start209792_
         _end209794_))))
  (define std/crypto/hmac#hmac-sha384__1
    (lambda (_key209796_ _bytes209797_ _start209798_)
      (let ((_end209800_ '#f))
        (std/crypto/hmac#hmac-sha384__%
         _key209796_
         _bytes209797_
         _start209798_
         _end209800_))))
  (define std/crypto/hmac#hmac-sha384
    (lambda _g301643_
      (let ((_g301642_ (let () (declare (not safe)) (##length _g301643_))))
        (cond ((let () (declare (not safe)) (##fx= _g301642_ 2))
               (apply std/crypto/hmac#hmac-sha384__0 _g301643_))
              ((let () (declare (not safe)) (##fx= _g301642_ 3))
               (apply std/crypto/hmac#hmac-sha384__1 _g301643_))
              ((let () (declare (not safe)) (##fx= _g301642_ 4))
               (apply std/crypto/hmac#hmac-sha384__% _g301643_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha384
                _g301643_))))))
  (define std/crypto/hmac#hmac-sha512__%
    (lambda (_key209746_ _bytes209748_ _start209750_ _end209752_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha512
       _key209746_
       _bytes209748_
       _start209750_
       _end209752_)))
  (define std/crypto/hmac#hmac-sha512__0
    (lambda (_key209758_ _bytes209759_)
      (let* ((_start209761_ '#f) (_end209763_ '#f))
        (std/crypto/hmac#hmac-sha512__%
         _key209758_
         _bytes209759_
         _start209761_
         _end209763_))))
  (define std/crypto/hmac#hmac-sha512__1
    (lambda (_key209765_ _bytes209766_ _start209767_)
      (let ((_end209769_ '#f))
        (std/crypto/hmac#hmac-sha512__%
         _key209765_
         _bytes209766_
         _start209767_
         _end209769_))))
  (define std/crypto/hmac#hmac-sha512
    (lambda _g301645_
      (let ((_g301644_ (let () (declare (not safe)) (##length _g301645_))))
        (cond ((let () (declare (not safe)) (##fx= _g301644_ 2))
               (apply std/crypto/hmac#hmac-sha512__0 _g301645_))
              ((let () (declare (not safe)) (##fx= _g301644_ 3))
               (apply std/crypto/hmac#hmac-sha512__1 _g301645_))
              ((let () (declare (not safe)) (##fx= _g301644_ 4))
               (apply std/crypto/hmac#hmac-sha512__% _g301645_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha512
                _g301645_)))))))
