(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/request#request::t
    (make-struct-type
     'std/net#request::t
     '#f
     '8
     'request
     '()
     ':init!
     '(port url history status status-text headers body encoding)))
  (define std/net/request#request?
    (make-struct-predicate std/net/request#request::t))
  (define std/net/request#make-request
    (lambda _$args173487_
      (apply make-struct-instance std/net/request#request::t _$args173487_)))
  (define std/net/request#request-port
    (make-struct-field-accessor std/net/request#request::t '0))
  (define std/net/request#request-url
    (make-struct-field-accessor std/net/request#request::t '1))
  (define std/net/request#request-history
    (make-struct-field-accessor std/net/request#request::t '2))
  (define std/net/request#request-status
    (make-struct-field-accessor std/net/request#request::t '3))
  (define std/net/request#request-status-text
    (make-struct-field-accessor std/net/request#request::t '4))
  (define std/net/request#request-headers
    (make-struct-field-accessor std/net/request#request::t '5))
  (define std/net/request#request-body
    (make-struct-field-accessor std/net/request#request::t '6))
  (define std/net/request#request-encoding
    (make-struct-field-accessor std/net/request#request::t '7))
  (define std/net/request#request-port-set!
    (make-struct-field-mutator std/net/request#request::t '0))
  (define std/net/request#request-url-set!
    (make-struct-field-mutator std/net/request#request::t '1))
  (define std/net/request#request-history-set!
    (make-struct-field-mutator std/net/request#request::t '2))
  (define std/net/request#request-status-set!
    (make-struct-field-mutator std/net/request#request::t '3))
  (define std/net/request#request-status-text-set!
    (make-struct-field-mutator std/net/request#request::t '4))
  (define std/net/request#request-headers-set!
    (make-struct-field-mutator std/net/request#request::t '5))
  (define std/net/request#request-body-set!
    (make-struct-field-mutator std/net/request#request::t '6))
  (define std/net/request#request-encoding-set!
    (make-struct-field-mutator std/net/request#request::t '7))
  (define std/net/request#request:::init!
    (lambda (_self173482_ _port173483_ _url173484_ _history173485_)
      (if (let ((__tmp300945
                 (let () (declare (not safe)) (##vector-length _self173482_))))
            (declare (not safe))
            (##fx< '3 __tmp300945))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self173482_ '1 _port173483_))
            (let ()
              (declare (not safe))
              (##vector-set! _self173482_ '2 _url173484_))
            (let ()
              (declare (not safe))
              (##vector-set! _self173482_ '3 _history173485_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self173482_))))
  (bind-method!
   std/net/request#request::t
   ':init!
   std/net/request#request:::init!
   '#f)
  (define std/net/request#url-target-e
    (lambda (_url173357_ _params173358_)
      (if _params173358_
          (string-append
           _url173357_
           '"?"
           (std/net/uri#form-url-encode__% _params173358_ '#f))
          _url173357_)))
  (define std/net/request#header-string-e
    (lambda (_str173355_)
      (if (string? _str173355_)
          _str173355_
          (if (symbol? _str173355_)
              (symbol->string _str173355_)
              (if (keyword? _str173355_)
                  (keyword->string _str173355_)
                  (error '"bad header key" _str173355_))))))
  (define std/net/request#make-http/1.1-headers
    (lambda (_headers173348_ _cookies173349_ _auth173350_)
      (std/net/request#http-headers-cons!
       _headers173348_
       (std/net/request#http-headers-cons
        (std/net/request#http-headers-cons
         std/net/request#http/1.1-base-headers
         (std/net/request#http-headers-cookies
          (let ((_$e173352_ _cookies173349_)) (if _$e173352_ _$e173352_ '()))))
        (std/net/request#http-headers-auth _auth173350_)))))
  (define std/net/request#http/1.1-base-headers
    '(("User-Agent" . "Mozilla/5.0 (compatible; gerbil/1.0)")
      ("Connection" . "close")
      ("Accept" . "*/*")
      ("Accept-Encoding" . "gzip, deflate, identity")))
  (define std/net/request#http-headers-auth
    (lambda (_auth173276_)
      (letrec ((_basic-auth-header173278_
                (lambda (_user173342_ _password173343_)
                  (let ((_credentials173346_
                         (std/text/base64#u8vector->base64-string
                          (with-output-to-u8vector
                           (lambda ()
                             (display _user173342_)
                             (display '":")
                             (display _password173343_))))))
                    (cons '"Authorization"
                          (string-append '"Basic " _credentials173346_))))))
        (let* ((_auth173279173294_ _auth173276_)
               (_E173283173298_
                (lambda () (error '"No clause matching" _auth173279173294_))))
          (let ((_K173286173320_
                 (lambda (_password173317_ _user173318_)
                   (cons (_basic-auth-header173278_
                          _user173318_
                          _password173317_)
                         '())))
                (_K173285173311_ (lambda () '()))
                (_K173284173303_
                 (lambda () (error '"unknown auth value" _auth173276_))))
            (let ((_try-match173281173314_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##eq? _auth173279173294_ '#f))
                         (_K173285173311_)
                         (_K173284173303_)))))
              (if (let () (declare (not safe)) (##pair? _auth173279173294_))
                  (let ((_tl173288173325_
                         (let ()
                           (declare (not safe))
                           (##cdr _auth173279173294_)))
                        (_hd173287173323_
                         (let ()
                           (declare (not safe))
                           (##car _auth173279173294_))))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _hd173287173323_ 'basic:))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl173288173325_))
                            (let ((_tl173290173330_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl173288173325_)))
                                  (_hd173289173328_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl173288173325_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl173290173330_))
                                  (let ((_tl173292173337_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl173290173330_)))
                                        (_hd173291173335_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl173290173330_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##null? _tl173292173337_))
                                        (let ((_user173333_ _hd173289173328_)
                                              (_password173340_
                                               _hd173291173335_))
                                          (_K173286173320_
                                           _password173340_
                                           _user173333_))
                                        (_try-match173281173314_)))
                                  (_try-match173281173314_)))
                            (_try-match173281173314_))
                        (_try-match173281173314_)))
                  (_try-match173281173314_))))))))
  (define std/net/request#http-headers-cookies
    (lambda (_cookies173241_)
      (letrec ((_fold-e173243_
                (lambda (_cookie173245_ _str173246_)
                  (let* ((_cookie173247173254_ _cookie173245_)
                         (_E173249173258_
                          (lambda ()
                            (error '"No clause matching"
                                   _cookie173247173254_)))
                         (_K173250173264_
                          (lambda (_value173261_ _key173262_)
                            (if (string-empty? _str173246_)
                                (std/format#format
                                 '"~a=~a"
                                 _key173262_
                                 _value173261_)
                                (std/format#format
                                 '"~a; ~a=~a"
                                 _str173246_
                                 _key173262_
                                 _value173261_)))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _cookie173247173254_))
                        (let ((_hd173251173267_
                               (let ()
                                 (declare (not safe))
                                 (##car _cookie173247173254_)))
                              (_tl173252173269_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _cookie173247173254_))))
                          (let* ((_key173272_ _hd173251173267_)
                                 (_value173274_ _tl173252173269_))
                            (_K173250173264_ _value173274_ _key173272_)))
                        (_E173249173258_))))))
        (if (null? _cookies173241_)
            '()
            (cons (cons '"Cookie" (foldr1 _fold-e173243_ _cookies173241_ '""))
                  '())))))
  (define std/net/request#http-headers-cons
    (lambda (_new-headers173201_ _headers173202_)
      (letrec ((_fold-e173204_
                (lambda (_header173206_ _headers173207_)
                  (let* ((_header173208173215_ _header173206_)
                         (_E173210173219_
                          (lambda ()
                            (error '"No clause matching"
                                   _header173208173215_)))
                         (_K173211173229_
                          (lambda (_value173222_ _key173223_)
                            (let ((_key173225_
                                   (std/srfi/13#string-titlecase__0
                                    (std/net/request#header-string-e
                                     _key173223_))))
                              (if (assoc _key173225_ _headers173207_)
                                  _headers173207_
                                  (let ((_value173227_
                                         (std/format#format
                                          '"~a"
                                          _value173222_)))
                                    (cons (cons _key173225_ _value173227_)
                                          _headers173207_)))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _header173208173215_))
                        (let ((_hd173212173232_
                               (let ()
                                 (declare (not safe))
                                 (##car _header173208173215_)))
                              (_tl173213173234_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _header173208173215_))))
                          (let* ((_key173237_ _hd173212173232_)
                                 (_value173239_ _tl173213173234_))
                            (_K173211173229_ _value173239_ _key173237_)))
                        (_E173210173219_))))))
        (foldr1 _fold-e173204_ _headers173202_ _new-headers173201_))))
  (define std/net/request#http-headers-cons!
    (lambda (_new-headers173157_ _headers173158_)
      (letrec ((_fold-e173160_
                (lambda (_header173162_ _headers173163_)
                  (let* ((_header173164173171_ _header173162_)
                         (_E173166173175_
                          (lambda ()
                            (error '"No clause matching"
                                   _header173164173171_)))
                         (_K173167173189_
                          (lambda (_value173178_ _key173179_)
                            (let ((_key173181_
                                   (std/srfi/13#string-titlecase__0
                                    (std/net/request#header-string-e
                                     _key173179_)))
                                  (_value173182_
                                   (std/format#format '"~a" _value173178_)))
                              (let ((_$e173184_
                                     (assoc _key173181_ _headers173163_)))
                                (if _$e173184_
                                    ((lambda (_pair173187_)
                                       (set-cdr! _pair173187_ _value173182_)
                                       _headers173163_)
                                     _$e173184_)
                                    (cons (cons _key173181_ _value173182_)
                                          _headers173163_)))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _header173164173171_))
                        (let ((_hd173168173192_
                               (let ()
                                 (declare (not safe))
                                 (##car _header173164173171_)))
                              (_tl173169173194_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _header173164173171_))))
                          (let* ((_key173197_ _hd173168173192_)
                                 (_value173199_ _tl173169173194_))
                            (_K173167173189_ _value173199_ _key173197_)))
                        (_E173166173175_))))))
        (foldr1 _fold-e173160_ _headers173158_ _new-headers173157_))))
  (define std/net/request#http-get__%
    (lambda (_g300946_
             _redirect173106173114_
             _headers173107173116_
             _cookies173108173118_
             _params173109173120_
             _data173110173122_
             _auth173111173124_
             _url173126_)
      (let* ((_redirect173128_
              (if (eq? _redirect173106173114_ absent-value)
                  '#t
                  _redirect173106173114_))
             (_headers173130_
              (if (eq? _headers173107173116_ absent-value)
                  '#f
                  _headers173107173116_))
             (_cookies173132_
              (if (eq? _cookies173108173118_ absent-value)
                  '#f
                  _cookies173108173118_))
             (_params173134_
              (if (eq? _params173109173120_ absent-value)
                  '#f
                  _params173109173120_))
             (_data173136_
              (if (eq? _data173110173122_ absent-value)
                  '#f
                  _data173110173122_))
             (_auth173138_
              (if (eq? _auth173111173124_ absent-value)
                  '#f
                  _auth173111173124_)))
        (let ((_url173140_
               (std/net/request#url-target-e _url173126_ _params173134_))
              (_headers173141_
               (std/net/request#make-http/1.1-headers
                _headers173130_
                _cookies173132_
                _auth173138_)))
          (std/net/request#http-request
           'GET
           _url173140_
           _headers173141_
           _data173136_
           '()
           _redirect173128_)))))
  (define std/net/request#http-get__@
    (lambda (_keys173105173146_ . _args173148_)
      (apply std/net/request#http-get__%
             _keys173105173146_
             (table-ref _keys173105173146_ 'redirect: absent-value)
             (table-ref _keys173105173146_ 'headers: absent-value)
             (table-ref _keys173105173146_ 'cookies: absent-value)
             (table-ref _keys173105173146_ 'params: absent-value)
             (table-ref _keys173105173146_ 'data: absent-value)
             (table-ref _keys173105173146_ 'auth: absent-value)
             _args173148_)))
  (define std/net/request#http-get
    (lambda _args173112173154_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-get__@
             _args173112173154_)))
  (define std/net/request#http-head__%
    (lambda (_g300947_
             _redirect173053173061_
             _headers173054173063_
             _cookies173055173065_
             _params173056173067_
             _data173057173069_
             _auth173058173071_
             _url173073_)
      (let* ((_redirect173075_
              (if (eq? _redirect173053173061_ absent-value)
                  '#t
                  _redirect173053173061_))
             (_headers173077_
              (if (eq? _headers173054173063_ absent-value)
                  '#f
                  _headers173054173063_))
             (_cookies173079_
              (if (eq? _cookies173055173065_ absent-value)
                  '#f
                  _cookies173055173065_))
             (_params173081_
              (if (eq? _params173056173067_ absent-value)
                  '#f
                  _params173056173067_))
             (_data173083_
              (if (eq? _data173057173069_ absent-value)
                  '#f
                  _data173057173069_))
             (_auth173085_
              (if (eq? _auth173058173071_ absent-value)
                  '#f
                  _auth173058173071_)))
        (let ((_url173087_
               (std/net/request#url-target-e _url173073_ _params173081_))
              (_headers173088_
               (std/net/request#make-http/1.1-headers
                _headers173077_
                _cookies173079_
                _auth173085_)))
          (std/net/request#http-request
           'HEAD
           _url173087_
           _headers173088_
           _data173083_
           '()
           _redirect173075_)))))
  (define std/net/request#http-head__@
    (lambda (_keys173052173093_ . _args173095_)
      (apply std/net/request#http-head__%
             _keys173052173093_
             (table-ref _keys173052173093_ 'redirect: absent-value)
             (table-ref _keys173052173093_ 'headers: absent-value)
             (table-ref _keys173052173093_ 'cookies: absent-value)
             (table-ref _keys173052173093_ 'params: absent-value)
             (table-ref _keys173052173093_ 'data: absent-value)
             (table-ref _keys173052173093_ 'auth: absent-value)
             _args173095_)))
  (define std/net/request#http-head
    (lambda _args173059173101_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-head__@
             _args173059173101_)))
  (define std/net/request#http-post__%
    (lambda (_g300948_
             _redirect172998173006_
             _headers172999173008_
             _cookies173000173010_
             _params173001173012_
             _data173002173014_
             _auth173003173016_
             _url173018_)
      (let* ((_redirect173020_
              (if (eq? _redirect172998173006_ absent-value)
                  '#t
                  _redirect172998173006_))
             (_headers173022_
              (if (eq? _headers172999173008_ absent-value)
                  '#f
                  _headers172999173008_))
             (_cookies173024_
              (if (eq? _cookies173000173010_ absent-value)
                  '#f
                  _cookies173000173010_))
             (_params173026_
              (if (eq? _params173001173012_ absent-value)
                  '#f
                  _params173001173012_))
             (_data173028_
              (if (eq? _data173002173014_ absent-value)
                  '#f
                  _data173002173014_))
             (_auth173030_
              (if (eq? _auth173003173016_ absent-value)
                  '#f
                  _auth173003173016_))
             (_g300949_
              (if _params173026_
                  (let ((_form-data173032_
                         (std/net/uri#form-url-encode__% _params173026_ '#t)))
                    (values (std/net/request#http-headers-cons
                             '(("Content-Type"
                                .
                                "application/x-www-form-urlencoded"))
                             (std/net/request#make-http/1.1-headers
                              _headers173022_
                              _cookies173024_
                              _auth173030_))
                            _form-data173032_))
                  (values (std/net/request#make-http/1.1-headers
                           _headers173022_
                           _cookies173024_
                           _auth173030_)
                          _data173028_))))
        (begin
          #!void
          (let ((_headers173034_
                 (let () (declare (not safe)) (##vector-ref _g300949_ 0)))
                (_data173035_
                 (let () (declare (not safe)) (##vector-ref _g300949_ 1))))
            (std/net/request#http-request
             'POST
             _url173018_
             _headers173034_
             _data173035_
             '()
             _redirect173020_))))))
  (define std/net/request#http-post__@
    (lambda (_keys172997173040_ . _args173042_)
      (apply std/net/request#http-post__%
             _keys172997173040_
             (table-ref _keys172997173040_ 'redirect: absent-value)
             (table-ref _keys172997173040_ 'headers: absent-value)
             (table-ref _keys172997173040_ 'cookies: absent-value)
             (table-ref _keys172997173040_ 'params: absent-value)
             (table-ref _keys172997173040_ 'data: absent-value)
             (table-ref _keys172997173040_ 'auth: absent-value)
             _args173042_)))
  (define std/net/request#http-post
    (lambda _args173004173048_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-post__@
             _args173004173048_)))
  (define std/net/request#http-put__%
    (lambda (_g300950_
             _redirect172945172953_
             _headers172946172955_
             _cookies172947172957_
             _params172948172959_
             _data172949172961_
             _auth172950172963_
             _url172965_)
      (let* ((_redirect172967_
              (if (eq? _redirect172945172953_ absent-value)
                  '#t
                  _redirect172945172953_))
             (_headers172969_
              (if (eq? _headers172946172955_ absent-value)
                  '#f
                  _headers172946172955_))
             (_cookies172971_
              (if (eq? _cookies172947172957_ absent-value)
                  '#f
                  _cookies172947172957_))
             (_params172973_
              (if (eq? _params172948172959_ absent-value)
                  '#f
                  _params172948172959_))
             (_data172975_
              (if (eq? _data172949172961_ absent-value)
                  '#f
                  _data172949172961_))
             (_auth172977_
              (if (eq? _auth172950172963_ absent-value)
                  '#f
                  _auth172950172963_)))
        (let ((_url172979_
               (std/net/request#url-target-e _url172965_ _params172973_))
              (_headers172980_
               (std/net/request#make-http/1.1-headers
                _headers172969_
                _cookies172971_
                _auth172977_)))
          (std/net/request#http-request
           'PUT
           _url172979_
           _headers172980_
           _data172975_
           '()
           _redirect172967_)))))
  (define std/net/request#http-put__@
    (lambda (_keys172944172985_ . _args172987_)
      (apply std/net/request#http-put__%
             _keys172944172985_
             (table-ref _keys172944172985_ 'redirect: absent-value)
             (table-ref _keys172944172985_ 'headers: absent-value)
             (table-ref _keys172944172985_ 'cookies: absent-value)
             (table-ref _keys172944172985_ 'params: absent-value)
             (table-ref _keys172944172985_ 'data: absent-value)
             (table-ref _keys172944172985_ 'auth: absent-value)
             _args172987_)))
  (define std/net/request#http-put
    (lambda _args172951172993_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-put__@
             _args172951172993_)))
  (define std/net/request#http-delete__%
    (lambda (_g300951_
             _redirect172892172900_
             _headers172893172902_
             _cookies172894172904_
             _params172895172906_
             _data172896172908_
             _auth172897172910_
             _url172912_)
      (let* ((_redirect172914_
              (if (eq? _redirect172892172900_ absent-value)
                  '#t
                  _redirect172892172900_))
             (_headers172916_
              (if (eq? _headers172893172902_ absent-value)
                  '#f
                  _headers172893172902_))
             (_cookies172918_
              (if (eq? _cookies172894172904_ absent-value)
                  '#f
                  _cookies172894172904_))
             (_params172920_
              (if (eq? _params172895172906_ absent-value)
                  '#f
                  _params172895172906_))
             (_data172922_
              (if (eq? _data172896172908_ absent-value)
                  '#f
                  _data172896172908_))
             (_auth172924_
              (if (eq? _auth172897172910_ absent-value)
                  '#f
                  _auth172897172910_)))
        (let ((_url172926_
               (std/net/request#url-target-e _url172912_ _params172920_))
              (_headers172927_
               (std/net/request#make-http/1.1-headers
                _headers172916_
                _cookies172918_
                _auth172924_)))
          (std/net/request#http-request
           'DELETE
           _url172926_
           _headers172927_
           _data172922_
           '()
           _redirect172914_)))))
  (define std/net/request#http-delete__@
    (lambda (_keys172891172932_ . _args172934_)
      (apply std/net/request#http-delete__%
             _keys172891172932_
             (table-ref _keys172891172932_ 'redirect: absent-value)
             (table-ref _keys172891172932_ 'headers: absent-value)
             (table-ref _keys172891172932_ 'cookies: absent-value)
             (table-ref _keys172891172932_ 'params: absent-value)
             (table-ref _keys172891172932_ 'data: absent-value)
             (table-ref _keys172891172932_ 'auth: absent-value)
             _args172934_)))
  (define std/net/request#http-delete
    (lambda _args172898172940_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-delete__@
             _args172898172940_)))
  (define std/net/request#http-options__%
    (lambda (_g300952_
             _redirect172839172847_
             _headers172840172849_
             _cookies172841172851_
             _params172842172853_
             _data172843172855_
             _auth172844172857_
             _url172859_)
      (let* ((_redirect172861_
              (if (eq? _redirect172839172847_ absent-value)
                  '#t
                  _redirect172839172847_))
             (_headers172863_
              (if (eq? _headers172840172849_ absent-value)
                  '#f
                  _headers172840172849_))
             (_cookies172865_
              (if (eq? _cookies172841172851_ absent-value)
                  '#f
                  _cookies172841172851_))
             (_params172867_
              (if (eq? _params172842172853_ absent-value)
                  '#f
                  _params172842172853_))
             (_data172869_
              (if (eq? _data172843172855_ absent-value)
                  '#f
                  _data172843172855_))
             (_auth172871_
              (if (eq? _auth172844172857_ absent-value)
                  '#f
                  _auth172844172857_)))
        (let ((_url172873_
               (std/net/request#url-target-e _url172859_ _params172867_))
              (_headers172874_
               (std/net/request#make-http/1.1-headers
                _headers172863_
                _cookies172865_
                _auth172871_)))
          (std/net/request#http-request
           'OPTIONS
           _url172873_
           _headers172874_
           _data172869_
           '()
           _redirect172861_)))))
  (define std/net/request#http-options__@
    (lambda (_keys172838172879_ . _args172881_)
      (apply std/net/request#http-options__%
             _keys172838172879_
             (table-ref _keys172838172879_ 'redirect: absent-value)
             (table-ref _keys172838172879_ 'headers: absent-value)
             (table-ref _keys172838172879_ 'cookies: absent-value)
             (table-ref _keys172838172879_ 'params: absent-value)
             (table-ref _keys172838172879_ 'data: absent-value)
             (table-ref _keys172838172879_ 'auth: absent-value)
             _args172881_)))
  (define std/net/request#http-options
    (lambda _args172845172887_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-options__@
             _args172845172887_)))
  (define std/net/request#url-rx
    (std/pregexp#pregexp '"(?:(https?)://)?([^/:]+)(:[0-9]+)?(/.*)?"))
  (define std/net/request#+tls-context+
    (make-promise (lambda () (make-tls-context))))
  (define std/net/request#http-request
    (lambda (_method172704_
             _url172705_
             _user-headers172706_
             _body172707_
             _history172708_
             _redirect172709_)
      (let* ((_g172710172725_
              (std/pregexp#pregexp-match std/net/request#url-rx _url172705_))
             (_E172712172729_
              (lambda () (error '"No clause matching" _g172710172725_)))
             (_K172713172802_
              (lambda (_target172732_ _port172733_ _host172734_ _scheme172735_)
                (let* ((_scheme172740_
                        (let ((_$e172737_ _scheme172735_))
                          (if _$e172737_ _$e172737_ '"http")))
                       (_port172742_
                        (if _port172733_
                            (string->number
                             (substring
                              _port172733_
                              '1
                              (string-length _port172733_)))
                            (if (equal? _scheme172740_ '"https") '443 '80)))
                       (_target172747_
                        (let ((_$e172744_ _target172732_))
                          (if _$e172744_ _$e172744_ '"/")))
                       (_host-header172755_
                        (let ((_$e172749_ _port172742_))
                          (if (or (eq? '80 _$e172749_) (eq? '443 _$e172749_))
                              _host172734_
                              (std/format#format
                               '"~a:~a"
                               _host172734_
                               _port172742_))))
                       (_headers172757_
                        (std/net/request#http-headers-cons
                         (cons (cons '"Host" _host-header172755_) '())
                         _user-headers172706_))
                       (_body172759_
                        (if (not _body172707_)
                            '#f
                            (if (u8vector? _body172707_)
                                _body172707_
                                (if (string? _body172707_)
                                    (std/text/utf8#string->utf8__0
                                     _body172707_)
                                    (error '"bad request body"
                                           _body172707_)))))
                       (_headers172761_
                        (if _body172759_
                            (std/net/request#http-headers-cons!
                             (cons (cons '"Content-Length"
                                         (u8vector-length _body172759_))
                                   '())
                             _headers172757_)
                            _headers172757_))
                       (_tcp-client-options172763_
                        (cons 'server-address:
                              (cons _host172734_
                                    (cons 'port-number:
                                          (cons _port172742_
                                                (cons 'eol-encoding:
                                                      (cons 'cr-lf '())))))))
                       (_tcp-client-options172765_
                        (if (equal? _scheme172740_ '"https")
                            (cons 'tls-context:
                                  (cons (force std/net/request#+tls-context+)
                                        _tcp-client-options172763_))
                            _tcp-client-options172763_))
                       (_sock172767_
                        (open-tcp-client _tcp-client-options172765_))
                       (_req172769_
                        (let ((__obj300944
                               (make-object std/net/request#request::t '8)))
                          (if (let ((__tmp300953
                                     (let ()
                                       (declare (not safe))
                                       (##vector-length __obj300944))))
                                (declare (not safe))
                                (##fx< '3 __tmp300953))
                              (begin
                                (let ()
                                  (declare (not safe))
                                  (##vector-set! __obj300944 '1 _sock172767_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-set! __obj300944 '2 _url172705_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-set!
                                   __obj300944
                                   '3
                                   _history172708_)))
                              (error '"struct-instance-init!: too many arguments for struct"
                                     __obj300944))
                          __obj300944)))
                  (std/net/request#http-request-write
                   _sock172767_
                   _method172704_
                   _target172747_
                   _headers172761_
                   _body172759_)
                  (std/net/request#http-request-read-response! _req172769_)
                  (let ((_$e172772_
                         (if _redirect172709_
                             (if (memv (##structure-ref
                                        _req172769_
                                        '4
                                        std/net/request#request::t
                                        '#f)
                                       '(301 302 303 307))
                                 (if (memq _method172704_ '(GET HEAD))
                                     (assoc '"Location"
                                            (##structure-ref
                                             _req172769_
                                             '6
                                             std/net/request#request::t
                                             '#f))
                                     '#f)
                                 '#f)
                             '#f)))
                    (if _$e172772_
                        ((lambda (_e172774172776_)
                           (let* ((_g172778172785_ _e172774172776_)
                                  (_E172780172789_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _g172778172785_)))
                                  (_K172781172794_
                                   (lambda (_new-url172792_)
                                     (if (member _new-url172792_
                                                 _history172708_)
                                         (error '"URL redirection loop"
                                                _url172705_)
                                         (begin
                                           (std/net/request#request-close
                                            _req172769_)
                                           (std/net/request#http-request
                                            _method172704_
                                            _new-url172792_
                                            _user-headers172706_
                                            _body172759_
                                            (cons _url172705_ _history172708_)
                                            '#t))))))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _g172778172785_))
                                 (let* ((_tl172783172797_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g172778172785_)))
                                        (_new-url172800_ _tl172783172797_))
                                   (_K172781172794_ _new-url172800_))
                                 (_E172780172789_))))
                         _$e172772_)
                        _req172769_))))))
        (if (let () (declare (not safe)) (##pair? _g172710172725_))
            (let ((_tl172715172805_
                   (let () (declare (not safe)) (##cdr _g172710172725_))))
              (if (let () (declare (not safe)) (##pair? _tl172715172805_))
                  (let ((_hd172716172808_
                         (let ()
                           (declare (not safe))
                           (##car _tl172715172805_)))
                        (_tl172717172810_
                         (let ()
                           (declare (not safe))
                           (##cdr _tl172715172805_))))
                    (let ((_scheme172813_ _hd172716172808_))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl172717172810_))
                          (let ((_hd172718172815_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl172717172810_)))
                                (_tl172719172817_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl172717172810_))))
                            (let ((_host172820_ _hd172718172815_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl172719172817_))
                                  (let ((_hd172720172822_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl172719172817_)))
                                        (_tl172721172824_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl172719172817_))))
                                    (let ((_port172827_ _hd172720172822_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##pair? _tl172721172824_))
                                          (let ((_hd172722172829_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##car _tl172721172824_)))
                                                (_tl172723172831_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##cdr _tl172721172824_))))
                                            (let ((_target172834_
                                                   _hd172722172829_))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##null? _tl172723172831_))
                                                  (_K172713172802_
                                                   _target172834_
                                                   _port172827_
                                                   _host172820_
                                                   _scheme172813_)
                                                  (_E172712172729_))))
                                          (_E172712172729_))))
                                  (_E172712172729_))))
                          (_E172712172729_))))
                  (_E172712172729_)))
            (_E172712172729_)))))
  (define std/net/request#http-request-write
    (lambda (_port172666_
             _method172667_
             _target172668_
             _headers172669_
             _body172670_)
      (std/format#fprintf
       _port172666_
       '"~a ~a HTTP/1.1~n"
       _method172667_
       _target172668_)
      (for-each
       (lambda (_e172671172673_)
         (let* ((_g172675172682_ _e172671172673_)
                (_E172677172686_
                 (lambda () (error '"No clause matching" _g172675172682_)))
                (_K172678172692_
                 (lambda (_val172689_ _key172690_)
                   (std/format#fprintf
                    _port172666_
                    '"~a: ~a~n"
                    _key172690_
                    _val172689_))))
           (if (let () (declare (not safe)) (##pair? _g172675172682_))
               (let ((_hd172679172695_
                      (let () (declare (not safe)) (##car _g172675172682_)))
                     (_tl172680172697_
                      (let () (declare (not safe)) (##cdr _g172675172682_))))
                 (let* ((_key172700_ _hd172679172695_)
                        (_val172702_ _tl172680172697_))
                   (_K172678172692_ _val172702_ _key172700_)))
               (_E172677172686_))))
       _headers172669_)
      (newline _port172666_)
      (if _body172670_
          (write-subu8vector
           _body172670_
           '0
           (u8vector-length _body172670_)
           _port172666_)
          '#!void)
      (force-output _port172666_)))
  (define std/net/request#status-line-rx
    (std/pregexp#pregexp '"([0-9]{3})\\s+(.*)"))
  (define std/net/request#header-line-rx
    (std/pregexp#pregexp '"([^:]+):\\s*(.*)?"))
  (define std/net/request#http-request-read-response!
    (lambda (_req172559_)
      (let* ((_port172561_
              (##structure-ref _req172559_ '1 std/net/request#request::t '#f))
             (_status-line172563_
              (std/net/request#read-response-line _port172561_)))
        (let* ((_g172565172577_
                (std/pregexp#pregexp-match
                 std/net/request#status-line-rx
                 _status-line172563_))
               (_else172567172585_
                (lambda ()
                  (std/error#raise-io-error
                   'http-request-read-response!
                   '"malformed status line"
                   _port172561_
                   _status-line172563_)))
               (_K172569172646_
                (lambda (_status-text172588_ _status172589_)
                  (##structure-set!
                   _req172559_
                   (string->number _status172589_)
                   '4
                   std/net/request#request::t
                   '#f)
                  (##structure-set!
                   _req172559_
                   (std/srfi/13#string-trim-both__0 _status-text172588_)
                   '5
                   std/net/request#request::t
                   '#f)
                  (let ((_root172591_ (cons '#f '())))
                    (let _lp172593_ ((_tl172595_ _root172591_))
                      (let ((_next172597_
                             (std/net/request#read-response-line
                              _port172561_)))
                        (if (string-empty? _next172597_)
                            (##structure-set!
                             _req172559_
                             (cdr _root172591_)
                             '6
                             std/net/request#request::t
                             '#f)
                            (let* ((_g172598172610_
                                    (std/pregexp#pregexp-match
                                     std/net/request#header-line-rx
                                     _next172597_))
                                   (_else172600172618_
                                    (lambda ()
                                      (std/error#raise-io-error
                                       'http-request-read-response!
                                       '"Malformed header"
                                       _port172561_
                                       _next172597_)))
                                   (_K172602172626_
                                    (lambda (_value172621_ _key172622_)
                                      (let ((_tl*172624_
                                             (cons (cons (std/srfi/13#string-titlecase__0
                                                          _key172622_)
                                                         (std/srfi/13#string-trim-both__0
                                                          _value172621_))
                                                   '())))
                                        (set-cdr! _tl172595_ _tl*172624_)
                                        (_lp172593_ _tl*172624_)))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _g172598172610_))
                                  (let ((_tl172604172629_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g172598172610_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##pair? _tl172604172629_))
                                        (let ((_hd172605172632_
                                               (let ()
                                                 (declare (not safe))
                                                 (##car _tl172604172629_)))
                                              (_tl172606172634_
                                               (let ()
                                                 (declare (not safe))
                                                 (##cdr _tl172604172629_))))
                                          (let ((_key172637_ _hd172605172632_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl172606172634_))
                                                (let ((_hd172607172639_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _tl172606172634_)))
                                                      (_tl172608172641_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _tl172606172634_))))
                                                  (let ((_value172644_
                                                         _hd172607172639_))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##null? _tl172608172641_))
                                                        (_K172602172626_
                                                         _value172644_
                                                         _key172637_)
                                                        (_else172600172618_))))
                                                (_else172600172618_))))
                                        (_else172600172618_)))
                                  (_else172600172618_))))))))))
          (if (let () (declare (not safe)) (##pair? _g172565172577_))
              (let ((_tl172571172649_
                     (let () (declare (not safe)) (##cdr _g172565172577_))))
                (if (let () (declare (not safe)) (##pair? _tl172571172649_))
                    (let ((_hd172572172652_
                           (let ()
                             (declare (not safe))
                             (##car _tl172571172649_)))
                          (_tl172573172654_
                           (let ()
                             (declare (not safe))
                             (##cdr _tl172571172649_))))
                      (let ((_status172657_ _hd172572172652_))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl172573172654_))
                            (let ((_hd172574172659_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl172573172654_)))
                                  (_tl172575172661_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl172573172654_))))
                              (let ((_status-text172664_ _hd172574172659_))
                                (if (let ()
                                      (declare (not safe))
                                      (##null? _tl172575172661_))
                                    (_K172569172646_
                                     _status-text172664_
                                     _status172657_)
                                    (_else172567172585_))))
                            (_else172567172585_))))
                    (_else172567172585_)))
              (_else172567172585_))))))
  (define std/net/request#http-request-read-body
    (lambda (_port172544_ _headers172545_)
      (letrec ((_length-e172547_
                (lambda (_headers172554_)
                  (let ((_$e172556_
                         (assget '"Content-Length" _headers172554_)))
                    (if _$e172556_ (string->number _$e172556_) '#f)))))
        (let ((_$e172549_ (assget '"Transfer-Encoding" _headers172545_)))
          (if _$e172549_
              ((lambda (_tenc172552_)
                 (if (not (equal? '"identity" _tenc172552_))
                     (std/net/request#http-request-read-chunked-body
                      _port172544_)
                     (std/net/request#http-request-read-simple-body
                      _port172544_
                      (_length-e172547_ _headers172545_))))
               _$e172549_)
              (std/net/request#http-request-read-simple-body
               _port172544_
               (_length-e172547_ _headers172545_)))))))
  (define std/net/request#http-request-read-chunked-body
    (lambda (_port172524_)
      (let ((_root172526_ (cons '#f '())))
        (let _lp172528_ ((_tl172530_ _root172526_))
          (let* ((_line172532_
                  (std/net/request#read-response-line _port172524_))
                 (_clen172534_
                  (string->number
                   (car (string-split _line172532_ '#\space))
                   '16)))
            (if (fxzero? _clen172534_)
                (u8vector-concatenate (cdr _root172526_))
                (let* ((_chunk172537_ (make-u8vector _clen172534_))
                       (_rd172539_
                        (read-subu8vector
                         _chunk172537_
                         '0
                         _clen172534_
                         _port172524_)))
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd172539_ _clen172534_))
                      (std/error#raise-io-error
                       'http-request-read-body
                       '"error reading chunk; premature end of port")
                      '#!void)
                  (std/net/request#read-response-line _port172524_)
                  (let ((_tl*172542_ (cons _chunk172537_ '())))
                    (set-cdr! _tl172530_ _tl*172542_)
                    (_lp172528_ _tl*172542_)))))))))
  (define std/net/request#http-request-read-simple-body
    (lambda (_port172493_ _length172494_)
      (letrec ((_read/length172496_
                (lambda (_port172516_ _length172517_)
                  (let* ((_data172519_ (make-u8vector _length172517_))
                         (_rd172521_
                          (read-subu8vector
                           _data172519_
                           '0
                           _length172517_
                           _port172516_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rd172521_ _length172517_))
                        (begin
                          (u8vector-shrink! _data172519_ _rd172521_)
                          _data172519_)
                        _data172519_))))
               (_read/end172497_
                (lambda (_port172499_)
                  (let ((_root172501_ (cons '#f '())))
                    (let _lp172503_ ((_tl172505_ _root172501_))
                      (let* ((_buflen172507_ '4096)
                             (_buf172509_ (make-u8vector _buflen172507_))
                             (_rd172511_
                              (read-subu8vector
                               _buf172509_
                               '0
                               _buflen172507_
                               _port172499_)))
                        (if (let ()
                              (declare (not safe))
                              (##fxzero? _rd172511_))
                            (u8vector-concatenate (cdr _root172501_))
                            (if (let ()
                                  (declare (not safe))
                                  (##fx< _rd172511_ _buflen172507_))
                                (begin
                                  (u8vector-shrink! _buf172509_ _rd172511_)
                                  (set-cdr! _tl172505_ (cons _buf172509_ '()))
                                  (u8vector-concatenate (cdr _root172501_)))
                                (let ((_tl*172514_ (cons _buf172509_ '())))
                                  (set-cdr! _tl172505_ _tl*172514_)
                                  (_lp172503_ _tl*172514_))))))))))
        (if _length172494_
            (_read/length172496_ _port172493_ _length172494_)
            (_read/end172497_ _port172493_)))))
  (define std/net/request#cr (char->integer '#\return))
  (define std/net/request#lf (char->integer '#\newline))
  (define std/net/request#crlf
    (u8vector std/net/request#cr std/net/request#lf))
  (define std/net/request#read-response-line
    (lambda (_port172477_)
      (let ((_root172479_ (cons '#f '())))
        (let _lp172481_ ((_tl172483_ _root172479_))
          (let ((_next172485_ (read-u8 _port172477_)))
            (if (eof-object? _next172485_)
                (std/error#raise-io-error
                 'request-read-response-line
                 '"Incomplete response; connection closed"
                 _port172477_)
                (if (eq? _next172485_ std/net/request#cr)
                    (let ((_next172487_ (read-u8 _port172477_)))
                      (if (eof-object? _next172487_)
                          (std/error#raise-io-error
                           'request-read-response-line
                           '"Incomplete response; connection closed"
                           _port172477_)
                          (if (eq? _next172487_ std/net/request#lf)
                              (std/text/utf8#utf8->string__0
                               (list->u8vector (cdr _root172479_)))
                              (let ((_tl*172489_
                                     (cons std/net/request#cr
                                           (cons _next172487_ '()))))
                                (set-cdr! _tl172483_ _tl*172489_)
                                (_lp172481_ (cdr _tl*172489_))))))
                    (let ((_tl*172491_ (cons _next172485_ '())))
                      (set-cdr! _tl172483_ _tl*172491_)
                      (_lp172481_ _tl*172491_)))))))))
  (define std/net/request#request-close
    (lambda (_req172468_)
      (let ((_port172469172471_
             (##structure-ref _req172468_ '1 std/net/request#request::t '#f)))
        (if _port172469172471_
            (let ((_port172474_ _port172469172471_))
              (with-exception-catcher
               void
               (lambda () (close-port _port172474_)))
              (##structure-set!
               _req172468_
               '#f
               '1
               std/net/request#request::t
               '#f))
            '#f))))
  (define std/net/request#request::destroy std/net/request#request-close)
  (bind-method!
   std/net/request#request::t
   'destroy
   std/net/request#request::destroy
   '#f)
  (define std/net/request#request-content
    (lambda (_req172316_)
      (let ((_$e172318_
             (##structure-ref _req172316_ '7 std/net/request#request::t '#f)))
        (if _$e172318_
            (values _$e172318_)
            (let ((_$e172321_
                   (##structure-ref
                    _req172316_
                    '1
                    std/net/request#request::t
                    '#f)))
              (if _$e172321_
                  ((lambda (_port172324_)
                     (let ((_headers172326_
                            (##structure-ref
                             _req172316_
                             '6
                             std/net/request#request::t
                             '#f)))
                       (with-unwind-protect
                        (lambda ()
                          (let* ((_body172329_
                                  (std/net/request#http-request-read-body
                                   _port172324_
                                   _headers172326_))
                                 (_body172342_
                                  (let ((_$e172331_
                                         (assoc '"Content-Encoding"
                                                _headers172326_)))
                                    (if _$e172331_
                                        ((lambda (_enc172334_)
                                           (let ((_$e172336_
                                                  (cdr _enc172334_)))
                                             (if (or (equal? '"gzip"
                                                             _$e172336_)
                                                     (equal? '"deflate"
                                                             _$e172336_))
                                                 (std/text/zlib#uncompress
                                                  _body172329_)
                                                 (if (equal? '"identity"
                                                             _$e172336_)
                                                     _body172329_
                                                     (error '"Unsupported content encoding"
                                                            _enc172334_)))))
                                         _$e172331_)
                                        _body172329_))))
                            (##structure-set!
                             _req172316_
                             _body172342_
                             '7
                             std/net/request#request::t
                             '#f)
                            _body172342_))
                        (lambda ()
                          (close-port _port172324_)
                          (##structure-set!
                           _req172316_
                           '#f
                           '1
                           std/net/request#request::t
                           '#f)))))
                   _$e172321_)
                  '#f))))))
  (define std/net/request#request-text
    (lambda (_req172307_)
      (letrec ((_get-text172309_
                (lambda (_enc172314_)
                  (if (eq? _enc172314_ 'UTF-8)
                      (std/text/utf8#utf8->string__0
                       (std/net/request#request-content _req172307_))
                      (bytes->string
                       (std/net/request#request-content _req172307_)
                       _enc172314_)))))
        (let ((_$e172311_
               (##structure-ref
                _req172307_
                '8
                std/net/request#request::t
                '#f)))
          (if _$e172311_
              (_get-text172309_ _$e172311_)
              (_get-text172309_ 'UTF-8))))))
  (define std/net/request#request-json
    (lambda (_req172305_)
      (std/text/json#string->json-object
       (std/net/request#request-text _req172305_))))
  (define std/net/request#request-cookies
    (lambda (_req172070_)
      (let* ((_head172072_ (cons '#f '())) (_tail172075_ _head172072_))
        (let _lp172235_ ((_rest172237_
                          (##structure-ref
                           _req172070_
                           '6
                           std/net/request#request::t
                           '#f)))
          (let* ((_rest172238172246_ _rest172237_)
                 (_else172240172254_ (lambda () '#!void))
                 (_K172242172293_
                  (lambda (_rest172257_ _hd172258_)
                    (let* ((_hd172259172267_ _hd172258_)
                           (_else172261172275_
                            (lambda () (_lp172235_ _rest172257_)))
                           (_K172263172283_
                            (lambda (_cookie172278_)
                              (let ((_new-tail172280_
                                     (cons _cookie172278_ '())))
                                (let ()
                                  (declare (not safe))
                                  (##set-cdr! _tail172075_ _new-tail172280_))
                                (set! _tail172075_ _new-tail172280_))
                              (_lp172235_ _rest172257_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _hd172259172267_))
                          (let ((_hd172264172286_
                                 (let ()
                                   (declare (not safe))
                                   (##car _hd172259172267_)))
                                (_tl172265172288_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _hd172259172267_))))
                            (if (equal? _hd172264172286_ '"Set-Cookie")
                                (let ((_cookie172291_ _tl172265172288_))
                                  (_K172263172283_ _cookie172291_))
                                (_else172261172275_)))
                          (_else172261172275_))))))
            (if (let () (declare (not safe)) (##pair? _rest172238172246_))
                (let ((_hd172243172296_
                       (let ()
                         (declare (not safe))
                         (##car _rest172238172246_)))
                      (_tl172244172298_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest172238172246_))))
                  (let* ((_hd172301_ _hd172243172296_)
                         (_rest172303_ _tl172244172298_))
                    (_K172242172293_ _rest172303_ _hd172301_)))
                '#!void)))
        (let () (declare (not safe)) (##cdr _head172072_))))))
