(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/websocket#errorf
    (lambda (_fmt175529_ . _args175530_)
      (std/logger#log-message 'websocket '0 _fmt175529_ _args175530_)))
  (define std/net/websocket#warnf
    (lambda (_fmt175526_ . _args175527_)
      (std/logger#log-message 'websocket '1 _fmt175526_ _args175527_)))
  (define std/net/websocket#infof
    (lambda (_fmt175523_ . _args175524_)
      (std/logger#log-message 'websocket '2 _fmt175523_ _args175524_)))
  (define std/net/websocket#debugf
    (lambda (_fmt175520_ . _args175521_)
      (std/logger#log-message 'websocket '3 _fmt175520_ _args175521_)))
  (define std/net/websocket#verbosef
    (lambda (_fmt175515_ . _args175517_)
      (std/logger#log-message 'websocket '4 _fmt175515_ _args175517_)))
  (define std/net/websocket#wsmagic '"258EAFA5-E914-47DA-95CA-C5AB0DC85B11")
  (define std/net/websocket#open-websocket-client__%
    (lambda (_g302031_
             _redirect175423175429_
             _headers175424175431_
             _cookies175425175433_
             _params175426175435_
             _url175437_)
      (let* ((_redirect175439_
              (if (eq? _redirect175423175429_ absent-value)
                  '#t
                  _redirect175423175429_))
             (_headers175441_
              (if (eq? _headers175424175431_ absent-value)
                  '#f
                  _headers175424175431_))
             (_cookies175443_
              (if (eq? _cookies175425175433_ absent-value)
                  '#f
                  _cookies175425175433_))
             (_params175445_
              (if (eq? _params175426175435_ absent-value)
                  '#f
                  _params175426175435_))
             (_url175447_ (std/net/websocket#url->request-url _url175437_))
             (_nonce175449_ (std/crypto/etc#random-bytes '16))
             (_nonce64175451_
              (std/text/base64#u8vector->base64-string _nonce175449_))
             (_headers175456_
              (cons (cons '"Upgrade" '"websocket")
                    (cons (cons '"Connection" '"Upgrade")
                          (cons (cons '"Sec-WebSocket-Key" _nonce64175451_)
                                (cons (cons '"Sec-WebSocket-Version" '13)
                                      (let ((_$e175453_ _headers175441_))
                                        (if _$e175453_ _$e175453_ '())))))))
             (_req175458_
              (std/net/request#http-get__%
               '#f
               _redirect175439_
               _headers175456_
               _cookies175443_
               _params175445_
               absent-value
               absent-value
               _url175447_)))
        (with-exception-catcher
         (lambda (_g175460175462_)
           (if '#t
               (let ((_e175465_ _g175460175462_))
                 (std/net/request#request-close _req175458_)
                 (raise _e175465_))
               (raise _g175460175462_)))
         (lambda ()
           (let ((_status175468_
                  (##structure-ref
                   _req175458_
                   '4
                   std/net/request#request::t
                   '#f)))
             (if (let () (declare (not safe)) (##fx= _status175468_ '101))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Unexpected server response"
                  _url175447_
                  _status175468_)))
           (let* ((_rheaders175470_
                   (##structure-ref
                    _req175458_
                    '6
                    std/net/request#request::t
                    '#f))
                  (_Connection175472_ (assoc '"Connection" _rheaders175470_))
                  (_Upgrade175474_ (assoc '"Upgrade" _rheaders175470_))
                  (_Sec-WebSocket-Accept175476_
                   (assoc '"Sec-Websocket-Accept" _rheaders175470_))
                  (_Sec-WebSocket-Extensions175478_
                   (assoc '"Sec-Websocket-Extensions" _rheaders175470_))
                  (_Sec-WebSocket-Protocol175480_
                   (assoc '"Sec-Websocket-Protocol" _rheaders175470_)))
             (if (and _Connection175472_
                      (equal? (std/srfi/13#string-downcase__0
                               (cdr _Connection175472_))
                              '"upgrade"))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; no connection upgrade"
                  _url175447_
                  _Connection175472_))
             (if (and _Upgrade175474_
                      (equal? (std/srfi/13#string-downcase__0
                               (cdr _Upgrade175474_))
                              '"websocket"))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; no websocket upgrade"
                  _url175447_
                  _Upgrade175474_))
             (let* ((_accept64175483_
                     (if _Sec-WebSocket-Accept175476_
                         (cdr _Sec-WebSocket-Accept175476_)
                         '#f))
                    (_digest175485_
                     (let ((__obj302028
                            (make-object std/crypto/digest#digest::t '2)))
                       (std/crypto/digest#digest:::init!
                        __obj302028
                        std/crypto/digest#digest::sha1)
                       __obj302028))
                    (_g302032_
                     (std/crypto/digest#digest-update!__0
                      _digest175485_
                      (std/text/utf8#string->utf8__0 _nonce64175451_)))
                    (_g302033_
                     (std/crypto/digest#digest-update!__0
                      _digest175485_
                      (std/text/utf8#string->utf8__0
                       std/net/websocket#wsmagic)))
                    (_verify175489_
                     (std/crypto/digest#digest-final!__0 _digest175485_))
                    (_verify64175491_
                     (std/text/base64#u8vector->base64-string _verify175489_)))
               (if (equal? _accept64175483_ _verify64175491_)
                   '#!void
                   (std/error#raise-io-error
                    'open-websocket-client
                    '"Bad server response; nonce verification failure"
                    _url175447_
                    _nonce64175451_
                    _accept64175483_
                    _verify64175491_)))
             (if _Sec-WebSocket-Extensions175478_
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; includes unsupported exensions"
                  _url175447_
                  _Sec-WebSocket-Extensions175478_)
                 '#!void)
             (if _Sec-WebSocket-Protocol175480_
                 (let* ((_proto175494_ (cdr _Sec-WebSocket-Protocol175480_))
                        (_uproto175496_
                         (assoc '"Sec-WebSocket-Protocol" _headers175456_))
                        (_uproto175498_
                         (string-split
                          (if _uproto175496_ (cdr _uproto175496_) '#f)
                          '#\,)))
                   (if (member _proto175494_ _uproto175498_)
                       '#!void
                       (std/error#raise-io-error
                        'open-websocket-client
                        '"Bad server response; unexpected protocol"
                        _url175447_
                        _Sec-WebSocket-Protocol175480_)))
                 '#!void))
           (std/net/websocket#make-websocket-client
            (##structure-ref
             _req175458_
             '1
             std/net/request#request::t
             '#f)))))))
  (define std/net/websocket#open-websocket-client__@
    (lambda (_keys175422175504_ . _args175506_)
      (apply std/net/websocket#open-websocket-client__%
             _keys175422175504_
             (table-ref _keys175422175504_ 'redirect: absent-value)
             (table-ref _keys175422175504_ 'headers: absent-value)
             (table-ref _keys175422175504_ 'cookies: absent-value)
             (table-ref _keys175422175504_ 'params: absent-value)
             _args175506_)))
  (define std/net/websocket#open-websocket-client
    (lambda _args175427175512_
      (apply keyword-dispatch
             '#(params:
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                redirect:
                headers:
                #f
                #f
                #f
                #f)
             std/net/websocket#open-websocket-client__@
             _args175427175512_)))
  (define std/net/websocket#url->request-url
    (lambda (_url175411_)
      (let ((_colon175413_ (std/srfi/13#string-index__0 _url175411_ '#\:)))
        (if _colon175413_
            (let* ((_scheme175416_ (substring _url175411_ '0 _colon175413_))
                   (_$e175418_ _scheme175416_))
              (if (equal? '"ws" _$e175418_)
                  (string-append
                   '"http"
                   (substring
                    _url175411_
                    _colon175413_
                    (string-length _url175411_)))
                  (if (equal? '"wss" _$e175418_)
                      (string-append
                       '"https"
                       (substring
                        _url175411_
                        _colon175413_
                        (string-length _url175411_)))
                      _url175411_)))
            _url175411_))))
  (define std/net/websocket#websocket::t
    (make-struct-type
     'std/net/websocket#websocket::t
     '#f
     '7
     'websocket
     '((final: . #t))
     ':init!
     '(port rd wr cs q mx cv)))
  (define std/net/websocket#websocket?
    (make-struct-predicate std/net/websocket#websocket::t))
  (define std/net/websocket#make-websocket
    (lambda _$args175408_
      (apply make-struct-instance
             std/net/websocket#websocket::t
             _$args175408_)))
  (define std/net/websocket#websocket-port
    (make-struct-field-accessor std/net/websocket#websocket::t '0))
  (define std/net/websocket#websocket-rd
    (make-struct-field-accessor std/net/websocket#websocket::t '1))
  (define std/net/websocket#websocket-wr
    (make-struct-field-accessor std/net/websocket#websocket::t '2))
  (define std/net/websocket#websocket-cs
    (make-struct-field-accessor std/net/websocket#websocket::t '3))
  (define std/net/websocket#websocket-q
    (make-struct-field-accessor std/net/websocket#websocket::t '4))
  (define std/net/websocket#websocket-mx
    (make-struct-field-accessor std/net/websocket#websocket::t '5))
  (define std/net/websocket#websocket-cv
    (make-struct-field-accessor std/net/websocket#websocket::t '6))
  (define std/net/websocket#websocket-port-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '0))
  (define std/net/websocket#websocket-rd-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '1))
  (define std/net/websocket#websocket-wr-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '2))
  (define std/net/websocket#websocket-cs-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '3))
  (define std/net/websocket#websocket-q-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '4))
  (define std/net/websocket#websocket-mx-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '5))
  (define std/net/websocket#websocket-cv-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '6))
  (define std/net/websocket#websocket:::init!
    (lambda (_self175405_ _port175406_)
      (if (let ((__tmp302034
                 (let () (declare (not safe)) (##vector-length _self175405_))))
            (declare (not safe))
            (##fx< '7 __tmp302034))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self175405_ '1 _port175406_))
            (let () (declare (not safe)) (##vector-set! _self175405_ '2 '#f))
            (let () (declare (not safe)) (##vector-set! _self175405_ '3 '#f))
            (let () (declare (not safe)) (##vector-set! _self175405_ '4 '#f))
            (let ((__tmp302035
                   (let ((__obj302029
                          (make-object std/misc/queue#queue::t '3)))
                     (std/misc/queue#queue:::init! __obj302029)
                     __obj302029)))
              (declare (not safe))
              (##vector-set! _self175405_ '5 __tmp302035))
            (let ((__tmp302036 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self175405_ '6 __tmp302036))
            (let ((__tmp302037 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self175405_ '7 __tmp302037)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self175405_))))
  (bind-method!
   std/net/websocket#websocket::t
   ':init!
   std/net/websocket#websocket:::init!
   '#f)
  (define std/net/websocket#make-websocket-client
    (lambda (_port175273_)
      (std/logger#start-logger!__0)
      (let* ((_ws175275_
              (let ((__obj302030
                     (make-object std/net/websocket#websocket::t '7)))
                (std/net/websocket#websocket:::init! __obj302030 _port175273_)
                __obj302030))
             (_reader175277_
              (gerbil/gambit/threads#spawn/name
               'websocket-reader
               std/net/websocket#websocket-reader
               _ws175275_))
             (_writer175279_
              (gerbil/gambit/threads#spawn/name
               'websocket-writer
               std/net/websocket#websocket-writer
               _ws175275_)))
        (##direct-structure-set!
         _ws175275_
         _reader175277_
         '2
         std/net/websocket#websocket::t
         '#f)
        (##direct-structure-set!
         _ws175275_
         _writer175279_
         '3
         std/net/websocket#websocket::t
         '#f)
        _ws175275_)))
  (define std/net/websocket#websocket-send
    (lambda (_ws175261_ _bytes175262_ _type175263_)
      (if (not (u8vector? _bytes175262_))
          (error '"Bad argument; expected u8vector" _bytes175262_)
          (if (not (or (eq? _type175263_ 'binary) (eq? _type175263_ 'text)))
              (error '"Bad argument; expected 'binary or 'text" _type175263_)
              (let ((_$e175268_
                     (##direct-structure-ref
                      _ws175261_
                      '4
                      std/net/websocket#websocket::t
                      '#f)))
                (if _$e175268_
                    ((lambda (_how175271_)
                       (std/error#raise-io-error
                        'websocket-send
                        '"Websocket has been closed"
                        _ws175261_
                        _how175271_))
                     _$e175268_)
                    (thread-send
                     (##direct-structure-ref
                      _ws175261_
                      '3
                      std/net/websocket#websocket::t
                      '#f)
                     (cons _type175263_ _bytes175262_))))))))
  (define std/net/websocket#websocket-write
    (lambda (_ws175258_ _obj175259_)
      (if (string? _obj175259_)
          (std/net/websocket#websocket-send
           _ws175258_
           (std/text/utf8#string->utf8__0 _obj175259_)
           'text)
          (if (u8vector? _obj175259_)
              (std/net/websocket#websocket-send _ws175258_ _obj175259_ 'binary)
              (error '"Bad argument; expected bytes or string" _obj175259_)))))
  (define std/net/websocket#websocket-recv__%
    (lambda (_ws175146_ _timeo175147_ _raise?175148_)
      (let* ((_timeo175150_ (std/misc/timeout#make-timeout__0 _timeo175147_))
             (_ws175151175163_ _ws175146_)
             (_E175153175167_
              (lambda () (error '"No clause matching" _ws175151175163_)))
             (_K175154175210_
              (lambda (_cv175170_ _mx175171_ _q175172_)
                (let _lp175174_ ()
                  (mutex-lock! _mx175171_)
                  (if (not (std/misc/queue#queue-empty? _q175172_))
                      (let* ((_g175176175183_
                              (std/misc/queue#dequeue!__0 _q175172_))
                             (_E175178175187_
                              (lambda ()
                                (error '"No clause matching" _g175176175183_)))
                             (_K175179175193_
                              (lambda (_data175190_ _type175191_)
                                (mutex-unlock! _mx175171_)
                                (values _data175190_ _type175191_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _g175176175183_))
                            (let ((_hd175180175196_
                                   (let ()
                                     (declare (not safe))
                                     (##car _g175176175183_)))
                                  (_tl175181175198_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _g175176175183_))))
                              (let* ((_type175201_ _hd175180175196_)
                                     (_data175203_ _tl175181175198_))
                                (_K175179175193_ _data175203_ _type175201_)))
                            (_E175178175187_)))
                      (let ((_$e175205_
                             (##direct-structure-ref
                              _ws175146_
                              '4
                              std/net/websocket#websocket::t
                              '#f)))
                        (if _$e175205_
                            ((lambda (_how175208_)
                               (mutex-unlock! _mx175171_)
                               (if _raise?175148_
                                   (std/error#raise-io-error
                                    'websocket-recv
                                    '"Websocket has been closed"
                                    _ws175146_
                                    _how175208_)
                                   '#!eof))
                             _$e175205_)
                            (if (mutex-unlock!
                                 _mx175171_
                                 _cv175170_
                                 _timeo175150_)
                                (_lp175174_)
                                (if _raise?175148_
                                    (std/error#raise-timeout
                                     'websocket-recv
                                     '"timeout"
                                     _ws175146_)
                                    '#f)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ws175151175163_
               'std/net/websocket#websocket::t))
            (let* ((_e175155175213_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '1)))
                   (_e175156175216_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '2)))
                   (_e175157175219_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '3)))
                   (_e175158175222_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '4)))
                   (_e175159175225_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '5)))
                   (_q175228_ _e175159175225_)
                   (_e175160175230_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '6)))
                   (_mx175233_ _e175160175230_)
                   (_e175161175235_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175151175163_ '7)))
                   (_cv175238_ _e175161175235_))
              (_K175154175210_ _cv175238_ _mx175233_ _q175228_))
            (_E175153175167_)))))
  (define std/net/websocket#websocket-recv__0
    (lambda (_ws175243_)
      (let* ((_timeo175245_ '#f) (_raise?175247_ '#t))
        (std/net/websocket#websocket-recv__%
         _ws175243_
         _timeo175245_
         _raise?175247_))))
  (define std/net/websocket#websocket-recv__1
    (lambda (_ws175249_ _timeo175250_)
      (let ((_raise?175252_ '#t))
        (std/net/websocket#websocket-recv__%
         _ws175249_
         _timeo175250_
         _raise?175252_))))
  (define std/net/websocket#websocket-recv
    (lambda _g302039_
      (let ((_g302038_ (let () (declare (not safe)) (##length _g302039_))))
        (cond ((let () (declare (not safe)) (##fx= _g302038_ 1))
               (apply std/net/websocket#websocket-recv__0 _g302039_))
              ((let () (declare (not safe)) (##fx= _g302038_ 2))
               (apply std/net/websocket#websocket-recv__1 _g302039_))
              ((let () (declare (not safe)) (##fx= _g302038_ 3))
               (apply std/net/websocket#websocket-recv__% _g302039_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-recv
                _g302039_))))))
  (define std/net/websocket#websocket-read__%
    (lambda (_ws175063_ _timeo175064_ _raise?175065_)
      (let* ((_g175066175079_
              (std/net/websocket#websocket-recv__%
               _ws175063_
               _timeo175064_
               _raise?175065_))
             (_E175070175083_
              (lambda () (error '"No clause matching" _g175066175079_))))
        (let ((_K175075175116_ (lambda (_data175114_) _data175114_))
              (_K175072175100_
               (lambda (_data175098_)
                 (std/text/utf8#utf8->string__0 _data175098_)))
              (_K175071175089_ (lambda (_r175087_) _r175087_)))
          (if (let ((__tmp302040
                     (if (let ()
                           (declare (not safe))
                           (##values? _g175066175079_))
                         (let ()
                           (declare (not safe))
                           (##vector-length _g175066175079_))
                         '1)))
                (declare (not safe))
                (##fx= __tmp302040 '2))
              (let* ((_e175076175119_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g175066175079_ '0)))
                     (_e175077175124_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g175066175079_ '1))))
                (if (let ()
                      (declare (not safe))
                      (##eq? _e175077175124_ 'binary))
                    (let ((_data175122_ _e175076175119_))
                      (_K175075175116_ _data175122_))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _e175077175124_ 'text))
                        (let ((_data175106_ _e175076175119_))
                          (std/text/utf8#utf8->string__0 _data175106_))
                        (let ((_r175092_ _g175066175079_))
                          (_K175071175089_ _r175092_)))))
              (let ((_r175092_ _g175066175079_))
                (_K175071175089_ _r175092_)))))))
  (define std/net/websocket#websocket-read__0
    (lambda (_ws175130_)
      (let* ((_timeo175132_ '#f) (_raise?175134_ '#f))
        (std/net/websocket#websocket-read__%
         _ws175130_
         _timeo175132_
         _raise?175134_))))
  (define std/net/websocket#websocket-read__1
    (lambda (_ws175136_ _timeo175137_)
      (let ((_raise?175139_ '#f))
        (std/net/websocket#websocket-read__%
         _ws175136_
         _timeo175137_
         _raise?175139_))))
  (define std/net/websocket#websocket-read
    (lambda _g302042_
      (let ((_g302041_ (let () (declare (not safe)) (##length _g302042_))))
        (cond ((let () (declare (not safe)) (##fx= _g302041_ 1))
               (apply std/net/websocket#websocket-read__0 _g302042_))
              ((let () (declare (not safe)) (##fx= _g302041_ 2))
               (apply std/net/websocket#websocket-read__1 _g302042_))
              ((let () (declare (not safe)) (##fx= _g302041_ 3))
               (apply std/net/websocket#websocket-read__% _g302042_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-read
                _g302042_))))))
  (define std/net/websocket#websocket-close__%__%
    (lambda (__174959174962_ _hard?174957174964_ _ws174966_ _how174967_)
      (let* ((_hard?174969_
              (if (eq? _hard?174957174964_ absent-value)
                  '#f
                  _hard?174957174964_))
             (_ws174970174982_ _ws174966_)
             (_E174972174986_
              (lambda () (error '"No clause matching" _ws174970174982_)))
             (_K174973174998_
              (lambda (_cv174989_
                       _mx174990_
                       _q174991_
                       _cs174992_
                       _writer174993_
                       _port174994_)
                (if _hard?174969_ (close-port _port174994_) '#!void)
                (if _cs174992_
                    '#!void
                    (begin
                      (mutex-lock! _mx174990_)
                      (if (##direct-structure-ref
                           _ws174966_
                           '4
                           std/net/websocket#websocket::t
                           '#f)
                          (mutex-unlock! _mx174990_)
                          (let ((_how174996_
                                 (if _hard?174969_ 'abort _how174967_)))
                            (##direct-structure-set!
                             _ws174966_
                             _how174996_
                             '4
                             std/net/websocket#websocket::t
                             '#f)
                            (thread-send
                             _writer174993_
                             (cons 'close _how174996_))
                            (condition-variable-broadcast! _cv174989_)
                            (mutex-unlock! _mx174990_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ws174970174982_
               'std/net/websocket#websocket::t))
            (let* ((_e174974175001_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '1)))
                   (_port175004_ _e174974175001_)
                   (_e174975175006_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '2)))
                   (_e174976175009_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '3)))
                   (_writer175012_ _e174976175009_)
                   (_e174977175014_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '4)))
                   (_cs175017_ _e174977175014_)
                   (_e174978175019_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '5)))
                   (_q175022_ _e174978175019_)
                   (_e174979175024_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '6)))
                   (_mx175027_ _e174979175024_)
                   (_e174980175029_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174970174982_ '7)))
                   (_cv175032_ _e174980175029_))
              (_K174973174998_
               _cv175032_
               _mx175027_
               _q175022_
               _cs175017_
               _writer175012_
               _port175004_))
            (_E174972174986_)))))
  (define std/net/websocket#websocket-close__%__0
    (lambda (__174959175037_ _hard?174957175038_ _ws175039_)
      (let ((_how175041_ '1000))
        (std/net/websocket#websocket-close__%__%
         __174959175037_
         _hard?174957175038_
         _ws175039_
         _how175041_))))
  (define std/net/websocket#websocket-close__%
    (lambda _g302044_
      (let ((_g302043_ (let () (declare (not safe)) (##length _g302044_))))
        (cond ((let () (declare (not safe)) (##fx= _g302043_ 3))
               (apply std/net/websocket#websocket-close__%__0 _g302044_))
              ((let () (declare (not safe)) (##fx= _g302043_ 4))
               (apply std/net/websocket#websocket-close__%__% _g302044_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-close__%
                _g302044_))))))
  (define std/net/websocket#websocket-close__@
    (lambda (_keys174956175051_ . _args175053_)
      (apply std/net/websocket#websocket-close__%
             _keys174956175051_
             (table-ref _keys174956175051_ 'hard: absent-value)
             _args175053_)))
  (define std/net/websocket#websocket-close
    (lambda _args174958175059_
      (apply keyword-dispatch
             '#(hard:)
             std/net/websocket#websocket-close__@
             _args174958175059_)))
  (define std/net/websocket#max-frame-size (expt '2 '20))
  (define std/net/websocket#max-message-size (expt '2 '20))
  (define std/net/websocket#set-websocket-max-frame-size!
    (lambda (_sz174953_) (set! std/net/websocket#max-frame-size _sz174953_)))
  (define std/net/websocket#set-websocket-max-message-size!
    (lambda (_sz174951_) (set! std/net/websocket#max-message-size _sz174951_)))
  (define std/net/websocket#websocket-reader
    (lambda (_ws174754_)
      (letrec* ((_buf174756_ (make-u8vector '1024))
                (_skip-to-eof174757_
                 (lambda (_port174942_)
                   (let ((_len174944_ (u8vector-length _buf174756_)))
                     (let _lp174946_ ()
                       (let ((_rd174949_
                              (read-subu8vector
                               _buf174756_
                               '0
                               _len174944_
                               _port174942_)))
                         (if (let ()
                               (declare (not safe))
                               (##fx= _len174944_ _rd174949_))
                             (_lp174946_)
                             '#!void))))))
                (_skip-payload174758_
                 (lambda (_port174926_ _plen174927_)
                   (let ((_len174929_ (u8vector-length _buf174756_)))
                     (let _lp174931_ ((_need174933_ _plen174927_))
                       (let ((_$e174935_
                              (let ()
                                (declare (not safe))
                                (##fxzero? _need174933_))))
                         (if _$e174935_
                             _$e174935_
                             (if (let ()
                                   (declare (not safe))
                                   (##fx<= _need174933_ _len174929_))
                                 (let ((_rd174938_
                                        (read-subu8vector
                                         _buf174756_
                                         '0
                                         _need174933_
                                         _port174926_)))
                                   (if (let ()
                                         (declare (not safe))
                                         (##fx< _rd174938_ _need174933_))
                                       (_read-eof174763_)
                                       '#!void))
                                 (let ((_rd174940_
                                        (read-subu8vector
                                         _buf174756_
                                         '0
                                         _len174929_
                                         _port174926_)))
                                   (if (let ()
                                         (declare (not safe))
                                         (##fx< _rd174940_ _len174929_))
                                       (_read-eof174763_)
                                       (_lp174931_
                                        (let ()
                                          (declare (not safe))
                                          (##fx- _need174933_
                                                 _len174929_))))))))))))
                (_read-header174759_
                 (lambda (_port174917_)
                   (let* ((_b0174919_ (read-u8 _port174917_))
                          (_g302045_
                           (if (eof-object? _b0174919_)
                               (_read-eof174763_)
                               '#!void))
                          (_b1174922_ (read-u8 _port174917_))
                          (_g302046_
                           (if (eof-object? _b1174922_)
                               (_read-eof174763_)
                               '#!void)))
                     (values (let ()
                               (declare (not safe))
                               (##fxand _b0174919_ '128))
                             (let ()
                               (declare (not safe))
                               (##fxand _b0174919_ '15))
                             (let ()
                               (declare (not safe))
                               (##fxand _b1174922_ '128))
                             (let ()
                               (declare (not safe))
                               (##fxand _b1174922_ '127))))))
                (_read-payload174760_
                 (lambda (_port174909_ _plen174910_)
                   (if (let () (declare (not safe)) (##fxzero? _plen174910_))
                       '#u8()
                       (let* ((_data174912_ (make-u8vector _plen174910_))
                              (_rd174914_
                               (read-subu8vector
                                _data174912_
                                '0
                                _plen174910_
                                _port174909_)))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _rd174914_ _plen174910_))
                             (_read-eof174763_)
                             _data174912_)))))
                (_read-u16174761_
                 (lambda (_port174900_)
                   (let* ((_b0174902_ (read-u8 _port174900_))
                          (_g302047_
                           (if (eof-object? _b0174902_)
                               (_read-eof174763_)
                               '#!void))
                          (_b1174905_ (read-u8 _port174900_))
                          (_g302048_
                           (if (eof-object? _b1174905_)
                               (_read-eof174763_)
                               '#!void)))
                     (let ((__tmp302049
                            (let ()
                              (declare (not safe))
                              (##fxarithmetic-shift _b0174902_ '8))))
                       (declare (not safe))
                       (##fxior __tmp302049 _b1174905_)))))
                (_read-u64174762_
                 (lambda (_port174891_)
                   (let ((_rd174893_
                          (read-subu8vector _buf174756_ '0 '8 _port174891_)))
                     (if (let () (declare (not safe)) (##fx= _rd174893_ '8))
                         (let _lp174895_ ((_k174897_ '0) (_r174898_ '0))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _k174897_ '8))
                               (_lp174895_
                                (let ()
                                  (declare (not safe))
                                  (##fx+ _k174897_ '1))
                                (bitwise-ior
                                 (arithmetic-shift _r174898_ '8)
                                 (let ()
                                   (declare (not safe))
                                   (##u8vector-ref _buf174756_ _k174897_))))
                               _r174898_))
                         (_read-eof174763_)))))
                (_read-eof174763_ (lambda () (raise 'eof))))
        (let* ((_ws174764174776_ _ws174754_)
               (_E174766174780_
                (lambda () (error '"No clause matching" _ws174764174776_)))
               (_K174767174856_
                (lambda (_cv174783_
                         _mx174784_
                         _q174785_
                         _writer174786_
                         _port174787_)
                  (letrec ((_receive174789_
                            (lambda (_type174853_ _data174854_)
                              (mutex-lock! _mx174784_)
                              (if (##direct-structure-ref
                                   _ws174754_
                                   '4
                                   std/net/websocket#websocket::t
                                   '#f)
                                  (begin
                                    (mutex-unlock! _mx174784_)
                                    (raise 'abort))
                                  (begin
                                    (std/misc/queue#enqueue!
                                     _q174785_
                                     (cons _type174853_ _data174854_))
                                    (condition-variable-broadcast! _cv174783_)
                                    (mutex-unlock! _mx174784_))))))
                    (with-unwind-protect
                     (lambda ()
                       (with-exception-catcher
                        (lambda (_g174790174793_)
                          (if '#t
                              (let ((_e174796_ _g174790174793_))
                                (let ((_$e174798_ _e174796_))
                                  (if (eq? 'eof _$e174798_)
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174754_
                                       'eof)
                                      (if (eq? 'abort _$e174798_)
                                          '#!void
                                          (begin
                                            (std/net/websocket#errorf
                                             '"unhandled exception: ~a"
                                             _e174796_)
                                            (std/net/websocket#websocket-close__%__%
                                             '#f
                                             absent-value
                                             _ws174754_
                                             'abort)
                                            (raise _e174796_)))))
                                _e174796_)
                              (raise _g174790174793_)))
                        (lambda ()
                          (let _lp174802_ ((_type174804_ '#f)
                                           (_frags174805_ '()))
                            (let ((_g302050_
                                   (_read-header174759_ _port174787_)))
                              (begin
                                (let ((_g302051_
                                       (let ()
                                         (declare (not safe))
                                         (if (##values? _g302050_)
                                             (##vector-length _g302050_)
                                             1))))
                                  (if (not (let ()
                                             (declare (not safe))
                                             (##fx= _g302051_ 4)))
                                      (error "Context expects 4 values"
                                             _g302051_)))
                                (let ((_fin174807_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302050_ 0)))
                                      (_opcode174808_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302050_ 1)))
                                      (_mask174809_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302050_ 2)))
                                      (_plen174810_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302050_ 3))))
                                  (let ((_plen174815_
                                         (let ((_$e174812_ _plen174810_))
                                           (if (eq? '126 _$e174812_)
                                               (_read-u16174761_ _port174787_)
                                               (if (eq? '127 _$e174812_)
                                                   (_read-u64174762_
                                                    _port174787_)
                                                   _plen174810_)))))
                                    (if (not (let ()
                                               (declare (not safe))
                                               (##fxzero? _mask174809_)))
                                        (begin
                                          (std/net/websocket#warnf
                                           '"server sent masked frame; closing websocket connection")
                                          (std/net/websocket#websocket-close__%__%
                                           '#f
                                           absent-value
                                           _ws174754_
                                           '1002)
                                          (_skip-to-eof174757_ _port174787_))
                                        (if (> _plen174815_
                                               std/net/websocket#max-frame-size)
                                            (begin
                                              (std/net/websocket#warnf
                                               '"frame size ~a exceeds max frame size; closing websocket connection"
                                               _plen174815_)
                                              (std/net/websocket#websocket-close__%__%
                                               '#f
                                               absent-value
                                               _ws174754_
                                               '1009)
                                              (_skip-to-eof174757_
                                               _port174787_))
                                            (let ((_$e174818_ _opcode174808_))
                                              (let ((_default174820174824_
                                                     (lambda ()
                                                       (std/net/websocket#warnf
                                                        '"unexpected frame ~x from server; closing websocket connection"
                                                        _opcode174808_)
                                                       (std/net/websocket#websocket-close__%__%
                                                        '#f
                                                        absent-value
                                                        _ws174754_
                                                        '1002)
                                                       (_skip-to-eof174757_
                                                        _port174787_)))
                                                    (_table174821174826_
                                                     '#(0
                                                        1
                                                        1
                                                        #f
                                                        #f
                                                        #f
                                                        #f
                                                        #f
                                                        2
                                                        3
                                                        4)))
                                                (if (fixnum? _$e174818_)
                                                    (if (and (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##fx>= _$e174818_ '0))
                     (let () (declare (not safe)) (##fx< _$e174818_ '11)))
                (let ((_x174829_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _table174821174826_ _$e174818_))))
                  (if _x174829_
                      (if (let () (declare (not safe)) (##fx< _x174829_ '2))
                          (if (let ()
                                (declare (not safe))
                                (##fx= _x174829_ '0))
                              (let ((_dlen174832_
                                     (foldl1 ##fx+
                                             _plen174815_
                                             (map u8vector-length
                                                  _frags174805_))))
                                (if (not _type174804_)
                                    (begin
                                      (std/net/websocket#warnf
                                       '"unexpected continuation frame from server; closing websocket connection")
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174754_
                                       '1002)
                                      (_skip-to-eof174757_ _port174787_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##fx> _dlen174832_
                                                 std/net/websocket#max-message-size))
                                        (begin
                                          (std/net/websocket#warnf
                                           '"message length ~a exceeds max message size; closing websocket connection"
                                           _dlen174832_)
                                          (std/net/websocket#websocket-close__%__%
                                           '#f
                                           absent-value
                                           _ws174754_
                                           '1009)
                                          (_skip-to-eof174757_ _port174787_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##fxzero? _fin174807_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##fxzero? _plen174815_))
                                                (_lp174802_
                                                 _type174804_
                                                 _frags174805_)
                                                (let ((_data174834_
                                                       (_read-payload174760_
                                                        _port174787_
                                                        _plen174815_)))
                                                  (_lp174802_
                                                   _type174804_
                                                   (cons _data174834_
                                                         _frags174805_))))
                                            (let* ((_data174836_
                                                    (_read-payload174760_
                                                     _port174787_
                                                     _plen174815_))
                                                   (_message174838_
                                                    (u8vector-concatenate
                                                     (reverse (cons _data174836_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _frags174805_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_receive174789_
                                               _type174804_
                                               _message174838_)
                                              (_lp174802_ '#f '()))))))
                              (let ((_xtype174841_
                                     (if (let ()
                                           (declare (not safe))
                                           (##fx= _opcode174808_ '1))
                                         'text
                                         'binary)))
                                (if _type174804_
                                    (begin
                                      (std/net/websocket#warnf
                                       '"unexpected frame ~x from server; closing websocket connection"
                                       _opcode174808_)
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174754_
                                       '1002)
                                      (_skip-to-eof174757_ _port174787_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##fxzero? _fin174807_))
                                        (let ((_data174843_
                                               (_read-payload174760_
                                                _port174787_
                                                _plen174815_)))
                                          (_lp174802_
                                           _xtype174841_
                                           (cons _data174843_ '())))
                                        (let ((_data174845_
                                               (_read-payload174760_
                                                _port174787_
                                                _plen174815_)))
                                          (_receive174789_
                                           _xtype174841_
                                           _data174845_)
                                          (_lp174802_ '#f '()))))))
                          (if (let ()
                                (declare (not safe))
                                (##fx= _x174829_ '2))
                              (let ((_how174847_
                                     (_read-u16174761_ _port174787_)))
                                (std/net/websocket#websocket-close__%__%
                                 '#f
                                 absent-value
                                 _ws174754_
                                 _how174847_)
                                (_skip-to-eof174757_ _port174787_))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x174829_ '3))
                                  (let ((_data174849_
                                         (_read-payload174760_
                                          _port174787_
                                          _plen174815_)))
                                    (thread-send
                                     _writer174786_
                                     (cons 'pong _data174849_))
                                    (_lp174802_ _type174804_ _frags174805_))
                                  (begin
                                    (_skip-payload174758_
                                     _port174787_
                                     _plen174815_)
                                    (_lp174802_ _type174804_ _frags174805_)))))
                      (_default174820174824_)))
                (_default174820174824_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_default174820174824_))))))))))))))
                     (lambda ()
                       (with-exception-catcher
                        void
                        (lambda () (close-input-port _port174787_)))))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _ws174764174776_
                 'std/net/websocket#websocket::t))
              (let* ((_e174768174859_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '1)))
                     (_port174862_ _e174768174859_)
                     (_e174769174864_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '2)))
                     (_e174770174867_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '3)))
                     (_writer174870_ _e174770174867_)
                     (_e174771174872_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '4)))
                     (_e174772174875_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '5)))
                     (_q174878_ _e174772174875_)
                     (_e174773174880_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '6)))
                     (_mx174883_ _e174773174880_)
                     (_e174774174885_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174764174776_ '7)))
                     (_cv174888_ _e174774174885_))
                (_K174767174856_
                 _cv174888_
                 _mx174883_
                 _q174878_
                 _writer174870_
                 _port174862_))
              (_E174766174780_))))))
  (define std/net/websocket#websocket-writer
    (lambda (_ws174562_)
      (letrec* ((_buf174564_ (make-u8vector '65535))
                (_mask-bytes174565_ (make-u8vector '4))
                (_write-u16174566_
                 (lambda (_plen174751_ _port174752_)
                   (write-u8
                    (let ((__tmp302052
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _plen174751_ '-8))))
                      (declare (not safe))
                      (##fxand __tmp302052 '255))
                    _port174752_)
                   (write-u8
                    (let () (declare (not safe)) (##fxand _plen174751_ '255))
                    _port174752_)))
                (_write-payload174567_
                 (lambda (_mask174740_
                          _data174741_
                          _start174742_
                          _end174743_
                          _port174744_)
                   (let _lp174746_ ((_k174748_ _start174742_) (_x174749_ '0))
                     (if (let ()
                           (declare (not safe))
                           (##fx< _k174748_ _end174743_))
                         (begin
                           (let ((__tmp302053
                                  (let ((__tmp302056
                                         (let ()
                                           (declare (not safe))
                                           (##u8vector-ref
                                            _data174741_
                                            _k174748_)))
                                        (__tmp302054
                                         (let ((__tmp302055
                                                (let ()
                                                  (declare (not safe))
                                                  (##fxmodulo _x174749_ '4))))
                                           (declare (not safe))
                                           (##u8vector-ref
                                            _mask174740_
                                            __tmp302055))))
                                    (declare (not safe))
                                    (##fxxor __tmp302056 __tmp302054))))
                             (declare (not safe))
                             (##u8vector-set!
                              _buf174564_
                              _x174749_
                              __tmp302053))
                           (_lp174746_
                            (let () (declare (not safe)) (##fx+ _k174748_ '1))
                            (let ()
                              (declare (not safe))
                              (##fx+ _x174749_ '1))))
                         (write-subu8vector
                          _buf174564_
                          '0
                          _x174749_
                          _port174744_)))))
                (_send-frame174568_
                 (lambda (_port174722_
                          _fin174723_
                          _opcode174724_
                          _data174725_
                          _start174726_
                          _end174727_)
                   (let* ((_plen174729_
                           (let ()
                             (declare (not safe))
                             (##fx- _end174727_ _start174726_)))
                          (_fin174731_
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _fin174723_ '7)))
                          (_b0174733_
                           (let ()
                             (declare (not safe))
                             (##fxior _fin174731_ _opcode174724_)))
                          (_mask174735_
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift '1 '7)))
                          (_b1174737_
                           (let ((__tmp302057
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _plen174729_ '126))
                                      _plen174729_
                                      '126)))
                             (declare (not safe))
                             (##fxior _mask174735_ __tmp302057))))
                     (std/crypto/etc#random-bytes!__0 _mask-bytes174565_)
                     (write-u8 _b0174733_ _port174722_)
                     (write-u8 _b1174737_ _port174722_)
                     (if (let ()
                           (declare (not safe))
                           (##fx< _plen174729_ '126))
                         '#!void
                         (_write-u16174566_ _plen174729_ _port174722_))
                     (write-subu8vector _mask-bytes174565_ '0 '4 _port174722_)
                     (_write-payload174567_
                      _mask-bytes174565_
                      _data174725_
                      _start174726_
                      _end174727_
                      _port174722_)
                     (force-output _port174722_))))
                (_send174569_
                 (lambda (_port174707_ _opcode174708_ _data174709_)
                   (let ((_end174711_ (u8vector-length _data174709_)))
                     (let _lp174713_ ((_start174715_ '0)
                                      (_opcode174716_ _opcode174708_))
                       (let ((_have174718_
                              (let ()
                                (declare (not safe))
                                (##fx- _end174711_ _start174715_))))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _have174718_ '65536))
                             (_send-frame174568_
                              _port174707_
                              '1
                              _opcode174716_
                              _data174709_
                              _start174715_
                              _end174711_)
                             (let ((_xend174720_
                                    (let ()
                                      (declare (not safe))
                                      (##fx+ _start174715_ '65535))))
                               (_send-frame174568_
                                _port174707_
                                '0
                                _opcode174716_
                                _data174709_
                                _start174715_
                                _xend174720_)
                               (_lp174713_ _xend174720_ '0)))))))))
        (let* ((_ws174570174576_ _ws174562_)
               (_E174572174580_
                (lambda () (error '"No clause matching" _ws174570174576_)))
               (_K174573174699_
                (lambda (_port174583_)
                  (with-unwind-protect
                   (lambda ()
                     (with-exception-catcher
                      (lambda (_g174584174587_)
                        (if '#t
                            (let ((_e174590_ _g174584174587_))
                              (std/net/websocket#errorf
                               '"unhandled exception: ~a"
                               _e174590_)
                              (std/net/websocket#websocket-close__%__%
                               '#f
                               absent-value
                               _ws174562_
                               'abort)
                              (with-exception-catcher
                               void
                               (lambda () (close-port _port174583_))))
                            (raise _g174584174587_)))
                      (lambda ()
                        (let _lp174594_ ()
                          (let* ((_g174596174617_ (thread-receive))
                                 (_E174602174621_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g174596174617_))))
                            (let ((_K174613174687_
                                   (lambda (_data174685_)
                                     (_send174569_
                                      _port174583_
                                      '1
                                      _data174685_)
                                     (_lp174594_)))
                                  (_K174610174672_
                                   (lambda (_data174670_)
                                     (_send174569_
                                      _port174583_
                                      '2
                                      _data174670_)
                                     (_lp174594_)))
                                  (_K174607174656_
                                   (lambda (_data174654_)
                                     (_send174569_
                                      _port174583_
                                      '10
                                      _data174654_)
                                     (_lp174594_)))
                                  (_K174604174640_
                                   (lambda (_how174636_)
                                     (if (fixnum? _how174636_)
                                         (let ((_bytes174638_
                                                (make-u8vector '2)))
                                           (let ((__tmp302058
                                                  (let ((__tmp302059
                                                         (let ()
                                                           (declare (not safe))
                                                           (##fxarithmetic-shift
                                                            _how174636_
                                                            '-8))))
                                                    (declare (not safe))
                                                    (##fxand __tmp302059
                                                             '255))))
                                             (declare (not safe))
                                             (##u8vector-set!
                                              _bytes174638_
                                              '0
                                              __tmp302058))
                                           (let ((__tmp302060
                                                  (let ()
                                                    (declare (not safe))
                                                    (##fxand _how174636_
                                                             '255))))
                                             (declare (not safe))
                                             (##u8vector-set!
                                              _bytes174638_
                                              '1
                                              __tmp302060))
                                           (_send174569_
                                            _port174583_
                                            '8
                                            _bytes174638_))
                                         '#!void)))
                                  (_K174603174627_
                                   (lambda (_bogus174625_)
                                     (std/net/websocket#warnf
                                      '"unexpected message ~a"
                                      _bogus174625_)
                                     (_lp174594_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _g174596174617_))
                                  (let ((_tl174615174692_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g174596174617_)))
                                        (_hd174614174690_
                                         (let ()
                                           (declare (not safe))
                                           (##car _g174596174617_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _hd174614174690_ 'text))
                                        (let ((_data174695_ _tl174615174692_))
                                          (_K174613174687_ _data174695_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _hd174614174690_ 'binary))
                                            (let ((_data174680_
                                                   _tl174615174692_))
                                              (_K174610174672_ _data174680_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##eq? _hd174614174690_
                                                         'pong))
                                                (let ((_data174664_
                                                       _tl174615174692_))
                                                  (_K174607174656_
                                                   _data174664_))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _hd174614174690_
                                                             'close))
                                                    (let ((_how174648_
                                                           _tl174615174692_))
                                                      (_K174604174640_
                                                       _how174648_))
                                                    (let ((_bogus174630_
                                                           _g174596174617_))
                                                      (_K174603174627_
                                                       _bogus174630_)))))))
                                  (let ((_bogus174630_ _g174596174617_))
                                    (_K174603174627_ _bogus174630_)))))))))
                   (lambda ()
                     (with-exception-catcher
                      void
                      (lambda () (close-output-port _port174583_))))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _ws174570174576_
                 'std/net/websocket#websocket::t))
              (let* ((_e174574174702_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174570174576_ '1)))
                     (_port174705_ _e174574174702_))
                (_K174573174699_ _port174705_))
              (_E174572174580_)))))))
