(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/flock#flock
    (lambda (_raw198059_ _op198060_)
      (let ((_fd198062_
             (if (std/os/fd#fd? _raw198059_)
                 (std/os/fd#fd-e _raw198059_)
                 _raw198059_))
            (_op198063_ (fxior _op198060_ std/os/flock#LOCK_NB)))
        (let _lp198065_ ()
          (let ((_r198069_ (std/os/flock#_flock _fd198062_ _op198063_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198069_)))
                _r198069_
                (let ((_errno198072_
                       (let () (declare (not safe)) (##fx- _r198069_))))
                  (if (or (eq? _errno198072_ std/os/error#EAGAIN)
                          (eq? _errno198072_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno198072_ std/os/error#EINTR)
                          (_lp198065_)
                          (std/os/error#raise-os-error
                           _errno198072_
                           std/os/flock#flock
                           _raw198059_
                           _op198063_))))))))))
  (define std/os/flock#flock/block__%
    (lambda (_raw-or-fd198038_ _op198039_ _timeout198040_)
      (letrec* ((_deadline198042_
                 (if (not _timeout198040_)
                     '#f
                     (if (time? _timeout198040_)
                         (time->seconds _timeout198040_)
                         (if (real? _timeout198040_)
                             (+ (let ()
                                  (declare (not safe))
                                  (##current-time-point))
                                _timeout198040_)
                             (error '"Bad argument; expected real, time or #f"
                                    _timeout198040_))))))
        (let _lp198044_ ()
          (if (std/os/flock#flock _raw-or-fd198038_ _op198039_)
              '#!void
              (begin
                (if _deadline198042_
                    (if (< _deadline198042_
                           (let ()
                             (declare (not safe))
                             (##current-time-point)))
                        '#!void
                        (std/error#raise-timeout
                         'flock
                         '"Deadline for flock operation exceeded"
                         _raw-or-fd198038_
                         _op198039_))
                    '#!void)
                (thread-sleep! (random-real))
                (_lp198044_)))))))
  (define std/os/flock#flock/block__0
    (lambda (_raw-or-fd198050_ _op198051_)
      (let ((_timeout198053_ '#f))
        (std/os/flock#flock/block__%
         _raw-or-fd198050_
         _op198051_
         _timeout198053_))))
  (define std/os/flock#flock/block
    (lambda _g300993_
      (let ((_g300992_ (let () (declare (not safe)) (##length _g300993_))))
        (cond ((let () (declare (not safe)) (##fx= _g300992_ 2))
               (apply std/os/flock#flock/block__0 _g300993_))
              ((let () (declare (not safe)) (##fx= _g300992_ 3))
               (apply std/os/flock#flock/block__% _g300993_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#flock/block
                _g300993_))))))
  (define std/os/flock#open-input-file/lock__%__%
    (lambda (__197991197994_
             _op197988197996_
             _flags197989197998_
             _path198000_
             _timeout198001_)
      (let* ((_op198003_
              (if (eq? _op197988197996_ absent-value)
                  std/os/flock#LOCK_SH
                  _op197988197996_))
             (_flags198005_
              (if (eq? _flags197989197998_ absent-value)
                  std/os/fcntl#O_RDONLY
                  _flags197989197998_)))
        (std/os/flock#open-file/lock__%__%
         '#f
         'in
         _flags198005_
         '0
         _path198000_
         _op198003_
         _timeout198001_))))
  (define std/os/flock#open-input-file/lock__%__0
    (lambda (__197991198010_ _op197988198011_ _flags197989198012_ _path198013_)
      (let ((_timeout198015_ '#f))
        (std/os/flock#open-input-file/lock__%__%
         __197991198010_
         _op197988198011_
         _flags197989198012_
         _path198013_
         _timeout198015_))))
  (define std/os/flock#open-input-file/lock__%
    (lambda _g300995_
      (let ((_g300994_ (let () (declare (not safe)) (##length _g300995_))))
        (cond ((let () (declare (not safe)) (##fx= _g300994_ 4))
               (apply std/os/flock#open-input-file/lock__%__0 _g300995_))
              ((let () (declare (not safe)) (##fx= _g300994_ 5))
               (apply std/os/flock#open-input-file/lock__%__% _g300995_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-input-file/lock__%
                _g300995_))))))
  (define std/os/flock#open-input-file/lock__@
    (lambda (_keys197987198026_ . _args198028_)
      (apply std/os/flock#open-input-file/lock__%
             _keys197987198026_
             (table-ref _keys197987198026_ 'op: absent-value)
             (table-ref _keys197987198026_ 'flags: absent-value)
             _args198028_)))
  (define std/os/flock#open-input-file/lock
    (lambda _args197990198034_
      (apply keyword-dispatch
             '#(flags: #f op: #f)
             std/os/flock#open-input-file/lock__@
             _args197990198034_)))
  (define std/os/flock#open-output-file/lock__%__%
    (lambda (__197934197937_
             _op197930197939_
             _flags197931197941_
             _mode197932197943_
             _path197945_
             _timeout197946_)
      (let* ((_op197948_
              (if (eq? _op197930197939_ absent-value)
                  std/os/flock#LOCK_EX
                  _op197930197939_))
             (_flags197950_
              (if (eq? _flags197931197941_ absent-value)
                  (fxior std/os/fcntl#O_WRONLY std/os/fcntl#O_CREAT)
                  _flags197931197941_))
             (_mode197952_
              (if (eq? _mode197932197943_ absent-value)
                  std/os/fdio#S_IRWXU
                  _mode197932197943_)))
        (std/os/flock#open-file/lock__%__%
         '#f
         'out
         _flags197950_
         _mode197952_
         _path197945_
         _op197948_
         _timeout197946_))))
  (define std/os/flock#open-output-file/lock__%__0
    (lambda (__197934197957_
             _op197930197958_
             _flags197931197959_
             _mode197932197960_
             _path197961_)
      (let ((_timeout197963_ '#f))
        (std/os/flock#open-output-file/lock__%__%
         __197934197957_
         _op197930197958_
         _flags197931197959_
         _mode197932197960_
         _path197961_
         _timeout197963_))))
  (define std/os/flock#open-output-file/lock__%
    (lambda _g300997_
      (let ((_g300996_ (let () (declare (not safe)) (##length _g300997_))))
        (cond ((let () (declare (not safe)) (##fx= _g300996_ 5))
               (apply std/os/flock#open-output-file/lock__%__0 _g300997_))
              ((let () (declare (not safe)) (##fx= _g300996_ 6))
               (apply std/os/flock#open-output-file/lock__%__% _g300997_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-output-file/lock__%
                _g300997_))))))
  (define std/os/flock#open-output-file/lock__@
    (lambda (_keys197929197975_ . _args197977_)
      (apply std/os/flock#open-output-file/lock__%
             _keys197929197975_
             (table-ref _keys197929197975_ 'op: absent-value)
             (table-ref _keys197929197975_ 'flags: absent-value)
             (table-ref _keys197929197975_ 'mode: absent-value)
             _args197977_)))
  (define std/os/flock#open-output-file/lock
    (lambda _args197933197983_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                mode:
                #f
                flags:
                #f
                #f
                #f
                #f
                #f
                #f
                op:
                #f)
             std/os/flock#open-output-file/lock__@
             _args197933197983_)))
  (define std/os/flock#open-file/lock__%__%
    (lambda (__197859197862_
             _dir197855197864_
             _flags197856197866_
             _mode197857197868_
             _path197870_
             _op197871_
             _timeout197872_)
      (let* ((_dir197874_
              (if (eq? _dir197855197864_ absent-value)
                  (error '"Missing required keyword argument" 'direction:)
                  _dir197855197864_))
             (_flags197876_
              (if (eq? _flags197856197866_ absent-value)
                  (error '"Missing required keyword argument" 'flags:)
                  _flags197856197866_))
             (_mode197878_
              (if (eq? _mode197857197868_ absent-value)
                  (error '"Missing required keyword argument" 'mode:)
                  _mode197857197868_))
             (_fd197880_
              (std/os/flock#open/lock__%__%
               '#f
               _flags197876_
               _mode197878_
               _path197870_
               _op197871_
               _timeout197872_))
             (_port197882_
              (std/os/fd#fdopen-port _fd197880_ _dir197874_ _path197870_))
             (_close-it197884_ (macro-port-close _port197882_))
             (_unlocked?197886_ '#f))
        (letrec ((_close197889_
                  (lambda (_port197891_ . _args197892_)
                    (if _unlocked?197886_
                        '#!void
                        (begin
                          (std/os/flock#flock _fd197880_ std/os/flock#LOCK_UN)
                          (set! _unlocked?197886_ '#t)))
                    (apply _close-it197884_ _port197891_ _args197892_))))
          (macro-port-close-set! _port197882_ _close197889_)
          _port197882_))))
  (define std/os/flock#open-file/lock__%__0
    (lambda (__197859197897_
             _dir197855197898_
             _flags197856197899_
             _mode197857197900_
             _path197901_
             _op197902_)
      (let ((_timeout197904_ '#f))
        (std/os/flock#open-file/lock__%__%
         __197859197897_
         _dir197855197898_
         _flags197856197899_
         _mode197857197900_
         _path197901_
         _op197902_
         _timeout197904_))))
  (define std/os/flock#open-file/lock__%
    (lambda _g300999_
      (let ((_g300998_ (let () (declare (not safe)) (##length _g300999_))))
        (cond ((let () (declare (not safe)) (##fx= _g300998_ 6))
               (apply std/os/flock#open-file/lock__%__0 _g300999_))
              ((let () (declare (not safe)) (##fx= _g300998_ 7))
               (apply std/os/flock#open-file/lock__%__% _g300999_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-file/lock__%
                _g300999_))))))
  (define std/os/flock#open-file/lock__@
    (lambda (_keys197854197917_ . _args197919_)
      (apply std/os/flock#open-file/lock__%
             _keys197854197917_
             (table-ref _keys197854197917_ 'direction: absent-value)
             (table-ref _keys197854197917_ 'flags: absent-value)
             (table-ref _keys197854197917_ 'mode: absent-value)
             _args197919_)))
  (define std/os/flock#open-file/lock
    (lambda _args197858197925_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                mode:
                #f
                flags:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                direction:)
             std/os/flock#open-file/lock__@
             _args197858197925_)))
  (define std/os/flock#open/lock__%__%
    (lambda (__197789197792_
             _flags197786197794_
             _mode197787197796_
             _path197798_
             _op197799_
             _timeout197800_)
      (let* ((_flags197802_
              (if (eq? _flags197786197794_ absent-value)
                  (error '"Missing required keyword argument" 'flags:)
                  _flags197786197794_))
             (_mode197804_
              (if (eq? _mode197787197796_ absent-value)
                  (error '"Missing required keyword argument" 'mode:)
                  _mode197787197796_))
             (_flags197806_ _flags197802_)
             (_fd197811_
              (let ((_r197808_
                     (std/os/fdio#_open
                      _path197798_
                      _flags197806_
                      _mode197804_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r197808_)))
                    _r197808_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r197808_))
                     std/os/fdio#open
                     _path197798_
                     _flags197806_
                     _mode197804_)))))
        (std/os/fcntl#fd-set-nonblock/closeonexec _fd197811_)
        (with-exception-catcher
         (lambda (_g197813197815_)
           (if '#t
               (let ((_e197818_ _g197813197815_))
                 (std/os/fdio#_close _fd197811_)
                 (raise _e197818_))
               (raise _g197813197815_)))
         (lambda ()
           (std/os/flock#flock/block__%
            _fd197811_
            _op197799_
            _timeout197800_)))
        _fd197811_)))
  (define std/os/flock#open/lock__%__0
    (lambda (__197789197824_
             _flags197786197825_
             _mode197787197826_
             _path197827_
             _op197828_)
      (let ((_timeout197830_ '#f))
        (std/os/flock#open/lock__%__%
         __197789197824_
         _flags197786197825_
         _mode197787197826_
         _path197827_
         _op197828_
         _timeout197830_))))
  (define std/os/flock#open/lock__%
    (lambda _g301001_
      (let ((_g301000_ (let () (declare (not safe)) (##length _g301001_))))
        (cond ((let () (declare (not safe)) (##fx= _g301000_ 5))
               (apply std/os/flock#open/lock__%__0 _g301001_))
              ((let () (declare (not safe)) (##fx= _g301000_ 6))
               (apply std/os/flock#open/lock__%__% _g301001_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open/lock__%
                _g301001_))))))
  (define std/os/flock#open/lock__@
    (lambda (_keys197785197842_ . _args197844_)
      (apply std/os/flock#open/lock__%
             _keys197785197842_
             (table-ref _keys197785197842_ 'flags: absent-value)
             (table-ref _keys197785197842_ 'mode: absent-value)
             _args197844_)))
  (define std/os/flock#open/lock
    (lambda _args197788197850_
      (apply keyword-dispatch
             '#(flags: mode: #f)
             std/os/flock#open/lock__@
             _args197788197850_)))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace ("std/os/flock#" LOCK_NB LOCK_UN LOCK_EX LOCK_SH _flock))
  (c-declare "#include <sys/file.h>")
  (define-const LOCK_SH)
  (define-const LOCK_EX)
  (define-const LOCK_UN)
  (define-const LOCK_NB)
  (namespace ("std/os/flock#" __flock))
  (define-c-lambda __flock (int int) int "flock")
  (define-with-errno _flock __flock (fd op))
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
