(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/133#nonneg-int?
    (lambda (_x100835_)
      (if (integer? _x100835_) (not (negative? _x100835_)) '#f)))
  (define std/srfi/133#between?
    (lambda (_x100831_ _y100832_ _z100833_)
      (if (< _x100831_ _y100832_) (<= _y100832_ _z100833_) '#f)))
  (define std/srfi/133#unspecified-value (lambda () (if '#f '#f '#!void)))
  (define std/srfi/133#vectors-ref
    (lambda (_vectors100825_ _i100826_)
      (map (lambda (_v100828_) (vector-ref _v100828_ _i100826_))
           _vectors100825_)))
  (define std/srfi/133#check-type
    (lambda (_pred?100821_ _value100822_ _callee100823_)
      (if (_pred?100821_ _value100822_)
          _value100822_
          (std/srfi/133#check-type
           _pred?100821_
           (error '"erroneous value"
                  (list _pred?100821_ _value100822_)
                  (cons 'while (cons 'calling (cons _callee100823_ '()))))
           _callee100823_))))
  (define std/srfi/133#check-index
    (lambda (_vec100815_ _index100816_ _callee100817_)
      (let ((_index100819_
             (std/srfi/133#check-type integer? _index100816_ _callee100817_)))
        (if (< _index100819_ '0)
            (std/srfi/133#check-index
             _vec100815_
             (error '"vector index too low"
                    _index100819_
                    (cons 'into (cons 'vector (cons _vec100815_ '())))
                    (cons 'while (cons 'calling (cons _callee100817_ '()))))
             _callee100817_)
            (if (>= _index100819_ (vector-length _vec100815_))
                (std/srfi/133#check-index
                 _vec100815_
                 (error '"vector index too high"
                        _index100819_
                        (cons 'into (cons 'vector (cons _vec100815_ '())))
                        (cons 'while
                              (cons 'calling (cons _callee100817_ '()))))
                 _callee100817_)
                _index100819_)))))
  (define std/srfi/133#check-indices
    (lambda (_vec100799_
             _start100800_
             _start-name100801_
             _end100802_
             _end-name100803_
             _callee100804_)
      (let ((_lose100808_
             (lambda _things100806_
               (apply error
                      '"vector range out of bounds"
                      (append _things100806_
                              (cons 'vector (cons 'was (cons _vec100799_ '())))
                              (cons _start-name100801_
                                    (cons 'was (cons _start100800_ '())))
                              (cons _end-name100803_
                                    (cons 'was (cons _end100802_ '())))
                              (cons 'while
                                    (cons 'calling
                                          (cons _callee100804_ '())))))))
            (_start100809_
             (std/srfi/133#check-type integer? _start100800_ _callee100804_))
            (_end100810_
             (std/srfi/133#check-type integer? _end100802_ _callee100804_)))
        (if (> _start100809_ _end100810_)
            (let ((_g289679_
                   (_lose100808_
                    (cons _end-name100803_
                          (cons '< (cons _start-name100801_ '()))))))
              (begin
                (let ((_g289680_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g289679_)
                             (##vector-length _g289679_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g289680_ 2)))
                      (error "Context expects 2 values" _g289680_)))
                (let ((_new-start100812_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g289679_ 0)))
                      (_new-end100813_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g289679_ 1))))
                  (std/srfi/133#check-indices
                   _vec100799_
                   _new-start100812_
                   _start-name100801_
                   _new-end100813_
                   _end-name100803_
                   _callee100804_))))
            (if (< _start100809_ '0)
                (std/srfi/133#check-indices
                 _vec100799_
                 (_lose100808_
                  (cons _start-name100801_ (cons '< (cons '0 '()))))
                 _start-name100801_
                 _end100810_
                 _end-name100803_
                 _callee100804_)
                (if (>= _start100809_ (vector-length _vec100799_))
                    (std/srfi/133#check-indices
                     _vec100799_
                     (_lose100808_
                      (cons _start-name100801_ (cons '> (cons 'len '())))
                      (cons 'len
                            (cons 'was
                                  (cons (vector-length _vec100799_) '()))))
                     _start-name100801_
                     _end100810_
                     _end-name100803_
                     _callee100804_)
                    (if (> _end100810_ (vector-length _vec100799_))
                        (std/srfi/133#check-indices
                         _vec100799_
                         _start100809_
                         _start-name100801_
                         (_lose100808_
                          (cons _end-name100803_ (cons '> (cons 'len '())))
                          (cons 'len
                                (cons 'was
                                      (cons (vector-length _vec100799_) '()))))
                         _end-name100803_
                         _callee100804_)
                        (values _start100809_ _end100810_))))))))
  (define std/srfi/133#vector-parse-start+end
    (lambda (_vec100791_
             _args100792_
             _start-name100793_
             _end-name100794_
             _callee100795_)
      (let ((_len100797_ (vector-length _vec100791_)))
        (if (null? _args100792_)
            (values '0 _len100797_)
            (if (null? (cdr _args100792_))
                (std/srfi/133#check-indices
                 _vec100791_
                 (car _args100792_)
                 _start-name100793_
                 _len100797_
                 _end-name100794_
                 _callee100795_)
                (if (null? (cddr _args100792_))
                    (std/srfi/133#check-indices
                     _vec100791_
                     (car _args100792_)
                     _start-name100793_
                     (cadr _args100792_)
                     _end-name100794_
                     _callee100795_)
                    (error '"too many arguments"
                           (cons 'extra
                                 (cons 'args
                                       (cons 'were
                                             (cons (cddr _args100792_) '()))))
                           (cons 'while
                                 (cons 'calling
                                       (cons _callee100795_ '()))))))))))
  (define std/srfi/133#%smallest-length
    (letrec ((_loop100785_
              (lambda (_vector-list100787_ _length100788_ _callee100789_)
                (if (null? _vector-list100787_)
                    _length100788_
                    (_loop100785_
                     (cdr _vector-list100787_)
                     (min (vector-length
                           (std/srfi/133#check-type
                            vector?
                            (car _vector-list100787_)
                            _callee100789_))
                          _length100788_)
                     _callee100789_)))))
      _loop100785_))
  (define std/srfi/133#%vector-copy!
    (letrec ((_loop/l->r100764_
              (lambda (_target100767_
                       _source100768_
                       _send100769_
                       _i100770_
                       _j100771_)
                (if (< _i100770_ _send100769_)
                    (begin
                      (vector-set!
                       _target100767_
                       _j100771_
                       (vector-ref _source100768_ _i100770_))
                      (_loop/l->r100764_
                       _target100767_
                       _source100768_
                       _send100769_
                       (+ _i100770_ '1)
                       (+ _j100771_ '1)))
                    '#!void)))
             (_loop/r->l100765_
              (lambda (_target100773_
                       _source100774_
                       _sstart100775_
                       _i100776_
                       _j100777_)
                (if (>= _i100776_ _sstart100775_)
                    (begin
                      (vector-set!
                       _target100773_
                       _j100777_
                       (vector-ref _source100774_ _i100776_))
                      (_loop/r->l100765_
                       _target100773_
                       _source100774_
                       _sstart100775_
                       (- _i100776_ '1)
                       (- _j100777_ '1)))
                    '#!void))))
      (lambda (_target100779_
               _tstart100780_
               _source100781_
               _sstart100782_
               _send100783_)
        (if (> _sstart100782_ _tstart100780_)
            (_loop/l->r100764_
             _target100779_
             _source100781_
             _send100783_
             _sstart100782_
             _tstart100780_)
            (_loop/r->l100765_
             _target100779_
             _source100781_
             _sstart100782_
             (- _send100783_ '1)
             (+ '-1 _tstart100780_ _send100783_ (- _sstart100782_)))))))
  (define std/srfi/133#%vector-reverse-copy!
    (letrec ((_loop100750_
              (lambda (_target100752_
                       _source100753_
                       _sstart100754_
                       _i100755_
                       _j100756_)
                (if (>= _i100755_ _sstart100754_)
                    (begin
                      (vector-set!
                       _target100752_
                       _j100756_
                       (vector-ref _source100753_ _i100755_))
                      (_loop100750_
                       _target100752_
                       _source100753_
                       _sstart100754_
                       (- _i100755_ '1)
                       (+ _j100756_ '1)))
                    '#!void))))
      (lambda (_target100758_
               _tstart100759_
               _source100760_
               _sstart100761_
               _send100762_)
        (_loop100750_
         _target100758_
         _source100760_
         _sstart100761_
         (- _send100762_ '1)
         _tstart100759_))))
  (define std/srfi/133#%vector-reverse!
    (letrec ((_loop100738_
              (lambda (_vec100740_ _i100741_ _j100742_)
                (if (<= _i100741_ _j100742_)
                    (let ((_v100744_ (vector-ref _vec100740_ _i100741_)))
                      (vector-set!
                       _vec100740_
                       _i100741_
                       (vector-ref _vec100740_ _j100742_))
                      (vector-set! _vec100740_ _j100742_ _v100744_)
                      (_loop100738_
                       _vec100740_
                       (+ _i100741_ '1)
                       (- _j100742_ '1)))
                    '#!void))))
      (lambda (_vec100746_ _start100747_ _end100748_)
        (_loop100738_ _vec100746_ _start100747_ (- _end100748_ '1)))))
  (define std/srfi/133#%vector-fold1
    (letrec ((_loop100725_
              (lambda (_kons100727_
                       _knil100728_
                       _len100729_
                       _vec100730_
                       _i100731_)
                (if (= _i100731_ _len100729_)
                    _knil100728_
                    (_loop100725_
                     _kons100727_
                     (_kons100727_
                      _knil100728_
                      (vector-ref _vec100730_ _i100731_))
                     _len100729_
                     _vec100730_
                     (+ _i100731_ '1))))))
      (lambda (_kons100733_ _knil100734_ _len100735_ _vec100736_)
        (_loop100725_ _kons100733_ _knil100734_ _len100735_ _vec100736_ '0))))
  (define std/srfi/133#%vector-fold2+
    (letrec ((_loop100712_
              (lambda (_kons100714_
                       _knil100715_
                       _len100716_
                       _vectors100717_
                       _i100718_)
                (if (= _i100718_ _len100716_)
                    _knil100715_
                    (_loop100712_
                     _kons100714_
                     (apply _kons100714_
                            _knil100715_
                            (std/srfi/133#vectors-ref
                             _vectors100717_
                             _i100718_))
                     _len100716_
                     _vectors100717_
                     (+ _i100718_ '1))))))
      (lambda (_kons100720_ _knil100721_ _len100722_ _vectors100723_)
        (_loop100712_
         _kons100720_
         _knil100721_
         _len100722_
         _vectors100723_
         '0))))
  (define std/srfi/133#%vector-map1!
    (letrec ((_loop100698_
              (lambda (_f100700_ _target100701_ _vec100702_ _i100703_)
                (if (zero? _i100703_)
                    _target100701_
                    (let ((_j100705_ (- _i100703_ '1)))
                      (vector-set!
                       _target100701_
                       _j100705_
                       (_f100700_ (vector-ref _vec100702_ _j100705_)))
                      (_loop100698_
                       _f100700_
                       _target100701_
                       _vec100702_
                       _j100705_))))))
      (lambda (_f100707_ _target100708_ _vec100709_ _len100710_)
        (_loop100698_ _f100707_ _target100708_ _vec100709_ _len100710_))))
  (define std/srfi/133#%vector-map2+!
    (letrec ((_loop100684_
              (lambda (_f100686_ _target100687_ _vectors100688_ _i100689_)
                (if (zero? _i100689_)
                    _target100687_
                    (let ((_j100691_ (- _i100689_ '1)))
                      (vector-set!
                       _target100687_
                       _j100691_
                       (apply _f100686_
                              (std/srfi/133#vectors-ref
                               _vectors100688_
                               _j100691_)))
                      (_loop100684_
                       _f100686_
                       _target100687_
                       _vectors100688_
                       _j100691_))))))
      (lambda (_f100693_ _target100694_ _vectors100695_ _len100696_)
        (_loop100684_ _f100693_ _target100694_ _vectors100695_ _len100696_))))
  (define std/srfi/133#vector-unfold
    (lambda (_f100678_ _length100679_ . _initial-seeds100680_)
      (letrec* ((_vec100682_ (make-vector _length100679_)))
        (apply std/srfi/133#vector-unfold!
               _f100678_
               _vec100682_
               '0
               _length100679_
               _initial-seeds100680_)
        _vec100682_)))
  (define std/srfi/133#vector-unfold!
    (letrec ((_tabulate!100640_
              (lambda (_f100644_ _vec100645_ _i100646_ _len100647_)
                (if (< _i100646_ _len100647_)
                    (begin
                      (vector-set! _vec100645_ _i100646_ (_f100644_ _i100646_))
                      (_tabulate!100640_
                       _f100644_
                       _vec100645_
                       (+ _i100646_ '1)
                       _len100647_))
                    '#!void)))
             (_unfold1!100641_
              (lambda (_f100649_
                       _vec100650_
                       _i100651_
                       _len100652_
                       _seed100653_)
                (if (< _i100651_ _len100652_)
                    (let ((_g289681_ (_f100649_ _i100651_ _seed100653_)))
                      (begin
                        (let ((_g289682_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g289681_)
                                     (##vector-length _g289681_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx= _g289682_ 2)))
                              (error "Context expects 2 values" _g289682_)))
                        (let ((_elt100655_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g289681_ 0)))
                              (_new-seed100656_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g289681_ 1))))
                          (begin
                            (vector-set! _vec100650_ _i100651_ _elt100655_)
                            (_unfold1!100641_
                             _f100649_
                             _vec100650_
                             (+ _i100651_ '1)
                             _len100652_
                             _new-seed100656_)))))
                    '#!void)))
             (_unfold2+!100642_
              (lambda (_f100658_
                       _vec100659_
                       _i100660_
                       _len100661_
                       _seeds100662_)
                (if (< _i100660_ _len100661_)
                    (let ((_g289683_
                           (apply _f100658_ _i100660_ _seeds100662_)))
                      (begin
                        (let ((_g289684_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g289683_)
                                     (##vector-length _g289683_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx>= _g289684_ 1)))
                              (error "Context expects at least 1 values"
                                     _g289684_)))
                        (let ((_elt100664_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g289683_)
                                     (##vector-ref _g289683_ 0)
                                     _g289683_)))
                              (_new-seeds100665_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g289683_)
                                     (##cdr (##vector->list _g289683_))
                                     '()))))
                          (begin
                            (vector-set! _vec100659_ _i100660_ _elt100664_)
                            (_unfold2+!100642_
                             _f100658_
                             _vec100659_
                             (+ _i100660_ '1)
                             _len100661_
                             _new-seeds100665_)))))
                    '#!void))))
      (lambda (_f100667_
               _vec100668_
               _start100669_
               _end100670_
               .
               _initial-seeds100671_)
        (let ((_f100673_
               (std/srfi/133#check-type
                procedure?
                _f100667_
                std/srfi/133#vector-unfold!))
              (_start100674_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _start100669_
                std/srfi/133#vector-unfold!))
              (_end100675_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _end100670_
                std/srfi/133#vector-unfold!)))
          (let ()
            (if (null? _initial-seeds100671_)
                (_tabulate!100640_
                 _f100673_
                 _vec100668_
                 _start100674_
                 _end100675_)
                (if (null? (cdr _initial-seeds100671_))
                    (_unfold1!100641_
                     _f100673_
                     _vec100668_
                     _start100674_
                     _end100675_
                     (car _initial-seeds100671_))
                    (_unfold2+!100642_
                     _f100673_
                     _vec100668_
                     _start100674_
                     _end100675_
                     _initial-seeds100671_))))))))
  (define std/srfi/133#vector-unfold-right
    (lambda (_f100634_ _len100635_ . _initial-seeds100636_)
      (letrec* ((_vec100638_ (make-vector _len100635_)))
        (apply std/srfi/133#vector-unfold-right!
               _f100634_
               _vec100638_
               '0
               _len100635_
               _initial-seeds100636_)
        _vec100638_)))
  (define std/srfi/133#vector-unfold-right!
    (lambda (_f100598_
             _vec100599_
             _start100600_
             _end100601_
             .
             _initial-seeds100602_)
      (letrec ((_tabulate!100604_
                (lambda (_f100608_ _vec100609_ _i100610_)
                  (if (>= _i100610_ _start100600_)
                      (begin
                        (vector-set!
                         _vec100609_
                         _i100610_
                         (_f100608_ _i100610_))
                        (_tabulate!100604_
                         _f100608_
                         _vec100609_
                         (- _i100610_ '1)))
                      '#!void)))
               (_unfold1!100605_
                (lambda (_f100612_ _vec100613_ _i100614_ _seed100615_)
                  (if (>= _i100614_ _start100600_)
                      (let ((_g289685_ (_f100612_ _i100614_ _seed100615_)))
                        (begin
                          (let ((_g289686_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g289685_)
                                       (##vector-length _g289685_)
                                       1))))
                            (if (not (let ()
                                       (declare (not safe))
                                       (##fx= _g289686_ 2)))
                                (error "Context expects 2 values" _g289686_)))
                          (let ((_elt100617_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _g289685_ 0)))
                                (_new-seed100618_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _g289685_ 1))))
                            (begin
                              (vector-set! _vec100613_ _i100614_ _elt100617_)
                              (_unfold1!100605_
                               _f100612_
                               _vec100613_
                               (- _i100614_ '1)
                               _new-seed100618_)))))
                      '#!void)))
               (_unfold2+!100606_
                (lambda (_f100620_ _vec100621_ _i100622_ _seeds100623_)
                  (if (>= _i100622_ _start100600_)
                      (let ((_g289687_
                             (apply _f100620_ _i100622_ _seeds100623_)))
                        (begin
                          (let ((_g289688_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g289687_)
                                       (##vector-length _g289687_)
                                       1))))
                            (if (not (let ()
                                       (declare (not safe))
                                       (##fx>= _g289688_ 1)))
                                (error "Context expects at least 1 values"
                                       _g289688_)))
                          (let ((_elt100625_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g289687_)
                                       (##vector-ref _g289687_ 0)
                                       _g289687_)))
                                (_new-seeds100626_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g289687_)
                                       (##cdr (##vector->list _g289687_))
                                       '()))))
                            (begin
                              (vector-set! _vec100621_ _i100622_ _elt100625_)
                              (_unfold2+!100606_
                               _f100620_
                               _vec100621_
                               (- _i100622_ '1)
                               _new-seeds100626_)))))
                      '#!void))))
        (let ((_f100628_
               (std/srfi/133#check-type
                procedure?
                _f100598_
                std/srfi/133#vector-unfold-right!))
              (_start100629_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _start100600_
                std/srfi/133#vector-unfold-right!))
              (_end100630_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _end100601_
                std/srfi/133#vector-unfold-right!)))
          (let ((_i100632_ (- _end100630_ '1)))
            (if (null? _initial-seeds100602_)
                (_tabulate!100604_ _f100628_ _vec100599_ _i100632_)
                (if (null? (cdr _initial-seeds100602_))
                    (_unfold1!100605_
                     _f100628_
                     _vec100599_
                     _i100632_
                     (car _initial-seeds100602_))
                    (_unfold2+!100606_
                     _f100628_
                     _vec100599_
                     _i100632_
                     _initial-seeds100602_))))))))
  (define std/srfi/133#vector-copy
    (lambda (_vec100587_ . _args100588_)
      (let* ((_vec100590_
              (std/srfi/133#check-type
               vector?
               _vec100587_
               std/srfi/133#vector-copy))
             (_g289689_
              (std/srfi/133#vector-copy:parse-args _vec100590_ _args100588_)))
        (begin
          (let ((_g289690_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289689_) (##vector-length _g289689_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289690_ 3)))
                (error "Context expects 3 values" _g289690_)))
          (let ((_start100592_
                 (let () (declare (not safe)) (##vector-ref _g289689_ 0)))
                (_end100593_
                 (let () (declare (not safe)) (##vector-ref _g289689_ 1)))
                (_fill100594_
                 (let () (declare (not safe)) (##vector-ref _g289689_ 2))))
            (let ((_new-vector100596_
                   (make-vector (- _end100593_ _start100592_) _fill100594_)))
              (std/srfi/133#%vector-copy!
               _new-vector100596_
               '0
               _vec100590_
               _start100592_
               (if (> _end100593_ (vector-length _vec100590_))
                   (vector-length _vec100590_)
                   _end100593_))
              _new-vector100596_))))))
  (define std/srfi/133#vector-copy:parse-args
    (lambda (_vec100572_ _args100573_)
      (letrec ((_parse-args100575_
                (lambda (_start100579_ _end100580_ _n100581_ _fill100582_)
                  (let ((_start100584_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _start100579_
                          std/srfi/133#vector-copy))
                        (_end100585_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _end100580_
                          std/srfi/133#vector-copy)))
                    (if (and (<= '0 _start100584_ _end100585_)
                             (<= _start100584_ _n100581_))
                        (values _start100584_ _end100585_ _fill100582_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/133#vector-copy
                                                 '())))
                               (cons 'start
                                     (cons 'was (cons _start100584_ '())))
                               (cons 'end (cons 'was (cons _end100585_ '())))
                               (cons 'vector
                                     (cons 'was (cons _vec100572_ '())))))))))
        (let ((_n100577_ (vector-length _vec100572_)))
          (if (null? _args100573_)
              (_parse-args100575_
               '0
               _n100577_
               _n100577_
               (std/srfi/133#unspecified-value))
              (if (null? (cdr _args100573_))
                  (_parse-args100575_
                   (car _args100573_)
                   _n100577_
                   _n100577_
                   (std/srfi/133#unspecified-value))
                  (if (null? (cddr _args100573_))
                      (_parse-args100575_
                       (car _args100573_)
                       (cadr _args100573_)
                       _n100577_
                       (std/srfi/133#unspecified-value))
                      (if (null? (cdddr _args100573_))
                          (_parse-args100575_
                           (car _args100573_)
                           (cadr _args100573_)
                           _n100577_
                           (caddr _args100573_))
                          (error '"too many arguments"
                                 std/srfi/133#vector-copy
                                 (cdddr _args100573_))))))))))
  (define std/srfi/133#vector-reverse-copy
    (lambda (_vec100562_ . _maybe-start+end100563_)
      (let* ((_vec100565_
              (std/srfi/133#check-type
               vector?
               _vec100562_
               std/srfi/133#vector-reverse-copy))
             (_g289691_
              (std/srfi/133#vector-parse-start+end
               _vec100565_
               _maybe-start+end100563_
               'start
               'end
               std/srfi/133#vector-reverse-copy)))
        (begin
          (let ((_g289692_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289691_) (##vector-length _g289691_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289692_ 2)))
                (error "Context expects 2 values" _g289692_)))
          (let ((_start100567_
                 (let () (declare (not safe)) (##vector-ref _g289691_ 0)))
                (_end100568_
                 (let () (declare (not safe)) (##vector-ref _g289691_ 1))))
            (let ((_new100570_ (make-vector (- _end100568_ _start100567_))))
              (std/srfi/133#%vector-reverse-copy!
               _new100570_
               '0
               _vec100565_
               _start100567_
               _end100568_)
              _new100570_))))))
  (define std/srfi/133#vector-append
    (lambda _vectors100560_
      (std/srfi/133#vector-concatenate:aux
       _vectors100560_
       std/srfi/133#vector-append)))
  (define std/srfi/133#vector-concatenate
    (lambda (_vector-list100558_)
      (std/srfi/133#vector-concatenate:aux
       _vector-list100558_
       std/srfi/133#vector-concatenate)))
  (define std/srfi/133#vector-concatenate:aux
    (letrec ((_compute-length100528_
              (lambda (_vectors100531_ _len100532_ _callee100533_)
                (if (null? _vectors100531_)
                    _len100532_
                    (let ((_vec100535_
                           (std/srfi/133#check-type
                            vector?
                            (car _vectors100531_)
                            _callee100533_)))
                      (_compute-length100528_
                       (cdr _vectors100531_)
                       (+ (vector-length _vec100535_) _len100532_)
                       _callee100533_)))))
             (_concatenate!100529_
              (lambda (_vectors100537_ _target100538_ _to100539_)
                (if (null? _vectors100537_)
                    _target100538_
                    (let* ((_vec1100541_ (car _vectors100537_))
                           (_len100543_ (vector-length _vec1100541_)))
                      (std/srfi/133#%vector-copy!
                       _target100538_
                       _to100539_
                       _vec1100541_
                       '0
                       _len100543_)
                      (_concatenate!100529_
                       (cdr _vectors100537_)
                       _target100538_
                       (+ _to100539_ _len100543_)))))))
      (lambda (_vectors100546_ _callee100547_)
        (if (null? _vectors100546_)
            (make-vector '0)
            (if (null? (cdr _vectors100546_))
                (let* ((_vec100549_
                        (std/srfi/133#check-type
                         vector?
                         (car _vectors100546_)
                         _callee100547_))
                       (_len100551_ (vector-length _vec100549_))
                       (_new100553_ (make-vector _len100551_)))
                  (std/srfi/133#%vector-copy!
                   _new100553_
                   '0
                   _vec100549_
                   '0
                   _len100551_)
                  _new100553_)
                (let ((_new-vector100556_
                       (make-vector
                        (_compute-length100528_
                         _vectors100546_
                         '0
                         _callee100547_))))
                  (_concatenate!100529_ _vectors100546_ _new-vector100556_ '0)
                  _new-vector100556_))))))
  (define std/srfi/133#vector-append-subvectors
    (lambda _args100479_
      (letrec ((_gather-args100481_
                (lambda (_args100519_)
                  (let _loop100521_ ((_args100523_ _args100519_)
                                     (_vecs100524_ '())
                                     (_starts100525_ '())
                                     (_ends100526_ '()))
                    (if (null? _args100523_)
                        (values (reverse _vecs100524_)
                                (reverse _starts100525_)
                                (reverse _ends100526_))
                        (_loop100521_
                         (cdddr _args100523_)
                         (cons (car _args100523_) _vecs100524_)
                         (cons (cadr _args100523_) _starts100525_)
                         (cons (caddr _args100523_) _ends100526_))))))
               (_total-length100482_
                (lambda (_starts100507_ _ends100508_)
                  (let _loop100510_ ((_count100512_ '0)
                                     (_starts100513_ _starts100507_)
                                     (_ends100514_ _ends100508_))
                    (if (null? _starts100513_)
                        _count100512_
                        (let ((_start100516_ (car _starts100513_))
                              (_end100517_ (car _ends100514_)))
                          (_loop100510_
                           (+ _count100512_ (- _end100517_ _start100516_))
                           (cdr _starts100513_)
                           (cdr _ends100514_)))))))
               (_copy-each!100483_
                (lambda (_result100491_
                         _vecs100492_
                         _starts100493_
                         _ends100494_)
                  (let _loop100496_ ((_at100498_ '0)
                                     (_vecs100499_ _vecs100492_)
                                     (_starts100500_ _starts100493_)
                                     (_ends100501_ _ends100494_))
                    (if (null? _vecs100499_)
                        _result100491_
                        (let ((_vec100503_ (car _vecs100499_))
                              (_start100504_ (car _starts100500_))
                              (_end100505_ (car _ends100501_)))
                          (std/srfi/133#%vector-copy!
                           _result100491_
                           _at100498_
                           _vec100503_
                           _start100504_
                           _end100505_)
                          (_loop100496_
                           (+ _at100498_ (- _end100505_ _start100504_))
                           (cdr _vecs100499_)
                           (cdr _starts100500_)
                           (cdr _ends100501_))))))))
        (let ((_g289693_ (_gather-args100481_ _args100479_)))
          (begin
            (let ((_g289694_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g289693_)
                         (##vector-length _g289693_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g289694_ 3)))
                  (error "Context expects 3 values" _g289694_)))
            (let ((_vecs100485_
                   (let () (declare (not safe)) (##vector-ref _g289693_ 0)))
                  (_starts100486_
                   (let () (declare (not safe)) (##vector-ref _g289693_ 1)))
                  (_ends100487_
                   (let () (declare (not safe)) (##vector-ref _g289693_ 2))))
              (letrec* ((_result100489_
                         (make-vector
                          (_total-length100482_ _starts100486_ _ends100487_))))
                (_copy-each!100483_
                 _result100489_
                 _vecs100485_
                 _starts100486_
                 _ends100487_))))))))
  (define std/srfi/133#vector-empty?
    (lambda (_vec100475_)
      (let ((_vec100477_
             (std/srfi/133#check-type
              vector?
              _vec100475_
              std/srfi/133#vector-empty?)))
        (zero? (vector-length _vec100477_)))))
  (define std/srfi/133#vector=
    (lambda (_elt=?100460_ . _vectors100461_)
      (let ((_elt=?100463_
             (std/srfi/133#check-type
              procedure?
              _elt=?100460_
              std/srfi/133#vector=)))
        (if (null? _vectors100461_)
            '#t
            (if (null? (cdr _vectors100461_))
                (begin
                  (std/srfi/133#check-type
                   vector?
                   (car _vectors100461_)
                   std/srfi/133#vector=)
                  '#t)
                (let _loop100465_ ((_vecs100467_ _vectors100461_))
                  (let ((_vec1100469_
                         (std/srfi/133#check-type
                          vector?
                          (car _vecs100467_)
                          std/srfi/133#vector=))
                        (_vec2+100470_ (cdr _vecs100467_)))
                    (let ((_$e100472_ (null? _vec2+100470_)))
                      (if _$e100472_
                          _$e100472_
                          (if (std/srfi/133#binary-vector=
                               _elt=?100463_
                               _vec1100469_
                               (car _vec2+100470_))
                              (_loop100465_ _vec2+100470_)
                              '#f))))))))))
  (define std/srfi/133#binary-vector=
    (lambda (_elt=?100449_ _vector-a100450_ _vector-b100451_)
      (let ((_length-a100453_ (vector-length _vector-a100450_))
            (_length-b100454_ (vector-length _vector-b100451_)))
        (if (= _length-a100453_ _length-b100454_)
            (let _loop100456_ ((_i100458_ '0))
              (if (= _i100458_ _length-a100453_)
                  '#t
                  (if (_elt=?100449_
                       (vector-ref _vector-a100450_ _i100458_)
                       (vector-ref _vector-b100451_ _i100458_))
                      (_loop100456_ (+ _i100458_ '1))
                      '#f)))
            '#f))))
  (define std/srfi/133#vector-fold
    (lambda (_kons100441_ _knil100442_ _vec100443_ . _vectors100444_)
      (let ((_kons100446_
             (std/srfi/133#check-type
              procedure?
              _kons100441_
              std/srfi/133#vector-fold))
            (_vec100447_
             (std/srfi/133#check-type
              vector?
              _vec100443_
              std/srfi/133#vector-fold)))
        (if (null? _vectors100444_)
            (std/srfi/133#%vector-fold1
             _kons100446_
             _knil100442_
             (vector-length _vec100447_)
             _vec100447_)
            (std/srfi/133#%vector-fold2+
             _kons100446_
             _knil100442_
             (std/srfi/133#%smallest-length
              _vectors100444_
              (vector-length _vec100447_)
              std/srfi/133#vector-fold)
             (cons _vec100447_ _vectors100444_))))))
  (define std/srfi/133#vector-fold-right
    (letrec ((_loop1100420_
              (lambda (_kons100423_ _knil100424_ _vec100425_ _i100426_)
                (if (negative? _i100426_)
                    _knil100424_
                    (_loop1100420_
                     _kons100423_
                     (_kons100423_
                      _knil100424_
                      (vector-ref _vec100425_ _i100426_))
                     _vec100425_
                     (- _i100426_ '1)))))
             (_loop2+100421_
              (lambda (_kons100428_ _knil100429_ _vectors100430_ _i100431_)
                (if (negative? _i100431_)
                    _knil100429_
                    (_loop2+100421_
                     _kons100428_
                     (apply _kons100428_
                            _knil100429_
                            (std/srfi/133#vectors-ref
                             _vectors100430_
                             _i100431_))
                     _vectors100430_
                     (- _i100431_ '1))))))
      (lambda (_kons100433_ _knil100434_ _vec100435_ . _vectors100436_)
        (let ((_kons100438_
               (std/srfi/133#check-type
                procedure?
                _kons100433_
                std/srfi/133#vector-fold-right))
              (_vec100439_
               (std/srfi/133#check-type
                vector?
                _vec100435_
                std/srfi/133#vector-fold-right)))
          (if (null? _vectors100436_)
              (_loop1100420_
               _kons100438_
               _knil100434_
               _vec100439_
               (- (vector-length _vec100439_) '1))
              (_loop2+100421_
               _kons100438_
               _knil100434_
               (cons _vec100439_ _vectors100436_)
               (- (std/srfi/133#%smallest-length
                   _vectors100436_
                   (vector-length _vec100439_)
                   std/srfi/133#vector-fold-right)
                  '1)))))))
  (define std/srfi/133#vector-map
    (lambda (_f100409_ _vec100410_ . _vectors100411_)
      (let ((_f100413_
             (std/srfi/133#check-type
              procedure?
              _f100409_
              std/srfi/133#vector-map))
            (_vec100414_
             (std/srfi/133#check-type
              vector?
              _vec100410_
              std/srfi/133#vector-map)))
        (if (null? _vectors100411_)
            (let ((_len100416_ (vector-length _vec100414_)))
              (std/srfi/133#%vector-map1!
               _f100413_
               (make-vector _len100416_)
               _vec100414_
               _len100416_))
            (let ((_len100418_
                   (std/srfi/133#%smallest-length
                    _vectors100411_
                    (vector-length _vec100414_)
                    std/srfi/133#vector-map)))
              (std/srfi/133#%vector-map2+!
               _f100413_
               (make-vector _len100418_)
               (cons _vec100414_ _vectors100411_)
               _len100418_))))))
  (define std/srfi/133#vector-map!
    (lambda (_f100402_ _vec100403_ . _vectors100404_)
      (let ((_f100406_
             (std/srfi/133#check-type
              procedure?
              _f100402_
              std/srfi/133#vector-map!))
            (_vec100407_
             (std/srfi/133#check-type
              vector?
              _vec100403_
              std/srfi/133#vector-map!)))
        (if (null? _vectors100404_)
            (std/srfi/133#%vector-map1!
             _f100406_
             _vec100407_
             _vec100407_
             (vector-length _vec100407_))
            (std/srfi/133#%vector-map2+!
             _f100406_
             _vec100407_
             (cons _vec100407_ _vectors100404_)
             (std/srfi/133#%smallest-length
              _vectors100404_
              (vector-length _vec100407_)
              std/srfi/133#vector-map!)))
        (std/srfi/133#unspecified-value))))
  (define std/srfi/133#vector-for-each
    (letrec ((_for-each1100382_
              (lambda (_f100385_ _vec100386_ _i100387_ _len100388_)
                (if (< _i100387_ _len100388_)
                    (begin
                      (_f100385_ (vector-ref _vec100386_ _i100387_))
                      (_for-each1100382_
                       _f100385_
                       _vec100386_
                       (+ _i100387_ '1)
                       _len100388_))
                    '#!void)))
             (_for-each2+100383_
              (lambda (_f100390_ _vecs100391_ _i100392_ _len100393_)
                (if (< _i100392_ _len100393_)
                    (begin
                      (apply _f100390_
                             (std/srfi/133#vectors-ref _vecs100391_ _i100392_))
                      (_for-each2+100383_
                       _f100390_
                       _vecs100391_
                       (+ _i100392_ '1)
                       _len100393_))
                    '#!void))))
      (lambda (_f100395_ _vec100396_ . _vectors100397_)
        (let ((_f100399_
               (std/srfi/133#check-type
                procedure?
                _f100395_
                std/srfi/133#vector-for-each))
              (_vec100400_
               (std/srfi/133#check-type
                vector?
                _vec100396_
                std/srfi/133#vector-for-each)))
          (if (null? _vectors100397_)
              (_for-each1100382_
               _f100399_
               _vec100400_
               '0
               (vector-length _vec100400_))
              (_for-each2+100383_
               _f100399_
               (cons _vec100400_ _vectors100397_)
               '0
               (std/srfi/133#%smallest-length
                _vectors100397_
                (vector-length _vec100400_)
                std/srfi/133#vector-for-each)))))))
  (define std/srfi/133#vector-count
    (lambda (_pred?100369_ _vec100370_ . _vectors100371_)
      (let ((_pred?100373_
             (std/srfi/133#check-type
              procedure?
              _pred?100369_
              std/srfi/133#vector-count))
            (_vec100374_
             (std/srfi/133#check-type
              vector?
              _vec100370_
              std/srfi/133#vector-count)))
        (if (null? _vectors100371_)
            (std/srfi/133#%vector-fold1
             (lambda (_count100376_ _elt100377_)
               (if (_pred?100373_ _elt100377_)
                   (+ _count100376_ '1)
                   _count100376_))
             '0
             (vector-length _vec100374_)
             _vec100374_)
            (std/srfi/133#%vector-fold2+
             (lambda (_count100379_ . _elts100380_)
               (if (apply _pred?100373_ _elts100380_)
                   (+ _count100379_ '1)
                   _count100379_))
             '0
             (std/srfi/133#%smallest-length
              _vectors100371_
              (vector-length _vec100374_)
              std/srfi/133#vector-count)
             (cons _vec100374_ _vectors100371_))))))
  (define std/srfi/133#vector-cumulate
    (lambda (_f100350_ _knil100351_ _vec100352_)
      (let* ((_len100354_ (vector-length _vec100352_))
             (_result100356_ (make-vector _len100354_)))
        (let _loop100359_ ((_i100361_ '0) (_left100362_ _knil100351_))
          (if (= _i100361_ _len100354_)
              _result100356_
              (let* ((_right100364_ (vector-ref _vec100352_ _i100361_))
                     (_r100366_ (_f100350_ _left100362_ _right100364_)))
                (vector-set! _result100356_ _i100361_ _r100366_)
                (_loop100359_ (+ _i100361_ '1) _r100366_)))))))
  (define std/srfi/133#vector-index
    (lambda (_pred?100346_ _vec100347_ . _vectors100348_)
      (std/srfi/133#vector-index/skip
       _pred?100346_
       _vec100347_
       _vectors100348_
       std/srfi/133#vector-index)))
  (define std/srfi/133#vector-skip
    (lambda (_pred?100340_ _vec100341_ . _vectors100342_)
      (std/srfi/133#vector-index/skip
       (lambda _elts100344_ (not (apply _pred?100340_ _elts100344_)))
       _vec100341_
       _vectors100342_
       std/srfi/133#vector-skip)))
  (define std/srfi/133#vector-index/skip
    (letrec ((_loop1100319_
              (lambda (_pred?100322_ _vec100323_ _len100324_ _i100325_)
                (if (= _i100325_ _len100324_)
                    '#f
                    (if (_pred?100322_ (vector-ref _vec100323_ _i100325_))
                        _i100325_
                        (_loop1100319_
                         _pred?100322_
                         _vec100323_
                         _len100324_
                         (+ _i100325_ '1))))))
             (_loop2+100320_
              (lambda (_pred?100327_ _vectors100328_ _len100329_ _i100330_)
                (if (= _i100330_ _len100329_)
                    '#f
                    (if (apply _pred?100327_
                               (std/srfi/133#vectors-ref
                                _vectors100328_
                                _i100330_))
                        _i100330_
                        (_loop2+100320_
                         _pred?100327_
                         _vectors100328_
                         _len100329_
                         (+ _i100330_ '1)))))))
      (lambda (_pred?100332_ _vec100333_ _vectors100334_ _callee100335_)
        (let ((_pred?100337_
               (std/srfi/133#check-type
                procedure?
                _pred?100332_
                _callee100335_))
              (_vec100338_
               (std/srfi/133#check-type vector? _vec100333_ _callee100335_)))
          (if (null? _vectors100334_)
              (_loop1100319_
               _pred?100337_
               _vec100338_
               (vector-length _vec100338_)
               '0)
              (_loop2+100320_
               _pred?100337_
               (cons _vec100338_ _vectors100334_)
               (std/srfi/133#%smallest-length
                _vectors100334_
                (vector-length _vec100338_)
                _callee100335_)
               '0))))))
  (define std/srfi/133#vector-index-right
    (lambda (_pred?100315_ _vec100316_ . _vectors100317_)
      (std/srfi/133#vector-index/skip-right
       _pred?100315_
       _vec100316_
       _vectors100317_
       std/srfi/133#vector-index-right)))
  (define std/srfi/133#vector-skip-right
    (lambda (_pred?100309_ _vec100310_ . _vectors100311_)
      (std/srfi/133#vector-index/skip-right
       (lambda _elts100313_ (not (apply _pred?100309_ _elts100313_)))
       _vec100310_
       _vectors100311_
       std/srfi/133#vector-index-right)))
  (define std/srfi/133#vector-index/skip-right
    (letrec ((_loop1100290_
              (lambda (_pred?100293_ _vec100294_ _i100295_)
                (if (negative? _i100295_)
                    '#f
                    (if (_pred?100293_ (vector-ref _vec100294_ _i100295_))
                        _i100295_
                        (_loop1100290_
                         _pred?100293_
                         _vec100294_
                         (- _i100295_ '1))))))
             (_loop2+100291_
              (lambda (_pred?100297_ _vectors100298_ _i100299_)
                (if (negative? _i100299_)
                    '#f
                    (if (apply _pred?100297_
                               (std/srfi/133#vectors-ref
                                _vectors100298_
                                _i100299_))
                        _i100299_
                        (_loop2+100291_
                         _pred?100297_
                         _vectors100298_
                         (- _i100299_ '1)))))))
      (lambda (_pred?100301_ _vec100302_ _vectors100303_ _callee100304_)
        (let ((_pred?100306_
               (std/srfi/133#check-type
                procedure?
                _pred?100301_
                _callee100304_))
              (_vec100307_
               (std/srfi/133#check-type vector? _vec100302_ _callee100304_)))
          (if (null? _vectors100303_)
              (_loop1100290_
               _pred?100306_
               _vec100307_
               (- (vector-length _vec100307_) '1))
              (_loop2+100291_
               _pred?100306_
               (cons _vec100307_ _vectors100303_)
               (- (std/srfi/133#%smallest-length
                   _vectors100303_
                   (vector-length _vec100307_)
                   _callee100304_)
                  '1)))))))
  (define std/srfi/133#vector-binary-search
    (lambda (_vec100265_ _value100266_ _cmp100267_ . _maybe-start+end100268_)
      (let* ((_cmp100270_
              (std/srfi/133#check-type
               procedure?
               _cmp100267_
               std/srfi/133#vector-binary-search))
             (_vec100272_
              (std/srfi/133#check-type
               vector?
               _vec100265_
               std/srfi/133#vector-binary-search))
             (_g289695_
              (std/srfi/133#vector-parse-start+end
               _vec100272_
               _maybe-start+end100268_
               'start
               'end
               std/srfi/133#vector-binary-search)))
        (begin
          (let ((_g289696_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289695_) (##vector-length _g289695_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289696_ 2)))
                (error "Context expects 2 values" _g289696_)))
          (let ((_start100274_
                 (let () (declare (not safe)) (##vector-ref _g289695_ 0)))
                (_end100275_
                 (let () (declare (not safe)) (##vector-ref _g289695_ 1))))
            (let _loop100277_ ((_start100279_ _start100274_)
                               (_end100280_ _end100275_)
                               (_j100281_ '#f))
              (let ((_i100283_ (quotient (+ _start100279_ _end100280_) '2)))
                (if (or (= _start100279_ _end100280_)
                        (and _j100281_ (= _i100283_ _j100281_)))
                    '#f
                    (let ((_comparison100288_
                           (std/srfi/133#check-type
                            integer?
                            (_cmp100270_
                             (vector-ref _vec100272_ _i100283_)
                             _value100266_)
                            (cons _cmp100270_
                                  (cons 'for
                                        (cons std/srfi/133#vector-binary-search
                                              '()))))))
                      (if (zero? _comparison100288_)
                          _i100283_
                          (if (positive? _comparison100288_)
                              (_loop100277_ _start100279_ _i100283_ _i100283_)
                              (_loop100277_
                               _i100283_
                               _end100280_
                               _i100283_))))))))))))
  (define std/srfi/133#vector-any
    (letrec ((_loop1100233_
              (lambda (_pred?100236_
                       _vec100237_
                       _i100238_
                       _len100239_
                       _len-1100240_)
                (if (not (= _i100238_ _len100239_))
                    (if (= _i100238_ _len-1100240_)
                        (_pred?100236_ (vector-ref _vec100237_ _i100238_))
                        (let ((_$e100242_
                               (_pred?100236_
                                (vector-ref _vec100237_ _i100238_))))
                          (if _$e100242_
                              _$e100242_
                              (_loop1100233_
                               _pred?100236_
                               _vec100237_
                               (+ _i100238_ '1)
                               _len100239_
                               _len-1100240_))))
                    '#f)))
             (_loop2+100234_
              (lambda (_pred?100245_
                       _vectors100246_
                       _i100247_
                       _len100248_
                       _len-1100249_)
                (if (not (= _i100247_ _len100248_))
                    (if (= _i100247_ _len-1100249_)
                        (apply _pred?100245_
                               (std/srfi/133#vectors-ref
                                _vectors100246_
                                _i100247_))
                        (let ((_$e100251_
                               (apply _pred?100245_
                                      (std/srfi/133#vectors-ref
                                       _vectors100246_
                                       _i100247_))))
                          (if _$e100251_
                              _$e100251_
                              (_loop2+100234_
                               _pred?100245_
                               _vectors100246_
                               (+ _i100247_ '1)
                               _len100248_
                               _len-1100249_))))
                    '#f))))
      (lambda (_pred?100254_ _vec100255_ . _vectors100256_)
        (let ((_pred?100258_
               (std/srfi/133#check-type
                procedure?
                _pred?100254_
                std/srfi/133#vector-any))
              (_vec100259_
               (std/srfi/133#check-type
                vector?
                _vec100255_
                std/srfi/133#vector-any)))
          (if (null? _vectors100256_)
              (let ((_len100261_ (vector-length _vec100259_)))
                (_loop1100233_
                 _pred?100258_
                 _vec100259_
                 '0
                 _len100261_
                 (- _len100261_ '1)))
              (let ((_len100263_
                     (std/srfi/133#%smallest-length
                      _vectors100256_
                      (vector-length _vec100259_)
                      std/srfi/133#vector-any)))
                (_loop2+100234_
                 _pred?100258_
                 (cons _vec100259_ _vectors100256_)
                 '0
                 _len100263_
                 (- _len100263_ '1))))))))
  (define std/srfi/133#vector-every
    (letrec ((_loop1100201_
              (lambda (_pred?100204_
                       _vec100205_
                       _i100206_
                       _len100207_
                       _len-1100208_)
                (let ((_$e100210_ (= _i100206_ _len100207_)))
                  (if _$e100210_
                      _$e100210_
                      (if (= _i100206_ _len-1100208_)
                          (_pred?100204_ (vector-ref _vec100205_ _i100206_))
                          (if (_pred?100204_
                               (vector-ref _vec100205_ _i100206_))
                              (_loop1100201_
                               _pred?100204_
                               _vec100205_
                               (+ _i100206_ '1)
                               _len100207_
                               _len-1100208_)
                              '#f))))))
             (_loop2+100202_
              (lambda (_pred?100213_
                       _vectors100214_
                       _i100215_
                       _len100216_
                       _len-1100217_)
                (let ((_$e100219_ (= _i100215_ _len100216_)))
                  (if _$e100219_
                      _$e100219_
                      (if (= _i100215_ _len-1100217_)
                          (apply _pred?100213_
                                 (std/srfi/133#vectors-ref
                                  _vectors100214_
                                  _i100215_))
                          (if (apply _pred?100213_
                                     (std/srfi/133#vectors-ref
                                      _vectors100214_
                                      _i100215_))
                              (_loop2+100202_
                               _pred?100213_
                               _vectors100214_
                               (+ _i100215_ '1)
                               _len100216_
                               _len-1100217_)
                              '#f)))))))
      (lambda (_pred?100222_ _vec100223_ . _vectors100224_)
        (let ((_pred?100226_
               (std/srfi/133#check-type
                procedure?
                _pred?100222_
                std/srfi/133#vector-every))
              (_vec100227_
               (std/srfi/133#check-type
                vector?
                _vec100223_
                std/srfi/133#vector-every)))
          (if (null? _vectors100224_)
              (let ((_len100229_ (vector-length _vec100227_)))
                (_loop1100201_
                 _pred?100226_
                 _vec100227_
                 '0
                 _len100229_
                 (- _len100229_ '1)))
              (let ((_len100231_
                     (std/srfi/133#%smallest-length
                      _vectors100224_
                      (vector-length _vec100227_)
                      std/srfi/133#vector-every)))
                (_loop2+100202_
                 _pred?100226_
                 (cons _vec100227_ _vectors100224_)
                 '0
                 _len100231_
                 (- _len100231_ '1))))))))
  (define std/srfi/133#vector-partition
    (lambda (_pred?100183_ _vec100184_)
      (let* ((_len100186_ (vector-length _vec100184_))
             (_cnt100188_
              (std/srfi/133#vector-count _pred?100183_ _vec100184_))
             (_result100190_ (make-vector _len100186_)))
        (let _loop100193_ ((_i100195_ '0)
                           (_yes100196_ '0)
                           (_no100197_ _cnt100188_))
          (if (= _i100195_ _len100186_)
              (values _result100190_ _cnt100188_)
              (let ((_elem100199_ (vector-ref _vec100184_ _i100195_)))
                (if (_pred?100183_ _elem100199_)
                    (begin
                      (vector-set! _result100190_ _yes100196_ _elem100199_)
                      (_loop100193_
                       (+ _i100195_ '1)
                       (+ _yes100196_ '1)
                       _no100197_))
                    (begin
                      (vector-set! _result100190_ _no100197_ _elem100199_)
                      (_loop100193_
                       (+ _i100195_ '1)
                       _yes100196_
                       (+ _no100197_ '1))))))))))
  (define std/srfi/133#vector-swap!
    (lambda (_vec100172_ _i100173_ _j100174_)
      (let ((_vec100176_
             (std/srfi/133#check-type
              vector?
              _vec100172_
              std/srfi/133#vector-swap!)))
        (let ((_i100178_
               (std/srfi/133#check-index
                _vec100176_
                _i100173_
                std/srfi/133#vector-swap!))
              (_j100179_
               (std/srfi/133#check-index
                _vec100176_
                _j100174_
                std/srfi/133#vector-swap!)))
          (let ((_x100181_ (vector-ref _vec100176_ _i100178_)))
            (vector-set!
             _vec100176_
             _i100178_
             (vector-ref _vec100176_ _j100179_))
            (vector-set! _vec100176_ _j100179_ _x100181_))))))
  (define std/srfi/133#vector-fill!
    (lambda (_vec100158_ _value100159_ . _maybe-start+end100160_)
      (let* ((_vec100162_
              (std/srfi/133#check-type
               vector?
               _vec100158_
               std/srfi/133#vector-fill!))
             (_g289697_
              (std/srfi/133#vector-parse-start+end
               _vec100162_
               _maybe-start+end100160_
               'start
               'end
               std/srfi/133#vector-fill!)))
        (begin
          (let ((_g289698_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289697_) (##vector-length _g289697_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289698_ 2)))
                (error "Context expects 2 values" _g289698_)))
          (let ((_start100164_
                 (let () (declare (not safe)) (##vector-ref _g289697_ 0)))
                (_end100165_
                 (let () (declare (not safe)) (##vector-ref _g289697_ 1))))
            (let _$loop100167_ ((_i100170_ _start100164_))
              (if (= _i100170_ _end100165_)
                  '#!void
                  (begin
                    (vector-set! _vec100162_ _i100170_ _value100159_)
                    (_$loop100167_ (+ _i100170_ '1))))))))))
  (define std/srfi/133#vector-copy!
    (lambda (_target100141_
             _tstart100142_
             _source100143_
             .
             _maybe-sstart+send100144_)
      (letrec ((_doit!100146_
                (lambda (_sstart100150_ _send100151_ _source-length100152_)
                  (let ((_tstart100154_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _tstart100142_
                          std/srfi/133#vector-copy!))
                        (_sstart100155_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _sstart100150_
                          std/srfi/133#vector-copy!))
                        (_send100156_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _send100151_
                          std/srfi/133#vector-copy!)))
                    (if (and (<= '0
                                 _sstart100155_
                                 _send100156_
                                 _source-length100152_)
                             (<= (+ _tstart100154_
                                    (- _send100156_ _sstart100155_))
                                 (vector-length _target100141_)))
                        (std/srfi/133#%vector-copy!
                         _target100141_
                         _tstart100154_
                         _source100143_
                         _sstart100155_
                         _send100156_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/133#vector-copy!
                                                 '())))
                               (cons 'target
                                     (cons 'was (cons _target100141_ '())))
                               (cons 'target-length
                                     (cons 'was
                                           (cons (vector-length _target100141_)
                                                 '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart100154_ '())))
                               (cons 'source
                                     (cons 'was (cons _source100143_ '())))
                               (cons 'source-length
                                     (cons 'was
                                           (cons _source-length100152_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart100155_ '())))
                               (cons 'send
                                     (cons 'was (cons _send100156_ '())))))))))
        (let ((_n100148_ (vector-length _source100143_)))
          (if (null? _maybe-sstart+send100144_)
              (_doit!100146_ '0 _n100148_ _n100148_)
              (if (null? (cdr _maybe-sstart+send100144_))
                  (_doit!100146_
                   (car _maybe-sstart+send100144_)
                   _n100148_
                   _n100148_)
                  (if (null? (cddr _maybe-sstart+send100144_))
                      (_doit!100146_
                       (car _maybe-sstart+send100144_)
                       (cadr _maybe-sstart+send100144_)
                       _n100148_)
                      (error '"too many arguments"
                             std/srfi/133#vector-copy!
                             (cddr _maybe-sstart+send100144_)))))))))
  (define std/srfi/133#vector-reverse-copy!
    (lambda (_target100121_
             _tstart100122_
             _source100123_
             .
             _maybe-sstart+send100124_)
      (letrec ((_doit!100126_
                (lambda (_sstart100130_ _send100131_ _source-length100132_)
                  (let ((_tstart100134_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _tstart100122_
                          std/srfi/133#vector-reverse-copy!))
                        (_sstart100135_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _sstart100130_
                          std/srfi/133#vector-reverse-copy!))
                        (_send100136_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _send100131_
                          std/srfi/133#vector-reverse-copy!)))
                    (if (and (eq? _target100121_ _source100123_)
                             (or (std/srfi/133#between?
                                  _sstart100135_
                                  _tstart100134_
                                  _send100136_)
                                 (std/srfi/133#between?
                                  _tstart100134_
                                  _sstart100135_
                                  (+ _tstart100134_
                                     (- _send100136_ _sstart100135_)))))
                        (error '"vector range for self-copying overlaps"
                               std/srfi/133#vector-reverse-copy!
                               (cons 'vector
                                     (cons 'was (cons _target100121_ '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart100134_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart100135_ '())))
                               (cons 'send
                                     (cons 'was (cons _send100136_ '()))))
                        (if (and (<= '0
                                     _sstart100135_
                                     _send100136_
                                     _source-length100132_)
                                 (<= (+ _tstart100134_
                                        (- _send100136_ _sstart100135_))
                                     (vector-length _target100121_)))
                            (std/srfi/133#%vector-reverse-copy!
                             _target100121_
                             _tstart100134_
                             _source100123_
                             _sstart100135_
                             _send100136_)
                            (error '"illegal arguments"
                                   (cons 'while
                                         (cons 'calling
                                               (cons std/srfi/133#vector-reverse-copy!
                                                     '())))
                                   (cons 'target
                                         (cons 'was (cons _target100121_ '())))
                                   (cons 'target-length
                                         (cons 'was
                                               (cons (vector-length
                                                      _target100121_)
                                                     '())))
                                   (cons 'tstart
                                         (cons 'was (cons _tstart100134_ '())))
                                   (cons 'source
                                         (cons 'was (cons _source100123_ '())))
                                   (cons 'source-length
                                         (cons 'was
                                               (cons _source-length100132_
                                                     '())))
                                   (cons 'sstart
                                         (cons 'was (cons _sstart100135_ '())))
                                   (cons 'send
                                         (cons 'was
                                               (cons _send100136_ '()))))))))))
        (let ((_n100128_ (vector-length _source100123_)))
          (if (null? _maybe-sstart+send100124_)
              (_doit!100126_ '0 _n100128_ _n100128_)
              (if (null? (cdr _maybe-sstart+send100124_))
                  (_doit!100126_
                   (car _maybe-sstart+send100124_)
                   _n100128_
                   _n100128_)
                  (if (null? (cddr _maybe-sstart+send100124_))
                      (_doit!100126_
                       (car _maybe-sstart+send100124_)
                       (cadr _maybe-sstart+send100124_)
                       _n100128_)
                      (error '"too many arguments"
                             std/srfi/133#vector-reverse-copy!
                             (cddr _maybe-sstart+send100124_)))))))))
  (define std/srfi/133#vector-reverse!
    (lambda (_vec100113_ . _start+end100114_)
      (let* ((_vec100116_
              (std/srfi/133#check-type
               vector?
               _vec100113_
               std/srfi/133#vector-reverse!))
             (_g289699_
              (std/srfi/133#vector-parse-start+end
               _vec100116_
               _start+end100114_
               'start
               'end
               std/srfi/133#vector-reverse!)))
        (begin
          (let ((_g289700_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289699_) (##vector-length _g289699_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289700_ 2)))
                (error "Context expects 2 values" _g289700_)))
          (let ((_start100118_
                 (let () (declare (not safe)) (##vector-ref _g289699_ 0)))
                (_end100119_
                 (let () (declare (not safe)) (##vector-ref _g289699_ 1))))
            (std/srfi/133#%vector-reverse!
             _vec100116_
             _start100118_
             _end100119_))))))
  (define std/srfi/133#vector->list
    (lambda (_vec100099_ . _maybe-start+end100100_)
      (let* ((_vec100102_
              (std/srfi/133#check-type
               vector?
               _vec100099_
               std/srfi/133#vector->list))
             (_g289701_
              (std/srfi/133#vector-parse-start+end
               _vec100102_
               _maybe-start+end100100_
               'start
               'end
               std/srfi/133#vector->list)))
        (begin
          (let ((_g289702_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289701_) (##vector-length _g289701_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289702_ 2)))
                (error "Context expects 2 values" _g289702_)))
          (let ((_start100104_
                 (let () (declare (not safe)) (##vector-ref _g289701_ 0)))
                (_end100105_
                 (let () (declare (not safe)) (##vector-ref _g289701_ 1))))
            (let _$loop100107_ ((_i100110_ (- _end100105_ '1))
                                (_result100111_ '()))
              (if (< _i100110_ _start100104_)
                  _result100111_
                  (_$loop100107_
                   (- _i100110_ '1)
                   (cons (vector-ref _vec100102_ _i100110_)
                         _result100111_)))))))))
  (define std/srfi/133#reverse-vector->list
    (lambda (_vec100085_ . _maybe-start+end100086_)
      (let* ((_vec100088_
              (std/srfi/133#check-type
               vector?
               _vec100085_
               std/srfi/133#reverse-vector->list))
             (_g289703_
              (std/srfi/133#vector-parse-start+end
               _vec100088_
               _maybe-start+end100086_
               'start
               'end
               std/srfi/133#reverse-vector->list)))
        (begin
          (let ((_g289704_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g289703_) (##vector-length _g289703_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g289704_ 2)))
                (error "Context expects 2 values" _g289704_)))
          (let ((_start100090_
                 (let () (declare (not safe)) (##vector-ref _g289703_ 0)))
                (_end100091_
                 (let () (declare (not safe)) (##vector-ref _g289703_ 1))))
            (let _$loop100093_ ((_i100096_ _start100090_) (_result100097_ '()))
              (if (= _i100096_ _end100091_)
                  _result100097_
                  (_$loop100093_
                   (+ _i100096_ '1)
                   (cons (vector-ref _vec100088_ _i100096_)
                         _result100097_)))))))))
  (define std/srfi/133#list->vector
    (lambda (_lst100041_ . _maybe-start+end100042_)
      (if (null? _maybe-start+end100042_)
          (let* ((_start100044_ '0) (_end100046_ (length _lst100041_)))
            (let ((_start100049_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _start100044_
                    std/srfi/133#list->vector))
                  (_end100050_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _end100046_
                    std/srfi/133#list->vector)))
              ((lambda (_f100052_)
                 (std/srfi/133#vector-unfold
                  _f100052_
                  (- _end100050_ _start100049_)
                  (list-tail _lst100041_ _start100049_)))
               (lambda (_index100054_ _l100055_)
                 (if (null? _l100055_)
                     (error '"list was too short"
                            (cons 'list (cons 'was (cons _lst100041_ '())))
                            (cons 'attempted
                                  (cons 'end
                                        (cons 'was (cons _end100050_ '()))))
                            (cons 'while
                                  (cons 'calling
                                        (cons std/srfi/133#list->vector '()))))
                     (if (pair? _l100055_)
                         (values (car _l100055_) (cdr _l100055_))
                         (error '"erroneous value"
                                (list list? _lst100041_)
                                (cons 'while
                                      (cons 'calling
                                            (cons std/srfi/133#list->vector
                                                  '()))))))))))
          (let ((_start100057_ (car _maybe-start+end100042_))
                (_new-args100058_ (cdr _maybe-start+end100042_)))
            (if (null? _new-args100058_)
                (let ((_end100061_ (length _lst100041_)))
                  (let ((_start100064_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _start100057_
                          std/srfi/133#list->vector))
                        (_end100065_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _end100061_
                          std/srfi/133#list->vector)))
                    ((lambda (_f100067_)
                       (std/srfi/133#vector-unfold
                        _f100067_
                        (- _end100065_ _start100064_)
                        (list-tail _lst100041_ _start100064_)))
                     (lambda (_index100069_ _l100070_)
                       (if (null? _l100070_)
                           (error '"list was too short"
                                  (cons 'list
                                        (cons 'was (cons _lst100041_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end100065_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/133#list->vector
                                                    '()))))
                           (if (pair? _l100070_)
                               (values (car _l100070_) (cdr _l100070_))
                               (error '"erroneous value"
                                      (list list? _lst100041_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/133#list->vector
                                                        '()))))))))))
                (let ((_end100072_ (car _new-args100058_))
                      (_new-args100073_ (cdr _new-args100058_)))
                  (if (null? _new-args100073_)
                      (let ()
                        (let ((_start100077_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _start100057_
                                std/srfi/133#list->vector))
                              (_end100078_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _end100072_
                                std/srfi/133#list->vector)))
                          ((lambda (_f100080_)
                             (std/srfi/133#vector-unfold
                              _f100080_
                              (- _end100078_ _start100077_)
                              (list-tail _lst100041_ _start100077_)))
                           (lambda (_index100082_ _l100083_)
                             (if (null? _l100083_)
                                 (error '"list was too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst100041_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end100078_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/133#list->vector
                                                          '()))))
                                 (if (pair? _l100083_)
                                     (values (car _l100083_) (cdr _l100083_))
                                     (error '"erroneous value"
                                            (list list? _lst100041_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/133#list->vector
                                                              '()))))))))))
                      (error '"too many arguments"
                             (length _maybe-start+end100042_)
                             _maybe-start+end100042_))))))))
  (define std/srfi/133#reverse-list->vector
    (lambda (_lst99997_ . _maybe-start+end99998_)
      (if (null? _maybe-start+end99998_)
          (let* ((_start100000_ '0) (_end100002_ (length _lst99997_)))
            (let ((_start100005_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _start100000_
                    std/srfi/133#reverse-list->vector))
                  (_end100006_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _end100002_
                    std/srfi/133#reverse-list->vector)))
              ((lambda (_f100008_)
                 (std/srfi/133#vector-unfold-right
                  _f100008_
                  (- _end100006_ _start100005_)
                  (list-tail _lst99997_ _start100005_)))
               (lambda (_index100010_ _l100011_)
                 (if (null? _l100011_)
                     (error '"list too short"
                            (cons 'list (cons 'was (cons _lst99997_ '())))
                            (cons 'attempted
                                  (cons 'end
                                        (cons 'was (cons _end100006_ '()))))
                            (cons 'while
                                  (cons 'calling
                                        (cons std/srfi/133#reverse-list->vector
                                              '()))))
                     (if (pair? _l100011_)
                         (values (car _l100011_) (cdr _l100011_))
                         (error '"erroneous value"
                                (list list? _lst99997_)
                                (cons 'while
                                      (cons 'calling
                                            (cons std/srfi/133#reverse-list->vector
                                                  '()))))))))))
          (let ((_start100013_ (car _maybe-start+end99998_))
                (_new-args100014_ (cdr _maybe-start+end99998_)))
            (if (null? _new-args100014_)
                (let ((_end100017_ (length _lst99997_)))
                  (let ((_start100020_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _start100013_
                          std/srfi/133#reverse-list->vector))
                        (_end100021_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _end100017_
                          std/srfi/133#reverse-list->vector)))
                    ((lambda (_f100023_)
                       (std/srfi/133#vector-unfold-right
                        _f100023_
                        (- _end100021_ _start100020_)
                        (list-tail _lst99997_ _start100020_)))
                     (lambda (_index100025_ _l100026_)
                       (if (null? _l100026_)
                           (error '"list too short"
                                  (cons 'list
                                        (cons 'was (cons _lst99997_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end100021_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/133#reverse-list->vector
                                                    '()))))
                           (if (pair? _l100026_)
                               (values (car _l100026_) (cdr _l100026_))
                               (error '"erroneous value"
                                      (list list? _lst99997_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/133#reverse-list->vector
                                                        '()))))))))))
                (let ((_end100028_ (car _new-args100014_))
                      (_new-args100029_ (cdr _new-args100014_)))
                  (if (null? _new-args100029_)
                      (let ()
                        (let ((_start100033_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _start100013_
                                std/srfi/133#reverse-list->vector))
                              (_end100034_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _end100028_
                                std/srfi/133#reverse-list->vector)))
                          ((lambda (_f100036_)
                             (std/srfi/133#vector-unfold-right
                              _f100036_
                              (- _end100034_ _start100033_)
                              (list-tail _lst99997_ _start100033_)))
                           (lambda (_index100038_ _l100039_)
                             (if (null? _l100039_)
                                 (error '"list too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst99997_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end100034_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/133#reverse-list->vector
                                                          '()))))
                                 (if (pair? _l100039_)
                                     (values (car _l100039_) (cdr _l100039_))
                                     (error '"erroneous value"
                                            (list list? _lst99997_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/133#reverse-list->vector
                                                              '()))))))))))
                      (error '"too many arguments"
                             (length _maybe-start+end99998_)
                             _maybe-start+end99998_))))))))
  (define std/srfi/133#vector->string
    (lambda (_vec99978_ . _maybe-start+end99979_)
      (let* ((_len99981_ (vector-length _vec99978_))
             (_start99983_
              (if (null? _maybe-start+end99979_)
                  '0
                  (car _maybe-start+end99979_)))
             (_end99985_
              (if (null? _maybe-start+end99979_)
                  _len99981_
                  (if (null? (cdr _maybe-start+end99979_))
                      _len99981_
                      (cadr _maybe-start+end99979_))))
             (_size99987_ (- _end99985_ _start99983_)))
        (letrec* ((_result99990_ (make-string _size99987_)))
          (let _loop99992_ ((_at99994_ '0) (_i99995_ _start99983_))
            (if (= _i99995_ _end99985_)
                _result99990_
                (begin
                  (string-set!
                   _result99990_
                   _at99994_
                   (vector-ref _vec99978_ _i99995_))
                  (_loop99992_ (+ _at99994_ '1) (+ _i99995_ '1)))))))))
  (define std/srfi/133#string->vector
    (lambda (_str99959_ . _maybe-start+end99960_)
      (let* ((_len99962_ (string-length _str99959_))
             (_start99964_
              (if (null? _maybe-start+end99960_)
                  '0
                  (car _maybe-start+end99960_)))
             (_end99966_
              (if (null? _maybe-start+end99960_)
                  _len99962_
                  (if (null? (cdr _maybe-start+end99960_))
                      _len99962_
                      (cadr _maybe-start+end99960_))))
             (_size99968_ (- _end99966_ _start99964_)))
        (letrec* ((_result99971_ (make-vector _size99968_)))
          (let _loop99973_ ((_at99975_ '0) (_i99976_ _start99964_))
            (if (= _i99976_ _end99966_)
                _result99971_
                (begin
                  (vector-set!
                   _result99971_
                   _at99975_
                   (string-ref _str99959_ _i99976_))
                  (_loop99973_ (+ _at99975_ '1) (+ _i99976_ '1))))))))))
