(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/19#time-tai 'time-tai)
  (define std/srfi/19#time-utc 'time-utc)
  (define std/srfi/19#time-monotonic 'time-monotonic)
  (define std/srfi/19#time-thread 'time-thread)
  (define std/srfi/19#time-process 'time-process)
  (define std/srfi/19#time-duration 'time-duration)
  (define std/srfi/19#tm:locale-number-separator '".")
  (define std/srfi/19#tm:locale-abbr-weekday-vector
    (vector '"Sun" '"Mon" '"Tue" '"Wed" '"Thu" '"Fri" '"Sat"))
  (define std/srfi/19#tm:locale-long-weekday-vector
    (vector '"Sunday"
            '"Monday"
            '"Tuesday"
            '"Wednesday"
            '"Thursday"
            '"Friday"
            '"Saturday"))
  (define std/srfi/19#tm:locale-abbr-month-vector
    (vector '""
            '"Jan"
            '"Feb"
            '"Mar"
            '"Apr"
            '"May"
            '"Jun"
            '"Jul"
            '"Aug"
            '"Sep"
            '"Oct"
            '"Nov"
            '"Dec"))
  (define std/srfi/19#tm:locale-long-month-vector
    (vector '""
            '"January"
            '"February"
            '"March"
            '"April"
            '"May"
            '"June"
            '"July"
            '"August"
            '"September"
            '"October"
            '"November"
            '"December"))
  (define std/srfi/19#tm:locale-pm '"PM")
  (define std/srfi/19#tm:locale-am '"AM")
  (define std/srfi/19#tm:locale-date-time-format '"~a ~b ~d ~H:~M:~S~z ~Y")
  (define std/srfi/19#tm:locale-short-date-format '"~m/~d/~y")
  (define std/srfi/19#tm:locale-time-format '"~H:~M:~S")
  (define std/srfi/19#tm:iso-8601-date-time-format '"~Y-~m-~dT~H:~M:~S~z")
  (define std/srfi/19#tm:nano (expt '10 '9))
  (define std/srfi/19#tm:sid '86400)
  (define std/srfi/19#tm:sihd '43200)
  (define std/srfi/19#tm:tai-epoch-in-jd '4881175/2)
  (define std/srfi/19#tm:time-error-types
    '(invalid-clock-type
      unsupported-clock-type
      incompatible-time-types
      not-duration
      dates-are-immutable
      bad-date-format-string
      bad-date-template-string
      invalid-month-specification))
  (define std/srfi/19#tm:time-error
    (lambda (_caller48692_ _type48693_ _value48694_)
      (if (member _type48693_ std/srfi/19#tm:time-error-types)
          (if _value48694_
              (error '"TIME-ERROR type" _caller48692_ _type48693_ _value48694_)
              (error '"TIME-ERROR type" _caller48692_ _type48693_))
          (error '"TIME-ERROR unsupported error type"
                 _caller48692_
                 _type48693_))))
  (define std/srfi/19#tm:read-tai-utc-data
    (lambda (_filename48667_)
      (letrec ((_convert-jd48669_
                (lambda (_jd48690_)
                  (* (- (inexact->exact _jd48690_)
                        std/srfi/19#tm:tai-epoch-in-jd)
                     std/srfi/19#tm:sid)))
               (_convert-sec48670_
                (lambda (_sec48688_) (inexact->exact _sec48688_))))
        (let ((_port48672_ (open-input-file _filename48667_))
              (_table48673_ '()))
          (let _loop48675_ ((_line48677_ (read-line _port48672_)))
            (if (not (eof-object? _line48677_))
                (let* ((_data48679_
                        (read (open-input-string
                               (string-append '"(" _line48677_ '")"))))
                       (_year48681_ (car _data48679_))
                       (_jd48683_ (cadddr (cdr _data48679_)))
                       (_secs48685_ (cadddr (cdddr _data48679_))))
                  (if (>= _year48681_ '1972)
                      (set! _table48673_
                            (cons (cons (_convert-jd48669_ _jd48683_)
                                        (inexact->exact _secs48685_))
                                  _table48673_))
                      '#!void)
                  (_loop48675_ (read-line _port48672_)))
                '#!void))
          _table48673_))))
  (define std/srfi/19#tm:leap-second-table
    '((1483228800 . 37)
      (1435708800 . 36)
      (1341100800 . 35)
      (1230768000 . 34)
      (1136073600 . 33)
      (915148800 . 32)
      (867715200 . 31)
      (820454400 . 30)
      (773020800 . 29)
      (741484800 . 28)
      (709948800 . 27)
      (662688000 . 26)
      (631152000 . 25)
      (567993600 . 24)
      (489024000 . 23)
      (425865600 . 22)
      (394329600 . 21)
      (362793600 . 20)
      (315532800 . 19)
      (283996800 . 18)
      (252460800 . 17)
      (220924800 . 16)
      (189302400 . 15)
      (157766400 . 14)
      (126230400 . 13)
      (94694400 . 12)
      (78796800 . 11)
      (63072000 . 10)))
  (define std/srfi/19#read-leap-second-table
    (lambda (_filename48665_)
      (set! std/srfi/19#tm:leap-second-table
            (std/srfi/19#tm:read-tai-utc-data _filename48665_))
      '#!void))
  (define std/srfi/19#tm:leap-second-delta
    (lambda (_utc-seconds48659_)
      (letrec ((_lsd48661_
                (lambda (_table48663_)
                  (if (>= _utc-seconds48659_ (caar _table48663_))
                      (cdar _table48663_)
                      (_lsd48661_ (cdr _table48663_))))))
        (if (< _utc-seconds48659_ (* (- '1972 '1970) '365 std/srfi/19#tm:sid))
            '0
            (_lsd48661_ std/srfi/19#tm:leap-second-table)))))
  (define std/srfi/19#tm:leap-second-neg-delta
    (lambda (_tai-seconds48653_)
      (letrec ((_lsd48655_
                (lambda (_table48657_)
                  (if (null? _table48657_)
                      '0
                      (if (<= (cdar _table48657_)
                              (- _tai-seconds48653_ (caar _table48657_)))
                          (cdar _table48657_)
                          (_lsd48655_ (cdr _table48657_)))))))
        (if (< _tai-seconds48653_ (* (- '1972 '1970) '365 std/srfi/19#tm:sid))
            '0
            (_lsd48655_ std/srfi/19#tm:leap-second-table)))))
  (define std/srfi/19#time::t
    (make-struct-type
     'std/srfi/19#time::t
     '#f
     '3
     'time
     '((transparent: . #t))
     '#f
     '(type nanosecond second)))
  (define std/srfi/19#time? (make-struct-predicate std/srfi/19#time::t))
  (define std/srfi/19#make-time
    (lambda _$args48650_
      (apply make-struct-instance std/srfi/19#time::t _$args48650_)))
  (define std/srfi/19#time-type
    (make-struct-field-accessor std/srfi/19#time::t '0))
  (define std/srfi/19#time-nanosecond
    (make-struct-field-accessor std/srfi/19#time::t '1))
  (define std/srfi/19#time-second
    (make-struct-field-accessor std/srfi/19#time::t '2))
  (define std/srfi/19#time-type-set!
    (make-struct-field-mutator std/srfi/19#time::t '0))
  (define std/srfi/19#time-nanosecond-set!
    (make-struct-field-mutator std/srfi/19#time::t '1))
  (define std/srfi/19#time-second-set!
    (make-struct-field-mutator std/srfi/19#time::t '2))
  (define std/srfi/19#make-time%
    (lambda (_type48628_ _nanosecond48629_ _second48630_)
      (let ((_$e48632_ _type48628_))
        (if (or (eq? 'time-tai _$e48632_)
                (eq? 'time-utc _$e48632_)
                (eq? 'time-monotonic _$e48632_)
                (eq? 'time-thread _$e48632_)
                (eq? 'time-process _$e48632_)
                (eq? 'time-duration _$e48632_))
            '#t
            (error '"Wrong time type" _type48628_)))
      (if (exact-integer? _second48630_)
          '#!void
          (error '"Invalid time second" _second48630_))
      (if (and (exact-integer? _nanosecond48629_)
               (<= (if (eq? _type48628_ std/srfi/19#time-duration)
                       '-999999999
                       '0)
                   _nanosecond48629_
                   '999999999))
          '#!void
          (error '"Invalid time nanosecond" _nanosecond48629_))
      (let ()
        (declare (not safe))
        (##structure
         std/srfi/19#time::t
         _type48628_
         _nanosecond48629_
         _second48630_))))
  (define std/srfi/19#copy-time
    (lambda (_time48626_)
      (let ((__tmp283566
             (##structure-ref _time48626_ '1 std/srfi/19#time::t '#f))
            (__tmp283565
             (##structure-ref _time48626_ '2 std/srfi/19#time::t '#f))
            (__tmp283564
             (##structure-ref _time48626_ '3 std/srfi/19#time::t '#f)))
        (declare (not safe))
        (##structure
         std/srfi/19#time::t
         __tmp283566
         __tmp283565
         __tmp283564))))
  (define std/srfi/19#current-seconds
    (lambda ()
      (inexact->exact
       (floor (let () (declare (not safe)) (##current-time-point))))))
  (define std/srfi/19#current-milliseconds
    (lambda ()
      (inexact->exact
       (floor (fl* '1000.
                   (let () (declare (not safe)) (##current-time-point)))))))
  (define std/srfi/19#tm:get-time-of-day
    (lambda ()
      (let* ((_now48619_ (let () (declare (not safe)) (##current-time-point)))
             (_sec48621_ (floor _now48619_)))
        (values (inexact->exact _sec48621_)
                (inexact->exact
                 (floor (fl* (fl- _now48619_ _sec48621_) '1000000000.)))))))
  (define std/srfi/19#tm:current-time-utc
    (lambda ()
      (let ((_g283567_ (std/srfi/19#tm:get-time-of-day)))
        (begin
          (let ((_g283568_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g283567_) (##vector-length _g283567_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g283568_ 2)))
                (error "Context expects 2 values" _g283568_)))
          (let ((_seconds48615_
                 (let () (declare (not safe)) (##vector-ref _g283567_ 0)))
                (_ns48616_
                 (let () (declare (not safe)) (##vector-ref _g283567_ 1))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/19#time::t
               std/srfi/19#time-utc
               _ns48616_
               _seconds48615_)))))))
  (define std/srfi/19#tm:current-time-tai
    (lambda ()
      (let ((_g283569_ (std/srfi/19#tm:get-time-of-day)))
        (begin
          (let ((_g283570_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g283569_) (##vector-length _g283569_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g283570_ 2)))
                (error "Context expects 2 values" _g283570_)))
          (let ((_seconds48611_
                 (let () (declare (not safe)) (##vector-ref _g283569_ 0)))
                (_ns48612_
                 (let () (declare (not safe)) (##vector-ref _g283569_ 1))))
            (let ((__tmp283571
                   (+ _seconds48611_
                      (std/srfi/19#tm:leap-second-delta _seconds48611_))))
              (declare (not safe))
              (##structure
               std/srfi/19#time::t
               std/srfi/19#time-tai
               _ns48612_
               __tmp283571)))))))
  (define std/srfi/19#tm:current-time-monotonic
    (lambda ()
      (let ((_g283572_ (std/srfi/19#tm:get-time-of-day)))
        (begin
          (let ((_g283573_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g283572_) (##vector-length _g283572_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g283573_ 2)))
                (error "Context expects 2 values" _g283573_)))
          (let ((_seconds48607_
                 (let () (declare (not safe)) (##vector-ref _g283572_ 0)))
                (_ns48608_
                 (let () (declare (not safe)) (##vector-ref _g283572_ 1))))
            (let ((__tmp283574
                   (+ _seconds48607_
                      (std/srfi/19#tm:leap-second-delta _seconds48607_))))
              (declare (not safe))
              (##structure
               std/srfi/19#time::t
               std/srfi/19#time-monotonic
               _ns48608_
               __tmp283574)))))))
  (define std/srfi/19#tm:current-time-thread
    (lambda () (error '"Unimplemented")))
  (define std/srfi/19#tm:current-time-process
    (lambda () (error '"Unimplemented")))
  (define std/srfi/19#current-time
    (lambda _clock-type48597_
      (let ((_clock-type48602_
             (let ((_maybe-arg48599_ _clock-type48597_))
               (if (null? _maybe-arg48599_)
                   std/srfi/19#time-utc
                   (if (null? (cdr _maybe-arg48599_))
                       (car _maybe-arg48599_)
                       (error '"too many optional arguments"
                              _maybe-arg48599_))))))
        (if (eq? _clock-type48602_ std/srfi/19#time-tai)
            (std/srfi/19#tm:current-time-tai)
            (if (eq? _clock-type48602_ std/srfi/19#time-utc)
                (std/srfi/19#tm:current-time-utc)
                (if (eq? _clock-type48602_ std/srfi/19#time-monotonic)
                    (std/srfi/19#tm:current-time-monotonic)
                    (if (eq? _clock-type48602_ std/srfi/19#time-thread)
                        (std/srfi/19#tm:current-time-thread)
                        (if (eq? _clock-type48602_ std/srfi/19#time-process)
                            (std/srfi/19#tm:current-time-process)
                            (std/srfi/19#tm:time-error
                             'current-time
                             'invalid-clock-type
                             _clock-type48602_)))))))))
  (define std/srfi/19#time-resolution
    (lambda _clock-type48590_
      (let ((_clock-type48595_
             (let ((_maybe-arg48592_ _clock-type48590_))
               (if (null? _maybe-arg48592_)
                   std/srfi/19#time-utc
                   (if (null? (cdr _maybe-arg48592_))
                       (car _maybe-arg48592_)
                       (error '"too many optional arguments"
                              _maybe-arg48592_))))))
        (if (eq? _clock-type48595_ std/srfi/19#time-tai)
            '1
            (if (eq? _clock-type48595_ std/srfi/19#time-utc)
                '1
                (if (eq? _clock-type48595_ std/srfi/19#time-monotonic)
                    '1
                    (if (eq? _clock-type48595_ std/srfi/19#time-thread)
                        '1000
                        (if (eq? _clock-type48595_ std/srfi/19#time-process)
                            '1000
                            (std/srfi/19#tm:time-error
                             'time-resolution
                             'invalid-clock-type
                             _clock-type48595_)))))))))
  (define std/srfi/19#tm:time-compare-check
    (lambda (_time148583_ _time248584_ _caller48585_)
      (if (or (not (and (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time148583_
                           'std/srfi/19#time::t))
                        (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time248584_
                           'std/srfi/19#time::t))))
              (not (eq? (##structure-ref
                         _time148583_
                         '1
                         std/srfi/19#time::t
                         '#f)
                        (##structure-ref
                         _time248584_
                         '1
                         std/srfi/19#time::t
                         '#f))))
          (std/srfi/19#tm:time-error
           _caller48585_
           'incompatible-time-types
           '#f)
          '#t)))
  (define std/srfi/19#time=?
    (lambda (_time148580_ _time248581_)
      (std/srfi/19#tm:time-compare-check _time148580_ _time248581_ 'time=?)
      (if (= (##structure-ref _time148580_ '3 std/srfi/19#time::t '#f)
             (##structure-ref _time248581_ '3 std/srfi/19#time::t '#f))
          (= (##structure-ref _time148580_ '2 std/srfi/19#time::t '#f)
             (##structure-ref _time248581_ '2 std/srfi/19#time::t '#f))
          '#f)))
  (define std/srfi/19#time>?
    (lambda (_time148574_ _time248575_)
      (std/srfi/19#tm:time-compare-check _time148574_ _time248575_ 'time>?)
      (let ((_$e48577_
             (> (##structure-ref _time148574_ '3 std/srfi/19#time::t '#f)
                (##structure-ref _time248575_ '3 std/srfi/19#time::t '#f))))
        (if _$e48577_
            _$e48577_
            (if (= (##structure-ref _time148574_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248575_ '3 std/srfi/19#time::t '#f))
                (> (##structure-ref _time148574_ '2 std/srfi/19#time::t '#f)
                   (##structure-ref _time248575_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#time<?
    (lambda (_time148568_ _time248569_)
      (std/srfi/19#tm:time-compare-check _time148568_ _time248569_ 'time<?)
      (let ((_$e48571_
             (< (##structure-ref _time148568_ '3 std/srfi/19#time::t '#f)
                (##structure-ref _time248569_ '3 std/srfi/19#time::t '#f))))
        (if _$e48571_
            _$e48571_
            (if (= (##structure-ref _time148568_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248569_ '3 std/srfi/19#time::t '#f))
                (< (##structure-ref _time148568_ '2 std/srfi/19#time::t '#f)
                   (##structure-ref _time248569_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#time>=?
    (lambda (_time148562_ _time248563_)
      (std/srfi/19#tm:time-compare-check _time148562_ _time248563_ 'time>=?)
      (let ((_$e48565_
             (>= (##structure-ref _time148562_ '3 std/srfi/19#time::t '#f)
                 (##structure-ref _time248563_ '3 std/srfi/19#time::t '#f))))
        (if _$e48565_
            _$e48565_
            (if (= (##structure-ref _time148562_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248563_ '3 std/srfi/19#time::t '#f))
                (>= (##structure-ref _time148562_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref _time248563_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#time<=?
    (lambda (_time148556_ _time248557_)
      (std/srfi/19#tm:time-compare-check _time148556_ _time248557_ 'time<=?)
      (let ((_$e48559_
             (<= (##structure-ref _time148556_ '3 std/srfi/19#time::t '#f)
                 (##structure-ref _time248557_ '3 std/srfi/19#time::t '#f))))
        (if _$e48559_
            _$e48559_
            (if (= (##structure-ref _time148556_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248557_ '3 std/srfi/19#time::t '#f))
                (<= (##structure-ref _time148556_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref _time248557_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#tm:time->nanoseconds
    (lambda (_time48550_)
      (letrec ((_sign148552_
                (lambda (_n48554_) (if (negative? _n48554_) '-1 '1))))
        (+ (* (##structure-ref _time48550_ '3 std/srfi/19#time::t '#f)
              std/srfi/19#tm:nano)
           (##structure-ref _time48550_ '2 std/srfi/19#time::t '#f)))))
  (define std/srfi/19#tm:nanoseconds->time
    (lambda (_time-type48547_ _nanoseconds48548_)
      (let ((__tmp283576 (remainder _nanoseconds48548_ std/srfi/19#tm:nano))
            (__tmp283575 (quotient _nanoseconds48548_ std/srfi/19#tm:nano)))
        (declare (not safe))
        (##structure
         std/srfi/19#time::t
         _time-type48547_
         __tmp283576
         __tmp283575))))
  (define std/srfi/19#tm:nanoseconds->values
    (lambda (_nanoseconds48545_)
      (values (abs (remainder _nanoseconds48545_ std/srfi/19#tm:nano))
              (quotient _nanoseconds48545_ std/srfi/19#tm:nano))))
  (define std/srfi/19#tm:time-difference
    (lambda (_time148535_ _time248536_ _time348537_)
      (if (or (not (and (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time148535_
                           'std/srfi/19#time::t))
                        (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time248536_
                           'std/srfi/19#time::t))))
              (not (eq? (##structure-ref
                         _time148535_
                         '1
                         std/srfi/19#time::t
                         '#f)
                        (##structure-ref
                         _time248536_
                         '1
                         std/srfi/19#time::t
                         '#f))))
          (std/srfi/19#tm:time-error
           'time-difference
           'incompatible-time-types
           '#f)
          '#!void)
      (##structure-set!
       _time348537_
       std/srfi/19#time-duration
       '1
       std/srfi/19#time::t
       '#f)
      (if (std/srfi/19#time=? _time148535_ _time248536_)
          (begin
            (##structure-set! _time348537_ '0 '3 std/srfi/19#time::t '#f)
            (##structure-set! _time348537_ '0 '2 std/srfi/19#time::t '#f))
          (let ((_g283577_
                 (std/srfi/19#tm:nanoseconds->values
                  (- (std/srfi/19#tm:time->nanoseconds _time148535_)
                     (std/srfi/19#tm:time->nanoseconds _time248536_)))))
            (begin
              (let ((_g283578_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g283577_)
                           (##vector-length _g283577_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g283578_ 2)))
                    (error "Context expects 2 values" _g283578_)))
              (let ((_nanos48542_
                     (let () (declare (not safe)) (##vector-ref _g283577_ 0)))
                    (_secs48543_
                     (let () (declare (not safe)) (##vector-ref _g283577_ 1))))
                (begin
                  (##structure-set!
                   _time348537_
                   _secs48543_
                   '3
                   std/srfi/19#time::t
                   '#f)
                  (##structure-set!
                   _time348537_
                   _nanos48542_
                   '2
                   std/srfi/19#time::t
                   '#f))))))
      _time348537_))
  (define std/srfi/19#time-difference
    (lambda (_time148532_ _time248533_)
      (std/srfi/19#tm:time-difference
       _time148532_
       _time248533_
       (let ()
         (declare (not safe))
         (##structure std/srfi/19#time::t '#f '#f '#f)))))
  (define std/srfi/19#time-difference!
    (lambda (_time148529_ _time248530_)
      (std/srfi/19#tm:time-difference _time148529_ _time248530_ _time148529_)))
  (define std/srfi/19#tm:add-duration
    (lambda (_time148519_ _duration48520_ _time348521_)
      (if (not (and (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _time148519_
                       'std/srfi/19#time::t))
                    (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _duration48520_
                       'std/srfi/19#time::t))))
          (std/srfi/19#tm:time-error
           'add-duration
           'incompatible-time-types
           '#f)
          '#!void)
      (if (not (eq? (##structure-ref
                     _duration48520_
                     '1
                     std/srfi/19#time::t
                     '#f)
                    std/srfi/19#time-duration))
          (std/srfi/19#tm:time-error
           'add-duration
           'not-duration
           _duration48520_)
          (let ((_sec-plus48523_
                 (+ (##structure-ref _time148519_ '3 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48520_
                     '3
                     std/srfi/19#time::t
                     '#f)))
                (_nsec-plus48524_
                 (+ (##structure-ref _time148519_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48520_
                     '2
                     std/srfi/19#time::t
                     '#f))))
            (let ((_r48526_ (remainder _nsec-plus48524_ std/srfi/19#tm:nano))
                  (_q48527_ (quotient _nsec-plus48524_ std/srfi/19#tm:nano)))
              (if (negative? _r48526_)
                  (begin
                    (##structure-set!
                     _time348521_
                     (+ _sec-plus48523_ _q48527_ '-1)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348521_
                     (+ std/srfi/19#tm:nano _r48526_)
                     '2
                     std/srfi/19#time::t
                     '#f))
                  (begin
                    (##structure-set!
                     _time348521_
                     (+ _sec-plus48523_ _q48527_)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348521_
                     _r48526_
                     '2
                     std/srfi/19#time::t
                     '#f)))
              _time348521_)))))
  (define std/srfi/19#add-duration
    (lambda (_time148516_ _duration48517_)
      (std/srfi/19#tm:add-duration
       _time148516_
       _duration48517_
       (let ((__tmp283579
              (##structure-ref _time148516_ '1 std/srfi/19#time::t '#f)))
         (declare (not safe))
         (##structure std/srfi/19#time::t __tmp283579 '#f '#f)))))
  (define std/srfi/19#add-duration!
    (lambda (_time148513_ _duration48514_)
      (std/srfi/19#tm:add-duration _time148513_ _duration48514_ _time148513_)))
  (define std/srfi/19#tm:subtract-duration
    (lambda (_time148503_ _duration48504_ _time348505_)
      (if (not (and (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _time148503_
                       'std/srfi/19#time::t))
                    (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _duration48504_
                       'std/srfi/19#time::t))))
          (std/srfi/19#tm:time-error
           'add-duration
           'incompatible-time-types
           '#f)
          '#!void)
      (if (not (eq? (##structure-ref
                     _duration48504_
                     '1
                     std/srfi/19#time::t
                     '#f)
                    std/srfi/19#time-duration))
          (std/srfi/19#tm:time-error
           'tm:subtract-duration
           'not-duration
           _duration48504_)
          (let ((_sec-minus48507_
                 (- (##structure-ref _time148503_ '3 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48504_
                     '3
                     std/srfi/19#time::t
                     '#f)))
                (_nsec-minus48508_
                 (- (##structure-ref _time148503_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48504_
                     '2
                     std/srfi/19#time::t
                     '#f))))
            (let ((_r48510_ (remainder _nsec-minus48508_ std/srfi/19#tm:nano))
                  (_q48511_ (quotient _nsec-minus48508_ std/srfi/19#tm:nano)))
              (if (negative? _r48510_)
                  (begin
                    (##structure-set!
                     _time348505_
                     (- _sec-minus48507_ _q48511_ '1)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348505_
                     (+ std/srfi/19#tm:nano _r48510_)
                     '2
                     std/srfi/19#time::t
                     '#f))
                  (begin
                    (##structure-set!
                     _time348505_
                     (- _sec-minus48507_ _q48511_)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348505_
                     _r48510_
                     '2
                     std/srfi/19#time::t
                     '#f)))
              _time348505_)))))
  (define std/srfi/19#subtract-duration
    (lambda (_time148500_ _duration48501_)
      (std/srfi/19#tm:subtract-duration
       _time148500_
       _duration48501_
       (let ((__tmp283580
              (##structure-ref _time148500_ '1 std/srfi/19#time::t '#f)))
         (declare (not safe))
         (##structure std/srfi/19#time::t __tmp283580 '#f '#f)))))
  (define std/srfi/19#subtract-duration!
    (lambda (_time148497_ _duration48498_)
      (std/srfi/19#tm:subtract-duration
       _time148497_
       _duration48498_
       _time148497_)))
  (define std/srfi/19#tm:time-tai->time-utc!
    (lambda (_time-in48493_ _time-out48494_ _caller48495_)
      (if (not (eq? (##structure-ref _time-in48493_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           _caller48495_
           'incompatible-time-types
           _time-in48493_)
          '#!void)
      (##structure-set!
       _time-out48494_
       std/srfi/19#time-utc
       '1
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48494_
       (##structure-ref _time-in48493_ '2 std/srfi/19#time::t '#f)
       '2
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48494_
       (- (##structure-ref _time-in48493_ '3 std/srfi/19#time::t '#f)
          (std/srfi/19#tm:leap-second-neg-delta
           (##structure-ref _time-in48493_ '3 std/srfi/19#time::t '#f)))
       '3
       std/srfi/19#time::t
       '#f)
      _time-out48494_))
  (define std/srfi/19#time-tai->time-utc
    (lambda (_time-in48491_)
      (std/srfi/19#tm:time-tai->time-utc!
       _time-in48491_
       (let ()
         (declare (not safe))
         (##structure std/srfi/19#time::t '#f '#f '#f))
       'time-tai->time-utc)))
  (define std/srfi/19#time-tai->time-utc!
    (lambda (_time-in48489_)
      (std/srfi/19#tm:time-tai->time-utc!
       _time-in48489_
       _time-in48489_
       'time-tai->time-utc!)))
  (define std/srfi/19#tm:time-utc->time-tai!
    (lambda (_time-in48485_ _time-out48486_ _caller48487_)
      (if (not (eq? (##structure-ref _time-in48485_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           _caller48487_
           'incompatible-time-types
           _time-in48485_)
          '#!void)
      (##structure-set!
       _time-out48486_
       std/srfi/19#time-tai
       '1
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48486_
       (##structure-ref _time-in48485_ '2 std/srfi/19#time::t '#f)
       '2
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48486_
       (+ (##structure-ref _time-in48485_ '3 std/srfi/19#time::t '#f)
          (std/srfi/19#tm:leap-second-delta
           (##structure-ref _time-in48485_ '3 std/srfi/19#time::t '#f)))
       '3
       std/srfi/19#time::t
       '#f)
      _time-out48486_))
  (define std/srfi/19#time-utc->time-tai
    (lambda (_time-in48483_)
      (std/srfi/19#tm:time-utc->time-tai!
       _time-in48483_
       (let ()
         (declare (not safe))
         (##structure std/srfi/19#time::t '#f '#f '#f))
       'time-utc->time-tai)))
  (define std/srfi/19#time-utc->time-tai!
    (lambda (_time-in48481_)
      (std/srfi/19#tm:time-utc->time-tai!
       _time-in48481_
       _time-in48481_
       'time-utc->time-tai!)))
  (define std/srfi/19#time-monotonic->time-utc
    (lambda (_time-in48477_)
      (if (not (eq? (##structure-ref _time-in48477_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-utc
           'incompatible-time-types
           _time-in48477_)
          '#!void)
      (let ((_ntime48479_ (std/srfi/19#copy-time _time-in48477_)))
        (##structure-set!
         _ntime48479_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        (std/srfi/19#tm:time-tai->time-utc!
         _ntime48479_
         _ntime48479_
         'time-monotonic->time-utc))))
  (define std/srfi/19#time-monotonic->time-utc!
    (lambda (_time-in48475_)
      (if (not (eq? (##structure-ref _time-in48475_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-utc!
           'incompatible-time-types
           _time-in48475_)
          '#!void)
      (##structure-set!
       _time-in48475_
       std/srfi/19#time-tai
       '1
       std/srfi/19#time::t
       '#f)
      (std/srfi/19#tm:time-tai->time-utc!
       _time-in48475_
       _time-in48475_
       'time-monotonic->time-utc)))
  (define std/srfi/19#time-monotonic->time-tai
    (lambda (_time-in48471_)
      (if (not (eq? (##structure-ref _time-in48471_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-tai
           'incompatible-time-types
           _time-in48471_)
          '#!void)
      (let ((_ntime48473_ (std/srfi/19#copy-time _time-in48471_)))
        (##structure-set!
         _ntime48473_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48473_)))
  (define std/srfi/19#time-monotonic->time-tai!
    (lambda (_time-in48469_)
      (if (not (eq? (##structure-ref _time-in48469_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-tai!
           'incompatible-time-types
           _time-in48469_)
          '#!void)
      (##structure-set!
       _time-in48469_
       std/srfi/19#time-tai
       '1
       std/srfi/19#time::t
       '#f)
      _time-in48469_))
  (define std/srfi/19#time-utc->time-monotonic
    (lambda (_time-in48465_)
      (if (not (eq? (##structure-ref _time-in48465_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           'time-utc->time-monotonic
           'incompatible-time-types
           _time-in48465_)
          '#!void)
      (let ((_ntime48467_
             (std/srfi/19#tm:time-utc->time-tai!
              _time-in48465_
              (let ()
                (declare (not safe))
                (##structure std/srfi/19#time::t '#f '#f '#f))
              'time-utc->time-monotonic)))
        (##structure-set!
         _ntime48467_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48467_)))
  (define std/srfi/19#time-utc->time-monotonic!
    (lambda (_time-in48461_)
      (if (not (eq? (##structure-ref _time-in48461_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           'time-utc->time-montonic!
           'incompatible-time-types
           _time-in48461_)
          '#!void)
      (let ((_ntime48463_
             (std/srfi/19#tm:time-utc->time-tai!
              _time-in48461_
              _time-in48461_
              'time-utc->time-monotonic!)))
        (##structure-set!
         _ntime48463_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48463_)))
  (define std/srfi/19#time-tai->time-monotonic
    (lambda (_time-in48457_)
      (if (not (eq? (##structure-ref _time-in48457_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           'time-tai->time-monotonic
           'incompatible-time-types
           _time-in48457_)
          '#!void)
      (let ((_ntime48459_ (std/srfi/19#copy-time _time-in48457_)))
        (##structure-set!
         _ntime48459_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48459_)))
  (define std/srfi/19#time-tai->time-monotonic!
    (lambda (_time-in48455_)
      (if (not (eq? (##structure-ref _time-in48455_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           'time-tai->time-monotonic!
           'incompatible-time-types
           _time-in48455_)
          '#!void)
      (##structure-set!
       _time-in48455_
       std/srfi/19#time-monotonic
       '1
       std/srfi/19#time::t
       '#f)
      _time-in48455_))
  (define std/srfi/19#date::t
    (make-struct-type
     'std/srfi/19#date::t
     '#f
     '8
     'date
     '((transparent: . #t))
     '#f
     '(nanosecond second minute hour day month year zone-offset)))
  (define std/srfi/19#date? (make-struct-predicate std/srfi/19#date::t))
  (define std/srfi/19#make-date
    (lambda _$args48452_
      (apply make-struct-instance std/srfi/19#date::t _$args48452_)))
  (define std/srfi/19#date-nanosecond
    (make-struct-field-accessor std/srfi/19#date::t '0))
  (define std/srfi/19#date-second
    (make-struct-field-accessor std/srfi/19#date::t '1))
  (define std/srfi/19#date-minute
    (make-struct-field-accessor std/srfi/19#date::t '2))
  (define std/srfi/19#date-hour
    (make-struct-field-accessor std/srfi/19#date::t '3))
  (define std/srfi/19#date-day
    (make-struct-field-accessor std/srfi/19#date::t '4))
  (define std/srfi/19#date-month
    (make-struct-field-accessor std/srfi/19#date::t '5))
  (define std/srfi/19#date-year
    (make-struct-field-accessor std/srfi/19#date::t '6))
  (define std/srfi/19#date-zone-offset
    (make-struct-field-accessor std/srfi/19#date::t '7))
  (define std/srfi/19#date-nanosecond-set!
    (make-struct-field-mutator std/srfi/19#date::t '0))
  (define std/srfi/19#date-second-set!
    (make-struct-field-mutator std/srfi/19#date::t '1))
  (define std/srfi/19#date-minute-set!
    (make-struct-field-mutator std/srfi/19#date::t '2))
  (define std/srfi/19#date-hour-set!
    (make-struct-field-mutator std/srfi/19#date::t '3))
  (define std/srfi/19#date-day-set!
    (make-struct-field-mutator std/srfi/19#date::t '4))
  (define std/srfi/19#date-month-set!
    (make-struct-field-mutator std/srfi/19#date::t '5))
  (define std/srfi/19#date-year-set!
    (make-struct-field-mutator std/srfi/19#date::t '6))
  (define std/srfi/19#date-zone-offset-set!
    (make-struct-field-mutator std/srfi/19#date::t '7))
  (define std/srfi/19#tm:encode-julian-day-number
    (lambda (_day48441_ _month48442_ _year48443_)
      (let* ((_a48445_ (quotient (- '14 _month48442_) '12))
             (_y48447_
              (- (- (+ _year48443_ '4800) _a48445_)
                 (if (negative? _year48443_) '-1 '0)))
             (_m48449_ (- (+ _month48442_ (* '12 _a48445_)) '3)))
        (+ _day48441_
           (quotient (+ (* '153 _m48449_) '2) '5)
           (* '365 _y48447_)
           (quotient _y48447_ '4)
           (- (quotient _y48447_ '100))
           (quotient _y48447_ '400)
           '-32045))))
  (define std/srfi/19#tm:char-pos
    (lambda (_char48436_ _str48437_ _index48438_ _len48439_)
      (if (>= _index48438_ _len48439_)
          '#f
          (if (char=? (string-ref _str48437_ _index48438_) _char48436_)
              _index48438_
              (std/srfi/19#tm:char-pos
               _char48436_
               _str48437_
               (+ _index48438_ '1)
               _len48439_)))))
  (define std/srfi/19#tm:fractional-part
    (lambda (_r48430_)
      (if (integer? _r48430_)
          '"0"
          (let* ((_str48432_ (number->string (exact->inexact _r48430_)))
                 (_ppos48434_
                  (std/srfi/19#tm:char-pos
                   '#\.
                   _str48432_
                   '0
                   (string-length _str48432_))))
            (substring
             _str48432_
             (+ _ppos48434_ '1)
             (string-length _str48432_))))))
  (define std/srfi/19#tm:decode-julian-day-number
    (lambda (_jdn48411_)
      (let* ((_days48413_ (truncate _jdn48411_))
             (_a48415_ (+ _days48413_ '32044))
             (_b48417_ (quotient (+ (* '4 _a48415_) '3) '146097))
             (_c48419_ (- _a48415_ (quotient (* '146097 _b48417_) '4)))
             (_d48421_ (quotient (+ (* '4 _c48419_) '3) '1461))
             (_e48423_ (- _c48419_ (quotient (* '1461 _d48421_) '4)))
             (_m48425_ (quotient (+ (* '5 _e48423_) '2) '153))
             (_y48427_
              (+ (* '100 _b48417_) _d48421_ '-4800 (quotient _m48425_ '10))))
        (values (* (- _jdn48411_ _days48413_) std/srfi/19#tm:sid)
                (+ _e48423_ (- (quotient (+ (* '153 _m48425_) '2) '5)) '1)
                (+ _m48425_ '3 (* '-12 (quotient _m48425_ '10)))
                (if (>= '0 _y48427_) (- _y48427_ '1) _y48427_)))))
  (define std/srfi/19#tm:local-tz-offset (lambda () '0))
  (define std/srfi/19#tm:time->julian-day-number
    (lambda (_seconds48407_ _tz-offset48408_)
      (+ (/ (+ _seconds48407_ _tz-offset48408_ std/srfi/19#tm:sihd)
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#tm:find
    (lambda (_proc48404_ _l48405_)
      (if (null? _l48405_)
          '#f
          (if (_proc48404_ (car _l48405_))
              '#t
              (std/srfi/19#tm:find _proc48404_ (cdr _l48405_))))))
  (define std/srfi/19#tm:tai-before-leap-second?
    (lambda (_second48400_)
      (std/srfi/19#tm:find
       (lambda (_x48402_)
         (= _second48400_ (- (+ (car _x48402_) (cdr _x48402_)) '1)))
       std/srfi/19#tm:leap-second-table)))
  (define std/srfi/19#tm:time->date
    (lambda (_time48376_ _tz-offset48377_ _ttype48378_)
      (if (not (eq? (##structure-ref _time48376_ '1 std/srfi/19#time::t '#f)
                    _ttype48378_))
          (std/srfi/19#tm:time-error
           'time->date
           'incompatible-time-types
           _time48376_)
          '#!void)
      (let ((_offset48383_
             (let ((_maybe-arg48380_ _tz-offset48377_))
               (if (null? _maybe-arg48380_)
                   (std/srfi/19#tm:local-tz-offset)
                   (if (null? (cdr _maybe-arg48380_))
                       (car _maybe-arg48380_)
                       (error '"too many optional arguments"
                              _maybe-arg48380_))))))
        (let ((_g283581_
               (std/srfi/19#tm:decode-julian-day-number
                (std/srfi/19#tm:time->julian-day-number
                 (##structure-ref _time48376_ '3 std/srfi/19#time::t '#f)
                 _offset48383_))))
          (begin
            (let ((_g283582_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g283581_)
                         (##vector-length _g283581_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g283582_ 4)))
                  (error "Context expects 4 values" _g283582_)))
            (let ((_secs48386_
                   (let () (declare (not safe)) (##vector-ref _g283581_ 0)))
                  (_date48387_
                   (let () (declare (not safe)) (##vector-ref _g283581_ 1)))
                  (_month48388_
                   (let () (declare (not safe)) (##vector-ref _g283581_ 2)))
                  (_year48389_
                   (let () (declare (not safe)) (##vector-ref _g283581_ 3))))
              (let* ((_hours48391_ (quotient _secs48386_ (* '60 '60)))
                     (_rem48393_ (remainder _secs48386_ (* '60 '60)))
                     (_minutes48395_ (quotient _rem48393_ '60))
                     (_seconds48397_ (remainder _rem48393_ '60)))
                (let ((__tmp283583
                       (##structure-ref
                        _time48376_
                        '2
                        std/srfi/19#time::t
                        '#f)))
                  (declare (not safe))
                  (##structure
                   std/srfi/19#date::t
                   __tmp283583
                   _seconds48397_
                   _minutes48395_
                   _hours48391_
                   _date48387_
                   _month48388_
                   _year48389_
                   _offset48383_)))))))))
  (define std/srfi/19#time-tai->date
    (lambda (_time48371_ . _tz-offset48372_)
      (if (std/srfi/19#tm:tai-before-leap-second?
           (##structure-ref _time48371_ '3 std/srfi/19#time::t '#f))
          (let ((_d48374_
                 (std/srfi/19#tm:time->date
                  (std/srfi/19#subtract-duration!
                   (std/srfi/19#time-tai->time-utc _time48371_)
                   (let ()
                     (declare (not safe))
                     (##structure
                      std/srfi/19#time::t
                      std/srfi/19#time-duration
                      '0
                      '1)))
                  _tz-offset48372_
                  std/srfi/19#time-utc)))
            (##structure-set! _d48374_ '60 '2 std/srfi/19#date::t '#f)
            _d48374_)
          (std/srfi/19#tm:time->date
           (std/srfi/19#time-tai->time-utc _time48371_)
           _tz-offset48372_
           std/srfi/19#time-utc))))
  (define std/srfi/19#time-utc->date
    (lambda (_time48368_ . _tz-offset48369_)
      (std/srfi/19#tm:time->date
       _time48368_
       _tz-offset48369_
       std/srfi/19#time-utc)))
  (define std/srfi/19#time-monotonic->date
    (lambda (_time48365_ . _tz-offset48366_)
      (std/srfi/19#tm:time->date
       _time48365_
       _tz-offset48366_
       std/srfi/19#time-monotonic)))
  (define std/srfi/19#date->time-utc
    (lambda (_date48352_)
      (let ((_nanosecond48354_
             (##structure-ref _date48352_ '1 std/srfi/19#date::t '#f))
            (_second48355_
             (##structure-ref _date48352_ '2 std/srfi/19#date::t '#f))
            (_minute48356_
             (##structure-ref _date48352_ '3 std/srfi/19#date::t '#f))
            (_hour48357_
             (##structure-ref _date48352_ '4 std/srfi/19#date::t '#f))
            (_day48358_
             (##structure-ref _date48352_ '5 std/srfi/19#date::t '#f))
            (_month48359_
             (##structure-ref _date48352_ '6 std/srfi/19#date::t '#f))
            (_year48360_
             (##structure-ref _date48352_ '7 std/srfi/19#date::t '#f))
            (_offset48361_
             (##structure-ref _date48352_ '8 std/srfi/19#date::t '#f)))
        (let* ((_jdays48363_
                (- (std/srfi/19#tm:encode-julian-day-number
                    _day48358_
                    _month48359_
                    _year48360_)
                   std/srfi/19#tm:tai-epoch-in-jd))
               (__tmp283584
                (+ (* (- _jdays48363_ '1/2) '24 '60 '60)
                   (* _hour48357_ '60 '60)
                   (* _minute48356_ '60)
                   _second48355_
                   (- _offset48361_))))
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           std/srfi/19#time-utc
           _nanosecond48354_
           __tmp283584)))))
  (define std/srfi/19#date->time-tai
    (lambda (_d48350_)
      (if (= (##structure-ref _d48350_ '2 std/srfi/19#date::t '#f) '60)
          (std/srfi/19#subtract-duration!
           (std/srfi/19#time-utc->time-tai!
            (std/srfi/19#date->time-utc _d48350_))
           (let ()
             (declare (not safe))
             (##structure
              std/srfi/19#time::t
              std/srfi/19#time-duration
              '0
              '1)))
          (std/srfi/19#time-utc->time-tai!
           (std/srfi/19#date->time-utc _d48350_)))))
  (define std/srfi/19#date->time-monotonic
    (lambda (_date48348_)
      (std/srfi/19#time-utc->time-monotonic!
       (std/srfi/19#date->time-utc _date48348_))))
  (define std/srfi/19#tm:leap-year?
    (lambda (_year48343_)
      (let ((_$e48345_ (= (modulo _year48343_ '400) '0)))
        (if _$e48345_
            _$e48345_
            (if (= (modulo _year48343_ '4) '0)
                (not (= (modulo _year48343_ '100) '0))
                '#f)))))
  (define std/srfi/19#leap-year?
    (lambda (_date48341_)
      (std/srfi/19#tm:leap-year?
       (##structure-ref _date48341_ '7 std/srfi/19#date::t '#f))))
  (define std/srfi/19#tm:month-assoc
    '((0 . 0)
      (1 . 31)
      (2 . 59)
      (3 . 90)
      (4 . 120)
      (5 . 151)
      (6 . 181)
      (7 . 212)
      (8 . 243)
      (9 . 273)
      (10 . 304)
      (11 . 334)))
  (define std/srfi/19#tm:year-day
    (lambda (_day48335_ _month48336_ _year48337_)
      (let ((_days-pr48339_
             (assoc (- _month48336_ '1) std/srfi/19#tm:month-assoc)))
        (if (not _days-pr48339_)
            (std/srfi/19#tm:time-error
             'date-year-day
             'invalid-month-specification
             _month48336_)
            '#!void)
        (if (and (std/srfi/19#tm:leap-year? _year48337_) (> _month48336_ '2))
            (+ _day48335_ (cdr _days-pr48339_) '1)
            (+ _day48335_ (cdr _days-pr48339_))))))
  (define std/srfi/19#date-year-day
    (lambda (_date48333_)
      (std/srfi/19#tm:year-day
       (##structure-ref _date48333_ '5 std/srfi/19#date::t '#f)
       (##structure-ref _date48333_ '6 std/srfi/19#date::t '#f)
       (##structure-ref _date48333_ '7 std/srfi/19#date::t '#f))))
  (define std/srfi/19#tm:week-day
    (lambda (_day48322_ _month48323_ _year48324_)
      (let* ((_a48326_ (quotient (- '14 _month48323_) '12))
             (_y48328_ (- _year48324_ _a48326_))
             (_m48330_ (+ _month48323_ (* '12 _a48326_) '-2)))
        (modulo (+ _day48322_
                   _y48328_
                   (quotient _y48328_ '4)
                   (- (quotient _y48328_ '100))
                   (quotient _y48328_ '400)
                   (quotient (* '31 _m48330_) '12))
                '7))))
  (define std/srfi/19#date-week-day
    (lambda (_date48320_)
      (std/srfi/19#tm:week-day
       (##structure-ref _date48320_ '5 std/srfi/19#date::t '#f)
       (##structure-ref _date48320_ '6 std/srfi/19#date::t '#f)
       (##structure-ref _date48320_ '7 std/srfi/19#date::t '#f))))
  (define std/srfi/19#tm:days-before-first-week
    (lambda (_date48312_ _day-of-week-starting-week48313_)
      (let* ((_first-day48315_
              (let ((__tmp283585
                     (##structure-ref _date48312_ '7 std/srfi/19#date::t '#f)))
                (declare (not safe))
                (##structure
                 std/srfi/19#date::t
                 '0
                 '0
                 '0
                 '0
                 '1
                 '1
                 __tmp283585
                 '#f)))
             (_fdweek-day48317_ (std/srfi/19#date-week-day _first-day48315_)))
        (modulo (- _day-of-week-starting-week48313_ _fdweek-day48317_) '7))))
  (define std/srfi/19#date-week-number
    (lambda (_date48309_ _day-of-week-starting-week48310_)
      (quotient
       (- (std/srfi/19#date-year-day _date48309_)
          (std/srfi/19#tm:days-before-first-week
           _date48309_
           _day-of-week-starting-week48310_))
       '7)))
  (define std/srfi/19#current-date
    (lambda _tz-offset48304_
      (std/srfi/19#time-utc->date
       (std/srfi/19#current-time std/srfi/19#time-utc)
       (let ((_maybe-arg48306_ _tz-offset48304_))
         (if (null? _maybe-arg48306_)
             (std/srfi/19#tm:local-tz-offset)
             (if (null? (cdr _maybe-arg48306_))
                 (car _maybe-arg48306_)
                 (error '"too many optional arguments" _maybe-arg48306_)))))))
  (define std/srfi/19#tm:natural-year
    (lambda (_n48297_)
      (let* ((_current-year48299_
              (##structure-ref
               (std/srfi/19#current-date)
               '7
               std/srfi/19#date::t
               '#f))
             (_current-century48301_
              (* (quotient _current-year48299_ '100) '100)))
        (if (>= _n48297_ '100)
            _n48297_
            (if (< _n48297_ '0)
                _n48297_
                (if (<= (- (+ _current-century48301_ _n48297_)
                           _current-year48299_)
                        '50)
                    (+ _current-century48301_ _n48297_)
                    (+ (- _current-century48301_ '100) _n48297_)))))))
  (define std/srfi/19#date->julian-day
    (lambda (_date48286_)
      (let ((_nanosecond48288_
             (##structure-ref _date48286_ '1 std/srfi/19#date::t '#f))
            (_second48289_
             (##structure-ref _date48286_ '2 std/srfi/19#date::t '#f))
            (_minute48290_
             (##structure-ref _date48286_ '3 std/srfi/19#date::t '#f))
            (_hour48291_
             (##structure-ref _date48286_ '4 std/srfi/19#date::t '#f))
            (_day48292_
             (##structure-ref _date48286_ '5 std/srfi/19#date::t '#f))
            (_month48293_
             (##structure-ref _date48286_ '6 std/srfi/19#date::t '#f))
            (_year48294_
             (##structure-ref _date48286_ '7 std/srfi/19#date::t '#f))
            (_offset48295_
             (##structure-ref _date48286_ '8 std/srfi/19#date::t '#f)))
        (+ (std/srfi/19#tm:encode-julian-day-number
            _day48292_
            _month48293_
            _year48294_)
           (- '1/2)
           (+ (/ (/ (+ (* _hour48291_ '60 '60)
                       (* _minute48290_ '60)
                       _second48289_
                       (/ _nanosecond48288_ std/srfi/19#tm:nano))
                    std/srfi/19#tm:sid)
                 (- _offset48295_)))))))
  (define std/srfi/19#date->modified-julian-day
    (lambda (_date48284_)
      (- (std/srfi/19#date->julian-day _date48284_) '4800001/2)))
  (define std/srfi/19#time-utc->julian-day
    (lambda (_time48282_)
      (if (not (eq? (##structure-ref _time48282_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           'time-utc->julian-day
           'incompatible-time-types
           _time48282_)
          '#!void)
      (+ (/ (+ (##structure-ref _time48282_ '3 std/srfi/19#time::t '#f)
               (/ (##structure-ref _time48282_ '2 std/srfi/19#time::t '#f)
                  std/srfi/19#tm:nano))
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#time-utc->modified-julian-day
    (lambda (_time48280_)
      (- (std/srfi/19#time-utc->julian-day _time48280_) '4800001/2)))
  (define std/srfi/19#time-tai->julian-day
    (lambda (_time48278_)
      (if (not (eq? (##structure-ref _time48278_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           'time-tai->julian-day
           'incompatible-time-types
           _time48278_)
          '#!void)
      (+ (/ (+ (- (##structure-ref _time48278_ '3 std/srfi/19#time::t '#f)
                  (std/srfi/19#tm:leap-second-delta
                   (##structure-ref _time48278_ '3 std/srfi/19#time::t '#f)))
               (/ (##structure-ref _time48278_ '2 std/srfi/19#time::t '#f)
                  std/srfi/19#tm:nano))
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#time-tai->modified-julian-day
    (lambda (_time48276_)
      (- (std/srfi/19#time-tai->julian-day _time48276_) '4800001/2)))
  (define std/srfi/19#time-monotonic->julian-day
    (lambda (_time48274_)
      (if (not (eq? (##structure-ref _time48274_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->julian-day
           'incompatible-time-types
           _time48274_)
          '#!void)
      (+ (/ (+ (- (##structure-ref _time48274_ '3 std/srfi/19#time::t '#f)
                  (std/srfi/19#tm:leap-second-delta
                   (##structure-ref _time48274_ '3 std/srfi/19#time::t '#f)))
               (/ (##structure-ref _time48274_ '2 std/srfi/19#time::t '#f)
                  std/srfi/19#tm:nano))
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#time-monotonic->modified-julian-day
    (lambda (_time48272_)
      (- (std/srfi/19#time-monotonic->julian-day _time48272_) '4800001/2)))
  (define std/srfi/19#julian-day->time-utc
    (lambda (_jdn48268_)
      (let ((_nanosecs48270_
             (* std/srfi/19#tm:nano
                std/srfi/19#tm:sid
                (- _jdn48268_ std/srfi/19#tm:tai-epoch-in-jd))))
        (let ((__tmp283587 (remainder _nanosecs48270_ std/srfi/19#tm:nano))
              (__tmp283586 (floor (/ _nanosecs48270_ std/srfi/19#tm:nano))))
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           std/srfi/19#time-utc
           __tmp283587
           __tmp283586)))))
  (define std/srfi/19#julian-day->time-tai
    (lambda (_jdn48266_)
      (std/srfi/19#time-utc->time-tai!
       (std/srfi/19#julian-day->time-utc _jdn48266_))))
  (define std/srfi/19#julian-day->time-monotonic
    (lambda (_jdn48264_)
      (std/srfi/19#time-utc->time-monotonic!
       (std/srfi/19#julian-day->time-utc _jdn48264_))))
  (define std/srfi/19#julian-day->date
    (lambda (_jdn48256_ . _tz-offset48257_)
      (let ((_offset48262_
             (let ((_maybe-arg48259_ _tz-offset48257_))
               (if (null? _maybe-arg48259_)
                   (std/srfi/19#tm:local-tz-offset)
                   (if (null? (cdr _maybe-arg48259_))
                       (car _maybe-arg48259_)
                       (error '"too many optional arguments"
                              _maybe-arg48259_))))))
        (std/srfi/19#time-utc->date
         (std/srfi/19#julian-day->time-utc _jdn48256_)
         _offset48262_))))
  (define std/srfi/19#modified-julian-day->date
    (lambda (_jdn48248_ . _tz-offset48249_)
      (let ((_offset48254_
             (let ((_maybe-arg48251_ _tz-offset48249_))
               (if (null? _maybe-arg48251_)
                   (std/srfi/19#tm:local-tz-offset)
                   (if (null? (cdr _maybe-arg48251_))
                       (car _maybe-arg48251_)
                       (error '"too many optional arguments"
                              _maybe-arg48251_))))))
        (std/srfi/19#julian-day->date
         (+ _jdn48248_ '4800001/2)
         _offset48254_))))
  (define std/srfi/19#modified-julian-day->time-utc
    (lambda (_jdn48246_)
      (std/srfi/19#julian-day->time-utc (+ _jdn48246_ '4800001/2))))
  (define std/srfi/19#modified-julian-day->time-tai
    (lambda (_jdn48244_)
      (std/srfi/19#julian-day->time-tai (+ _jdn48244_ '4800001/2))))
  (define std/srfi/19#modified-julian-day->time-monotonic
    (lambda (_jdn48242_)
      (std/srfi/19#julian-day->time-monotonic (+ _jdn48242_ '4800001/2))))
  (define std/srfi/19#current-julian-day
    (lambda ()
      (std/srfi/19#time-utc->julian-day
       (std/srfi/19#current-time std/srfi/19#time-utc))))
  (define std/srfi/19#current-modified-julian-day
    (lambda ()
      (std/srfi/19#time-utc->modified-julian-day
       (std/srfi/19#current-time std/srfi/19#time-utc))))
  (define std/srfi/19#tm:padding
    (lambda (_n48218_ _pad-with48219_ _length48220_)
      (let* ((_str48222_ (number->string _n48218_))
             (_str-len48224_ (string-length _str48222_)))
        (if (or (> _str-len48224_ _length48220_) (not _pad-with48219_))
            _str48222_
            (let* ((_new-str48230_ (make-string _length48220_ _pad-with48219_))
                   (_new-str-offset48232_
                    (- (string-length _new-str48230_) _str-len48224_)))
              (let _$loop48235_ ((_i48238_ '0))
                (if (>= _i48238_ (string-length _str48222_))
                    '#!void
                    (begin
                      (string-set!
                       _new-str48230_
                       (+ _new-str-offset48232_ _i48238_)
                       (string-ref _str48222_ _i48238_))
                      (_$loop48235_ (+ _i48238_ '1)))))
              _new-str48230_)))))
  (define std/srfi/19#tm:last-n-digits
    (lambda (_i48215_ _n48216_)
      (abs (remainder _i48215_ (expt '10 _n48216_)))))
  (define std/srfi/19#tm:locale-abbr-weekday
    (lambda (_n48213_)
      (vector-ref std/srfi/19#tm:locale-abbr-weekday-vector _n48213_)))
  (define std/srfi/19#tm:locale-long-weekday
    (lambda (_n48211_)
      (vector-ref std/srfi/19#tm:locale-long-weekday-vector _n48211_)))
  (define std/srfi/19#tm:locale-abbr-month
    (lambda (_n48209_)
      (vector-ref std/srfi/19#tm:locale-abbr-month-vector _n48209_)))
  (define std/srfi/19#tm:locale-long-month
    (lambda (_n48207_)
      (vector-ref std/srfi/19#tm:locale-long-month-vector _n48207_)))
  (define std/srfi/19#tm:vector-find
    (lambda (_needle48197_ _haystack48198_ _comparator48199_)
      (let ((_len48201_ (vector-length _haystack48198_)))
        (letrec ((_tm:vector-find-int48203_
                  (lambda (_index48205_)
                    (if (>= _index48205_ _len48201_)
                        '#f
                        (if (_comparator48199_
                             _needle48197_
                             (vector-ref _haystack48198_ _index48205_))
                            _index48205_
                            (_tm:vector-find-int48203_
                             (+ _index48205_ '1)))))))
          (_tm:vector-find-int48203_ '0)))))
  (define std/srfi/19#tm:locale-abbr-weekday->index
    (lambda (_string48195_)
      (std/srfi/19#tm:vector-find
       _string48195_
       std/srfi/19#tm:locale-abbr-weekday-vector
       string=?)))
  (define std/srfi/19#tm:locale-long-weekday->index
    (lambda (_string48193_)
      (std/srfi/19#tm:vector-find
       _string48193_
       std/srfi/19#tm:locale-long-weekday-vector
       string=?)))
  (define std/srfi/19#tm:locale-abbr-month->index
    (lambda (_string48191_)
      (std/srfi/19#tm:vector-find
       _string48191_
       std/srfi/19#tm:locale-abbr-month-vector
       string=?)))
  (define std/srfi/19#tm:locale-long-month->index
    (lambda (_string48189_)
      (std/srfi/19#tm:vector-find
       _string48189_
       std/srfi/19#tm:locale-long-month-vector
       string=?)))
  (define std/srfi/19#tm:locale-print-time-zone
    (lambda (_date48186_ _port48187_) '#!void))
  (define std/srfi/19#tm:locale-am/pm
    (lambda (_hr48184_)
      (if (> _hr48184_ '11)
          std/srfi/19#tm:locale-pm
          std/srfi/19#tm:locale-am)))
  (define std/srfi/19#tm:tz-printer
    (lambda (_offset48178_ _port48179_)
      (if (= _offset48178_ '0)
          (display '"Z" _port48179_)
          (if (negative? _offset48178_)
              (display '"-" _port48179_)
              (display '"+" _port48179_)))
      (if (not (= _offset48178_ '0))
          (let ((_hours48181_ (abs (quotient _offset48178_ (* '60 '60))))
                (_minutes48182_
                 (abs (quotient (remainder _offset48178_ (* '60 '60)) '60))))
            (display (std/srfi/19#tm:padding _hours48181_ '#\0 '2) _port48179_)
            (display (std/srfi/19#tm:padding _minutes48182_ '#\0 '2)
                     _port48179_))
          '#!void)))
  (define std/srfi/19#tm:directives
    (list (cons '#\~
                (lambda (_date48005_ _pad-with48006_ _port48007_)
                  (display '#\~ _port48007_)))
          (cons '#\a
                (lambda (_date48009_ _pad-with48010_ _port48011_)
                  (display (std/srfi/19#tm:locale-abbr-weekday
                            (std/srfi/19#date-week-day _date48009_))
                           _port48011_)))
          (cons '#\A
                (lambda (_date48013_ _pad-with48014_ _port48015_)
                  (display (std/srfi/19#tm:locale-long-weekday
                            (std/srfi/19#date-week-day _date48013_))
                           _port48015_)))
          (cons '#\b
                (lambda (_date48017_ _pad-with48018_ _port48019_)
                  (display (std/srfi/19#tm:locale-abbr-month
                            (##structure-ref
                             _date48017_
                             '6
                             std/srfi/19#date::t
                             '#f))
                           _port48019_)))
          (cons '#\B
                (lambda (_date48021_ _pad-with48022_ _port48023_)
                  (display (std/srfi/19#tm:locale-long-month
                            (##structure-ref
                             _date48021_
                             '6
                             std/srfi/19#date::t
                             '#f))
                           _port48023_)))
          (cons '#\c
                (lambda (_date48025_ _pad-with48026_ _port48027_)
                  (display (std/srfi/19#date->string
                            _date48025_
                            std/srfi/19#tm:locale-date-time-format)
                           _port48027_)))
          (cons '#\d
                (lambda (_date48029_ _pad-with48030_ _port48031_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48029_
                             '5
                             std/srfi/19#date::t
                             '#f)
                            '#\0
                            '2)
                           _port48031_)))
          (cons '#\D
                (lambda (_date48033_ _pad-with48034_ _port48035_)
                  (display (std/srfi/19#date->string _date48033_ '"~m/~d/~y")
                           _port48035_)))
          (cons '#\e
                (lambda (_date48037_ _pad-with48038_ _port48039_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48037_
                             '5
                             std/srfi/19#date::t
                             '#f)
                            '#\space
                            '2)
                           _port48039_)))
          (cons '#\f
                (lambda (_date48041_ _pad-with48042_ _port48043_)
                  (if (> (##structure-ref
                          _date48041_
                          '1
                          std/srfi/19#date::t
                          '#f)
                         std/srfi/19#tm:nano)
                      (display (std/srfi/19#tm:padding
                                (+ (##structure-ref
                                    _date48041_
                                    '2
                                    std/srfi/19#date::t
                                    '#f)
                                   '1)
                                _pad-with48042_
                                '2)
                               _port48043_)
                      (display (std/srfi/19#tm:padding
                                (##structure-ref
                                 _date48041_
                                 '2
                                 std/srfi/19#date::t
                                 '#f)
                                _pad-with48042_
                                '2)
                               _port48043_))
                  (let* ((_ns48045_
                          (std/srfi/19#tm:fractional-part
                           (/ (##structure-ref
                               _date48041_
                               '1
                               std/srfi/19#date::t
                               '#f)
                              std/srfi/19#tm:nano
                              '1.)))
                         (_le48047_ (string-length _ns48045_)))
                    (if (> _le48047_ '2)
                        (begin
                          (display std/srfi/19#tm:locale-number-separator
                                   _port48043_)
                          (display (substring _ns48045_ '2 _le48047_)
                                   _port48043_))
                        '#!void))))
          (cons '#\h
                (lambda (_date48050_ _pad-with48051_ _port48052_)
                  (display (std/srfi/19#date->string _date48050_ '"~b")
                           _port48052_)))
          (cons '#\H
                (lambda (_date48054_ _pad-with48055_ _port48056_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48054_
                             '4
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48055_
                            '2)
                           _port48056_)))
          (cons '#\I
                (lambda (_date48058_ _pad-with48059_ _port48060_)
                  (let ((_hr48062_
                         (##structure-ref
                          _date48058_
                          '4
                          std/srfi/19#date::t
                          '#f)))
                    (if (> _hr48062_ '12)
                        (display (std/srfi/19#tm:padding
                                  (- _hr48062_ '12)
                                  _pad-with48059_
                                  '2)
                                 _port48060_)
                        (display (std/srfi/19#tm:padding
                                  _hr48062_
                                  _pad-with48059_
                                  '2)
                                 _port48060_)))))
          (cons '#\j
                (lambda (_date48064_ _pad-with48065_ _port48066_)
                  (display (std/srfi/19#tm:padding
                            (std/srfi/19#date-year-day _date48064_)
                            _pad-with48065_
                            '3)
                           _port48066_)))
          (cons '#\k
                (lambda (_date48068_ _pad-with48069_ _port48070_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48068_
                             '4
                             std/srfi/19#date::t
                             '#f)
                            '#\0
                            '2)
                           _port48070_)))
          (cons '#\l
                (lambda (_date48072_ _pad-with48073_ _port48074_)
                  (let ((_hr48076_
                         (if (> (##structure-ref
                                 _date48072_
                                 '4
                                 std/srfi/19#date::t
                                 '#f)
                                '12)
                             (- (##structure-ref
                                 _date48072_
                                 '4
                                 std/srfi/19#date::t
                                 '#f)
                                '12)
                             (##structure-ref
                              _date48072_
                              '4
                              std/srfi/19#date::t
                              '#f))))
                    (display (std/srfi/19#tm:padding _hr48076_ '#\space '2)
                             _port48074_))))
          (cons '#\m
                (lambda (_date48078_ _pad-with48079_ _port48080_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48078_
                             '6
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48079_
                            '2)
                           _port48080_)))
          (cons '#\M
                (lambda (_date48082_ _pad-with48083_ _port48084_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48082_
                             '3
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48083_
                            '2)
                           _port48084_)))
          (cons '#\n
                (lambda (_date48086_ _pad-with48087_ _port48088_)
                  (newline _port48088_)))
          (cons '#\N
                (lambda (_date48090_ _pad-with48091_ _port48092_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48090_
                             '1
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48091_
                            '9)
                           _port48092_)))
          (cons '#\p
                (lambda (_date48094_ _pad-with48095_ _port48096_)
                  (display (std/srfi/19#tm:locale-am/pm
                            (##structure-ref
                             _date48094_
                             '4
                             std/srfi/19#date::t
                             '#f))
                           _port48096_)))
          (cons '#\r
                (lambda (_date48098_ _pad-with48099_ _port48100_)
                  (display (std/srfi/19#date->string
                            _date48098_
                            '"~I:~M:~S ~p")
                           _port48100_)))
          (cons '#\s
                (lambda (_date48102_ _pad-with48103_ _port48104_)
                  (display (##structure-ref
                            (std/srfi/19#date->time-utc _date48102_)
                            '3
                            std/srfi/19#time::t
                            '#f)
                           _port48104_)))
          (cons '#\S
                (lambda (_date48106_ _pad-with48107_ _port48108_)
                  (if (> (##structure-ref
                          _date48106_
                          '1
                          std/srfi/19#date::t
                          '#f)
                         std/srfi/19#tm:nano)
                      (display (std/srfi/19#tm:padding
                                (+ (##structure-ref
                                    _date48106_
                                    '2
                                    std/srfi/19#date::t
                                    '#f)
                                   '1)
                                _pad-with48107_
                                '2)
                               _port48108_)
                      (display (std/srfi/19#tm:padding
                                (##structure-ref
                                 _date48106_
                                 '2
                                 std/srfi/19#date::t
                                 '#f)
                                _pad-with48107_
                                '2)
                               _port48108_))))
          (cons '#\t
                (lambda (_date48110_ _pad-with48111_ _port48112_)
                  (display (integer->char '9) _port48112_)))
          (cons '#\T
                (lambda (_date48114_ _pad-with48115_ _port48116_)
                  (display (std/srfi/19#date->string _date48114_ '"~H:~M:~S")
                           _port48116_)))
          (cons '#\U
                (lambda (_date48118_ _pad-with48119_ _port48120_)
                  (if (> (std/srfi/19#tm:days-before-first-week _date48118_ '0)
                         '0)
                      (display (std/srfi/19#tm:padding
                                (+ (std/srfi/19#date-week-number
                                    _date48118_
                                    '0)
                                   '1)
                                '#\0
                                '2)
                               _port48120_)
                      (display (std/srfi/19#tm:padding
                                (std/srfi/19#date-week-number _date48118_ '0)
                                '#\0
                                '2)
                               _port48120_))))
          (cons '#\V
                (lambda (_date48122_ _pad-with48123_ _port48124_)
                  (display (std/srfi/19#tm:padding
                            (std/srfi/19#date-week-number _date48122_ '1)
                            '#\0
                            '2)
                           _port48124_)))
          (cons '#\w
                (lambda (_date48126_ _pad-with48127_ _port48128_)
                  (display (std/srfi/19#date-week-day _date48126_)
                           _port48128_)))
          (cons '#\x
                (lambda (_date48130_ _pad-with48131_ _port48132_)
                  (display (std/srfi/19#date->string
                            _date48130_
                            std/srfi/19#tm:locale-short-date-format)
                           _port48132_)))
          (cons '#\X
                (lambda (_date48134_ _pad-with48135_ _port48136_)
                  (display (std/srfi/19#date->string
                            _date48134_
                            std/srfi/19#tm:locale-time-format)
                           _port48136_)))
          (cons '#\W
                (lambda (_date48138_ _pad-with48139_ _port48140_)
                  (if (> (std/srfi/19#tm:days-before-first-week _date48138_ '1)
                         '0)
                      (display (std/srfi/19#tm:padding
                                (+ (std/srfi/19#date-week-number
                                    _date48138_
                                    '1)
                                   '1)
                                '#\0
                                '2)
                               _port48140_)
                      (display (std/srfi/19#tm:padding
                                (std/srfi/19#date-week-number _date48138_ '1)
                                '#\0
                                '2)
                               _port48140_))))
          (cons '#\y
                (lambda (_date48142_ _pad-with48143_ _port48144_)
                  (display (std/srfi/19#tm:padding
                            (std/srfi/19#tm:last-n-digits
                             (##structure-ref
                              _date48142_
                              '7
                              std/srfi/19#date::t
                              '#f)
                             '2)
                            _pad-with48143_
                            '2)
                           _port48144_)))
          (cons '#\Y
                (lambda (_date48146_ _pad-with48147_ _port48148_)
                  (display (##structure-ref
                            _date48146_
                            '7
                            std/srfi/19#date::t
                            '#f)
                           _port48148_)))
          (cons '#\z
                (lambda (_date48150_ _pad-with48151_ _port48152_)
                  (std/srfi/19#tm:tz-printer
                   (##structure-ref _date48150_ '8 std/srfi/19#date::t '#f)
                   _port48152_)))
          (cons '#\Z
                (lambda (_date48154_ _pad-with48155_ _port48156_)
                  (std/srfi/19#tm:locale-print-time-zone
                   _date48154_
                   _port48156_)))
          (cons '#\1
                (lambda (_date48158_ _pad-with48159_ _port48160_)
                  (display (std/srfi/19#date->string _date48158_ '"~Y-~m-~d")
                           _port48160_)))
          (cons '#\2
                (lambda (_date48162_ _pad-with48163_ _port48164_)
                  (display (std/srfi/19#date->string _date48162_ '"~k:~M:~S~z")
                           _port48164_)))
          (cons '#\3
                (lambda (_date48166_ _pad-with48167_ _port48168_)
                  (display (std/srfi/19#date->string _date48166_ '"~k:~M:~S")
                           _port48168_)))
          (cons '#\4
                (lambda (_date48170_ _pad-with48171_ _port48172_)
                  (display (std/srfi/19#date->string
                            _date48170_
                            '"~Y-~m-~dT~k:~M:~S~z")
                           _port48172_)))
          (cons '#\5
                (lambda (_date48174_ _pad-with48175_ _port48176_)
                  (display (std/srfi/19#date->string
                            _date48174_
                            '"~Y-~m-~dT~k:~M:~S")
                           _port48176_)))))
  (define std/srfi/19#tm:get-formatter
    (lambda (_char48001_)
      (let ((_associated48003_ (assoc _char48001_ std/srfi/19#tm:directives)))
        (if _associated48003_ (cdr _associated48003_) '#f))))
  (define std/srfi/19#tm:date-printer
    (lambda (_date47985_
             _index47986_
             _format-string47987_
             _str-len47988_
             _port47989_)
      (if (>= _index47986_ _str-len47988_)
          '#!void
          (let ((_current-char47991_
                 (string-ref _format-string47987_ _index47986_)))
            (if (not (char=? _current-char47991_ '#\~))
                (begin
                  (display _current-char47991_ _port47989_)
                  (std/srfi/19#tm:date-printer
                   _date47985_
                   (+ _index47986_ '1)
                   _format-string47987_
                   _str-len47988_
                   _port47989_))
                (if (= (+ _index47986_ '1) _str-len47988_)
                    (std/srfi/19#tm:time-error
                     'tm:date-printer
                     'bad-date-format-string
                     _format-string47987_)
                    (let ((_pad-char?47993_
                           (string-ref
                            _format-string47987_
                            (+ _index47986_ '1))))
                      (if (char=? _pad-char?47993_ '#\-)
                          (if (= (+ _index47986_ '2) _str-len47988_)
                              (std/srfi/19#tm:time-error
                               'tm:date-printer
                               'bad-date-format-string
                               _format-string47987_)
                              (let ((_formatter47995_
                                     (std/srfi/19#tm:get-formatter
                                      (string-ref
                                       _format-string47987_
                                       (+ _index47986_ '2)))))
                                (if (not _formatter47995_)
                                    (std/srfi/19#tm:time-error
                                     'tm:date-printer
                                     'bad-date-format-string
                                     _format-string47987_)
                                    (begin
                                      (_formatter47995_
                                       _date47985_
                                       '#f
                                       _port47989_)
                                      (std/srfi/19#tm:date-printer
                                       _date47985_
                                       (+ _index47986_ '3)
                                       _format-string47987_
                                       _str-len47988_
                                       _port47989_)))))
                          (if (char=? _pad-char?47993_ '#\_)
                              (if (= (+ _index47986_ '2) _str-len47988_)
                                  (std/srfi/19#tm:time-error
                                   'tm:date-printer
                                   'bad-date-format-string
                                   _format-string47987_)
                                  (let ((_formatter47997_
                                         (std/srfi/19#tm:get-formatter
                                          (string-ref
                                           _format-string47987_
                                           (+ _index47986_ '2)))))
                                    (if (not _formatter47997_)
                                        (std/srfi/19#tm:time-error
                                         'tm:date-printer
                                         'bad-date-format-string
                                         _format-string47987_)
                                        (begin
                                          (_formatter47997_
                                           _date47985_
                                           '#\space
                                           _port47989_)
                                          (std/srfi/19#tm:date-printer
                                           _date47985_
                                           (+ _index47986_ '3)
                                           _format-string47987_
                                           _str-len47988_
                                           _port47989_)))))
                              (let ((_formatter47999_
                                     (std/srfi/19#tm:get-formatter
                                      (string-ref
                                       _format-string47987_
                                       (+ _index47986_ '1)))))
                                (if (not _formatter47999_)
                                    (std/srfi/19#tm:time-error
                                     'tm:date-printer
                                     'bad-date-format-string
                                     _format-string47987_)
                                    (begin
                                      (_formatter47999_
                                       _date47985_
                                       '#\0
                                       _port47989_)
                                      (std/srfi/19#tm:date-printer
                                       _date47985_
                                       (+ _index47986_ '2)
                                       _format-string47987_
                                       _str-len47988_
                                       _port47989_)))))))))))))
  (define std/srfi/19#date->string
    (lambda (_date47976_ . _format-string47977_)
      (let ((_str-port47982_ (open-output-string))
            (_fmt-str47983_
             (let ((_maybe-arg47979_ _format-string47977_))
               (if (null? _maybe-arg47979_)
                   '"~c"
                   (if (null? (cdr _maybe-arg47979_))
                       (car _maybe-arg47979_)
                       (error '"too many optional arguments"
                              _maybe-arg47979_))))))
        (std/srfi/19#tm:date-printer
         _date47976_
         '0
         _fmt-str47983_
         (string-length _fmt-str47983_)
         _str-port47982_)
        (get-output-string _str-port47982_))))
  (define std/srfi/19#tm:char->int
    (lambda (_ch47974_)
      (if (char=? _ch47974_ '#\0)
          '0
          (if (char=? _ch47974_ '#\1)
              '1
              (if (char=? _ch47974_ '#\2)
                  '2
                  (if (char=? _ch47974_ '#\3)
                      '3
                      (if (char=? _ch47974_ '#\4)
                          '4
                          (if (char=? _ch47974_ '#\5)
                              '5
                              (if (char=? _ch47974_ '#\6)
                                  '6
                                  (if (char=? _ch47974_ '#\7)
                                      '7
                                      (if (char=? _ch47974_ '#\8)
                                          '8
                                          (if (char=? _ch47974_ '#\9)
                                              '9
                                              (std/srfi/19#tm:time-error
                                               'string->date
                                               'bad-date-template-string
                                               (list '"Non-integer character"
                                                     _ch47974_))))))))))))))
  (define std/srfi/19#tm:integer-reader
    (lambda (_upto47957_ _port47958_)
      (letrec ((_accum-int47960_
                (lambda (_port47962_ _accum47963_ _nchars47964_)
                  (let ((_ch47966_ (peek-char _port47962_)))
                    (if (or (eof-object? _ch47966_)
                            (not (char-numeric? _ch47966_))
                            (and _upto47957_ (>= _nchars47964_ _upto47957_)))
                        _accum47963_
                        (_accum-int47960_
                         _port47962_
                         (+ (* _accum47963_ '10)
                            (std/srfi/19#tm:char->int (read-char _port47962_)))
                         (+ _nchars47964_ '1)))))))
        (_accum-int47960_ _port47958_ '0 '0))))
  (define std/srfi/19#tm:make-integer-reader
    (lambda (_upto47953_)
      (lambda (_port47955_)
        (std/srfi/19#tm:integer-reader _upto47953_ _port47955_))))
  (define std/srfi/19#tm:fractional-integer-reader
    (lambda (_upto47936_ _port47937_)
      (letrec ((_accum-int47939_
                (lambda (_port47941_ _accum47942_ _nchars47943_)
                  (let ((_ch47945_ (peek-char _port47941_)))
                    (if (or (eof-object? _ch47945_)
                            (not (char-numeric? _ch47945_))
                            (and _upto47936_ (>= _nchars47943_ _upto47936_)))
                        (* _accum47942_
                           (expt '10 (- _upto47936_ _nchars47943_)))
                        (_accum-int47939_
                         _port47941_
                         (+ (* _accum47942_ '10)
                            (std/srfi/19#tm:char->int (read-char _port47941_)))
                         (+ _nchars47943_ '1)))))))
        (_accum-int47939_ _port47937_ '0 '0))))
  (define std/srfi/19#tm:make-fractional-integer-reader
    (lambda (_upto47932_)
      (lambda (_port47934_)
        (std/srfi/19#tm:fractional-integer-reader _upto47932_ _port47934_))))
  (define std/srfi/19#tm:integer-reader-exact
    (lambda (_n47919_ _port47920_)
      (let ((_padding-ok47922_ '#t))
        (letrec ((_accum-int47924_
                  (lambda (_port47926_ _accum47927_ _nchars47928_)
                    (let ((_ch47930_ (peek-char _port47926_)))
                      (if (>= _nchars47928_ _n47919_)
                          _accum47927_
                          (if (eof-object? _ch47930_)
                              (std/srfi/19#tm:time-error
                               'string->date
                               'bad-date-template-string
                               '"Premature ending to integer read.")
                              (if (char-numeric? _ch47930_)
                                  (begin
                                    (set! _padding-ok47922_ '#f)
                                    (_accum-int47924_
                                     _port47926_
                                     (+ (* _accum47927_ '10)
                                        (std/srfi/19#tm:char->int
                                         (read-char _port47926_)))
                                     (+ _nchars47928_ '1)))
                                  (if _padding-ok47922_
                                      (begin
                                        (read-char _port47926_)
                                        (_accum-int47924_
                                         _port47926_
                                         _accum47927_
                                         (+ _nchars47928_ '1)))
                                      (std/srfi/19#tm:time-error
                                       'string->date
                                       'bad-date-template-string
                                       '"Non-numeric characters in integer read.")))))))))
          (_accum-int47924_ _port47920_ '0 '0)))))
  (define std/srfi/19#tm:make-integer-exact-reader
    (lambda (_n47915_)
      (lambda (_port47917_)
        (std/srfi/19#tm:integer-reader-exact _n47915_ _port47917_))))
  (define std/srfi/19#tm:zone-reader
    (lambda (_port47897_)
      (let ((_offset47899_ '0) (_positive?47900_ '#f))
        (let ((_ch47902_ (read-char _port47897_)))
          (if (eof-object? _ch47902_)
              (std/srfi/19#tm:time-error
               'string->date
               'bad-date-template-string
               (list '"Invalid time zone +/-" _ch47902_))
              '#!void)
          (if (or (char=? _ch47902_ '#\Z) (char=? _ch47902_ '#\z))
              '0
              (begin
                (if (char=? _ch47902_ '#\+)
                    (set! _positive?47900_ '#t)
                    (if (char=? _ch47902_ '#\-)
                        (set! _positive?47900_ '#f)
                        (std/srfi/19#tm:time-error
                         'string->date
                         'bad-date-template-string
                         (list '"Invalid time zone +/-" _ch47902_))))
                (let ((_ch47907_ (read-char _port47897_)))
                  (if (eof-object? _ch47907_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47907_))
                      '#!void)
                  (set! _offset47899_
                        (* (std/srfi/19#tm:char->int _ch47907_) '10 '60 '60)))
                (let ((_ch47909_ (read-char _port47897_)))
                  (if (eof-object? _ch47909_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47909_))
                      '#!void)
                  (set! _offset47899_
                        (+ _offset47899_
                           (* (std/srfi/19#tm:char->int _ch47909_) '60 '60))))
                (let ((_ch47911_ (read-char _port47897_)))
                  (if (eof-object? _ch47911_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47911_))
                      '#!void)
                  (set! _offset47899_
                        (+ _offset47899_
                           (* (std/srfi/19#tm:char->int _ch47911_) '10 '60))))
                (let ((_ch47913_ (read-char _port47897_)))
                  (if (eof-object? _ch47913_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47913_))
                      '#!void)
                  (set! _offset47899_
                        (+ _offset47899_
                           (* (std/srfi/19#tm:char->int _ch47913_) '60))))
                (if _positive?47900_ _offset47899_ (- _offset47899_))))))))
  (define std/srfi/19#tm:locale-reader
    (lambda (_port47882_ _indexer47883_)
      (let ((_string-port47885_ (open-output-string)))
        (letrec ((_read-char-string47887_
                  (lambda ()
                    (let ((_ch47895_ (peek-char _port47882_)))
                      (if (char-alphabetic? _ch47895_)
                          (begin
                            (write-char
                             (read-char _port47882_)
                             _string-port47885_)
                            (_read-char-string47887_))
                          (get-output-string _string-port47885_))))))
          (let* ((_str47889_ (_read-char-string47887_))
                 (_index47891_ (_indexer47883_ _str47889_)))
            (if _index47891_
                _index47891_
                (std/srfi/19#tm:time-error
                 'string->date
                 'bad-date-template-string
                 (list '"Invalid string for " _indexer47883_))))))))
  (define std/srfi/19#tm:make-locale-reader
    (lambda (_indexer47878_)
      (lambda (_port47880_)
        (std/srfi/19#tm:locale-reader _port47880_ _indexer47878_))))
  (define std/srfi/19#tm:make-char-id-reader
    (lambda (_char47874_)
      (lambda (_port47876_)
        (if (char=? _char47874_ (read-char _port47876_))
            _char47874_
            (std/srfi/19#tm:time-error
             'string->date
             'bad-date-template-string
             '"Invalid character match.")))))
  (define std/srfi/19#tm:read-directives
    (let ((_ireader447808_ (std/srfi/19#tm:make-integer-reader '4))
          (_ireader247809_ (std/srfi/19#tm:make-integer-reader '2))
          (_fireader947810_ (std/srfi/19#tm:make-fractional-integer-reader '9))
          (_ireaderf47811_ (std/srfi/19#tm:make-integer-reader '#f))
          (_eireader247812_ (std/srfi/19#tm:make-integer-exact-reader '2))
          (_eireader447813_ (std/srfi/19#tm:make-integer-exact-reader '4))
          (_locale-reader-abbr-weekday47814_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-abbr-weekday->index))
          (_locale-reader-long-weekday47815_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-long-weekday->index))
          (_locale-reader-abbr-month47816_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-abbr-month->index))
          (_locale-reader-long-month47817_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-long-month->index))
          (_char-fail47818_ (lambda (_ch47803_) '#t))
          (_do-nothing47819_ (lambda (_val47805_ _object47806_) '#!void)))
      (list (list '#\~
                  _char-fail47818_
                  (std/srfi/19#tm:make-char-id-reader '#\~)
                  _do-nothing47819_)
            (list '#\a
                  char-alphabetic?
                  _locale-reader-abbr-weekday47814_
                  _do-nothing47819_)
            (list '#\A
                  char-alphabetic?
                  _locale-reader-long-weekday47815_
                  _do-nothing47819_)
            (list '#\b
                  char-alphabetic?
                  _locale-reader-abbr-month47816_
                  (lambda (_val47821_ _object47822_)
                    (##structure-set!
                     _object47822_
                     _val47821_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\B
                  char-alphabetic?
                  _locale-reader-long-month47817_
                  (lambda (_val47824_ _object47825_)
                    (##structure-set!
                     _object47825_
                     _val47824_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\d
                  char-numeric?
                  _ireader247809_
                  (lambda (_val47827_ _object47828_)
                    (##structure-set!
                     _object47828_
                     _val47827_
                     '5
                     std/srfi/19#date::t
                     '#f)))
            (list '#\e
                  _char-fail47818_
                  _eireader247812_
                  (lambda (_val47830_ _object47831_)
                    (##structure-set!
                     _object47831_
                     _val47830_
                     '5
                     std/srfi/19#date::t
                     '#f)))
            (list '#\h
                  char-alphabetic?
                  _locale-reader-abbr-month47816_
                  (lambda (_val47833_ _object47834_)
                    (##structure-set!
                     _object47834_
                     _val47833_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\H
                  char-numeric?
                  _ireader247809_
                  (lambda (_val47836_ _object47837_)
                    (##structure-set!
                     _object47837_
                     _val47836_
                     '4
                     std/srfi/19#date::t
                     '#f)))
            (list '#\k
                  _char-fail47818_
                  _eireader247812_
                  (lambda (_val47839_ _object47840_)
                    (##structure-set!
                     _object47840_
                     _val47839_
                     '4
                     std/srfi/19#date::t
                     '#f)))
            (list '#\m
                  char-numeric?
                  _ireader247809_
                  (lambda (_val47842_ _object47843_)
                    (##structure-set!
                     _object47843_
                     _val47842_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\M
                  char-numeric?
                  _ireader247809_
                  (lambda (_val47845_ _object47846_)
                    (##structure-set!
                     _object47846_
                     _val47845_
                     '3
                     std/srfi/19#date::t
                     '#f)))
            (list '#\N
                  char-numeric?
                  _fireader947810_
                  (lambda (_val47848_ _object47849_)
                    (##structure-set!
                     _object47849_
                     _val47848_
                     '1
                     std/srfi/19#date::t
                     '#f)))
            (list '#\S
                  char-numeric?
                  _ireader247809_
                  (lambda (_val47851_ _object47852_)
                    (##structure-set!
                     _object47852_
                     _val47851_
                     '2
                     std/srfi/19#date::t
                     '#f)))
            (list '#\y
                  _char-fail47818_
                  _eireader247812_
                  (lambda (_val47854_ _object47855_)
                    (##structure-set!
                     _object47855_
                     (std/srfi/19#tm:natural-year _val47854_)
                     '7
                     std/srfi/19#date::t
                     '#f)))
            (list '#\Y
                  char-numeric?
                  _ireader447808_
                  (lambda (_val47857_ _object47858_)
                    (##structure-set!
                     _object47858_
                     _val47857_
                     '7
                     std/srfi/19#date::t
                     '#f)))
            (list '#\z
                  (lambda (_c47860_)
                    (let ((_$e47862_ (char=? _c47860_ '#\Z)))
                      (if _$e47862_
                          _$e47862_
                          (let ((_$e47865_ (char=? _c47860_ '#\z)))
                            (if _$e47865_
                                _$e47865_
                                (let ((_$e47868_ (char=? _c47860_ '#\+)))
                                  (if _$e47868_
                                      _$e47868_
                                      (char=? _c47860_ '#\-))))))))
                  std/srfi/19#tm:zone-reader
                  (lambda (_val47871_ _object47872_)
                    (##structure-set!
                     _object47872_
                     _val47871_
                     '8
                     std/srfi/19#date::t
                     '#f))))))
  (define std/srfi/19#tm:string->date
    (lambda (_date47771_
             _index47772_
             _format-string47773_
             _str-len47774_
             _port47775_
             _template-string47776_)
      (letrec ((_skip-until47778_
                (lambda (_port47798_ _skipper47799_)
                  (let ((_ch47801_ (peek-char _port47798_)))
                    (if (eof-object? _ch47801_)
                        (std/srfi/19#tm:time-error
                         'string->date
                         'bad-date-format-string
                         _template-string47776_)
                        (if (not (_skipper47799_ _ch47801_))
                            (begin
                              (read-char _port47798_)
                              (_skip-until47778_ _port47798_ _skipper47799_))
                            '#!void))))))
        (if (>= _index47772_ _str-len47774_)
            '#!void
            (let ((_current-char47780_
                   (string-ref _format-string47773_ _index47772_)))
              (if (not (char=? _current-char47780_ '#\~))
                  (let ((_port-char47782_ (read-char _port47775_)))
                    (if (or (eof-object? _port-char47782_)
                            (not (char=? _current-char47780_
                                         _port-char47782_)))
                        (std/srfi/19#tm:time-error
                         'string->date
                         'bad-date-format-string
                         _template-string47776_)
                        '#!void)
                    (std/srfi/19#tm:string->date
                     _date47771_
                     (+ _index47772_ '1)
                     _format-string47773_
                     _str-len47774_
                     _port47775_
                     _template-string47776_))
                  (if (> (+ _index47772_ '1) _str-len47774_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-format-string
                       _template-string47776_)
                      (let* ((_format-char47787_
                              (string-ref
                               _format-string47773_
                               (+ _index47772_ '1)))
                             (_format-info47789_
                              (assoc _format-char47787_
                                     std/srfi/19#tm:read-directives)))
                        (if (not _format-info47789_)
                            (std/srfi/19#tm:time-error
                             'string->date
                             'bad-date-format-string
                             _template-string47776_)
                            (let ((_skipper47792_ (cadr _format-info47789_))
                                  (_reader47793_ (caddr _format-info47789_))
                                  (_actor47794_ (cadddr _format-info47789_)))
                              (_skip-until47778_ _port47775_ _skipper47792_)
                              (let ((_val47796_ (_reader47793_ _port47775_)))
                                (if (eof-object? _val47796_)
                                    (std/srfi/19#tm:time-error
                                     'string->date
                                     'bad-date-format-string
                                     _template-string47776_)
                                    (_actor47794_ _val47796_ _date47771_)))
                              (std/srfi/19#tm:string->date
                               _date47771_
                               (+ _index47772_ '2)
                               _format-string47773_
                               _str-len47774_
                               _port47775_
                               _template-string47776_)))))))))))
  (define std/srfi/19#string->date
    (lambda (_input-string47762_ _template-string47763_)
      (letrec ((_tm:date-ok?47765_
                (lambda (_date47769_)
                  (if (##structure-ref _date47769_ '1 std/srfi/19#date::t '#f)
                      (if (##structure-ref
                           _date47769_
                           '2
                           std/srfi/19#date::t
                           '#f)
                          (if (##structure-ref
                               _date47769_
                               '3
                               std/srfi/19#date::t
                               '#f)
                              (if (##structure-ref
                                   _date47769_
                                   '4
                                   std/srfi/19#date::t
                                   '#f)
                                  (if (##structure-ref
                                       _date47769_
                                       '5
                                       std/srfi/19#date::t
                                       '#f)
                                      (if (##structure-ref
                                           _date47769_
                                           '6
                                           std/srfi/19#date::t
                                           '#f)
                                          (if (##structure-ref
                                               _date47769_
                                               '7
                                               std/srfi/19#date::t
                                               '#f)
                                              (##structure-ref
                                               _date47769_
                                               '8
                                               std/srfi/19#date::t
                                               '#f)
                                              '#f)
                                          '#f)
                                      '#f)
                                  '#f)
                              '#f)
                          '#f)
                      '#f))))
        (let ((_newdate47767_
               (let ()
                 (declare (not safe))
                 (##structure
                  std/srfi/19#date::t
                  '0
                  '0
                  '0
                  '0
                  '#f
                  '#f
                  '#f
                  '0))))
          (std/srfi/19#tm:string->date
           _newdate47767_
           '0
           _template-string47763_
           (string-length _template-string47763_)
           (open-input-string _input-string47762_)
           _template-string47763_)
          (if (_tm:date-ok?47765_ _newdate47767_)
              _newdate47767_
              (std/srfi/19#tm:time-error
               'string->date
               'bad-date-format-string
               (list '"Incomplete date read. "
                     _newdate47767_
                     _template-string47763_))))))))
