(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/yaml#yaml-key-format (make-parameter values))
  (define std/text/yaml#yaml-load
    (lambda (_fname170473_)
      (let ((_$e170475_
             (std/text/libyaml#open_yaml_input_file
              (path-normalize _fname170473_))))
        (if _$e170475_
            ((lambda (_file170478_)
               (with-unwind-protect
                (lambda () (std/text/yaml#yaml-parse-file _file170478_))
                (lambda () (std/text/libyaml#close_yaml_file _file170478_))))
             _$e170475_)
            (error '"Cannot open yaml input file" _fname170473_)))))
  (define std/text/yaml#yaml-load-string
    (lambda (_str170464_)
      (let ((_$e170466_ (std/text/libyaml#yaml_strdup _str170464_)))
        (if _$e170466_
            ((lambda (_xstr170469_)
               (with-unwind-protect
                (lambda () (std/text/yaml#yaml-parse-string _xstr170469_))
                (lambda () (std/text/libyaml#yaml_strfree _xstr170469_))))
             _$e170466_)
            (error '"Failed to allocate memory for string" _str170464_)))))
  (define std/text/yaml#yaml-parse-file
    (lambda (_file170462_)
      (std/text/yaml#yaml-parse-input
       _file170462_
       std/text/libyaml#yaml_parser_set_input_file)))
  (define std/text/yaml#yaml-parse-string
    (lambda (_str170460_)
      (std/text/yaml#yaml-parse-input
       _str170460_
       std/text/libyaml#yaml_parser_set_input_string)))
  (define std/text/yaml#yaml-parse-input
    (lambda (_file170448_ _parser-set-input!170449_)
      (let* ((_parser170451_ (std/text/libyaml#make_yaml_parser))
             (_g300821_
              (std/text/libyaml#yaml_parser_initialize _parser170451_))
             (_g300822_
              (_parser-set-input!170449_ _parser170451_ _file170448_))
             (_event170455_ (std/text/libyaml#make_yaml_event)))
        (with-unwind-protect
         (lambda () (std/text/yaml#yaml-parse _parser170451_ _event170455_))
         (lambda () (std/text/libyaml#yaml_parser_delete _parser170451_))))))
  (define std/text/yaml#yaml-parse
    (lambda (_parser169996_ _event169997_)
      (letrec* ((_anchors169999_ (make-table))
                (_parse170000_
                 (lambda ()
                   (let ((_r170446_
                          (std/text/libyaml#yaml_parser_parse
                           _parser169996_
                           _event169997_)))
                     (if (zero? _r170446_)
                         (std/error#raise-io-error
                          'yaml-load
                          '"LibYAML parse error"
                          (std/text/libyaml#yaml_parser_error _parser169996_))
                         '#!void))))
                (_stream-start170001_
                 (lambda ()
                   (let* ((_g300823_ (_parse170000_))
                          (_t170442_
                           (std/text/libyaml#yaml_event_type _event169997_)))
                     (if (eq? _t170442_
                              std/text/libyaml#YAML_STREAM_START_EVENT)
                         (begin
                           (std/text/libyaml#yaml_event_delete _event169997_)
                           (_read-stream170002_))
                         (if (eq? _t170442_ std/text/libyaml#YAML_NO_EVENT)
                             (_stream-start170001_)
                             (std/error#raise-io-error
                              'yaml-load
                              '"stream-start: unexpected event"
                              _t170442_))))))
                (_read-stream170002_
                 (lambda ()
                   (let* ((_head170265_ (cons '#f '()))
                          (_tail170268_ _head170265_))
                     (let _lp170427_ ()
                       (let* ((_g300824_ (_parse170000_))
                              (_t170431_
                               (std/text/libyaml#yaml_event_type
                                _event169997_)))
                         (let ((_$e170434_
                                (eq? _t170431_
                                     std/text/libyaml#YAML_STREAM_END_EVENT)))
                           (if _$e170434_
                               _$e170434_
                               (if (eq? _t170431_
                                        std/text/libyaml#YAML_DOCUMENT_START_EVENT)
                                   (begin
                                     (std/text/libyaml#yaml_event_delete
                                      _event169997_)
                                     (let ((_new-tail170437_
                                            (cons (_read-node__0__300819300820_)
                                                  '())))
                                       (let ()
                                         (declare (not safe))
                                         (##set-cdr!
                                          _tail170268_
                                          _new-tail170437_))
                                       (set! _tail170268_ _new-tail170437_))
                                     (_lp170427_))
                                   (if (eq? _t170431_
                                            std/text/libyaml#YAML_DOCUMENT_END_EVENT)
                                       (_lp170427_)
                                       (if (eq? _t170431_
                                                std/text/libyaml#YAML_NO_EVENT)
                                           (_lp170427_)
                                           (std/error#raise-io-error
                                            'yaml-load
                                            '"read-stream: unexpected event"
                                            _t170431_))))))))
                     (let () (declare (not safe)) (##cdr _head170265_)))))
                (_end-token170003_ '#(end))
                (_read-node__300817300818_
                 (lambda (_end-event-t170217_)
                   (let* ((_g300825_ (_parse170000_))
                          (_t170220_
                           (std/text/libyaml#yaml_event_type _event169997_)))
                     (if (eq? _t170220_ std/text/libyaml#YAML_ALIAS_EVENT)
                         (let* ((_anchor170223_
                                 (std/text/libyaml#yaml_event_anchor
                                  _event169997_))
                                (_g300826_
                                 (std/text/libyaml#yaml_event_delete
                                  _event169997_)))
                           (if (hash-key? _anchors169999_ _anchor170223_)
                               (table-ref _anchors169999_ _anchor170223_)
                               (std/error#raise-io-error
                                'yaml-load
                                '"read-node: undefined alias"
                                _anchor170223_)))
                         (if (eq? _t170220_ std/text/libyaml#YAML_SCALAR_EVENT)
                             (let* ((_anchor170227_
                                     (std/text/libyaml#yaml_event_anchor
                                      _event169997_))
                                    (_tag170229_
                                     (std/text/libyaml#yaml_event_tag
                                      _event169997_))
                                    (_len170231_
                                     (std/text/libyaml#yaml_event_scalar_length
                                      _event169997_))
                                    (_data170233_ (make-u8vector _len170231_))
                                    (_g300827_
                                     (std/text/libyaml#yaml_event_scalar_bytes
                                      _event169997_
                                      _data170233_))
                                    (_g300828_
                                     (std/text/libyaml#yaml_event_delete
                                      _event169997_))
                                    (_value170237_
                                     (_parse-scalar170008_
                                      _data170233_
                                      _tag170229_)))
                               (if _anchor170227_
                                   (table-set!
                                    _anchors169999_
                                    _anchor170227_
                                    _value170237_)
                                   '#!void)
                               _value170237_)
                             (if (eq? _t170220_
                                      std/text/libyaml#YAML_SEQUENCE_START_EVENT)
                                 (let* ((_anchor170240_
                                         (std/text/libyaml#yaml_event_anchor
                                          _event169997_))
                                        (_tag170242_
                                         (std/text/libyaml#yaml_event_tag
                                          _event169997_))
                                        (_g300829_
                                         (std/text/libyaml#yaml_event_delete
                                          _event169997_))
                                        (_value170245_
                                         (_read-sequence170005_ _tag170242_)))
                                   (if _anchor170240_
                                       (table-set!
                                        _anchors169999_
                                        _anchor170240_
                                        _value170245_)
                                       '#!void)
                                   _value170245_)
                                 (if (eq? _t170220_
                                          std/text/libyaml#YAML_MAPPING_START_EVENT)
                                     (let* ((_anchor170248_
                                             (std/text/libyaml#yaml_event_anchor
                                              _event169997_))
                                            (_tag170250_
                                             (std/text/libyaml#yaml_event_tag
                                              _event169997_))
                                            (_g300830_
                                             (std/text/libyaml#yaml_event_delete
                                              _event169997_))
                                            (_value170253_
                                             (_read-mapping170007_
                                              _tag170250_)))
                                       (if _anchor170248_
                                           (table-set!
                                            _anchors169999_
                                            _anchor170248_
                                            _value170253_)
                                           '#!void)
                                       _value170253_)
                                     (if (eq? _t170220_ _end-event-t170217_)
                                         _end-token170003_
                                         (if (eq? _t170220_
                                                  std/text/libyaml#YAML_NO_EVENT)
                                             (_read-node__0__300819300820_)
                                             (std/error#raise-io-error
                                              'yaml-load
                                              '"read-object: unexpected event"
                                              _t170220_))))))))))
                (_read-node__0__300819300820_
                 (lambda ()
                   (let ((_end-event-t170260_ '#f))
                     (_read-node__300817300818_ _end-event-t170260_))))
                (_read-node170004_
                 (lambda _g300832_
                   (let ((_g300831_
                          (let () (declare (not safe)) (##length _g300832_))))
                     (cond ((let () (declare (not safe)) (##fx= _g300831_ 0))
                            (apply _read-node__0__300819300820_ _g300832_))
                           ((let () (declare (not safe)) (##fx= _g300831_ 1))
                            (apply _read-node__300817300818_ _g300832_))
                           (else
                            (##raise-wrong-number-of-arguments-exception
                             'case-lambda-dispatch
                             _g300832_))))))
                (_read-sequence170005_
                 (lambda (_tag170038_)
                   (let* ((_head170040_ (cons '#f '()))
                          (_tail170043_ _head170040_))
                     (let _lp170208_ ()
                       (let ((_next170211_
                              (_read-node__300817300818_
                               std/text/libyaml#YAML_SEQUENCE_END_EVENT)))
                         (if (eq? _next170211_ _end-token170003_)
                             '#!void
                             (begin
                               (let ((_new-tail170213_
                                      (cons _next170211_ '())))
                                 (let ()
                                   (declare (not safe))
                                   (##set-cdr! _tail170043_ _new-tail170213_))
                                 (set! _tail170043_ _new-tail170213_))
                               (_lp170208_)))))
                     (let () (declare (not safe)) (##cdr _head170040_)))))
                (_format-map-key170006_
                 (lambda (_key170036_)
                   (if (string? _key170036_)
                       ((std/text/yaml#yaml-key-format) _key170036_)
                       _key170036_)))
                (_read-mapping170007_
                 (lambda (_tag170025_)
                   (let ((_ht170027_ (make-table)))
                     (let _lp170029_ ()
                       (let ((_key170032_
                              (_read-node__300817300818_
                               std/text/libyaml#YAML_MAPPING_END_EVENT)))
                         (if (eq? _key170032_ _end-token170003_)
                             _ht170027_
                             (let ((_value170034_
                                    (_read-node__0__300819300820_)))
                               (table-set!
                                _ht170027_
                                (_format-map-key170006_ _key170032_)
                                _value170034_)
                               (_lp170029_))))))))
                (_parse-scalar170008_
                 (lambda (_data170010_ _tag170011_)
                   (let* ((_str170013_
                           (std/text/utf8#utf8->string__0 _data170010_))
                          (_$e170015_
                           (table-ref
                            std/text/yaml#yaml-scalar-tags
                            _tag170011_
                            '#f)))
                     (if _$e170015_
                         ((lambda (_g170017170019_)
                            (_g170017170019_ _str170013_))
                          _$e170015_)
                         (if (or (std/pregexp#pregexp-match
                                  std/text/yaml#rx-scalar-decimal
                                  _str170013_)
                                 (std/pregexp#pregexp-match
                                  std/text/yaml#rx-scalar-float
                                  _str170013_))
                             (string->number _str170013_)
                             (if (std/pregexp#pregexp-match
                                  std/text/yaml#rx-scalar-octal
                                  _str170013_)
                                 (string->number
                                  (substring
                                   _str170013_
                                   '1
                                   (string-length _str170013_))
                                  '8)
                                 (if (std/pregexp#pregexp-match
                                      std/text/yaml#rx-scalar-hex
                                      _str170013_)
                                     (string->number
                                      (substring
                                       _str170013_
                                       '2
                                       (string-length _str170013_))
                                      '16)
                                     (if (equal? '".inf" _str170013_)
                                         '+inf.0
                                         (if (equal? '"-.inf" _str170013_)
                                             '-inf.0
                                             (if (equal? '".NaN" _str170013_)
                                                 '+nan.0
                                                 (if (equal? '"true"
                                                             _str170013_)
                                                     '#t
                                                     (if (equal? '"false"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _str170013_)
                 '#f
                 (if (equal? '"null" _str170013_)
                     '#!void
                     _str170013_))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        (_stream-start170001_))))
  (define std/text/yaml#rx-scalar-decimal
    (std/pregexp#pregexp '"^[-+]?[0-9]+$"))
  (define std/text/yaml#rx-scalar-float
    (std/pregexp#pregexp '"^[-+]?[0-9]*[.][0-9]+([eE][-+]?[0-9]+)?$"))
  (define std/text/yaml#rx-scalar-octal (std/pregexp#pregexp '"^0o[0-7]+$"))
  (define std/text/yaml#rx-scalar-hex
    (std/pregexp#pregexp '"^0x[0-9a-fA-F]+$"))
  (define std/text/yaml#yaml-string->float
    (lambda (_str169994_)
      (if (equal? _str169994_ '".inf")
          '+inf.0
          (if (equal? _str169994_ '"-.inf")
              '-inf.0
              (if (equal? _str169994_ '".nan")
                  '+nan.0
                  (string->number _str169994_))))))
  (define std/text/yaml#yaml-scalar-tags
    (let ((_ht169987_ (make-table 'size: '4)))
      (table-set! _ht169987_ '"!!null" void)
      (table-set!
       _ht169987_
       '"!!bool"
       (lambda (_g169989169991_) (equal? _g169989169991_ '"true")))
      (table-set! _ht169987_ '"!!int" string->number)
      (table-set! _ht169987_ '"!!float" std/text/yaml#yaml-string->float)
      _ht169987_))
  (define std/text/yaml#yaml-dump
    (lambda (_fname169977_ . _args169978_)
      (let ((_$e169980_
             (std/text/libyaml#open_yaml_output_file
              (path-normalize _fname169977_))))
        (if _$e169980_
            ((lambda (_file169983_)
               (with-unwind-protect
                (lambda ()
                  (std/text/yaml#yaml-dump-file _file169983_ _args169978_))
                (lambda () (std/text/libyaml#close_yaml_file _file169983_))))
             _$e169980_)
            (error '"Cannot open yaml input file" _fname169977_)))))
  (define std/text/yaml#yaml-dump-file
    (lambda (_file169965_ _args169966_)
      (let* ((_emitter169968_ (std/text/libyaml#make_yaml_emitter))
             (_g300833_
              (std/text/libyaml#yaml_emitter_initialize _emitter169968_))
             (_g300834_
              (std/text/libyaml#yaml_emitter_set_output_file
               _emitter169968_
               _file169965_))
             (_event169972_ (std/text/libyaml#make_yaml_event)))
        (with-unwind-protect
         (lambda ()
           (std/text/yaml#yaml-emit
            _emitter169968_
            _event169972_
            _args169966_))
         (lambda () (std/text/libyaml#yaml_emitter_delete _emitter169968_))))))
  (define std/text/yaml#yaml-emit
    (lambda (_emitter169881_ _event169882_ _args169883_)
      (letrec ((_emit169885_
                (lambda ()
                  (let ((_r169963_
                         (std/text/libyaml#yaml_emitter_emit
                          _emitter169881_
                          _event169882_)))
                    (if (zero? _r169963_)
                        (std/error#raise-io-error
                         'yaml-dump
                         '"LibYAML emit error"
                         (std/text/libyaml#yaml_emitter_error _emitter169881_))
                        '#!void))))
               (_emit-document169886_
                (lambda (_obj169960_)
                  (std/text/libyaml#yaml_event_document_start _event169882_)
                  (_emit169885_)
                  (_emit-object169887_ _obj169960_)
                  (std/text/libyaml#yaml_event_document_end _event169882_)
                  (_emit169885_)))
               (_emit-object169887_
                (lambda (_obj169889_)
                  (if (string? _obj169889_)
                      (begin
                        (std/text/libyaml#yaml_event_scalar
                         _event169882_
                         _obj169889_)
                        (_emit169885_))
                      (if (symbol? _obj169889_)
                          (let ((_str169891_ (symbol->string _obj169889_)))
                            (std/text/libyaml#yaml_event_scalar
                             _event169882_
                             _str169891_)
                            (_emit169885_))
                          (if (and (number? _obj169889_) (real? _obj169889_))
                              (let ((_str169893_
                                     (if (integer? _obj169889_)
                                         (number->string _obj169889_)
                                         (if (finite? _obj169889_)
                                             (number->string
                                              (exact->inexact _obj169889_))
                                             (if (eqv? _obj169889_ '+inf.0)
                                                 '".inf"
                                                 (if (eqv? _obj169889_ '-inf.0)
                                                     '"-.inf"
                                                     (if (eqv? _obj169889_
                                                               '+nan.0)
                                                         '".NaN"
                                                         (error '"Bad YAML object"
                                                                _obj169889_))))))))
                                (std/text/libyaml#yaml_event_scalar
                                 _event169882_
                                 _str169893_)
                                (_emit169885_))
                              (if (list? _obj169889_)
                                  (begin
                                    (std/text/libyaml#yaml_event_sequence_start
                                     _event169882_)
                                    (_emit169885_)
                                    (for-each _emit-object169887_ _obj169889_)
                                    (std/text/libyaml#yaml_event_sequence_end
                                     _event169882_)
                                    (_emit169885_))
                                  (if (vector? _obj169889_)
                                      (_emit-object169887_
                                       (vector->list _obj169889_))
                                      (if (table? _obj169889_)
                                          (begin
                                            (std/text/libyaml#yaml_event_mapping_start
                                             _event169882_)
                                            (_emit169885_)
                                            (let ((_iterable169927_
                                                   _obj169889_)
                                                  (_iter-do169929_
                                                   (lambda (_val169895_)
                                                     (let* ((_val169897169904_
                                                             _val169895_)
                                                            (_E169899169908_
                                                             (lambda ()
                                                               (error '"No clause matching"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _val169897169904_)))
                    (_K169900169914_
                     (lambda (_val169911_ _key169912_)
                       (_emit-object169887_ _key169912_)
                       (_emit-object169887_ _val169911_))))
               (if (let ((__tmp300835
                          (if (let ()
                                (declare (not safe))
                                (##values? _val169897169904_))
                              (let ()
                                (declare (not safe))
                                (##vector-length _val169897169904_))
                              '1)))
                     (declare (not safe))
                     (##fx= __tmp300835 '2))
                   (let* ((_e169901169917_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _val169897169904_ '0)))
                          (_key169920_ _e169901169917_)
                          (_e169902169922_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _val169897169904_ '1)))
                          (_val169925_ _e169902169922_))
                     (_K169900169914_ _val169925_ _key169920_))
                   (_E169899169908_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (pair? _iterable169927_)
                                                  (for-each
                                                   _iter-do169929_
                                                   _iterable169927_)
                                                  (if (null? _iterable169927_)
                                                      '#!void
                                                      (let* ((_it169932_
                                                              (std/iter#iter
                                                               _iterable169927_))
                                                             (_next!169935_
                                                              (let ()
                                                                (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (not safe))
                        (##unchecked-structure-ref
                         _it169932_
                         '2
                         std/iter#iterator::t
                         '#f))))
                (declare (not safe))
                (begin
                  (let _lp169940_ ()
                    (let ((_val169944_ (_next!169935_ _it169932_)))
                      (if (eq? std/iter#iter-end _val169944_)
                          '#!void
                          (begin (_iter-do169929_ _val169944_) (_lp169940_)))))
                  (let ((_$e169946_
                         (##unchecked-structure-ref
                          _it169932_
                          '3
                          std/iter#iterator::t
                          '#f)))
                    (if _$e169946_
                        ((lambda (_g169948169950_)
                           (_g169948169950_ _it169932_))
                         _$e169946_)
                        '#!void))
                  '#!void)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (std/text/libyaml#yaml_event_mapping_end
                                             _event169882_)
                                            (_emit169885_))
                                          (if (boolean? _obj169889_)
                                              (let ((_str169953_
                                                     (if _obj169889_
                                                         '"true"
                                                         '"false")))
                                                (std/text/libyaml#yaml_event_scalar
                                                 _event169882_
                                                 _str169953_)
                                                (_emit169885_))
                                              (if (eq? _obj169889_ '#!void)
                                                  (begin
                                                    (std/text/libyaml#yaml_event_scalar
                                                     _event169882_
                                                     '"null")
                                                    (_emit169885_))
                                                  (let ((_$e169955_
                                                         (method-ref
                                                          _obj169889_
                                                          ':yaml)))
                                                    (if _$e169955_
                                                        ((lambda (_yamlf169958_)
                                                           (_emit-object169887_
                                                            (_yamlf169958_
                                                             _obj169889_)))
                                                         _$e169955_)
                                                        (error '"Bad YAML object"
                                                               _obj169889_))))))))))))))
        (std/text/libyaml#yaml_event_stream_start _event169882_)
        (_emit169885_)
        (for-each _emit-document169886_ _args169883_)
        (std/text/libyaml#yaml_event_stream_end _event169882_)
        (_emit169885_)))))
